#------------------------------------------------------------------------------
# <auto-generated>
#     This file was auto generated.
#
#     Changes to this file may cause incorrect behavior and will be lost if
#     the code is regenerated.
# </auto-generated>
#------------------------------------------------------------------------------
import typing
from abc import abstractmethod, ABCMeta
from System import Array, AsyncCallback, Attribute, Decimal, Enum, Exception, Func, IAsyncResult, ICloneable, IComparable, IConvertible, IEquatable, IFormatProvider, IFormattable, IntPtr, MulticastDelegate, TimeSpan, Type, ValueTuple, ValueType
from System.Collections.Generic import IDictionary, IEnumerable
from System.ComponentModel import ITypeDescriptorContext, TypeConverter
from System.Globalization import CultureInfo
from System.Runtime.Serialization import ISerializable
from UnitsNet.Units import AccelerationUnit, AmountOfSubstanceUnit, AmplitudeRatioUnit, AngleUnit, ApparentEnergyUnit, ApparentPowerUnit, AreaDensityUnit, AreaMomentOfInertiaUnit, AreaUnit, BitRateUnit, BrakeSpecificFuelConsumptionUnit, CapacitanceUnit, CoefficientOfThermalExpansionUnit, DensityUnit, DurationUnit, DynamicViscosityUnit, ElectricAdmittanceUnit, ElectricChargeDensityUnit, ElectricChargeUnit, ElectricConductanceUnit, ElectricConductivityUnit, ElectricCurrentDensityUnit, ElectricCurrentGradientUnit, ElectricCurrentUnit, ElectricFieldUnit, ElectricInductanceUnit, ElectricPotentialAcUnit, ElectricPotentialChangeRateUnit, ElectricPotentialDcUnit, ElectricPotentialUnit, ElectricResistanceUnit, ElectricResistivityUnit, ElectricSurfaceChargeDensityUnit, EnergyUnit, EntropyUnit, ForceChangeRateUnit, ForcePerLengthUnit, ForceUnit, FrequencyUnit, FuelEfficiencyUnit, HeatFluxUnit, HeatTransferCoefficientUnit, IlluminanceUnit, InformationUnit, IrradianceUnit, IrradiationUnit, KinematicViscosityUnit, LapseRateUnit, LengthUnit, LevelUnit, LinearDensityUnit, LinearPowerDensityUnit, LuminosityUnit, LuminousFluxUnit, LuminousIntensityUnit, MagneticFieldUnit, MagneticFluxUnit, MagnetizationUnit, MassConcentrationUnit, MassFlowUnit, MassFluxUnit, MassFractionUnit, MassMomentOfInertiaUnit, MassUnit, MolarEnergyUnit, MolarEntropyUnit, MolarityUnit, MolarMassUnit, PermeabilityUnit, PermittivityUnit, PowerDensityUnit, PowerRatioUnit, PowerUnit, PressureChangeRateUnit, PressureUnit, RatioChangeRateUnit, RatioUnit, ReactiveEnergyUnit, ReactivePowerUnit, RelativeHumidityUnit, RotationalAccelerationUnit, RotationalSpeedUnit, RotationalStiffnessPerLengthUnit, RotationalStiffnessUnit, ScalarUnit, SolidAngleUnit, SpecificEnergyUnit, SpecificEntropyUnit, SpecificVolumeUnit, SpecificWeightUnit, SpeedUnit, StandardVolumeFlowUnit, TemperatureChangeRateUnit, TemperatureDeltaUnit, TemperatureUnit, ThermalConductivityUnit, ThermalResistanceUnit, TorquePerLengthUnit, TorqueUnit, TurbidityUnit, VitaminAUnit, VolumeConcentrationUnit, VolumeFlowUnit, VolumePerLengthUnit, VolumeUnit, WarpingMomentOfInertiaUnit
TQuantity = typing.TypeVar('TQuantity')
TUnit = typing.TypeVar('TUnit')
TUnitType = typing.TypeVar('TUnitType')


# noinspection PyPep8Naming
class AmbiguousUnitParseException(UnitsNetException, ISerializable):
    """ Unable to parse because more than one unit of the given quantity type had this exact unit abbreviation.
     Example: Length.Parse("1 pt") will throw "AmbiguousUnitParseException", because both
     "Field DtpPoint" and
     "Field PrinterPoint" have "pt" as their abbreviation.
    """

    def __init__(self, message: str) -> None:
        """
        """
        pass

    def __init__(self, message: str, innerException: Exception) -> None:
        """
        """
        pass


# noinspection PyPep8Naming
class BaseDimensions:
    """ Represents the base dimensions of a quantity.
    """

    @property
    def Length(self) -> int:
        """Gets the length dimensions (L).
        """
        pass

    @property
    def Mass(self) -> int:
        """Gets the mass dimensions (M).
        """
        pass

    @property
    def Time(self) -> int:
        """Gets the time dimensions (T).
        """
        pass

    @property
    def Current(self) -> int:
        """Gets the electric current dimensions (I).
        """
        pass

    @property
    def Temperature(self) -> int:
        """Gets the temperature dimensions (Θ).
        """
        pass

    @property
    def Amount(self) -> int:
        """Gets the amount of substance dimensions (N).
        """
        pass

    @property
    def LuminousIntensity(self) -> int:
        """Gets the luminous intensity dimensions (J).
        """
        pass

    Dimensionless: typing.ClassVar[BaseDimensions]

    def __init__(self, length: int, mass: int, time: int, current: int, temperature: int, amount: int, luminousIntensity: int) -> None:
        """
        """
        pass

    def IsBaseQuantity(self) -> bool:
        """Checks if the dimensions represent a base quantity.

        :return: True if the dimensions represent a base quantity, otherwise false.
        :rtype: bool
        """
        pass

    def IsDerivedQuantity(self) -> bool:
        """Checks if the dimensions represent a derived quantity.

        :return: True if the dimensions represent a derived quantity, otherwise false.
        :rtype: bool
        """
        pass

    def IsDimensionless(self) -> bool:
        """Checks if this base dimensions object represents a dimensionless quantity.

        :return: True if this object represents a dimensionless quantity, otherwise false.
        :rtype: bool
        """
        pass

    def Equals(self, obj: typing.Any) -> bool:
        """
        """
        pass

    def GetHashCode(self) -> int:
        """
        """
        pass

    def Multiply(self, right: BaseDimensions) -> BaseDimensions:
        """Get resulting dimensions after multiplying two dimensions, by performing addition of each dimension.

        :param right: Other dimensions.
        :type right: BaseDimensions
        :return: Resulting dimensions.
        :rtype: BaseDimensions
        """
        pass

    def Divide(self, right: BaseDimensions) -> BaseDimensions:
        """Get resulting dimensions after dividing two dimensions, by performing subtraction of each dimension.

        :param right: Other dimensions.
        :type right: BaseDimensions
        :return: Resulting dimensions.
        :rtype: BaseDimensions
        """
        pass

    def ToString(self) -> str:
        """
        """
        pass


# noinspection PyPep8Naming
class BaseUnits(IEquatable[BaseUnits]):
    """ Represents the base units for a quantity. All quantities, both base and derived, can be
     represented by a combination of these seven base units.
    """

    Undefined: typing.ClassVar[BaseUnits]

    @property
    def Length(self) -> LengthUnit:
        """Gets the length unit (L).
        """
        pass

    @property
    def Mass(self) -> MassUnit:
        """Gets the mass unit (M).
        """
        pass

    @property
    def Time(self) -> DurationUnit:
        """Gets the time unit (T).
        """
        pass

    @property
    def Current(self) -> ElectricCurrentUnit:
        """Gets the electric current unit (I).
        """
        pass

    @property
    def Temperature(self) -> TemperatureUnit:
        """Gets the temperature unit (Θ).
        """
        pass

    @property
    def Amount(self) -> AmountOfSubstanceUnit:
        """Gets the amount of substance unit (N).
        """
        pass

    @property
    def LuminousIntensity(self) -> LuminousIntensityUnit:
        """Gets the luminous intensity unit (J).
        """
        pass

    @property
    def IsFullyDefined(self) -> bool:
        """Gets whether or not all of the base units are defined.
        """
        pass

    def __init__(self, length: LengthUnit, mass: MassUnit, time: DurationUnit, current: ElectricCurrentUnit, temperature: TemperatureUnit, amount: AmountOfSubstanceUnit, luminousIntensity: LuminousIntensityUnit) -> None:
        """Creates an instance of if the base units class that represents the base units for a quantity.
        All quantities, both base and derived, can be represented by a combination of these seven base units.

        :param length: The length unit (L).
        :type length: LengthUnit
        :param mass: The mass unit (M).
        :type mass: MassUnit
        :param time: The time unit (T).
        :type time: DurationUnit
        :param current: The electric current unit (I).
        :type current: ElectricCurrentUnit
        :param temperature: The temperature unit (Θ).
        :type temperature: TemperatureUnit
        :param amount: The amount of substance unit (N).
        :type amount: AmountOfSubstanceUnit
        :param luminousIntensity: The luminous intensity unit (J).
        :type luminousIntensity: LuminousIntensityUnit
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """
        """
        pass

    @typing.overload
    def Equals(self, other: BaseUnits) -> bool:
        """Checks if all of the base units are equal to another instance's.

        :param other: The other instance to check if equal to.
        :type other: BaseUnits
        :return: True if equal, otherwise false.
        :rtype: bool
        """
        pass

    def IsSubsetOf(self, other: BaseUnits) -> bool:
        """Checks if the base units are a subset of another. Undefined base units are ignored.
        If all base united are undefined (equal to "Property Undefined"),
        IsSubsetOf will return true only if other is also equal to "Property Undefined".

        :param other: The other "BaseUnits" to compare to.
        :type other: BaseUnits
        :return: True if the base units are a subset of other, otherwise false.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """
        """
        pass

    def ToString(self) -> str:
        """
        """
        pass


# noinspection PyPep8Naming
class Comparison(metaclass=ABCMeta):
    """ Helper methods to perform relative and absolute comparison.
    """

    @staticmethod
    def Equals(referenceValue: float, otherValue: float, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Checks if two values are equal with a given relative or absolute tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between and as a percentage of . A relative tolerance of 0.01 means the absolute difference of and must be within +/- 1%. In this example, the two values will be equal if the value of b is within +/- 1% of a. Equals(a, b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between and as a fixed number. In this example, the two values will be equal if abs( - ) <= 0.01 Equals(a, b, 0.01, ComparisonType.Absolute);

        :param referenceValue: The reference value. If using relative tolerance, it is the value which the relative
        tolerance will be calculated against.
        :type referenceValue: float
        :param otherValue: The value to compare to.
        :type otherValue: float
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: Whether the tolerance is absolute or relative.
        :type comparisonType: ComparisonType
        :return:
        :rtype: bool
        """
        pass

    @staticmethod
    def EqualsRelative(referenceValue: float, otherValue: float, tolerance: float) -> bool:
        """ Checks if two values are equal with a given relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between and as a percentage of . A relative tolerance of 0.01 means the absolute difference of and must be within +/- 1%. In this example, the two values will be equal if the value of b is within +/- 1% of a. EqualsRelative(a, b, 0.01);

        :param referenceValue: The reference value which the tolerance will be calculated against.
        :type referenceValue: float
        :param otherValue: The value to compare to.
        :type otherValue: float
        :param tolerance: The relative tolerance. Must be greater than or equal to 0.
        :type tolerance: float
        :return: True if the two values are equal within the given relative tolerance, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    def EqualsAbsolute(value1: float, value2: float, tolerance: float) -> bool:
        """ Checks if two values are equal with a given absolute tolerance.

         Absolute tolerance is defined as the maximum allowable absolute difference between and as a fixed number. In this example, the two values will be equal if abs( - ) <= 0.01 Equals(a, b, 0.01, ComparisonType.Absolute);

        :param value1: The first value.
        :type value1: float
        :param value2: The second value.
        :type value2: float
        :param tolerance: The absolute tolerance. Must be greater than or equal to 0.
        :type tolerance: float
        :return: True if the two values are equal within the given absolute tolerance, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class ComparisonType(Enum, IComparable, IFormattable, IConvertible):
    """Specifies if the comparison between numbers is absolute or relative.
    """

    value__: int = ...

    Relative: ComparisonType = ...
    """Error margin in relative size to a reference value.
    """

    Absolute: ComparisonType = ...
    """Error margin as absolute size.
    """


# noinspection PyPep8Naming
class GlobalConfiguration(metaclass=ABCMeta):
    """ Global configuration for culture, used as default culture in methods like "Function ToString" and
     "Function String)".
    """

    DefaultCulture: typing.ClassVar[IFormatProvider]


# noinspection PyPep8Naming
class Acceleration(ValueType, IQuantity[AccelerationUnit], IQuantity, IFormattable, IEquatable[Acceleration], IComparable, IComparable[Acceleration], IConvertible):
    """ Acceleration, in physics, is the rate at which the velocity of an object changes over time. An object's acceleration is the net result of any and all forces acting on the object, as described by Newton's Second Law. The SI unit for acceleration is the Meter per second squared (m/s²). Accelerations are vector quantities (they have magnitude and direction) and add according to the parallelogram law. As a vector, the calculated net force is equal to the product of the object's mass (a scalar quantity) and the acceleration.
    """

    Info: typing.ClassVar[QuantityInfo[AccelerationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AccelerationUnit]

    MaxValue: typing.ClassVar[Acceleration]

    MinValue: typing.ClassVar[Acceleration]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AccelerationUnit]]

    Zero: typing.ClassVar[Acceleration]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AccelerationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AccelerationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimetersPerSecondSquared(self) -> float:
        """ Get Acceleration in CentimetersPerSecondSquared.
        """
        pass

    @property
    def DecimetersPerSecondSquared(self) -> float:
        """ Get Acceleration in DecimetersPerSecondSquared.
        """
        pass

    @property
    def FeetPerSecondSquared(self) -> float:
        """ Get Acceleration in FeetPerSecondSquared.
        """
        pass

    @property
    def InchesPerSecondSquared(self) -> float:
        """ Get Acceleration in InchesPerSecondSquared.
        """
        pass

    @property
    def KilometersPerSecondSquared(self) -> float:
        """ Get Acceleration in KilometersPerSecondSquared.
        """
        pass

    @property
    def KnotsPerHour(self) -> float:
        """ Get Acceleration in KnotsPerHour.
        """
        pass

    @property
    def KnotsPerMinute(self) -> float:
        """ Get Acceleration in KnotsPerMinute.
        """
        pass

    @property
    def KnotsPerSecond(self) -> float:
        """ Get Acceleration in KnotsPerSecond.
        """
        pass

    @property
    def MetersPerSecondSquared(self) -> float:
        """ Get Acceleration in MetersPerSecondSquared.
        """
        pass

    @property
    def MicrometersPerSecondSquared(self) -> float:
        """ Get Acceleration in MicrometersPerSecondSquared.
        """
        pass

    @property
    def MillimetersPerSecondSquared(self) -> float:
        """ Get Acceleration in MillimetersPerSecondSquared.
        """
        pass

    @property
    def MillistandardGravity(self) -> float:
        """ Get Acceleration in MillistandardGravity.
        """
        pass

    @property
    def NanometersPerSecondSquared(self) -> float:
        """ Get Acceleration in NanometersPerSecondSquared.
        """
        pass

    @property
    def StandardGravity(self) -> float:
        """ Get Acceleration in StandardGravity.
        """
        pass

    def __init__(self, value: float, unit: AccelerationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AccelerationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: Acceleration, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Acceleration within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Acceleration
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Acceleration.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AccelerationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AccelerationUnit) -> Acceleration:
        """ Converts this Acceleration to another Acceleration with the unit representation .

        :return: A Acceleration with the specified unit.
        :rtype: Acceleration
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Acceleration:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AccelerationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AccelerationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AccelerationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AccelerationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimetersPerSecondSquared(centimeterspersecondsquared: QuantityValue) -> Acceleration:
        """ Get Acceleration from CentimetersPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersPerSecondSquared(decimeterspersecondsquared: QuantityValue) -> Acceleration:
        """ Get Acceleration from DecimetersPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetPerSecondSquared(feetpersecondsquared: QuantityValue) -> Acceleration:
        """ Get Acceleration from FeetPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesPerSecondSquared(inchespersecondsquared: QuantityValue) -> Acceleration:
        """ Get Acceleration from InchesPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilometersPerSecondSquared(kilometerspersecondsquared: QuantityValue) -> Acceleration:
        """ Get Acceleration from KilometersPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKnotsPerHour(knotsperhour: QuantityValue) -> Acceleration:
        """ Get Acceleration from KnotsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKnotsPerMinute(knotsperminute: QuantityValue) -> Acceleration:
        """ Get Acceleration from KnotsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKnotsPerSecond(knotspersecond: QuantityValue) -> Acceleration:
        """ Get Acceleration from KnotsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersPerSecondSquared(meterspersecondsquared: QuantityValue) -> Acceleration:
        """ Get Acceleration from MetersPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrometersPerSecondSquared(micrometerspersecondsquared: QuantityValue) -> Acceleration:
        """ Get Acceleration from MicrometersPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersPerSecondSquared(millimeterspersecondsquared: QuantityValue) -> Acceleration:
        """ Get Acceleration from MillimetersPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillistandardGravity(millistandardgravity: QuantityValue) -> Acceleration:
        """ Get Acceleration from MillistandardGravity.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanometersPerSecondSquared(nanometerspersecondsquared: QuantityValue) -> Acceleration:
        """ Get Acceleration from NanometersPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardGravity(standardgravity: QuantityValue) -> Acceleration:
        """ Get Acceleration from StandardGravity.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AccelerationUnit) -> Acceleration:
        """ Dynamically convert from value and unit enum "AccelerationUnit" to "Acceleration".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AccelerationUnit
        :return: Acceleration unit value.
        :rtype: Acceleration
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Acceleration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Acceleration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Acceleration) -> typing.Tuple[Acceleration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Acceleration
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Acceleration) -> typing.Tuple[Acceleration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Acceleration
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AccelerationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AccelerationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AccelerationUnit) -> typing.Tuple[AccelerationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AccelerationUnit) -> typing.Tuple[AccelerationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AccelerationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Acceleration) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Acceleration) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass


# noinspection PyPep8Naming
class AmountOfSubstance(ValueType, IQuantity[AmountOfSubstanceUnit], IQuantity, IFormattable, IEquatable[AmountOfSubstance], IComparable, IComparable[AmountOfSubstance], IConvertible):
    """ Mole is the amount of substance containing Avagadro's Number (6.02 x 10 ^ 23) of real particles such as molecules,atoms, ions or radicals.
    """

    AvogadroConstant: typing.ClassVar[float]

    Info: typing.ClassVar[QuantityInfo[AmountOfSubstanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AmountOfSubstanceUnit]

    MaxValue: typing.ClassVar[AmountOfSubstance]

    MinValue: typing.ClassVar[AmountOfSubstance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AmountOfSubstanceUnit]]

    Zero: typing.ClassVar[AmountOfSubstance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AmountOfSubstanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AmountOfSubstanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Centimoles(self) -> float:
        """ Get AmountOfSubstance in Centimoles.
        """
        pass

    @property
    def CentipoundMoles(self) -> float:
        """ Get AmountOfSubstance in CentipoundMoles.
        """
        pass

    @property
    def Decimoles(self) -> float:
        """ Get AmountOfSubstance in Decimoles.
        """
        pass

    @property
    def DecipoundMoles(self) -> float:
        """ Get AmountOfSubstance in DecipoundMoles.
        """
        pass

    @property
    def Kilomoles(self) -> float:
        """ Get AmountOfSubstance in Kilomoles.
        """
        pass

    @property
    def KilopoundMoles(self) -> float:
        """ Get AmountOfSubstance in KilopoundMoles.
        """
        pass

    @property
    def Megamoles(self) -> float:
        """ Get AmountOfSubstance in Megamoles.
        """
        pass

    @property
    def Micromoles(self) -> float:
        """ Get AmountOfSubstance in Micromoles.
        """
        pass

    @property
    def MicropoundMoles(self) -> float:
        """ Get AmountOfSubstance in MicropoundMoles.
        """
        pass

    @property
    def Millimoles(self) -> float:
        """ Get AmountOfSubstance in Millimoles.
        """
        pass

    @property
    def MillipoundMoles(self) -> float:
        """ Get AmountOfSubstance in MillipoundMoles.
        """
        pass

    @property
    def Moles(self) -> float:
        """ Get AmountOfSubstance in Moles.
        """
        pass

    @property
    def Nanomoles(self) -> float:
        """ Get AmountOfSubstance in Nanomoles.
        """
        pass

    @property
    def NanopoundMoles(self) -> float:
        """ Get AmountOfSubstance in NanopoundMoles.
        """
        pass

    @property
    def PoundMoles(self) -> float:
        """ Get AmountOfSubstance in PoundMoles.
        """
        pass

    def __init__(self, value: float, unit: AmountOfSubstanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AmountOfSubstanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: AmountOfSubstance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AmountOfSubstance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AmountOfSubstance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another AmountOfSubstance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: AmountOfSubstance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current AmountOfSubstance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AmountOfSubstanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AmountOfSubstanceUnit) -> AmountOfSubstance:
        """ Converts this AmountOfSubstance to another AmountOfSubstance with the unit representation .

        :return: A AmountOfSubstance with the specified unit.
        :rtype: AmountOfSubstance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> AmountOfSubstance:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def NumberOfParticles(self) -> float:
        """Calculates the number of particles (atoms or molecules) in this amount of substance using the "Property AvogadroConstant".

        :return: The number of particles (atoms or molecules) in this amount of substance.
        :rtype: float
        """
        pass

    @staticmethod
    def FromMass(mass: Mass, molarMass: MolarMass) -> AmountOfSubstance:
        """Get "AmountOfSubstance" from "Mass" and a given "MolarMass".
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AmountOfSubstanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AmountOfSubstanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AmountOfSubstanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AmountOfSubstanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimoles(centimoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from Centimoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentipoundMoles(centipoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from CentipoundMoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimoles(decimoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from Decimoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecipoundMoles(decipoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from DecipoundMoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilomoles(kilomoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from Kilomoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundMoles(kilopoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from KilopoundMoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegamoles(megamoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from Megamoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicromoles(micromoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from Micromoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicropoundMoles(micropoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from MicropoundMoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimoles(millimoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from Millimoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillipoundMoles(millipoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from MillipoundMoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMoles(moles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from Moles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanomoles(nanomoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from Nanomoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanopoundMoles(nanopoundmoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from NanopoundMoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundMoles(poundmoles: QuantityValue) -> AmountOfSubstance:
        """ Get AmountOfSubstance from PoundMoles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AmountOfSubstanceUnit) -> AmountOfSubstance:
        """ Dynamically convert from value and unit enum "AmountOfSubstanceUnit" to "AmountOfSubstance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AmountOfSubstanceUnit
        :return: AmountOfSubstance unit value.
        :rtype: AmountOfSubstance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> AmountOfSubstance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> AmountOfSubstance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: AmountOfSubstance) -> typing.Tuple[AmountOfSubstance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AmountOfSubstance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: AmountOfSubstance) -> typing.Tuple[AmountOfSubstance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AmountOfSubstance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AmountOfSubstanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AmountOfSubstanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AmountOfSubstanceUnit) -> typing.Tuple[AmountOfSubstanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AmountOfSubstanceUnit) -> typing.Tuple[AmountOfSubstanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AmountOfSubstanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class AmplitudeRatio(ValueType, IQuantity[AmplitudeRatioUnit], IQuantity, IFormattable, IEquatable[AmplitudeRatio], IComparable, IComparable[AmplitudeRatio], IConvertible):
    """ The strength of a signal expressed in decibels (dB) relative to one volt RMS.
    """

    Info: typing.ClassVar[QuantityInfo[AmplitudeRatioUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AmplitudeRatioUnit]

    MaxValue: typing.ClassVar[AmplitudeRatio]

    MinValue: typing.ClassVar[AmplitudeRatio]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AmplitudeRatioUnit]]

    Zero: typing.ClassVar[AmplitudeRatio]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AmplitudeRatioUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AmplitudeRatioUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DecibelMicrovolts(self) -> float:
        """ Get AmplitudeRatio in DecibelMicrovolts.
        """
        pass

    @property
    def DecibelMillivolts(self) -> float:
        """ Get AmplitudeRatio in DecibelMillivolts.
        """
        pass

    @property
    def DecibelsUnloaded(self) -> float:
        """ Get AmplitudeRatio in DecibelsUnloaded.
        """
        pass

    @property
    def DecibelVolts(self) -> float:
        """ Get AmplitudeRatio in DecibelVolts.
        """
        pass

    def __init__(self, voltage: ElectricPotential) -> None:
        """ Initializes a new instance of the "AmplitudeRatio" struct from the specified electric potential
         referenced to one volt RMS. This assumes both the specified electric potential and the one volt reference have the
         same
         resistance.

        :param voltage: The electric potential referenced to one volt.
        :type voltage: ElectricPotential
        """
        pass

    def __init__(self, value: float, unit: AmplitudeRatioUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AmplitudeRatioUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToElectricPotential(self) -> ElectricPotential:
        """ Gets an "ElectricPotential" from this "AmplitudeRatio".
         Provides a nicer syntax for converting an amplitude ratio back to a voltage.
         var voltage = voltageRatio.ToElectricPotential();
        """
        pass

    def ToPowerRatio(self, impedance: ElectricResistance) -> PowerRatio:
        """ Converts this "AmplitudeRatio" to a "PowerRatio".
        http://www.maximintegrated.com/en/app-notes/index.mvp/id/808

        :param impedance: The input impedance of the load. This is usually 50, 75 or 600 ohms.
        :type impedance: ElectricResistance
        """
        pass

    @staticmethod
    def FromElectricPotential(voltage: ElectricPotential) -> AmplitudeRatio:
        """ Gets an "AmplitudeRatio" in decibels (dB) relative to 1 volt RMS from an
         "ElectricPotential".

        :param voltage: The voltage (electric potential) relative to one volt RMS.
        :type voltage: ElectricPotential
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AmplitudeRatioUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AmplitudeRatioUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AmplitudeRatioUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AmplitudeRatioUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecibelMicrovolts(decibelmicrovolts: QuantityValue) -> AmplitudeRatio:
        """ Get AmplitudeRatio from DecibelMicrovolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecibelMillivolts(decibelmillivolts: QuantityValue) -> AmplitudeRatio:
        """ Get AmplitudeRatio from DecibelMillivolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecibelsUnloaded(decibelsunloaded: QuantityValue) -> AmplitudeRatio:
        """ Get AmplitudeRatio from DecibelsUnloaded.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecibelVolts(decibelvolts: QuantityValue) -> AmplitudeRatio:
        """ Get AmplitudeRatio from DecibelVolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AmplitudeRatioUnit) -> AmplitudeRatio:
        """ Dynamically convert from value and unit enum "AmplitudeRatioUnit" to "AmplitudeRatio".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AmplitudeRatioUnit
        :return: AmplitudeRatio unit value.
        :rtype: AmplitudeRatio
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> AmplitudeRatio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> AmplitudeRatio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: AmplitudeRatio) -> typing.Tuple[AmplitudeRatio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AmplitudeRatio
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: AmplitudeRatio) -> typing.Tuple[AmplitudeRatio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AmplitudeRatio
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AmplitudeRatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AmplitudeRatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AmplitudeRatioUnit) -> typing.Tuple[AmplitudeRatioUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AmplitudeRatioUnit) -> typing.Tuple[AmplitudeRatioUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AmplitudeRatioUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: AmplitudeRatio) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AmplitudeRatio) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AmplitudeRatio, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another AmplitudeRatio within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: AmplitudeRatio
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current AmplitudeRatio.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AmplitudeRatioUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AmplitudeRatioUnit) -> AmplitudeRatio:
        """ Converts this AmplitudeRatio to another AmplitudeRatio with the unit representation .

        :return: A AmplitudeRatio with the specified unit.
        :rtype: AmplitudeRatio
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> AmplitudeRatio:
        """
        """
        pass


# noinspection PyPep8Naming
class Angle(ValueType, IQuantity[AngleUnit], IQuantity, IFormattable, IEquatable[Angle], IComparable, IComparable[Angle], IConvertible):
    """ In geometry, an angle is the figure formed by two rays, called the sides of the angle, sharing a common endpoint, called the vertex of the angle.
    """

    Info: typing.ClassVar[QuantityInfo[AngleUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AngleUnit]

    MaxValue: typing.ClassVar[Angle]

    MinValue: typing.ClassVar[Angle]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AngleUnit]]

    Zero: typing.ClassVar[Angle]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AngleUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AngleUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Arcminutes(self) -> float:
        """ Get Angle in Arcminutes.
        """
        pass

    @property
    def Arcseconds(self) -> float:
        """ Get Angle in Arcseconds.
        """
        pass

    @property
    def Centiradians(self) -> float:
        """ Get Angle in Centiradians.
        """
        pass

    @property
    def Deciradians(self) -> float:
        """ Get Angle in Deciradians.
        """
        pass

    @property
    def Degrees(self) -> float:
        """ Get Angle in Degrees.
        """
        pass

    @property
    def Gradians(self) -> float:
        """ Get Angle in Gradians.
        """
        pass

    @property
    def Microdegrees(self) -> float:
        """ Get Angle in Microdegrees.
        """
        pass

    @property
    def Microradians(self) -> float:
        """ Get Angle in Microradians.
        """
        pass

    @property
    def Millidegrees(self) -> float:
        """ Get Angle in Millidegrees.
        """
        pass

    @property
    def Milliradians(self) -> float:
        """ Get Angle in Milliradians.
        """
        pass

    @property
    def Nanodegrees(self) -> float:
        """ Get Angle in Nanodegrees.
        """
        pass

    @property
    def Nanoradians(self) -> float:
        """ Get Angle in Nanoradians.
        """
        pass

    @property
    def Radians(self) -> float:
        """ Get Angle in Radians.
        """
        pass

    @property
    def Revolutions(self) -> float:
        """ Get Angle in Revolutions.
        """
        pass

    @property
    def Tilt(self) -> float:
        """ Get Angle in Tilt.
        """
        pass

    def __init__(self, value: float, unit: AngleUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AngleUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Angle) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Angle, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Angle within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Angle
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Angle.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AngleUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AngleUnit) -> Angle:
        """ Converts this Angle to another Angle with the unit representation .

        :return: A Angle with the specified unit.
        :rtype: Angle
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Angle:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AngleUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AngleUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AngleUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AngleUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromArcminutes(arcminutes: QuantityValue) -> Angle:
        """ Get Angle from Arcminutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromArcseconds(arcseconds: QuantityValue) -> Angle:
        """ Get Angle from Arcseconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentiradians(centiradians: QuantityValue) -> Angle:
        """ Get Angle from Centiradians.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciradians(deciradians: QuantityValue) -> Angle:
        """ Get Angle from Deciradians.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegrees(degrees: QuantityValue) -> Angle:
        """ Get Angle from Degrees.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGradians(gradians: QuantityValue) -> Angle:
        """ Get Angle from Gradians.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrodegrees(microdegrees: QuantityValue) -> Angle:
        """ Get Angle from Microdegrees.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroradians(microradians: QuantityValue) -> Angle:
        """ Get Angle from Microradians.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidegrees(millidegrees: QuantityValue) -> Angle:
        """ Get Angle from Millidegrees.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliradians(milliradians: QuantityValue) -> Angle:
        """ Get Angle from Milliradians.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanodegrees(nanodegrees: QuantityValue) -> Angle:
        """ Get Angle from Nanodegrees.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoradians(nanoradians: QuantityValue) -> Angle:
        """ Get Angle from Nanoradians.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRadians(radians: QuantityValue) -> Angle:
        """ Get Angle from Radians.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRevolutions(revolutions: QuantityValue) -> Angle:
        """ Get Angle from Revolutions.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTilt(tilt: QuantityValue) -> Angle:
        """ Get Angle from Tilt.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AngleUnit) -> Angle:
        """ Dynamically convert from value and unit enum "AngleUnit" to "Angle".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AngleUnit
        :return: Angle unit value.
        :rtype: Angle
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Angle:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Angle:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Angle) -> typing.Tuple[Angle, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Angle
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Angle) -> typing.Tuple[Angle, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Angle
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AngleUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AngleUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AngleUnit) -> typing.Tuple[AngleUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AngleUnit) -> typing.Tuple[AngleUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AngleUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Angle) -> int:
        """
        """
        pass


# noinspection PyPep8Naming
class Area(ValueType, IQuantity[AreaUnit], IQuantity, IFormattable, IEquatable[Area], IComparable, IComparable[Area], IConvertible):
    """ Area is a quantity that expresses the extent of a two-dimensional surface or shape, or planar lamina, in the plane. Area can be understood as the amount of material with a given thickness that would be necessary to fashion a model of the shape, or the amount of paint necessary to cover the surface with a single coat.[1] It is the two-dimensional analog of the length of a curve (a one-dimensional concept) or the volume of a solid (a three-dimensional concept).
    """

    Info: typing.ClassVar[QuantityInfo[AreaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AreaUnit]

    MaxValue: typing.ClassVar[Area]

    MinValue: typing.ClassVar[Area]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AreaUnit]]

    Zero: typing.ClassVar[Area]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AreaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AreaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Acres(self) -> float:
        """ Get Area in Acres.
        """
        pass

    @property
    def Hectares(self) -> float:
        """ Get Area in Hectares.
        """
        pass

    @property
    def SquareCentimeters(self) -> float:
        """ Get Area in SquareCentimeters.
        """
        pass

    @property
    def SquareDecimeters(self) -> float:
        """ Get Area in SquareDecimeters.
        """
        pass

    @property
    def SquareFeet(self) -> float:
        """ Get Area in SquareFeet.
        """
        pass

    @property
    def SquareInches(self) -> float:
        """ Get Area in SquareInches.
        """
        pass

    @property
    def SquareKilometers(self) -> float:
        """ Get Area in SquareKilometers.
        """
        pass

    @property
    def SquareMeters(self) -> float:
        """ Get Area in SquareMeters.
        """
        pass

    @property
    def SquareMicrometers(self) -> float:
        """ Get Area in SquareMicrometers.
        """
        pass

    @property
    def SquareMiles(self) -> float:
        """ Get Area in SquareMiles.
        """
        pass

    @property
    def SquareMillimeters(self) -> float:
        """ Get Area in SquareMillimeters.
        """
        pass

    @property
    def SquareNauticalMiles(self) -> float:
        """ Get Area in SquareNauticalMiles.
        """
        pass

    @property
    def SquareYards(self) -> float:
        """ Get Area in SquareYards.
        """
        pass

    @property
    def UsSurveySquareFeet(self) -> float:
        """ Get Area in UsSurveySquareFeet.
        """
        pass

    def __init__(self, value: float, unit: AreaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AreaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, other: Area) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Area) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Area, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Area within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Area
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Area.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AreaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AreaUnit) -> Area:
        """ Converts this Area to another Area with the unit representation .

        :return: A Area with the specified unit.
        :rtype: Area
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Area:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCircleDiameter(diameter: Length) -> Area:
        """Get circle area from a diameter.
        """
        pass

    @staticmethod
    def FromCircleRadius(radius: Length) -> Area:
        """Get circle area from a radius.
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAcres(acres: QuantityValue) -> Area:
        """ Get Area from Acres.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectares(hectares: QuantityValue) -> Area:
        """ Get Area from Hectares.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareCentimeters(squarecentimeters: QuantityValue) -> Area:
        """ Get Area from SquareCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareDecimeters(squaredecimeters: QuantityValue) -> Area:
        """ Get Area from SquareDecimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareFeet(squarefeet: QuantityValue) -> Area:
        """ Get Area from SquareFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareInches(squareinches: QuantityValue) -> Area:
        """ Get Area from SquareInches.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareKilometers(squarekilometers: QuantityValue) -> Area:
        """ Get Area from SquareKilometers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMeters(squaremeters: QuantityValue) -> Area:
        """ Get Area from SquareMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMicrometers(squaremicrometers: QuantityValue) -> Area:
        """ Get Area from SquareMicrometers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMiles(squaremiles: QuantityValue) -> Area:
        """ Get Area from SquareMiles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMillimeters(squaremillimeters: QuantityValue) -> Area:
        """ Get Area from SquareMillimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareNauticalMiles(squarenauticalmiles: QuantityValue) -> Area:
        """ Get Area from SquareNauticalMiles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareYards(squareyards: QuantityValue) -> Area:
        """ Get Area from SquareYards.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsSurveySquareFeet(ussurveysquarefeet: QuantityValue) -> Area:
        """ Get Area from UsSurveySquareFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AreaUnit) -> Area:
        """ Dynamically convert from value and unit enum "AreaUnit" to "Area".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AreaUnit
        :return: Area unit value.
        :rtype: Area
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Area:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Area:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Area) -> typing.Tuple[Area, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Area
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Area) -> typing.Tuple[Area, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Area
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AreaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AreaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AreaUnit) -> typing.Tuple[AreaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AreaUnit) -> typing.Tuple[AreaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AreaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass


# noinspection PyPep8Naming
class AreaMomentOfInertia(ValueType, IQuantity[AreaMomentOfInertiaUnit], IQuantity, IFormattable, IEquatable[AreaMomentOfInertia], IComparable, IComparable[AreaMomentOfInertia], IConvertible):
    """ A geometric property of an area that reflects how its points are distributed with regard to an axis.
    """

    Info: typing.ClassVar[QuantityInfo[AreaMomentOfInertiaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AreaMomentOfInertiaUnit]

    MaxValue: typing.ClassVar[AreaMomentOfInertia]

    MinValue: typing.ClassVar[AreaMomentOfInertia]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AreaMomentOfInertiaUnit]]

    Zero: typing.ClassVar[AreaMomentOfInertia]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AreaMomentOfInertiaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AreaMomentOfInertiaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimetersToTheFourth(self) -> float:
        """ Get AreaMomentOfInertia in CentimetersToTheFourth.
        """
        pass

    @property
    def DecimetersToTheFourth(self) -> float:
        """ Get AreaMomentOfInertia in DecimetersToTheFourth.
        """
        pass

    @property
    def FeetToTheFourth(self) -> float:
        """ Get AreaMomentOfInertia in FeetToTheFourth.
        """
        pass

    @property
    def InchesToTheFourth(self) -> float:
        """ Get AreaMomentOfInertia in InchesToTheFourth.
        """
        pass

    @property
    def MetersToTheFourth(self) -> float:
        """ Get AreaMomentOfInertia in MetersToTheFourth.
        """
        pass

    @property
    def MillimetersToTheFourth(self) -> float:
        """ Get AreaMomentOfInertia in MillimetersToTheFourth.
        """
        pass

    def __init__(self, value: float, unit: AreaMomentOfInertiaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AreaMomentOfInertiaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaMomentOfInertiaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaMomentOfInertiaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaMomentOfInertiaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaMomentOfInertiaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimetersToTheFourth(centimeterstothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Get AreaMomentOfInertia from CentimetersToTheFourth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersToTheFourth(decimeterstothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Get AreaMomentOfInertia from DecimetersToTheFourth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetToTheFourth(feettothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Get AreaMomentOfInertia from FeetToTheFourth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesToTheFourth(inchestothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Get AreaMomentOfInertia from InchesToTheFourth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersToTheFourth(meterstothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Get AreaMomentOfInertia from MetersToTheFourth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersToTheFourth(millimeterstothefourth: QuantityValue) -> AreaMomentOfInertia:
        """ Get AreaMomentOfInertia from MillimetersToTheFourth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AreaMomentOfInertiaUnit) -> AreaMomentOfInertia:
        """ Dynamically convert from value and unit enum "AreaMomentOfInertiaUnit" to "AreaMomentOfInertia".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AreaMomentOfInertiaUnit
        :return: AreaMomentOfInertia unit value.
        :rtype: AreaMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> AreaMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> AreaMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: AreaMomentOfInertia) -> typing.Tuple[AreaMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AreaMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: AreaMomentOfInertia) -> typing.Tuple[AreaMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AreaMomentOfInertia
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AreaMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AreaMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AreaMomentOfInertiaUnit) -> typing.Tuple[AreaMomentOfInertiaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AreaMomentOfInertiaUnit) -> typing.Tuple[AreaMomentOfInertiaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AreaMomentOfInertiaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: AreaMomentOfInertia) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AreaMomentOfInertia) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AreaMomentOfInertia, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another AreaMomentOfInertia within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: AreaMomentOfInertia
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current AreaMomentOfInertia.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AreaMomentOfInertiaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AreaMomentOfInertiaUnit) -> AreaMomentOfInertia:
        """ Converts this AreaMomentOfInertia to another AreaMomentOfInertia with the unit representation .

        :return: A AreaMomentOfInertia with the specified unit.
        :rtype: AreaMomentOfInertia
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> AreaMomentOfInertia:
        """
        """
        pass


# noinspection PyPep8Naming
class BrakeSpecificFuelConsumption(ValueType, IQuantity[BrakeSpecificFuelConsumptionUnit], IQuantity, IFormattable, IEquatable[BrakeSpecificFuelConsumption], IComparable, IComparable[BrakeSpecificFuelConsumption], IConvertible):
    """ Brake specific fuel consumption (BSFC) is a measure of the fuel efficiency of any prime mover that burns fuel and produces rotational, or shaft, power. It is typically used for comparing the efficiency of internal combustion engines with a shaft output.
    """

    Info: typing.ClassVar[QuantityInfo[BrakeSpecificFuelConsumptionUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[BrakeSpecificFuelConsumptionUnit]

    MaxValue: typing.ClassVar[BrakeSpecificFuelConsumption]

    MinValue: typing.ClassVar[BrakeSpecificFuelConsumption]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[BrakeSpecificFuelConsumptionUnit]]

    Zero: typing.ClassVar[BrakeSpecificFuelConsumption]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> BrakeSpecificFuelConsumptionUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[BrakeSpecificFuelConsumptionUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GramsPerKiloWattHour(self) -> float:
        """ Get BrakeSpecificFuelConsumption in GramsPerKiloWattHour.
        """
        pass

    @property
    def KilogramsPerJoule(self) -> float:
        """ Get BrakeSpecificFuelConsumption in KilogramsPerJoule.
        """
        pass

    @property
    def PoundsPerMechanicalHorsepowerHour(self) -> float:
        """ Get BrakeSpecificFuelConsumption in PoundsPerMechanicalHorsepowerHour.
        """
        pass

    def __init__(self, value: float, unit: BrakeSpecificFuelConsumptionUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: BrakeSpecificFuelConsumptionUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: BrakeSpecificFuelConsumptionUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: BrakeSpecificFuelConsumptionUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: BrakeSpecificFuelConsumptionUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: BrakeSpecificFuelConsumptionUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramsPerKiloWattHour(gramsperkilowatthour: QuantityValue) -> BrakeSpecificFuelConsumption:
        """ Get BrakeSpecificFuelConsumption from GramsPerKiloWattHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerJoule(kilogramsperjoule: QuantityValue) -> BrakeSpecificFuelConsumption:
        """ Get BrakeSpecificFuelConsumption from KilogramsPerJoule.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerMechanicalHorsepowerHour(poundspermechanicalhorsepowerhour: QuantityValue) -> BrakeSpecificFuelConsumption:
        """ Get BrakeSpecificFuelConsumption from PoundsPerMechanicalHorsepowerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: BrakeSpecificFuelConsumptionUnit) -> BrakeSpecificFuelConsumption:
        """ Dynamically convert from value and unit enum "BrakeSpecificFuelConsumptionUnit" to "BrakeSpecificFuelConsumption".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: BrakeSpecificFuelConsumptionUnit
        :return: BrakeSpecificFuelConsumption unit value.
        :rtype: BrakeSpecificFuelConsumption
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> BrakeSpecificFuelConsumption:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> BrakeSpecificFuelConsumption:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: BrakeSpecificFuelConsumption) -> typing.Tuple[BrakeSpecificFuelConsumption, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: BrakeSpecificFuelConsumption
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: BrakeSpecificFuelConsumption) -> typing.Tuple[BrakeSpecificFuelConsumption, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: BrakeSpecificFuelConsumption
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> BrakeSpecificFuelConsumptionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> BrakeSpecificFuelConsumptionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: BrakeSpecificFuelConsumptionUnit) -> typing.Tuple[BrakeSpecificFuelConsumptionUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: BrakeSpecificFuelConsumptionUnit) -> typing.Tuple[BrakeSpecificFuelConsumptionUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: BrakeSpecificFuelConsumptionUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: BrakeSpecificFuelConsumption) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: BrakeSpecificFuelConsumption) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: BrakeSpecificFuelConsumption, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another BrakeSpecificFuelConsumption within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: BrakeSpecificFuelConsumption
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current BrakeSpecificFuelConsumption.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: BrakeSpecificFuelConsumptionUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: BrakeSpecificFuelConsumptionUnit) -> BrakeSpecificFuelConsumption:
        """ Converts this BrakeSpecificFuelConsumption to another BrakeSpecificFuelConsumption with the unit representation .

        :return: A BrakeSpecificFuelConsumption with the specified unit.
        :rtype: BrakeSpecificFuelConsumption
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> BrakeSpecificFuelConsumption:
        """
        """
        pass


# noinspection PyPep8Naming
class Density(ValueType, IQuantity[DensityUnit], IQuantity, IFormattable, IEquatable[Density], IComparable, IComparable[Density], IConvertible):
    """ The density, or more precisely, the volumetric mass density, of a substance is its mass per unit volume.
     http://en.wikipedia.org/wiki/Density
    """

    Info: typing.ClassVar[QuantityInfo[DensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[DensityUnit]

    MaxValue: typing.ClassVar[Density]

    MinValue: typing.ClassVar[Density]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[DensityUnit]]

    Zero: typing.ClassVar[Density]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> DensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[DensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentigramsPerDeciLiter(self) -> float:
        """ Get Density in CentigramsPerDeciLiter.
        """
        pass

    @property
    def CentigramsPerLiter(self) -> float:
        """ Get Density in CentigramsPerLiter.
        """
        pass

    @property
    def CentigramsPerMilliliter(self) -> float:
        """ Get Density in CentigramsPerMilliliter.
        """
        pass

    @property
    def DecigramsPerDeciLiter(self) -> float:
        """ Get Density in DecigramsPerDeciLiter.
        """
        pass

    @property
    def DecigramsPerLiter(self) -> float:
        """ Get Density in DecigramsPerLiter.
        """
        pass

    @property
    def DecigramsPerMilliliter(self) -> float:
        """ Get Density in DecigramsPerMilliliter.
        """
        pass

    @property
    def GramsPerCubicCentimeter(self) -> float:
        """ Get Density in GramsPerCubicCentimeter.
        """
        pass

    @property
    def GramsPerCubicMeter(self) -> float:
        """ Get Density in GramsPerCubicMeter.
        """
        pass

    @property
    def GramsPerCubicMillimeter(self) -> float:
        """ Get Density in GramsPerCubicMillimeter.
        """
        pass

    @property
    def GramsPerDeciLiter(self) -> float:
        """ Get Density in GramsPerDeciLiter.
        """
        pass

    @property
    def GramsPerLiter(self) -> float:
        """ Get Density in GramsPerLiter.
        """
        pass

    @property
    def GramsPerMilliliter(self) -> float:
        """ Get Density in GramsPerMilliliter.
        """
        pass

    @property
    def KilogramsPerCubicCentimeter(self) -> float:
        """ Get Density in KilogramsPerCubicCentimeter.
        """
        pass

    @property
    def KilogramsPerCubicMeter(self) -> float:
        """ Get Density in KilogramsPerCubicMeter.
        """
        pass

    @property
    def KilogramsPerCubicMillimeter(self) -> float:
        """ Get Density in KilogramsPerCubicMillimeter.
        """
        pass

    @property
    def KilogramsPerLiter(self) -> float:
        """ Get Density in KilogramsPerLiter.
        """
        pass

    @property
    def KilopoundsPerCubicFoot(self) -> float:
        """ Get Density in KilopoundsPerCubicFoot.
        """
        pass

    @property
    def KilopoundsPerCubicInch(self) -> float:
        """ Get Density in KilopoundsPerCubicInch.
        """
        pass

    @property
    def MicrogramsPerCubicMeter(self) -> float:
        """ Get Density in MicrogramsPerCubicMeter.
        """
        pass

    @property
    def MicrogramsPerDeciLiter(self) -> float:
        """ Get Density in MicrogramsPerDeciLiter.
        """
        pass

    @property
    def MicrogramsPerLiter(self) -> float:
        """ Get Density in MicrogramsPerLiter.
        """
        pass

    @property
    def MicrogramsPerMilliliter(self) -> float:
        """ Get Density in MicrogramsPerMilliliter.
        """
        pass

    @property
    def MilligramsPerCubicMeter(self) -> float:
        """ Get Density in MilligramsPerCubicMeter.
        """
        pass

    @property
    def MilligramsPerDeciLiter(self) -> float:
        """ Get Density in MilligramsPerDeciLiter.
        """
        pass

    @property
    def MilligramsPerLiter(self) -> float:
        """ Get Density in MilligramsPerLiter.
        """
        pass

    @property
    def MilligramsPerMilliliter(self) -> float:
        """ Get Density in MilligramsPerMilliliter.
        """
        pass

    @property
    def NanogramsPerDeciLiter(self) -> float:
        """ Get Density in NanogramsPerDeciLiter.
        """
        pass

    @property
    def NanogramsPerLiter(self) -> float:
        """ Get Density in NanogramsPerLiter.
        """
        pass

    @property
    def NanogramsPerMilliliter(self) -> float:
        """ Get Density in NanogramsPerMilliliter.
        """
        pass

    @property
    def PicogramsPerDeciLiter(self) -> float:
        """ Get Density in PicogramsPerDeciLiter.
        """
        pass

    @property
    def PicogramsPerLiter(self) -> float:
        """ Get Density in PicogramsPerLiter.
        """
        pass

    @property
    def PicogramsPerMilliliter(self) -> float:
        """ Get Density in PicogramsPerMilliliter.
        """
        pass

    @property
    def PoundsPerCubicFoot(self) -> float:
        """ Get Density in PoundsPerCubicFoot.
        """
        pass

    @property
    def PoundsPerCubicInch(self) -> float:
        """ Get Density in PoundsPerCubicInch.
        """
        pass

    @property
    def PoundsPerImperialGallon(self) -> float:
        """ Get Density in PoundsPerImperialGallon.
        """
        pass

    @property
    def PoundsPerUSGallon(self) -> float:
        """ Get Density in PoundsPerUSGallon.
        """
        pass

    @property
    def SlugsPerCubicFoot(self) -> float:
        """ Get Density in SlugsPerCubicFoot.
        """
        pass

    @property
    def TonnesPerCubicCentimeter(self) -> float:
        """ Get Density in TonnesPerCubicCentimeter.
        """
        pass

    @property
    def TonnesPerCubicMeter(self) -> float:
        """ Get Density in TonnesPerCubicMeter.
        """
        pass

    @property
    def TonnesPerCubicMillimeter(self) -> float:
        """ Get Density in TonnesPerCubicMillimeter.
        """
        pass

    def __init__(self, value: float, unit: DensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: DensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramsPerDeciLiter(gramsperdeciliter: QuantityValue) -> Density:
        """ Get Density from GramsPerDeciLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerLiter(gramsperliter: QuantityValue) -> Density:
        """ Get Density from GramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMilliliter(gramspermilliliter: QuantityValue) -> Density:
        """ Get Density from GramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicCentimeter(kilogramspercubiccentimeter: QuantityValue) -> Density:
        """ Get Density from KilogramsPerCubicCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicMeter(kilogramspercubicmeter: QuantityValue) -> Density:
        """ Get Density from KilogramsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicMillimeter(kilogramspercubicmillimeter: QuantityValue) -> Density:
        """ Get Density from KilogramsPerCubicMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerLiter(kilogramsperliter: QuantityValue) -> Density:
        """ Get Density from KilogramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsPerCubicFoot(kilopoundspercubicfoot: QuantityValue) -> Density:
        """ Get Density from KilopoundsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsPerCubicInch(kilopoundspercubicinch: QuantityValue) -> Density:
        """ Get Density from KilopoundsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerCubicMeter(microgramspercubicmeter: QuantityValue) -> Density:
        """ Get Density from MicrogramsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerDeciLiter(microgramsperdeciliter: QuantityValue) -> Density:
        """ Get Density from MicrogramsPerDeciLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerLiter(microgramsperliter: QuantityValue) -> Density:
        """ Get Density from MicrogramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMilliliter(microgramspermilliliter: QuantityValue) -> Density:
        """ Get Density from MicrogramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerCubicMeter(milligramspercubicmeter: QuantityValue) -> Density:
        """ Get Density from MilligramsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerDeciLiter(milligramsperdeciliter: QuantityValue) -> Density:
        """ Get Density from MilligramsPerDeciLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerLiter(milligramsperliter: QuantityValue) -> Density:
        """ Get Density from MilligramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMilliliter(milligramspermilliliter: QuantityValue) -> Density:
        """ Get Density from MilligramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerDeciLiter(nanogramsperdeciliter: QuantityValue) -> Density:
        """ Get Density from NanogramsPerDeciLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerLiter(nanogramsperliter: QuantityValue) -> Density:
        """ Get Density from NanogramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerMilliliter(nanogramspermilliliter: QuantityValue) -> Density:
        """ Get Density from NanogramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerDeciLiter(picogramsperdeciliter: QuantityValue) -> Density:
        """ Get Density from PicogramsPerDeciLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerLiter(picogramsperliter: QuantityValue) -> Density:
        """ Get Density from PicogramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerMilliliter(picogramspermilliliter: QuantityValue) -> Density:
        """ Get Density from PicogramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicFoot(poundspercubicfoot: QuantityValue) -> Density:
        """ Get Density from PoundsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicInch(poundspercubicinch: QuantityValue) -> Density:
        """ Get Density from PoundsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerImperialGallon(poundsperimperialgallon: QuantityValue) -> Density:
        """ Get Density from PoundsPerImperialGallon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerUSGallon(poundsperusgallon: QuantityValue) -> Density:
        """ Get Density from PoundsPerUSGallon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugsPerCubicFoot(slugspercubicfoot: QuantityValue) -> Density:
        """ Get Density from SlugsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicCentimeter(tonnespercubiccentimeter: QuantityValue) -> Density:
        """ Get Density from TonnesPerCubicCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicMeter(tonnespercubicmeter: QuantityValue) -> Density:
        """ Get Density from TonnesPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicMillimeter(tonnespercubicmillimeter: QuantityValue) -> Density:
        """ Get Density from TonnesPerCubicMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: DensityUnit) -> Density:
        """ Dynamically convert from value and unit enum "DensityUnit" to "Density".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: DensityUnit
        :return: Density unit value.
        :rtype: Density
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Density:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Density:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Density) -> typing.Tuple[Density, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Density
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Density) -> typing.Tuple[Density, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Density
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> DensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> DensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: DensityUnit) -> typing.Tuple[DensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: DensityUnit) -> typing.Tuple[DensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: DensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Density) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Density) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Density, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Density within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Density
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Density.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: DensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: DensityUnit) -> Density:
        """ Converts this Density to another Density with the unit representation .

        :return: A Density with the specified unit.
        :rtype: Density
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Density:
        """
        """
        pass

    def ToMolarity(self, molecularWeight: Mass) -> Molarity:
        """ Gets "Molarity" from this "Density".

        :param molecularWeight:
        :type molecularWeight: Mass
        """
        pass

    @staticmethod
    def FromMolarity(molarity: Molarity, molecularWeight: Mass) -> Density:
        """ Get "Density" from "Molarity".
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerDeciLiter(centigramsperdeciliter: QuantityValue) -> Density:
        """ Get Density from CentigramsPerDeciLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerLiter(centigramsperliter: QuantityValue) -> Density:
        """ Get Density from CentigramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerMilliliter(centigramspermilliliter: QuantityValue) -> Density:
        """ Get Density from CentigramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerDeciLiter(decigramsperdeciliter: QuantityValue) -> Density:
        """ Get Density from DecigramsPerDeciLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerLiter(decigramsperliter: QuantityValue) -> Density:
        """ Get Density from DecigramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerMilliliter(decigramspermilliliter: QuantityValue) -> Density:
        """ Get Density from DecigramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicCentimeter(gramspercubiccentimeter: QuantityValue) -> Density:
        """ Get Density from GramsPerCubicCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicMeter(gramspercubicmeter: QuantityValue) -> Density:
        """ Get Density from GramsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicMillimeter(gramspercubicmillimeter: QuantityValue) -> Density:
        """ Get Density from GramsPerCubicMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class Duration(ValueType, IQuantity[DurationUnit], IQuantity, IFormattable, IEquatable[Duration], IComparable, IComparable[Duration], IConvertible):
    """ Time is a dimension in which events can be ordered from the past through the present into the future, and also the measure of durations of events and the intervals between them.
    """

    Info: typing.ClassVar[QuantityInfo[DurationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[DurationUnit]

    MaxValue: typing.ClassVar[Duration]

    MinValue: typing.ClassVar[Duration]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[DurationUnit]]

    Zero: typing.ClassVar[Duration]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> DurationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[DurationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Days(self) -> float:
        """ Get Duration in Days.
        """
        pass

    @property
    def Hours(self) -> float:
        """ Get Duration in Hours.
        """
        pass

    @property
    def Microseconds(self) -> float:
        """ Get Duration in Microseconds.
        """
        pass

    @property
    def Milliseconds(self) -> float:
        """ Get Duration in Milliseconds.
        """
        pass

    @property
    def Minutes(self) -> float:
        """ Get Duration in Minutes.
        """
        pass

    @property
    def Months30(self) -> float:
        """ Get Duration in Months30.
        """
        pass

    @property
    def Nanoseconds(self) -> float:
        """ Get Duration in Nanoseconds.
        """
        pass

    @property
    def Seconds(self) -> float:
        """ Get Duration in Seconds.
        """
        pass

    @property
    def Weeks(self) -> float:
        """ Get Duration in Weeks.
        """
        pass

    @property
    def Years365(self) -> float:
        """ Get Duration in Years365.
        """
        pass

    def __init__(self, value: float, unit: DurationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: DurationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Duration) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Duration) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Duration, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Duration within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Duration
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Duration.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: DurationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: DurationUnit) -> Duration:
        """ Converts this Duration to another Duration with the unit representation .

        :return: A Duration with the specified unit.
        :rtype: Duration
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Duration:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToTimeSpan(self) -> TimeSpan:
        """ Convert a Duration to a TimeSpan.

        :return: The TimeSpan with the same time as the duration
        :rtype: TimeSpan

        :exception ArgumentOutOfRangeException: Throws if the TimeSpan can't represent the Duration exactly
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DurationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DurationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DurationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DurationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDays(days: QuantityValue) -> Duration:
        """ Get Duration from Days.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHours(hours: QuantityValue) -> Duration:
        """ Get Duration from Hours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroseconds(microseconds: QuantityValue) -> Duration:
        """ Get Duration from Microseconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliseconds(milliseconds: QuantityValue) -> Duration:
        """ Get Duration from Milliseconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMinutes(minutes: QuantityValue) -> Duration:
        """ Get Duration from Minutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMonths30(months30: QuantityValue) -> Duration:
        """ Get Duration from Months30.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoseconds(nanoseconds: QuantityValue) -> Duration:
        """ Get Duration from Nanoseconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSeconds(seconds: QuantityValue) -> Duration:
        """ Get Duration from Seconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWeeks(weeks: QuantityValue) -> Duration:
        """ Get Duration from Weeks.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromYears365(years365: QuantityValue) -> Duration:
        """ Get Duration from Years365.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: DurationUnit) -> Duration:
        """ Dynamically convert from value and unit enum "DurationUnit" to "Duration".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: DurationUnit
        :return: Duration unit value.
        :rtype: Duration
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Duration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Duration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Duration) -> typing.Tuple[Duration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Duration
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Duration) -> typing.Tuple[Duration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Duration
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> DurationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> DurationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: DurationUnit) -> typing.Tuple[DurationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: DurationUnit) -> typing.Tuple[DurationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: DurationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class DynamicViscosity(ValueType, IQuantity[DynamicViscosityUnit], IQuantity, IFormattable, IEquatable[DynamicViscosity], IComparable, IComparable[DynamicViscosity], IConvertible):
    """ The dynamic (shear) viscosity of a fluid expresses its resistance to shearing flows, where adjacent layers move parallel to each other with different speeds
     https://en.wikipedia.org/wiki/Viscosity#Dynamic_.28shear.29_viscosity
    """

    Info: typing.ClassVar[QuantityInfo[DynamicViscosityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[DynamicViscosityUnit]

    MaxValue: typing.ClassVar[DynamicViscosity]

    MinValue: typing.ClassVar[DynamicViscosity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[DynamicViscosityUnit]]

    Zero: typing.ClassVar[DynamicViscosity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> DynamicViscosityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[DynamicViscosityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Centipoise(self) -> float:
        """ Get DynamicViscosity in Centipoise.
        """
        pass

    @property
    def MicropascalSeconds(self) -> float:
        """ Get DynamicViscosity in MicropascalSeconds.
        """
        pass

    @property
    def MillipascalSeconds(self) -> float:
        """ Get DynamicViscosity in MillipascalSeconds.
        """
        pass

    @property
    def NewtonSecondsPerMeterSquared(self) -> float:
        """ Get DynamicViscosity in NewtonSecondsPerMeterSquared.
        """
        pass

    @property
    def PascalSeconds(self) -> float:
        """ Get DynamicViscosity in PascalSeconds.
        """
        pass

    @property
    def Poise(self) -> float:
        """ Get DynamicViscosity in Poise.
        """
        pass

    @property
    def PoundsForceSecondPerSquareFoot(self) -> float:
        """ Get DynamicViscosity in PoundsForceSecondPerSquareFoot.
        """
        pass

    @property
    def PoundsForceSecondPerSquareInch(self) -> float:
        """ Get DynamicViscosity in PoundsForceSecondPerSquareInch.
        """
        pass

    @property
    def PoundsPerFootSecond(self) -> float:
        """ Get DynamicViscosity in PoundsPerFootSecond.
        """
        pass

    @property
    def Reyns(self) -> float:
        """ Get DynamicViscosity in Reyns.
        """
        pass

    def __init__(self, value: float, unit: DynamicViscosityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: DynamicViscosityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: DynamicViscosityUnit) -> DynamicViscosity:
        """ Converts this DynamicViscosity to another DynamicViscosity with the unit representation .

        :return: A DynamicViscosity with the specified unit.
        :rtype: DynamicViscosity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> DynamicViscosity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DynamicViscosityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DynamicViscosityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: DynamicViscosityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: DynamicViscosityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentipoise(centipoise: QuantityValue) -> DynamicViscosity:
        """ Get DynamicViscosity from Centipoise.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicropascalSeconds(micropascalseconds: QuantityValue) -> DynamicViscosity:
        """ Get DynamicViscosity from MicropascalSeconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillipascalSeconds(millipascalseconds: QuantityValue) -> DynamicViscosity:
        """ Get DynamicViscosity from MillipascalSeconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonSecondsPerMeterSquared(newtonsecondspermetersquared: QuantityValue) -> DynamicViscosity:
        """ Get DynamicViscosity from NewtonSecondsPerMeterSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPascalSeconds(pascalseconds: QuantityValue) -> DynamicViscosity:
        """ Get DynamicViscosity from PascalSeconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoise(poise: QuantityValue) -> DynamicViscosity:
        """ Get DynamicViscosity from Poise.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForceSecondPerSquareFoot(poundsforcesecondpersquarefoot: QuantityValue) -> DynamicViscosity:
        """ Get DynamicViscosity from PoundsForceSecondPerSquareFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForceSecondPerSquareInch(poundsforcesecondpersquareinch: QuantityValue) -> DynamicViscosity:
        """ Get DynamicViscosity from PoundsForceSecondPerSquareInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerFootSecond(poundsperfootsecond: QuantityValue) -> DynamicViscosity:
        """ Get DynamicViscosity from PoundsPerFootSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromReyns(reyns: QuantityValue) -> DynamicViscosity:
        """ Get DynamicViscosity from Reyns.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: DynamicViscosityUnit) -> DynamicViscosity:
        """ Dynamically convert from value and unit enum "DynamicViscosityUnit" to "DynamicViscosity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: DynamicViscosityUnit
        :return: DynamicViscosity unit value.
        :rtype: DynamicViscosity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> DynamicViscosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> DynamicViscosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: DynamicViscosity) -> typing.Tuple[DynamicViscosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: DynamicViscosity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: DynamicViscosity) -> typing.Tuple[DynamicViscosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: DynamicViscosity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> DynamicViscosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> DynamicViscosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: DynamicViscosityUnit) -> typing.Tuple[DynamicViscosityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: DynamicViscosityUnit) -> typing.Tuple[DynamicViscosityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: DynamicViscosityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: DynamicViscosity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: DynamicViscosity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: DynamicViscosity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another DynamicViscosity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: DynamicViscosity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current DynamicViscosity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: DynamicViscosityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricCharge(ValueType, IQuantity[ElectricChargeUnit], IQuantity, IFormattable, IEquatable[ElectricCharge], IComparable, IComparable[ElectricCharge], IConvertible):
    """ Electric charge is the physical property of matter that causes it to experience a force when placed in an electromagnetic field.
     https://en.wikipedia.org/wiki/Electric_charge
    """

    Info: typing.ClassVar[QuantityInfo[ElectricChargeUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricChargeUnit]

    MaxValue: typing.ClassVar[ElectricCharge]

    MinValue: typing.ClassVar[ElectricCharge]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricChargeUnit]]

    Zero: typing.ClassVar[ElectricCharge]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricChargeUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricChargeUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AmpereHours(self) -> float:
        """ Get ElectricCharge in AmpereHours.
        """
        pass

    @property
    def Coulombs(self) -> float:
        """ Get ElectricCharge in Coulombs.
        """
        pass

    @property
    def KiloampereHours(self) -> float:
        """ Get ElectricCharge in KiloampereHours.
        """
        pass

    @property
    def MegaampereHours(self) -> float:
        """ Get ElectricCharge in MegaampereHours.
        """
        pass

    @property
    def MilliampereHours(self) -> float:
        """ Get ElectricCharge in MilliampereHours.
        """
        pass

    def __init__(self, value: float, unit: ElectricChargeUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricChargeUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricChargeUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricChargeUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricChargeUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricChargeUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmpereHours(amperehours: QuantityValue) -> ElectricCharge:
        """ Get ElectricCharge from AmpereHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCoulombs(coulombs: QuantityValue) -> ElectricCharge:
        """ Get ElectricCharge from Coulombs.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloampereHours(kiloamperehours: QuantityValue) -> ElectricCharge:
        """ Get ElectricCharge from KiloampereHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaampereHours(megaamperehours: QuantityValue) -> ElectricCharge:
        """ Get ElectricCharge from MegaampereHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliampereHours(milliamperehours: QuantityValue) -> ElectricCharge:
        """ Get ElectricCharge from MilliampereHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricChargeUnit) -> ElectricCharge:
        """ Dynamically convert from value and unit enum "ElectricChargeUnit" to "ElectricCharge".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricChargeUnit
        :return: ElectricCharge unit value.
        :rtype: ElectricCharge
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricCharge:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricCharge:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricCharge) -> typing.Tuple[ElectricCharge, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCharge
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricCharge) -> typing.Tuple[ElectricCharge, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCharge
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricChargeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricChargeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricChargeUnit) -> typing.Tuple[ElectricChargeUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricChargeUnit) -> typing.Tuple[ElectricChargeUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricChargeUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricCharge) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCharge) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCharge, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricCharge within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricCharge
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricCharge.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricChargeUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricChargeUnit) -> ElectricCharge:
        """ Converts this ElectricCharge to another ElectricCharge with the unit representation .

        :return: A ElectricCharge with the specified unit.
        :rtype: ElectricCharge
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricCharge:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricCurrent(ValueType, IQuantity[ElectricCurrentUnit], IQuantity, IFormattable, IEquatable[ElectricCurrent], IComparable, IComparable[ElectricCurrent], IConvertible):
    """ An electric current is a flow of electric charge. In electric circuits this charge is often carried by moving electrons in a wire. It can also be carried by ions in an electrolyte, or by both ions and electrons such as in a plasma.
    """

    Info: typing.ClassVar[QuantityInfo[ElectricCurrentUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricCurrentUnit]

    MaxValue: typing.ClassVar[ElectricCurrent]

    MinValue: typing.ClassVar[ElectricCurrent]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricCurrentUnit]]

    Zero: typing.ClassVar[ElectricCurrent]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricCurrentUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricCurrentUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Amperes(self) -> float:
        """ Get ElectricCurrent in Amperes.
        """
        pass

    @property
    def Centiamperes(self) -> float:
        """ Get ElectricCurrent in Centiamperes.
        """
        pass

    @property
    def Kiloamperes(self) -> float:
        """ Get ElectricCurrent in Kiloamperes.
        """
        pass

    @property
    def Megaamperes(self) -> float:
        """ Get ElectricCurrent in Megaamperes.
        """
        pass

    @property
    def Microamperes(self) -> float:
        """ Get ElectricCurrent in Microamperes.
        """
        pass

    @property
    def Milliamperes(self) -> float:
        """ Get ElectricCurrent in Milliamperes.
        """
        pass

    @property
    def Nanoamperes(self) -> float:
        """ Get ElectricCurrent in Nanoamperes.
        """
        pass

    @property
    def Picoamperes(self) -> float:
        """ Get ElectricCurrent in Picoamperes.
        """
        pass

    def __init__(self, value: float, unit: ElectricCurrentUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricCurrentUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricCurrent:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmperes(amperes: QuantityValue) -> ElectricCurrent:
        """ Get ElectricCurrent from Amperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentiamperes(centiamperes: QuantityValue) -> ElectricCurrent:
        """ Get ElectricCurrent from Centiamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloamperes(kiloamperes: QuantityValue) -> ElectricCurrent:
        """ Get ElectricCurrent from Kiloamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaamperes(megaamperes: QuantityValue) -> ElectricCurrent:
        """ Get ElectricCurrent from Megaamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroamperes(microamperes: QuantityValue) -> ElectricCurrent:
        """ Get ElectricCurrent from Microamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliamperes(milliamperes: QuantityValue) -> ElectricCurrent:
        """ Get ElectricCurrent from Milliamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoamperes(nanoamperes: QuantityValue) -> ElectricCurrent:
        """ Get ElectricCurrent from Nanoamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicoamperes(picoamperes: QuantityValue) -> ElectricCurrent:
        """ Get ElectricCurrent from Picoamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricCurrentUnit) -> ElectricCurrent:
        """ Dynamically convert from value and unit enum "ElectricCurrentUnit" to "ElectricCurrent".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricCurrentUnit
        :return: ElectricCurrent unit value.
        :rtype: ElectricCurrent
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricCurrent:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricCurrent:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricCurrent) -> typing.Tuple[ElectricCurrent, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrent
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricCurrent) -> typing.Tuple[ElectricCurrent, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrent
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricCurrentUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricCurrentUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricCurrentUnit) -> typing.Tuple[ElectricCurrentUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricCurrentUnit) -> typing.Tuple[ElectricCurrentUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricCurrentUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricCurrent) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrent) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrent, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricCurrent within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricCurrent
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricCurrent.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricCurrentUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricCurrentUnit) -> ElectricCurrent:
        """ Converts this ElectricCurrent to another ElectricCurrent with the unit representation .

        :return: A ElectricCurrent with the specified unit.
        :rtype: ElectricCurrent
        """
        pass


# noinspection PyPep8Naming
class ElectricPotential(ValueType, IQuantity[ElectricPotentialUnit], IQuantity, IFormattable, IEquatable[ElectricPotential], IComparable, IComparable[ElectricPotential], IConvertible):
    """ In classical electromagnetism, the electric potential (a scalar quantity denoted by Φ, ΦE or V and also called the electric field potential or the electrostatic potential) at a point is the amount of electric potential energy that a unitary point charge would have when located at that point.
    """

    Info: typing.ClassVar[QuantityInfo[ElectricPotentialUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricPotentialUnit]

    MaxValue: typing.ClassVar[ElectricPotential]

    MinValue: typing.ClassVar[ElectricPotential]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricPotentialUnit]]

    Zero: typing.ClassVar[ElectricPotential]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricPotentialUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricPotentialUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Kilovolts(self) -> float:
        """ Get ElectricPotential in Kilovolts.
        """
        pass

    @property
    def Megavolts(self) -> float:
        """ Get ElectricPotential in Megavolts.
        """
        pass

    @property
    def Microvolts(self) -> float:
        """ Get ElectricPotential in Microvolts.
        """
        pass

    @property
    def Millivolts(self) -> float:
        """ Get ElectricPotential in Millivolts.
        """
        pass

    @property
    def Volts(self) -> float:
        """ Get ElectricPotential in Volts.
        """
        pass

    def __init__(self, value: float, unit: ElectricPotentialUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricPotentialUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToAmplitudeRatio(self) -> AmplitudeRatio:
        """ Gets an "AmplitudeRatio" in decibels (dB) relative to 1 volt RMS from this "ElectricPotential".
         Provides a nicer syntax for converting a voltage to an amplitude ratio (relative to 1 volt RMS).
         var voltageRatio = voltage.ToAmplitudeRatio();
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovolts(kilovolts: QuantityValue) -> ElectricPotential:
        """ Get ElectricPotential from Kilovolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavolts(megavolts: QuantityValue) -> ElectricPotential:
        """ Get ElectricPotential from Megavolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovolts(microvolts: QuantityValue) -> ElectricPotential:
        """ Get ElectricPotential from Microvolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivolts(millivolts: QuantityValue) -> ElectricPotential:
        """ Get ElectricPotential from Millivolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVolts(volts: QuantityValue) -> ElectricPotential:
        """ Get ElectricPotential from Volts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricPotentialUnit) -> ElectricPotential:
        """ Dynamically convert from value and unit enum "ElectricPotentialUnit" to "ElectricPotential".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricPotentialUnit
        :return: ElectricPotential unit value.
        :rtype: ElectricPotential
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricPotential:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricPotential:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricPotential) -> typing.Tuple[ElectricPotential, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotential
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricPotential) -> typing.Tuple[ElectricPotential, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotential
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricPotentialUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricPotentialUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricPotentialUnit) -> typing.Tuple[ElectricPotentialUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricPotentialUnit) -> typing.Tuple[ElectricPotentialUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricPotentialUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricPotential) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotential) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotential, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricPotential within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricPotential
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricPotential.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricPotentialUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialUnit) -> ElectricPotential:
        """ Converts this ElectricPotential to another ElectricPotential with the unit representation .

        :return: A ElectricPotential with the specified unit.
        :rtype: ElectricPotential
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricPotential:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricResistance(ValueType, IQuantity[ElectricResistanceUnit], IQuantity, IFormattable, IEquatable[ElectricResistance], IComparable, IComparable[ElectricResistance], IConvertible):
    """ The electrical resistance of an electrical conductor is the opposition to the passage of an electric current through that conductor.
    """

    Info: typing.ClassVar[QuantityInfo[ElectricResistanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricResistanceUnit]

    MaxValue: typing.ClassVar[ElectricResistance]

    MinValue: typing.ClassVar[ElectricResistance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricResistanceUnit]]

    Zero: typing.ClassVar[ElectricResistance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricResistanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricResistanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Gigaohms(self) -> float:
        """ Get ElectricResistance in Gigaohms.
        """
        pass

    @property
    def Kiloohms(self) -> float:
        """ Get ElectricResistance in Kiloohms.
        """
        pass

    @property
    def Megaohms(self) -> float:
        """ Get ElectricResistance in Megaohms.
        """
        pass

    @property
    def Microohms(self) -> float:
        """ Get ElectricResistance in Microohms.
        """
        pass

    @property
    def Milliohms(self) -> float:
        """ Get ElectricResistance in Milliohms.
        """
        pass

    @property
    def Ohms(self) -> float:
        """ Get ElectricResistance in Ohms.
        """
        pass

    def __init__(self, value: float, unit: ElectricResistanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricResistanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricResistanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricResistanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricResistanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricResistanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGigaohms(gigaohms: QuantityValue) -> ElectricResistance:
        """ Get ElectricResistance from Gigaohms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloohms(kiloohms: QuantityValue) -> ElectricResistance:
        """ Get ElectricResistance from Kiloohms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaohms(megaohms: QuantityValue) -> ElectricResistance:
        """ Get ElectricResistance from Megaohms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroohms(microohms: QuantityValue) -> ElectricResistance:
        """ Get ElectricResistance from Microohms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliohms(milliohms: QuantityValue) -> ElectricResistance:
        """ Get ElectricResistance from Milliohms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOhms(ohms: QuantityValue) -> ElectricResistance:
        """ Get ElectricResistance from Ohms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricResistanceUnit) -> ElectricResistance:
        """ Dynamically convert from value and unit enum "ElectricResistanceUnit" to "ElectricResistance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricResistanceUnit
        :return: ElectricResistance unit value.
        :rtype: ElectricResistance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricResistance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricResistance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricResistance) -> typing.Tuple[ElectricResistance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricResistance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricResistance) -> typing.Tuple[ElectricResistance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricResistance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricResistanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricResistanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricResistanceUnit) -> typing.Tuple[ElectricResistanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricResistanceUnit) -> typing.Tuple[ElectricResistanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricResistanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricResistance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricResistance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricResistance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricResistance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricResistance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricResistance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricResistanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricResistanceUnit) -> ElectricResistance:
        """ Converts this ElectricResistance to another ElectricResistance with the unit representation .

        :return: A ElectricResistance with the specified unit.
        :rtype: ElectricResistance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricResistance:
        """
        """
        pass


# noinspection PyPep8Naming
class Force(ValueType, IQuantity[ForceUnit], IQuantity, IFormattable, IEquatable[Force], IComparable, IComparable[Force], IConvertible):
    """ In physics, a force is any influence that causes an object to undergo a certain change, either concerning its movement, direction, or geometrical construction. In other words, a force can cause an object with mass to change its velocity (which includes to begin moving from a state of rest), i.e., to accelerate, or a flexible object to deform, or both. Force can also be described by intuitive concepts such as a push or a pull. A force has both magnitude and direction, making it a vector quantity. It is measured in the SI unit of newtons and represented by the symbol F.
    """

    Info: typing.ClassVar[QuantityInfo[ForceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ForceUnit]

    MaxValue: typing.ClassVar[Force]

    MinValue: typing.ClassVar[Force]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ForceUnit]]

    Zero: typing.ClassVar[Force]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ForceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ForceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Decanewtons(self) -> float:
        """ Get Force in Decanewtons.
        """
        pass

    @property
    def Dyne(self) -> float:
        """ Get Force in Dyne.
        """
        pass

    @property
    def KilogramsForce(self) -> float:
        """ Get Force in KilogramsForce.
        """
        pass

    @property
    def Kilonewtons(self) -> float:
        """ Get Force in Kilonewtons.
        """
        pass

    @property
    def KiloPonds(self) -> float:
        """ Get Force in KiloPonds.
        """
        pass

    @property
    def KilopoundsForce(self) -> float:
        """ Get Force in KilopoundsForce.
        """
        pass

    @property
    def Meganewtons(self) -> float:
        """ Get Force in Meganewtons.
        """
        pass

    @property
    def Micronewtons(self) -> float:
        """ Get Force in Micronewtons.
        """
        pass

    @property
    def Millinewtons(self) -> float:
        """ Get Force in Millinewtons.
        """
        pass

    @property
    def Newtons(self) -> float:
        """ Get Force in Newtons.
        """
        pass

    @property
    def OunceForce(self) -> float:
        """ Get Force in OunceForce.
        """
        pass

    @property
    def Poundals(self) -> float:
        """ Get Force in Poundals.
        """
        pass

    @property
    def PoundsForce(self) -> float:
        """ Get Force in PoundsForce.
        """
        pass

    @property
    def ShortTonsForce(self) -> float:
        """ Get Force in ShortTonsForce.
        """
        pass

    @property
    def TonnesForce(self) -> float:
        """ Get Force in TonnesForce.
        """
        pass

    def __init__(self, value: float, unit: ForceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ForceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Force) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Force) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Force, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Force within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Force
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Force.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ForceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ForceUnit) -> Force:
        """ Converts this Force to another Force with the unit representation .

        :return: A Force with the specified unit.
        :rtype: Force
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Force:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromPressureByArea(p: Pressure, area: Area) -> Force:
        """Get "Force" from "Pressure" divided by "Area".
        """
        pass

    @staticmethod
    def FromMassByAcceleration(mass: Mass, acceleration: Acceleration) -> Force:
        """Get "Force" from "Mass" times "Acceleration".
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecanewtons(decanewtons: QuantityValue) -> Force:
        """ Get Force from Decanewtons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDyne(dyne: QuantityValue) -> Force:
        """ Get Force from Dyne.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForce(kilogramsforce: QuantityValue) -> Force:
        """ Get Force from KilogramsForce.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtons(kilonewtons: QuantityValue) -> Force:
        """ Get Force from Kilonewtons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloPonds(kiloponds: QuantityValue) -> Force:
        """ Get Force from KiloPonds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForce(kilopoundsforce: QuantityValue) -> Force:
        """ Get Force from KilopoundsForce.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtons(meganewtons: QuantityValue) -> Force:
        """ Get Force from Meganewtons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtons(micronewtons: QuantityValue) -> Force:
        """ Get Force from Micronewtons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtons(millinewtons: QuantityValue) -> Force:
        """ Get Force from Millinewtons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtons(newtons: QuantityValue) -> Force:
        """ Get Force from Newtons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOunceForce(ounceforce: QuantityValue) -> Force:
        """ Get Force from OunceForce.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundals(poundals: QuantityValue) -> Force:
        """ Get Force from Poundals.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForce(poundsforce: QuantityValue) -> Force:
        """ Get Force from PoundsForce.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromShortTonsForce(shorttonsforce: QuantityValue) -> Force:
        """ Get Force from ShortTonsForce.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForce(tonnesforce: QuantityValue) -> Force:
        """ Get Force from TonnesForce.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ForceUnit) -> Force:
        """ Dynamically convert from value and unit enum "ForceUnit" to "Force".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ForceUnit
        :return: Force unit value.
        :rtype: Force
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Force:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Force:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Force) -> typing.Tuple[Force, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Force
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Force) -> typing.Tuple[Force, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Force
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ForceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ForceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ForceUnit) -> typing.Tuple[ForceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ForceUnit) -> typing.Tuple[ForceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ForceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class ForcePerLength(ValueType, IQuantity[ForcePerLengthUnit], IQuantity, IFormattable, IEquatable[ForcePerLength], IComparable, IComparable[ForcePerLength], IConvertible):
    """ The magnitude of force per unit length.
    """

    Info: typing.ClassVar[QuantityInfo[ForcePerLengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ForcePerLengthUnit]

    MaxValue: typing.ClassVar[ForcePerLength]

    MinValue: typing.ClassVar[ForcePerLength]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ForcePerLengthUnit]]

    Zero: typing.ClassVar[ForcePerLength]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ForcePerLengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ForcePerLengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentinewtonsPerCentimeter(self) -> float:
        """ Get ForcePerLength in CentinewtonsPerCentimeter.
        """
        pass

    @property
    def CentinewtonsPerMeter(self) -> float:
        """ Get ForcePerLength in CentinewtonsPerMeter.
        """
        pass

    @property
    def CentinewtonsPerMillimeter(self) -> float:
        """ Get ForcePerLength in CentinewtonsPerMillimeter.
        """
        pass

    @property
    def DecanewtonsPerCentimeter(self) -> float:
        """ Get ForcePerLength in DecanewtonsPerCentimeter.
        """
        pass

    @property
    def DecanewtonsPerMeter(self) -> float:
        """ Get ForcePerLength in DecanewtonsPerMeter.
        """
        pass

    @property
    def DecanewtonsPerMillimeter(self) -> float:
        """ Get ForcePerLength in DecanewtonsPerMillimeter.
        """
        pass

    @property
    def DecinewtonsPerCentimeter(self) -> float:
        """ Get ForcePerLength in DecinewtonsPerCentimeter.
        """
        pass

    @property
    def DecinewtonsPerMeter(self) -> float:
        """ Get ForcePerLength in DecinewtonsPerMeter.
        """
        pass

    @property
    def DecinewtonsPerMillimeter(self) -> float:
        """ Get ForcePerLength in DecinewtonsPerMillimeter.
        """
        pass

    @property
    def KilogramsForcePerCentimeter(self) -> float:
        """ Get ForcePerLength in KilogramsForcePerCentimeter.
        """
        pass

    @property
    def KilogramsForcePerMeter(self) -> float:
        """ Get ForcePerLength in KilogramsForcePerMeter.
        """
        pass

    @property
    def KilogramsForcePerMillimeter(self) -> float:
        """ Get ForcePerLength in KilogramsForcePerMillimeter.
        """
        pass

    @property
    def KilonewtonsPerCentimeter(self) -> float:
        """ Get ForcePerLength in KilonewtonsPerCentimeter.
        """
        pass

    @property
    def KilonewtonsPerMeter(self) -> float:
        """ Get ForcePerLength in KilonewtonsPerMeter.
        """
        pass

    @property
    def KilonewtonsPerMillimeter(self) -> float:
        """ Get ForcePerLength in KilonewtonsPerMillimeter.
        """
        pass

    @property
    def KilopoundsForcePerFoot(self) -> float:
        """ Get ForcePerLength in KilopoundsForcePerFoot.
        """
        pass

    @property
    def KilopoundsForcePerInch(self) -> float:
        """ Get ForcePerLength in KilopoundsForcePerInch.
        """
        pass

    @property
    def MeganewtonsPerCentimeter(self) -> float:
        """ Get ForcePerLength in MeganewtonsPerCentimeter.
        """
        pass

    @property
    def MeganewtonsPerMeter(self) -> float:
        """ Get ForcePerLength in MeganewtonsPerMeter.
        """
        pass

    @property
    def MeganewtonsPerMillimeter(self) -> float:
        """ Get ForcePerLength in MeganewtonsPerMillimeter.
        """
        pass

    @property
    def MicronewtonsPerCentimeter(self) -> float:
        """ Get ForcePerLength in MicronewtonsPerCentimeter.
        """
        pass

    @property
    def MicronewtonsPerMeter(self) -> float:
        """ Get ForcePerLength in MicronewtonsPerMeter.
        """
        pass

    @property
    def MicronewtonsPerMillimeter(self) -> float:
        """ Get ForcePerLength in MicronewtonsPerMillimeter.
        """
        pass

    @property
    def MillinewtonsPerCentimeter(self) -> float:
        """ Get ForcePerLength in MillinewtonsPerCentimeter.
        """
        pass

    @property
    def MillinewtonsPerMeter(self) -> float:
        """ Get ForcePerLength in MillinewtonsPerMeter.
        """
        pass

    @property
    def MillinewtonsPerMillimeter(self) -> float:
        """ Get ForcePerLength in MillinewtonsPerMillimeter.
        """
        pass

    @property
    def NanonewtonsPerCentimeter(self) -> float:
        """ Get ForcePerLength in NanonewtonsPerCentimeter.
        """
        pass

    @property
    def NanonewtonsPerMeter(self) -> float:
        """ Get ForcePerLength in NanonewtonsPerMeter.
        """
        pass

    @property
    def NanonewtonsPerMillimeter(self) -> float:
        """ Get ForcePerLength in NanonewtonsPerMillimeter.
        """
        pass

    @property
    def NewtonsPerCentimeter(self) -> float:
        """ Get ForcePerLength in NewtonsPerCentimeter.
        """
        pass

    @property
    def NewtonsPerMeter(self) -> float:
        """ Get ForcePerLength in NewtonsPerMeter.
        """
        pass

    @property
    def NewtonsPerMillimeter(self) -> float:
        """ Get ForcePerLength in NewtonsPerMillimeter.
        """
        pass

    @property
    def PoundsForcePerFoot(self) -> float:
        """ Get ForcePerLength in PoundsForcePerFoot.
        """
        pass

    @property
    def PoundsForcePerInch(self) -> float:
        """ Get ForcePerLength in PoundsForcePerInch.
        """
        pass

    @property
    def PoundsForcePerYard(self) -> float:
        """ Get ForcePerLength in PoundsForcePerYard.
        """
        pass

    @property
    def TonnesForcePerCentimeter(self) -> float:
        """ Get ForcePerLength in TonnesForcePerCentimeter.
        """
        pass

    @property
    def TonnesForcePerMeter(self) -> float:
        """ Get ForcePerLength in TonnesForcePerMeter.
        """
        pass

    @property
    def TonnesForcePerMillimeter(self) -> float:
        """ Get ForcePerLength in TonnesForcePerMillimeter.
        """
        pass

    def __init__(self, value: float, unit: ForcePerLengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ForcePerLengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerInch(kilopoundsforceperinch: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from KilopoundsForcePerInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonsPerCentimeter(meganewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from MeganewtonsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonsPerMeter(meganewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from MeganewtonsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonsPerMillimeter(meganewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from MeganewtonsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonsPerCentimeter(micronewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from MicronewtonsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonsPerMeter(micronewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from MicronewtonsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonsPerMillimeter(micronewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from MicronewtonsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonsPerCentimeter(millinewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from MillinewtonsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonsPerMeter(millinewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from MillinewtonsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonsPerMillimeter(millinewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from MillinewtonsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonsPerCentimeter(nanonewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from NanonewtonsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonsPerMeter(nanonewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from NanonewtonsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonsPerMillimeter(nanonewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from NanonewtonsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerCentimeter(newtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from NewtonsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerMeter(newtonspermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from NewtonsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerMillimeter(newtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from NewtonsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerFoot(poundsforceperfoot: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from PoundsForcePerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerInch(poundsforceperinch: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from PoundsForcePerInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerYard(poundsforceperyard: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from PoundsForcePerYard.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerCentimeter(tonnesforcepercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from TonnesForcePerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerMeter(tonnesforcepermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from TonnesForcePerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerMillimeter(tonnesforcepermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from TonnesForcePerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ForcePerLengthUnit) -> ForcePerLength:
        """ Dynamically convert from value and unit enum "ForcePerLengthUnit" to "ForcePerLength".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ForcePerLengthUnit
        :return: ForcePerLength unit value.
        :rtype: ForcePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ForcePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ForcePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ForcePerLength) -> typing.Tuple[ForcePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ForcePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ForcePerLength) -> typing.Tuple[ForcePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ForcePerLength
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ForcePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ForcePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ForcePerLengthUnit) -> typing.Tuple[ForcePerLengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ForcePerLengthUnit) -> typing.Tuple[ForcePerLengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ForcePerLengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ForcePerLength) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ForcePerLength) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ForcePerLength, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ForcePerLength within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ForcePerLength
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ForcePerLength.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ForcePerLengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ForcePerLengthUnit) -> ForcePerLength:
        """ Converts this ForcePerLength to another ForcePerLength with the unit representation .

        :return: A ForcePerLength with the specified unit.
        :rtype: ForcePerLength
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ForcePerLength:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForcePerLengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForcePerLengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForcePerLengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForcePerLengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentinewtonsPerCentimeter(centinewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from CentinewtonsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentinewtonsPerMeter(centinewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from CentinewtonsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentinewtonsPerMillimeter(centinewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from CentinewtonsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonsPerCentimeter(decanewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from DecanewtonsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonsPerMeter(decanewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from DecanewtonsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonsPerMillimeter(decanewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from DecanewtonsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonsPerCentimeter(decinewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from DecinewtonsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonsPerMeter(decinewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from DecinewtonsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonsPerMillimeter(decinewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from DecinewtonsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerCentimeter(kilogramsforcepercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from KilogramsForcePerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerMeter(kilogramsforcepermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from KilogramsForcePerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerMillimeter(kilogramsforcepermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from KilogramsForcePerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerCentimeter(kilonewtonspercentimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from KilonewtonsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerMeter(kilonewtonspermeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from KilonewtonsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerMillimeter(kilonewtonspermillimeter: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from KilonewtonsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerFoot(kilopoundsforceperfoot: QuantityValue) -> ForcePerLength:
        """ Get ForcePerLength from KilopoundsForcePerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class HeatFlux(ValueType, IQuantity[HeatFluxUnit], IQuantity, IFormattable, IEquatable[HeatFlux], IComparable, IComparable[HeatFlux], IConvertible):
    """ Heat flux is the flow of energy per unit of area per unit of time
    """

    Info: typing.ClassVar[QuantityInfo[HeatFluxUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[HeatFluxUnit]

    MaxValue: typing.ClassVar[HeatFlux]

    MinValue: typing.ClassVar[HeatFlux]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[HeatFluxUnit]]

    Zero: typing.ClassVar[HeatFlux]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> HeatFluxUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[HeatFluxUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtusPerHourSquareFoot(self) -> float:
        """ Get HeatFlux in BtusPerHourSquareFoot.
        """
        pass

    @property
    def BtusPerMinuteSquareFoot(self) -> float:
        """ Get HeatFlux in BtusPerMinuteSquareFoot.
        """
        pass

    @property
    def BtusPerSecondSquareFoot(self) -> float:
        """ Get HeatFlux in BtusPerSecondSquareFoot.
        """
        pass

    @property
    def BtusPerSecondSquareInch(self) -> float:
        """ Get HeatFlux in BtusPerSecondSquareInch.
        """
        pass

    @property
    def CaloriesPerSecondSquareCentimeter(self) -> float:
        """ Get HeatFlux in CaloriesPerSecondSquareCentimeter.
        """
        pass

    @property
    def CentiwattsPerSquareMeter(self) -> float:
        """ Get HeatFlux in CentiwattsPerSquareMeter.
        """
        pass

    @property
    def DeciwattsPerSquareMeter(self) -> float:
        """ Get HeatFlux in DeciwattsPerSquareMeter.
        """
        pass

    @property
    def KilocaloriesPerHourSquareMeter(self) -> float:
        """ Get HeatFlux in KilocaloriesPerHourSquareMeter.
        """
        pass

    @property
    def KilocaloriesPerSecondSquareCentimeter(self) -> float:
        """ Get HeatFlux in KilocaloriesPerSecondSquareCentimeter.
        """
        pass

    @property
    def KilowattsPerSquareMeter(self) -> float:
        """ Get HeatFlux in KilowattsPerSquareMeter.
        """
        pass

    @property
    def MicrowattsPerSquareMeter(self) -> float:
        """ Get HeatFlux in MicrowattsPerSquareMeter.
        """
        pass

    @property
    def MilliwattsPerSquareMeter(self) -> float:
        """ Get HeatFlux in MilliwattsPerSquareMeter.
        """
        pass

    @property
    def NanowattsPerSquareMeter(self) -> float:
        """ Get HeatFlux in NanowattsPerSquareMeter.
        """
        pass

    @property
    def PoundsForcePerFootSecond(self) -> float:
        """ Get HeatFlux in PoundsForcePerFootSecond.
        """
        pass

    @property
    def PoundsPerSecondCubed(self) -> float:
        """ Get HeatFlux in PoundsPerSecondCubed.
        """
        pass

    @property
    def WattsPerSquareFoot(self) -> float:
        """ Get HeatFlux in WattsPerSquareFoot.
        """
        pass

    @property
    def WattsPerSquareInch(self) -> float:
        """ Get HeatFlux in WattsPerSquareInch.
        """
        pass

    @property
    def WattsPerSquareMeter(self) -> float:
        """ Get HeatFlux in WattsPerSquareMeter.
        """
        pass

    def __init__(self, value: float, unit: HeatFluxUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: HeatFluxUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: HeatFlux) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: HeatFlux) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: HeatFlux, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another HeatFlux within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: HeatFlux
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current HeatFlux.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: HeatFluxUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: HeatFluxUnit) -> HeatFlux:
        """ Converts this HeatFlux to another HeatFlux with the unit representation .

        :return: A HeatFlux with the specified unit.
        :rtype: HeatFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> HeatFlux:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: HeatFluxUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: HeatFluxUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: HeatFluxUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: HeatFluxUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtusPerHourSquareFoot(btusperhoursquarefoot: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from BtusPerHourSquareFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBtusPerMinuteSquareFoot(btusperminutesquarefoot: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from BtusPerMinuteSquareFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBtusPerSecondSquareFoot(btuspersecondsquarefoot: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from BtusPerSecondSquareFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBtusPerSecondSquareInch(btuspersecondsquareinch: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from BtusPerSecondSquareInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCaloriesPerSecondSquareCentimeter(caloriespersecondsquarecentimeter: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from CaloriesPerSecondSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentiwattsPerSquareMeter(centiwattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from CentiwattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwattsPerSquareMeter(deciwattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from DeciwattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerHourSquareMeter(kilocaloriesperhoursquaremeter: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from KilocaloriesPerHourSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerSecondSquareCentimeter(kilocaloriespersecondsquarecentimeter: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from KilocaloriesPerSecondSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerSquareMeter(kilowattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from KilowattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerSquareMeter(microwattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from MicrowattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerSquareMeter(milliwattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from MilliwattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerSquareMeter(nanowattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from NanowattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerFootSecond(poundsforceperfootsecond: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from PoundsForcePerFootSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerSecondCubed(poundspersecondcubed: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from PoundsPerSecondCubed.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareFoot(wattspersquarefoot: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from WattsPerSquareFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareInch(wattspersquareinch: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from WattsPerSquareInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareMeter(wattspersquaremeter: QuantityValue) -> HeatFlux:
        """ Get HeatFlux from WattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: HeatFluxUnit) -> HeatFlux:
        """ Dynamically convert from value and unit enum "HeatFluxUnit" to "HeatFlux".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: HeatFluxUnit
        :return: HeatFlux unit value.
        :rtype: HeatFlux
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> HeatFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> HeatFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: HeatFlux) -> typing.Tuple[HeatFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: HeatFlux
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: HeatFlux) -> typing.Tuple[HeatFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: HeatFlux
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> HeatFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> HeatFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: HeatFluxUnit) -> typing.Tuple[HeatFluxUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: HeatFluxUnit) -> typing.Tuple[HeatFluxUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: HeatFluxUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class KinematicViscosity(ValueType, IQuantity[KinematicViscosityUnit], IQuantity, IFormattable, IEquatable[KinematicViscosity], IComparable, IComparable[KinematicViscosity], IConvertible):
    """ The viscosity of a fluid is a measure of its resistance to gradual deformation by shear stress or tensile stress.
     http://en.wikipedia.org/wiki/Viscosity
    """

    Info: typing.ClassVar[QuantityInfo[KinematicViscosityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[KinematicViscosityUnit]

    MaxValue: typing.ClassVar[KinematicViscosity]

    MinValue: typing.ClassVar[KinematicViscosity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[KinematicViscosityUnit]]

    Zero: typing.ClassVar[KinematicViscosity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> KinematicViscosityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[KinematicViscosityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Centistokes(self) -> float:
        """ Get KinematicViscosity in Centistokes.
        """
        pass

    @property
    def Decistokes(self) -> float:
        """ Get KinematicViscosity in Decistokes.
        """
        pass

    @property
    def Kilostokes(self) -> float:
        """ Get KinematicViscosity in Kilostokes.
        """
        pass

    @property
    def Microstokes(self) -> float:
        """ Get KinematicViscosity in Microstokes.
        """
        pass

    @property
    def Millistokes(self) -> float:
        """ Get KinematicViscosity in Millistokes.
        """
        pass

    @property
    def Nanostokes(self) -> float:
        """ Get KinematicViscosity in Nanostokes.
        """
        pass

    @property
    def SquareMetersPerSecond(self) -> float:
        """ Get KinematicViscosity in SquareMetersPerSecond.
        """
        pass

    @property
    def Stokes(self) -> float:
        """ Get KinematicViscosity in Stokes.
        """
        pass

    def __init__(self, value: float, unit: KinematicViscosityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: KinematicViscosityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: KinematicViscosityUnit) -> KinematicViscosity:
        """ Converts this KinematicViscosity to another KinematicViscosity with the unit representation .

        :return: A KinematicViscosity with the specified unit.
        :rtype: KinematicViscosity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> KinematicViscosity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: KinematicViscosityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: KinematicViscosityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: KinematicViscosityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: KinematicViscosityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentistokes(centistokes: QuantityValue) -> KinematicViscosity:
        """ Get KinematicViscosity from Centistokes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecistokes(decistokes: QuantityValue) -> KinematicViscosity:
        """ Get KinematicViscosity from Decistokes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilostokes(kilostokes: QuantityValue) -> KinematicViscosity:
        """ Get KinematicViscosity from Kilostokes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrostokes(microstokes: QuantityValue) -> KinematicViscosity:
        """ Get KinematicViscosity from Microstokes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillistokes(millistokes: QuantityValue) -> KinematicViscosity:
        """ Get KinematicViscosity from Millistokes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanostokes(nanostokes: QuantityValue) -> KinematicViscosity:
        """ Get KinematicViscosity from Nanostokes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMetersPerSecond(squaremeterspersecond: QuantityValue) -> KinematicViscosity:
        """ Get KinematicViscosity from SquareMetersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStokes(stokes: QuantityValue) -> KinematicViscosity:
        """ Get KinematicViscosity from Stokes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: KinematicViscosityUnit) -> KinematicViscosity:
        """ Dynamically convert from value and unit enum "KinematicViscosityUnit" to "KinematicViscosity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: KinematicViscosityUnit
        :return: KinematicViscosity unit value.
        :rtype: KinematicViscosity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> KinematicViscosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> KinematicViscosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: KinematicViscosity) -> typing.Tuple[KinematicViscosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: KinematicViscosity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: KinematicViscosity) -> typing.Tuple[KinematicViscosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: KinematicViscosity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> KinematicViscosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> KinematicViscosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: KinematicViscosityUnit) -> typing.Tuple[KinematicViscosityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: KinematicViscosityUnit) -> typing.Tuple[KinematicViscosityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: KinematicViscosityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: KinematicViscosity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: KinematicViscosity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: KinematicViscosity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another KinematicViscosity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: KinematicViscosity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current KinematicViscosity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: KinematicViscosityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass


# noinspection PyPep8Naming
class LapseRate(ValueType, IQuantity[LapseRateUnit], IQuantity, IFormattable, IEquatable[LapseRate], IComparable, IComparable[LapseRate], IConvertible):
    """ Lapse rate is the rate at which Earth's atmospheric temperature decreases with an increase in altitude, or increases with the decrease in altitude.
    """

    Info: typing.ClassVar[QuantityInfo[LapseRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LapseRateUnit]

    MaxValue: typing.ClassVar[LapseRate]

    MinValue: typing.ClassVar[LapseRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LapseRateUnit]]

    Zero: typing.ClassVar[LapseRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LapseRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LapseRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DegreesCelciusPerKilometer(self) -> float:
        """ Get LapseRate in DegreesCelciusPerKilometer.
        """
        pass

    def __init__(self, value: float, unit: LapseRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LapseRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LapseRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LapseRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LapseRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LapseRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDegreesCelciusPerKilometer(degreescelciusperkilometer: QuantityValue) -> LapseRate:
        """ Get LapseRate from DegreesCelciusPerKilometer.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LapseRateUnit) -> LapseRate:
        """ Dynamically convert from value and unit enum "LapseRateUnit" to "LapseRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LapseRateUnit
        :return: LapseRate unit value.
        :rtype: LapseRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> LapseRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> LapseRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: LapseRate) -> typing.Tuple[LapseRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LapseRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: LapseRate) -> typing.Tuple[LapseRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LapseRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LapseRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LapseRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LapseRateUnit) -> typing.Tuple[LapseRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LapseRateUnit) -> typing.Tuple[LapseRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LapseRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: LapseRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LapseRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LapseRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another LapseRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: LapseRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current LapseRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LapseRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LapseRateUnit) -> LapseRate:
        """ Converts this LapseRate to another LapseRate with the unit representation .

        :return: A LapseRate with the specified unit.
        :rtype: LapseRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> LapseRate:
        """
        """
        pass


# noinspection PyPep8Naming
class Length(ValueType, IQuantity[LengthUnit], IQuantity, IFormattable, IEquatable[Length], IComparable, IComparable[Length], IConvertible):
    """ Many different units of length have been used around the world. The main units in modern use are U.S. customary units in the United States and the Metric system elsewhere. British Imperial units are still used for some purposes in the United Kingdom and some other countries. The metric system is sub-divided into SI and non-SI units.
    """

    @property
    def FeetInches(self) -> FeetInches:
        """ Converts the length to a customary feet/inches combination.
        """
        pass

    Info: typing.ClassVar[QuantityInfo[LengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LengthUnit]

    MaxValue: typing.ClassVar[Length]

    MinValue: typing.ClassVar[Length]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LengthUnit]]

    Zero: typing.ClassVar[Length]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AstronomicalUnits(self) -> float:
        """ Get Length in AstronomicalUnits.
        """
        pass

    @property
    def Centimeters(self) -> float:
        """ Get Length in Centimeters.
        """
        pass

    @property
    def Chains(self) -> float:
        """ Get Length in Chains.
        """
        pass

    @property
    def Decimeters(self) -> float:
        """ Get Length in Decimeters.
        """
        pass

    @property
    def DtpPicas(self) -> float:
        """ Get Length in DtpPicas.
        """
        pass

    @property
    def DtpPoints(self) -> float:
        """ Get Length in DtpPoints.
        """
        pass

    @property
    def Fathoms(self) -> float:
        """ Get Length in Fathoms.
        """
        pass

    @property
    def Feet(self) -> float:
        """ Get Length in Feet.
        """
        pass

    @property
    def Hands(self) -> float:
        """ Get Length in Hands.
        """
        pass

    @property
    def Hectometers(self) -> float:
        """ Get Length in Hectometers.
        """
        pass

    @property
    def Inches(self) -> float:
        """ Get Length in Inches.
        """
        pass

    @property
    def KilolightYears(self) -> float:
        """ Get Length in KilolightYears.
        """
        pass

    @property
    def Kilometers(self) -> float:
        """ Get Length in Kilometers.
        """
        pass

    @property
    def Kiloparsecs(self) -> float:
        """ Get Length in Kiloparsecs.
        """
        pass

    @property
    def LightYears(self) -> float:
        """ Get Length in LightYears.
        """
        pass

    @property
    def MegalightYears(self) -> float:
        """ Get Length in MegalightYears.
        """
        pass

    @property
    def Megaparsecs(self) -> float:
        """ Get Length in Megaparsecs.
        """
        pass

    @property
    def Meters(self) -> float:
        """ Get Length in Meters.
        """
        pass

    @property
    def Microinches(self) -> float:
        """ Get Length in Microinches.
        """
        pass

    @property
    def Micrometers(self) -> float:
        """ Get Length in Micrometers.
        """
        pass

    @property
    def Mils(self) -> float:
        """ Get Length in Mils.
        """
        pass

    @property
    def Miles(self) -> float:
        """ Get Length in Miles.
        """
        pass

    @property
    def Millimeters(self) -> float:
        """ Get Length in Millimeters.
        """
        pass

    @property
    def Nanometers(self) -> float:
        """ Get Length in Nanometers.
        """
        pass

    @property
    def NauticalMiles(self) -> float:
        """ Get Length in NauticalMiles.
        """
        pass

    @property
    def Parsecs(self) -> float:
        """ Get Length in Parsecs.
        """
        pass

    @property
    def PrinterPicas(self) -> float:
        """ Get Length in PrinterPicas.
        """
        pass

    @property
    def PrinterPoints(self) -> float:
        """ Get Length in PrinterPoints.
        """
        pass

    @property
    def Shackles(self) -> float:
        """ Get Length in Shackles.
        """
        pass

    @property
    def SolarRadiuses(self) -> float:
        """ Get Length in SolarRadiuses.
        """
        pass

    @property
    def Twips(self) -> float:
        """ Get Length in Twips.
        """
        pass

    @property
    def UsSurveyFeet(self) -> float:
        """ Get Length in UsSurveyFeet.
        """
        pass

    @property
    def Yards(self) -> float:
        """ Get Length in Yards.
        """
        pass

    def __init__(self, value: float, unit: LengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilolightYears(kilolightyears: QuantityValue) -> Length:
        """ Get Length from KilolightYears.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilometers(kilometers: QuantityValue) -> Length:
        """ Get Length from Kilometers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloparsecs(kiloparsecs: QuantityValue) -> Length:
        """ Get Length from Kiloparsecs.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLightYears(lightyears: QuantityValue) -> Length:
        """ Get Length from LightYears.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegalightYears(megalightyears: QuantityValue) -> Length:
        """ Get Length from MegalightYears.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaparsecs(megaparsecs: QuantityValue) -> Length:
        """ Get Length from Megaparsecs.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeters(meters: QuantityValue) -> Length:
        """ Get Length from Meters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroinches(microinches: QuantityValue) -> Length:
        """ Get Length from Microinches.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrometers(micrometers: QuantityValue) -> Length:
        """ Get Length from Micrometers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMils(mils: QuantityValue) -> Length:
        """ Get Length from Mils.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMiles(miles: QuantityValue) -> Length:
        """ Get Length from Miles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimeters(millimeters: QuantityValue) -> Length:
        """ Get Length from Millimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanometers(nanometers: QuantityValue) -> Length:
        """ Get Length from Nanometers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNauticalMiles(nauticalmiles: QuantityValue) -> Length:
        """ Get Length from NauticalMiles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromParsecs(parsecs: QuantityValue) -> Length:
        """ Get Length from Parsecs.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPrinterPicas(printerpicas: QuantityValue) -> Length:
        """ Get Length from PrinterPicas.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPrinterPoints(printerpoints: QuantityValue) -> Length:
        """ Get Length from PrinterPoints.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromShackles(shackles: QuantityValue) -> Length:
        """ Get Length from Shackles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSolarRadiuses(solarradiuses: QuantityValue) -> Length:
        """ Get Length from SolarRadiuses.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTwips(twips: QuantityValue) -> Length:
        """ Get Length from Twips.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsSurveyFeet(ussurveyfeet: QuantityValue) -> Length:
        """ Get Length from UsSurveyFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromYards(yards: QuantityValue) -> Length:
        """ Get Length from Yards.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LengthUnit) -> Length:
        """ Dynamically convert from value and unit enum "LengthUnit" to "Length".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LengthUnit
        :return: Length unit value.
        :rtype: Length
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Length:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Length:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Length) -> typing.Tuple[Length, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Length
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Length) -> typing.Tuple[Length, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Length
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LengthUnit) -> typing.Tuple[LengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LengthUnit) -> typing.Tuple[LengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Length) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Length) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Length, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Length within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Length
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Length.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LengthUnit) -> Length:
        """ Converts this Length to another Length with the unit representation .

        :return: A Length with the specified unit.
        :rtype: Length
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Length:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromFeetInches(feet: float, inches: float) -> Length:
        """ Get length from combination of feet and inches.
        """
        pass

    @staticmethod
    def ParseFeetInches(str: str, formatProvider: IFormatProvider) -> Length:
        """Special parsing of feet/inches strings, commonly used.
        2 feet 4 inches is sometimes denoted as 2′−4″, 2′ 4″, 2′4″, 2 ft 4 in.
        The apostrophe can be ′ and '.
        The double prime can be ″ and ".
        https://en.wikipedia.org/wiki/Foot_(unit)

        :param str:
        :type str: str
        :param formatProvider: Optionally specify the culture format numbers and localize unit abbreviations. Defaults to thread's culture.
        :type formatProvider: IFormatProvider
        :return: Parsed length.
        :rtype: Length
        """
        pass

    @staticmethod
    def TryParseFeetInches(str: str, result: Length, formatProvider: IFormatProvider) -> typing.Tuple[Length, bool]:
        """Special parsing of feet/inches strings, commonly used.
        2 feet 4 inches is sometimes denoted as 2′−4″, 2′ 4″, 2′4″, 2 ft 4 in.
        The apostrophe can be ′ and '.
        The double prime can be ″ and ".
        https://en.wikipedia.org/wiki/Foot_(unit)

        :param str:
        :type str: str
        :param result: Parsed length.
        :type result: Length
        :param formatProvider: Optionally specify the culture format numbers and localize unit abbreviations. Defaults to thread's culture.
        :type formatProvider: IFormatProvider
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAstronomicalUnits(astronomicalunits: QuantityValue) -> Length:
        """ Get Length from AstronomicalUnits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentimeters(centimeters: QuantityValue) -> Length:
        """ Get Length from Centimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromChains(chains: QuantityValue) -> Length:
        """ Get Length from Chains.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimeters(decimeters: QuantityValue) -> Length:
        """ Get Length from Decimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDtpPicas(dtppicas: QuantityValue) -> Length:
        """ Get Length from DtpPicas.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDtpPoints(dtppoints: QuantityValue) -> Length:
        """ Get Length from DtpPoints.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFathoms(fathoms: QuantityValue) -> Length:
        """ Get Length from Fathoms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeet(feet: QuantityValue) -> Length:
        """ Get Length from Feet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHands(hands: QuantityValue) -> Length:
        """ Get Length from Hands.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectometers(hectometers: QuantityValue) -> Length:
        """ Get Length from Hectometers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInches(inches: QuantityValue) -> Length:
        """ Get Length from Inches.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class FeetInches:
    """ Representation of feet and inches, used to preserve the original values when constructing "Length" by
     "Function Double)" and later output them unaltered with "Function ToString".
    """

    @property
    def Feet(self) -> float:
        """ The feet value it was constructed with.
        """
        pass

    @property
    def Inches(self) -> float:
        """ The inches value it was constructed with.
        """
        pass

    def __init__(self, feet: float, inches: float) -> None:
        """ Construct from feet and inches.
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """
        """
        pass

    @typing.overload
    def ToString(self, cultureInfo: IFormatProvider) -> str:
        """ Outputs feet and inches on the format: {feetValue} {feetUnit} {inchesValue} {inchesUnit}

        :param cultureInfo: Optional culture to format number and localize unit abbreviations.
        If null, defaults to "Property CurrentUICulture".
        :type cultureInfo: IFormatProvider
        """
        pass


# noinspection PyPep8Naming
class Level(ValueType, IQuantity[LevelUnit], IQuantity, IFormattable, IEquatable[Level], IComparable, IComparable[Level], IConvertible):
    """ Level is the logarithm of the ratio of a quantity Q to a reference value of that quantity, Q₀, expressed in dimensionless units.
    """

    Info: typing.ClassVar[QuantityInfo[LevelUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LevelUnit]

    MaxValue: typing.ClassVar[Level]

    MinValue: typing.ClassVar[Level]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LevelUnit]]

    Zero: typing.ClassVar[Level]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LevelUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LevelUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Decibels(self) -> float:
        """ Get Level in Decibels.
        """
        pass

    @property
    def Nepers(self) -> float:
        """ Get Level in Nepers.
        """
        pass

    def __init__(self, quantity: float, reference: float) -> None:
        """ Initializes a new instance of the logarithmic "Level" struct which is the ratio of a quantity Q to a
         reference value of that quantity Q0.

        :param quantity: The quantity.
        :type quantity: float
        :param reference: The reference value that is compared to.
        :type reference: float
        """
        pass

    def __init__(self, value: float, unit: LevelUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LevelUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LevelUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LevelUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LevelUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LevelUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecibels(decibels: QuantityValue) -> Level:
        """ Get Level from Decibels.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNepers(nepers: QuantityValue) -> Level:
        """ Get Level from Nepers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LevelUnit) -> Level:
        """ Dynamically convert from value and unit enum "LevelUnit" to "Level".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LevelUnit
        :return: Level unit value.
        :rtype: Level
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Level:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Level:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Level) -> typing.Tuple[Level, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Level
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Level) -> typing.Tuple[Level, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Level
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LevelUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LevelUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LevelUnit) -> typing.Tuple[LevelUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LevelUnit) -> typing.Tuple[LevelUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LevelUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Level) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Level) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Level, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Level within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Level
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Level.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LevelUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LevelUnit) -> Level:
        """ Converts this Level to another Level with the unit representation .

        :return: A Level with the specified unit.
        :rtype: Level
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Level:
        """
        """
        pass


# noinspection PyPep8Naming
class LinearDensity(ValueType, IQuantity[LinearDensityUnit], IQuantity, IFormattable, IEquatable[LinearDensity], IComparable, IComparable[LinearDensity], IConvertible):
    """ The Linear Density, or more precisely, the linear mass density, of a substance is its mass per unit length. The term linear density is most often used when describing the characteristics of one-dimensional objects, although linear density can also be used to describe the density of a three-dimensional quantity along one particular dimension.
     http://en.wikipedia.org/wiki/Linear_density
    """

    Info: typing.ClassVar[QuantityInfo[LinearDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LinearDensityUnit]

    MaxValue: typing.ClassVar[LinearDensity]

    MinValue: typing.ClassVar[LinearDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LinearDensityUnit]]

    Zero: typing.ClassVar[LinearDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LinearDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LinearDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GramsPerCentimeter(self) -> float:
        """ Get LinearDensity in GramsPerCentimeter.
        """
        pass

    @property
    def GramsPerMeter(self) -> float:
        """ Get LinearDensity in GramsPerMeter.
        """
        pass

    @property
    def GramsPerMillimeter(self) -> float:
        """ Get LinearDensity in GramsPerMillimeter.
        """
        pass

    @property
    def KilogramsPerCentimeter(self) -> float:
        """ Get LinearDensity in KilogramsPerCentimeter.
        """
        pass

    @property
    def KilogramsPerMeter(self) -> float:
        """ Get LinearDensity in KilogramsPerMeter.
        """
        pass

    @property
    def KilogramsPerMillimeter(self) -> float:
        """ Get LinearDensity in KilogramsPerMillimeter.
        """
        pass

    @property
    def MicrogramsPerCentimeter(self) -> float:
        """ Get LinearDensity in MicrogramsPerCentimeter.
        """
        pass

    @property
    def MicrogramsPerMeter(self) -> float:
        """ Get LinearDensity in MicrogramsPerMeter.
        """
        pass

    @property
    def MicrogramsPerMillimeter(self) -> float:
        """ Get LinearDensity in MicrogramsPerMillimeter.
        """
        pass

    @property
    def MilligramsPerCentimeter(self) -> float:
        """ Get LinearDensity in MilligramsPerCentimeter.
        """
        pass

    @property
    def MilligramsPerMeter(self) -> float:
        """ Get LinearDensity in MilligramsPerMeter.
        """
        pass

    @property
    def MilligramsPerMillimeter(self) -> float:
        """ Get LinearDensity in MilligramsPerMillimeter.
        """
        pass

    @property
    def PoundsPerFoot(self) -> float:
        """ Get LinearDensity in PoundsPerFoot.
        """
        pass

    @property
    def PoundsPerInch(self) -> float:
        """ Get LinearDensity in PoundsPerInch.
        """
        pass

    def __init__(self, value: float, unit: LinearDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LinearDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: LinearDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LinearDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another LinearDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: LinearDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current LinearDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LinearDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LinearDensityUnit) -> LinearDensity:
        """ Converts this LinearDensity to another LinearDensity with the unit representation .

        :return: A LinearDensity with the specified unit.
        :rtype: LinearDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> LinearDensity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LinearDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LinearDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LinearDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LinearDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramsPerCentimeter(gramspercentimeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from GramsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMeter(gramspermeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from GramsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMillimeter(gramspermillimeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from GramsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCentimeter(kilogramspercentimeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from KilogramsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerMeter(kilogramspermeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from KilogramsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerMillimeter(kilogramspermillimeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from KilogramsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerCentimeter(microgramspercentimeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from MicrogramsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMeter(microgramspermeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from MicrogramsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMillimeter(microgramspermillimeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from MicrogramsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerCentimeter(milligramspercentimeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from MilligramsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMeter(milligramspermeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from MilligramsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMillimeter(milligramspermillimeter: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from MilligramsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerFoot(poundsperfoot: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from PoundsPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerInch(poundsperinch: QuantityValue) -> LinearDensity:
        """ Get LinearDensity from PoundsPerInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LinearDensityUnit) -> LinearDensity:
        """ Dynamically convert from value and unit enum "LinearDensityUnit" to "LinearDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LinearDensityUnit
        :return: LinearDensity unit value.
        :rtype: LinearDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> LinearDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> LinearDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: LinearDensity) -> typing.Tuple[LinearDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LinearDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: LinearDensity) -> typing.Tuple[LinearDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LinearDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LinearDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LinearDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LinearDensityUnit) -> typing.Tuple[LinearDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LinearDensityUnit) -> typing.Tuple[LinearDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LinearDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: LinearDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass


# noinspection PyPep8Naming
class Mass(ValueType, IQuantity[MassUnit], IQuantity, IFormattable, IEquatable[Mass], IComparable, IComparable[Mass], IConvertible):
    """ In physics, mass (from Greek μᾶζα "barley cake, lump [of dough]") is a property of a physical system or body, giving rise to the phenomena of the body's resistance to being accelerated by a force and the strength of its mutual gravitational attraction with other bodies. Instruments such as mass balances or scales use those phenomena to measure mass. The SI unit of mass is the kilogram (kg).
    """

    @property
    def StonePounds(self) -> StonePounds:
        """ Converts the mass to a customary stone/pounds combination.
        """
        pass

    Info: typing.ClassVar[QuantityInfo[MassUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassUnit]

    MaxValue: typing.ClassVar[Mass]

    MinValue: typing.ClassVar[Mass]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassUnit]]

    Zero: typing.ClassVar[Mass]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Centigrams(self) -> float:
        """ Get Mass in Centigrams.
        """
        pass

    @property
    def Decagrams(self) -> float:
        """ Get Mass in Decagrams.
        """
        pass

    @property
    def Decigrams(self) -> float:
        """ Get Mass in Decigrams.
        """
        pass

    @property
    def EarthMasses(self) -> float:
        """ Get Mass in EarthMasses.
        """
        pass

    @property
    def Grains(self) -> float:
        """ Get Mass in Grains.
        """
        pass

    @property
    def Grams(self) -> float:
        """ Get Mass in Grams.
        """
        pass

    @property
    def Hectograms(self) -> float:
        """ Get Mass in Hectograms.
        """
        pass

    @property
    def Kilograms(self) -> float:
        """ Get Mass in Kilograms.
        """
        pass

    @property
    def Kilopounds(self) -> float:
        """ Get Mass in Kilopounds.
        """
        pass

    @property
    def Kilotonnes(self) -> float:
        """ Get Mass in Kilotonnes.
        """
        pass

    @property
    def LongHundredweight(self) -> float:
        """ Get Mass in LongHundredweight.
        """
        pass

    @property
    def LongTons(self) -> float:
        """ Get Mass in LongTons.
        """
        pass

    @property
    def Megapounds(self) -> float:
        """ Get Mass in Megapounds.
        """
        pass

    @property
    def Megatonnes(self) -> float:
        """ Get Mass in Megatonnes.
        """
        pass

    @property
    def Micrograms(self) -> float:
        """ Get Mass in Micrograms.
        """
        pass

    @property
    def Milligrams(self) -> float:
        """ Get Mass in Milligrams.
        """
        pass

    @property
    def Nanograms(self) -> float:
        """ Get Mass in Nanograms.
        """
        pass

    @property
    def Ounces(self) -> float:
        """ Get Mass in Ounces.
        """
        pass

    @property
    def Pounds(self) -> float:
        """ Get Mass in Pounds.
        """
        pass

    @property
    def ShortHundredweight(self) -> float:
        """ Get Mass in ShortHundredweight.
        """
        pass

    @property
    def ShortTons(self) -> float:
        """ Get Mass in ShortTons.
        """
        pass

    @property
    def Slugs(self) -> float:
        """ Get Mass in Slugs.
        """
        pass

    @property
    def SolarMasses(self) -> float:
        """ Get Mass in SolarMasses.
        """
        pass

    @property
    def Stone(self) -> float:
        """ Get Mass in Stone.
        """
        pass

    @property
    def Tonnes(self) -> float:
        """ Get Mass in Tonnes.
        """
        pass

    def __init__(self, value: float, unit: MassUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromStone(stone: QuantityValue) -> Mass:
        """ Get Mass from Stone.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnes(tonnes: QuantityValue) -> Mass:
        """ Get Mass from Tonnes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassUnit) -> Mass:
        """ Dynamically convert from value and unit enum "MassUnit" to "Mass".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassUnit
        :return: Mass unit value.
        :rtype: Mass
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Mass:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Mass:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Mass) -> typing.Tuple[Mass, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Mass
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Mass) -> typing.Tuple[Mass, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Mass
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassUnit) -> typing.Tuple[MassUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassUnit) -> typing.Tuple[MassUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Mass) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Mass) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Mass, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Mass within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Mass
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Mass.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassUnit) -> Mass:
        """ Converts this Mass to another Mass with the unit representation .

        :return: A Mass with the specified unit.
        :rtype: Mass
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Mass:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGravitationalForce(f: Force) -> Mass:
        """Get "Mass" from "Force" of gravity.
        """
        pass

    @staticmethod
    def FromStonePounds(stone: float, pounds: float) -> Mass:
        """ Get Mass from combination of stone and pounds.
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigrams(centigrams: QuantityValue) -> Mass:
        """ Get Mass from Centigrams.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagrams(decagrams: QuantityValue) -> Mass:
        """ Get Mass from Decagrams.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigrams(decigrams: QuantityValue) -> Mass:
        """ Get Mass from Decigrams.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromEarthMasses(earthmasses: QuantityValue) -> Mass:
        """ Get Mass from EarthMasses.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGrains(grains: QuantityValue) -> Mass:
        """ Get Mass from Grains.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGrams(grams: QuantityValue) -> Mass:
        """ Get Mass from Grams.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectograms(hectograms: QuantityValue) -> Mass:
        """ Get Mass from Hectograms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilograms(kilograms: QuantityValue) -> Mass:
        """ Get Mass from Kilograms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopounds(kilopounds: QuantityValue) -> Mass:
        """ Get Mass from Kilopounds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilotonnes(kilotonnes: QuantityValue) -> Mass:
        """ Get Mass from Kilotonnes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLongHundredweight(longhundredweight: QuantityValue) -> Mass:
        """ Get Mass from LongHundredweight.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLongTons(longtons: QuantityValue) -> Mass:
        """ Get Mass from LongTons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapounds(megapounds: QuantityValue) -> Mass:
        """ Get Mass from Megapounds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegatonnes(megatonnes: QuantityValue) -> Mass:
        """ Get Mass from Megatonnes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrograms(micrograms: QuantityValue) -> Mass:
        """ Get Mass from Micrograms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligrams(milligrams: QuantityValue) -> Mass:
        """ Get Mass from Milligrams.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanograms(nanograms: QuantityValue) -> Mass:
        """ Get Mass from Nanograms.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOunces(ounces: QuantityValue) -> Mass:
        """ Get Mass from Ounces.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPounds(pounds: QuantityValue) -> Mass:
        """ Get Mass from Pounds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromShortHundredweight(shorthundredweight: QuantityValue) -> Mass:
        """ Get Mass from ShortHundredweight.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromShortTons(shorttons: QuantityValue) -> Mass:
        """ Get Mass from ShortTons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugs(slugs: QuantityValue) -> Mass:
        """ Get Mass from Slugs.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSolarMasses(solarmasses: QuantityValue) -> Mass:
        """ Get Mass from SolarMasses.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class StonePounds:
    """ Representation of stone and pounds, used to preserve the original values when constructing "Mass" by
     "Function Double)" and later output them unaltered with "Function ToString".
    """

    @property
    def Stone(self) -> float:
        """ The stone value it was created with.
        """
        pass

    @property
    def Pounds(self) -> float:
        """ The pounds value it was created with.
        """
        pass

    def __init__(self, stone: float, pounds: float) -> None:
        """ Construct from stone and pounds.
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """
        """
        pass

    @typing.overload
    def ToString(self, cultureInfo: IFormatProvider) -> str:
        """ Outputs stone and pounds on the format: {stoneValue} {stoneUnit} {poundsValue} {poundsUnit}

        :param cultureInfo: Optional culture to format number and localize unit abbreviations.
        If null, defaults to "Property CurrentUICulture".
        :type cultureInfo: IFormatProvider
        """
        pass


# noinspection PyPep8Naming
class MassConcentration(ValueType, IQuantity[MassConcentrationUnit], IQuantity, IFormattable, IEquatable[MassConcentration], IComparable, IComparable[MassConcentration], IConvertible):
    """ In chemistry, the mass concentration ρi (or γi) is defined as the mass of a constituent mi divided by the volume of the mixture V
     https://en.wikipedia.org/wiki/Mass_concentration_(chemistry)
    """

    Info: typing.ClassVar[QuantityInfo[MassConcentrationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassConcentrationUnit]

    MaxValue: typing.ClassVar[MassConcentration]

    MinValue: typing.ClassVar[MassConcentration]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassConcentrationUnit]]

    Zero: typing.ClassVar[MassConcentration]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassConcentrationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassConcentrationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentigramsPerDeciliter(self) -> float:
        """ Get MassConcentration in CentigramsPerDeciliter.
        """
        pass

    @property
    def CentigramsPerLiter(self) -> float:
        """ Get MassConcentration in CentigramsPerLiter.
        """
        pass

    @property
    def CentigramsPerMicroliter(self) -> float:
        """ Get MassConcentration in CentigramsPerMicroliter.
        """
        pass

    @property
    def CentigramsPerMilliliter(self) -> float:
        """ Get MassConcentration in CentigramsPerMilliliter.
        """
        pass

    @property
    def DecigramsPerDeciliter(self) -> float:
        """ Get MassConcentration in DecigramsPerDeciliter.
        """
        pass

    @property
    def DecigramsPerLiter(self) -> float:
        """ Get MassConcentration in DecigramsPerLiter.
        """
        pass

    @property
    def DecigramsPerMicroliter(self) -> float:
        """ Get MassConcentration in DecigramsPerMicroliter.
        """
        pass

    @property
    def DecigramsPerMilliliter(self) -> float:
        """ Get MassConcentration in DecigramsPerMilliliter.
        """
        pass

    @property
    def GramsPerCubicCentimeter(self) -> float:
        """ Get MassConcentration in GramsPerCubicCentimeter.
        """
        pass

    @property
    def GramsPerCubicMeter(self) -> float:
        """ Get MassConcentration in GramsPerCubicMeter.
        """
        pass

    @property
    def GramsPerCubicMillimeter(self) -> float:
        """ Get MassConcentration in GramsPerCubicMillimeter.
        """
        pass

    @property
    def GramsPerDeciliter(self) -> float:
        """ Get MassConcentration in GramsPerDeciliter.
        """
        pass

    @property
    def GramsPerLiter(self) -> float:
        """ Get MassConcentration in GramsPerLiter.
        """
        pass

    @property
    def GramsPerMicroliter(self) -> float:
        """ Get MassConcentration in GramsPerMicroliter.
        """
        pass

    @property
    def GramsPerMilliliter(self) -> float:
        """ Get MassConcentration in GramsPerMilliliter.
        """
        pass

    @property
    def KilogramsPerCubicCentimeter(self) -> float:
        """ Get MassConcentration in KilogramsPerCubicCentimeter.
        """
        pass

    @property
    def KilogramsPerCubicMeter(self) -> float:
        """ Get MassConcentration in KilogramsPerCubicMeter.
        """
        pass

    @property
    def KilogramsPerCubicMillimeter(self) -> float:
        """ Get MassConcentration in KilogramsPerCubicMillimeter.
        """
        pass

    @property
    def KilogramsPerLiter(self) -> float:
        """ Get MassConcentration in KilogramsPerLiter.
        """
        pass

    @property
    def KilopoundsPerCubicFoot(self) -> float:
        """ Get MassConcentration in KilopoundsPerCubicFoot.
        """
        pass

    @property
    def KilopoundsPerCubicInch(self) -> float:
        """ Get MassConcentration in KilopoundsPerCubicInch.
        """
        pass

    @property
    def MicrogramsPerCubicMeter(self) -> float:
        """ Get MassConcentration in MicrogramsPerCubicMeter.
        """
        pass

    @property
    def MicrogramsPerDeciliter(self) -> float:
        """ Get MassConcentration in MicrogramsPerDeciliter.
        """
        pass

    @property
    def MicrogramsPerLiter(self) -> float:
        """ Get MassConcentration in MicrogramsPerLiter.
        """
        pass

    @property
    def MicrogramsPerMicroliter(self) -> float:
        """ Get MassConcentration in MicrogramsPerMicroliter.
        """
        pass

    @property
    def MicrogramsPerMilliliter(self) -> float:
        """ Get MassConcentration in MicrogramsPerMilliliter.
        """
        pass

    @property
    def MilligramsPerCubicMeter(self) -> float:
        """ Get MassConcentration in MilligramsPerCubicMeter.
        """
        pass

    @property
    def MilligramsPerDeciliter(self) -> float:
        """ Get MassConcentration in MilligramsPerDeciliter.
        """
        pass

    @property
    def MilligramsPerLiter(self) -> float:
        """ Get MassConcentration in MilligramsPerLiter.
        """
        pass

    @property
    def MilligramsPerMicroliter(self) -> float:
        """ Get MassConcentration in MilligramsPerMicroliter.
        """
        pass

    @property
    def MilligramsPerMilliliter(self) -> float:
        """ Get MassConcentration in MilligramsPerMilliliter.
        """
        pass

    @property
    def NanogramsPerDeciliter(self) -> float:
        """ Get MassConcentration in NanogramsPerDeciliter.
        """
        pass

    @property
    def NanogramsPerLiter(self) -> float:
        """ Get MassConcentration in NanogramsPerLiter.
        """
        pass

    @property
    def NanogramsPerMicroliter(self) -> float:
        """ Get MassConcentration in NanogramsPerMicroliter.
        """
        pass

    @property
    def NanogramsPerMilliliter(self) -> float:
        """ Get MassConcentration in NanogramsPerMilliliter.
        """
        pass

    @property
    def PicogramsPerDeciliter(self) -> float:
        """ Get MassConcentration in PicogramsPerDeciliter.
        """
        pass

    @property
    def PicogramsPerLiter(self) -> float:
        """ Get MassConcentration in PicogramsPerLiter.
        """
        pass

    @property
    def PicogramsPerMicroliter(self) -> float:
        """ Get MassConcentration in PicogramsPerMicroliter.
        """
        pass

    @property
    def PicogramsPerMilliliter(self) -> float:
        """ Get MassConcentration in PicogramsPerMilliliter.
        """
        pass

    @property
    def PoundsPerCubicFoot(self) -> float:
        """ Get MassConcentration in PoundsPerCubicFoot.
        """
        pass

    @property
    def PoundsPerCubicInch(self) -> float:
        """ Get MassConcentration in PoundsPerCubicInch.
        """
        pass

    @property
    def PoundsPerImperialGallon(self) -> float:
        """ Get MassConcentration in PoundsPerImperialGallon.
        """
        pass

    @property
    def PoundsPerUSGallon(self) -> float:
        """ Get MassConcentration in PoundsPerUSGallon.
        """
        pass

    @property
    def SlugsPerCubicFoot(self) -> float:
        """ Get MassConcentration in SlugsPerCubicFoot.
        """
        pass

    @property
    def TonnesPerCubicCentimeter(self) -> float:
        """ Get MassConcentration in TonnesPerCubicCentimeter.
        """
        pass

    @property
    def TonnesPerCubicMeter(self) -> float:
        """ Get MassConcentration in TonnesPerCubicMeter.
        """
        pass

    @property
    def TonnesPerCubicMillimeter(self) -> float:
        """ Get MassConcentration in TonnesPerCubicMillimeter.
        """
        pass

    def __init__(self, value: float, unit: MassConcentrationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassConcentrationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MassConcentration:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerMilliliter(centigramspermilliliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from CentigramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerDeciliter(decigramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from DecigramsPerDeciliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerLiter(decigramsperliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from DecigramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerMicroliter(decigramspermicroliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from DecigramsPerMicroliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerMilliliter(decigramspermilliliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from DecigramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicCentimeter(gramspercubiccentimeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from GramsPerCubicCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicMeter(gramspercubicmeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from GramsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerCubicMillimeter(gramspercubicmillimeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from GramsPerCubicMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerDeciliter(gramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from GramsPerDeciliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerLiter(gramsperliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from GramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMicroliter(gramspermicroliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from GramsPerMicroliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMilliliter(gramspermilliliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from GramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicCentimeter(kilogramspercubiccentimeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from KilogramsPerCubicCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicMeter(kilogramspercubicmeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from KilogramsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerCubicMillimeter(kilogramspercubicmillimeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from KilogramsPerCubicMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerLiter(kilogramsperliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from KilogramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsPerCubicFoot(kilopoundspercubicfoot: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from KilopoundsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsPerCubicInch(kilopoundspercubicinch: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from KilopoundsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerCubicMeter(microgramspercubicmeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from MicrogramsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerDeciliter(microgramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from MicrogramsPerDeciliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerLiter(microgramsperliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from MicrogramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMicroliter(microgramspermicroliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from MicrogramsPerMicroliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMilliliter(microgramspermilliliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from MicrogramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerCubicMeter(milligramspercubicmeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from MilligramsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerDeciliter(milligramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from MilligramsPerDeciliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerLiter(milligramsperliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from MilligramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMicroliter(milligramspermicroliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from MilligramsPerMicroliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMilliliter(milligramspermilliliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from MilligramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerDeciliter(nanogramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from NanogramsPerDeciliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerLiter(nanogramsperliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from NanogramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerMicroliter(nanogramspermicroliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from NanogramsPerMicroliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerMilliliter(nanogramspermilliliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from NanogramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerDeciliter(picogramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from PicogramsPerDeciliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerLiter(picogramsperliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from PicogramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerMicroliter(picogramspermicroliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from PicogramsPerMicroliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicogramsPerMilliliter(picogramspermilliliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from PicogramsPerMilliliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicFoot(poundspercubicfoot: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from PoundsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerCubicInch(poundspercubicinch: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from PoundsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerImperialGallon(poundsperimperialgallon: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from PoundsPerImperialGallon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerUSGallon(poundsperusgallon: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from PoundsPerUSGallon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugsPerCubicFoot(slugspercubicfoot: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from SlugsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicCentimeter(tonnespercubiccentimeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from TonnesPerCubicCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicMeter(tonnespercubicmeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from TonnesPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerCubicMillimeter(tonnespercubicmillimeter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from TonnesPerCubicMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassConcentrationUnit) -> MassConcentration:
        """ Dynamically convert from value and unit enum "MassConcentrationUnit" to "MassConcentration".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassConcentrationUnit
        :return: MassConcentration unit value.
        :rtype: MassConcentration
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MassConcentration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MassConcentration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MassConcentration) -> typing.Tuple[MassConcentration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassConcentration
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MassConcentration) -> typing.Tuple[MassConcentration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassConcentration
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassConcentrationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassConcentrationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassConcentrationUnit) -> typing.Tuple[MassConcentrationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassConcentrationUnit) -> typing.Tuple[MassConcentrationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassConcentrationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MassConcentration) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassConcentration) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassConcentration, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MassConcentration within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MassConcentration
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MassConcentration.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassConcentrationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassConcentrationUnit) -> MassConcentration:
        """ Converts this MassConcentration to another MassConcentration with the unit representation .

        :return: A MassConcentration with the specified unit.
        :rtype: MassConcentration
        """
        pass

    def ToMolarity(self, molecularWeight: MolarMass) -> Molarity:
        """ Get "Molarity" from this "MassConcentration" using the known component "MolarMass".

        :param molecularWeight:
        :type molecularWeight: MolarMass
        """
        pass

    def ToVolumeConcentration(self, componentDensity: Density) -> VolumeConcentration:
        """ Get "VolumeConcentration" from this "MassConcentration" using the known component "Density".

        :param componentDensity:
        :type componentDensity: Density
        :return:
        :rtype: VolumeConcentration
        """
        pass

    @staticmethod
    def FromMolarity(molarity: Molarity, mass: MolarMass) -> MassConcentration:
        """ Get "MassConcentration" from "Molarity".
        """
        pass

    @staticmethod
    def FromVolumeConcentration(volumeConcentration: VolumeConcentration, componentDensity: Density) -> MassConcentration:
        """ Get "MassConcentration" from "VolumeConcentration" and component "Density".
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassConcentrationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassConcentrationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassConcentrationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassConcentrationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerDeciliter(centigramsperdeciliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from CentigramsPerDeciliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerLiter(centigramsperliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from CentigramsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerMicroliter(centigramspermicroliter: QuantityValue) -> MassConcentration:
        """ Get MassConcentration from CentigramsPerMicroliter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class MassFlow(ValueType, IQuantity[MassFlowUnit], IQuantity, IFormattable, IEquatable[MassFlow], IComparable, IComparable[MassFlow], IConvertible):
    """ Mass flow is the ratio of the mass change to the time during which the change occurred (value of mass changes per unit time).
    """

    Info: typing.ClassVar[QuantityInfo[MassFlowUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassFlowUnit]

    MaxValue: typing.ClassVar[MassFlow]

    MinValue: typing.ClassVar[MassFlow]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassFlowUnit]]

    Zero: typing.ClassVar[MassFlow]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassFlowUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassFlowUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentigramsPerDay(self) -> float:
        """ Get MassFlow in CentigramsPerDay.
        """
        pass

    @property
    def CentigramsPerSecond(self) -> float:
        """ Get MassFlow in CentigramsPerSecond.
        """
        pass

    @property
    def DecagramsPerDay(self) -> float:
        """ Get MassFlow in DecagramsPerDay.
        """
        pass

    @property
    def DecagramsPerSecond(self) -> float:
        """ Get MassFlow in DecagramsPerSecond.
        """
        pass

    @property
    def DecigramsPerDay(self) -> float:
        """ Get MassFlow in DecigramsPerDay.
        """
        pass

    @property
    def DecigramsPerSecond(self) -> float:
        """ Get MassFlow in DecigramsPerSecond.
        """
        pass

    @property
    def GramsPerDay(self) -> float:
        """ Get MassFlow in GramsPerDay.
        """
        pass

    @property
    def GramsPerHour(self) -> float:
        """ Get MassFlow in GramsPerHour.
        """
        pass

    @property
    def GramsPerSecond(self) -> float:
        """ Get MassFlow in GramsPerSecond.
        """
        pass

    @property
    def HectogramsPerDay(self) -> float:
        """ Get MassFlow in HectogramsPerDay.
        """
        pass

    @property
    def HectogramsPerSecond(self) -> float:
        """ Get MassFlow in HectogramsPerSecond.
        """
        pass

    @property
    def KilogramsPerDay(self) -> float:
        """ Get MassFlow in KilogramsPerDay.
        """
        pass

    @property
    def KilogramsPerHour(self) -> float:
        """ Get MassFlow in KilogramsPerHour.
        """
        pass

    @property
    def KilogramsPerMinute(self) -> float:
        """ Get MassFlow in KilogramsPerMinute.
        """
        pass

    @property
    def KilogramsPerSecond(self) -> float:
        """ Get MassFlow in KilogramsPerSecond.
        """
        pass

    @property
    def MegagramsPerDay(self) -> float:
        """ Get MassFlow in MegagramsPerDay.
        """
        pass

    @property
    def MegapoundsPerDay(self) -> float:
        """ Get MassFlow in MegapoundsPerDay.
        """
        pass

    @property
    def MegapoundsPerHour(self) -> float:
        """ Get MassFlow in MegapoundsPerHour.
        """
        pass

    @property
    def MegapoundsPerMinute(self) -> float:
        """ Get MassFlow in MegapoundsPerMinute.
        """
        pass

    @property
    def MegapoundsPerSecond(self) -> float:
        """ Get MassFlow in MegapoundsPerSecond.
        """
        pass

    @property
    def MicrogramsPerDay(self) -> float:
        """ Get MassFlow in MicrogramsPerDay.
        """
        pass

    @property
    def MicrogramsPerSecond(self) -> float:
        """ Get MassFlow in MicrogramsPerSecond.
        """
        pass

    @property
    def MilligramsPerDay(self) -> float:
        """ Get MassFlow in MilligramsPerDay.
        """
        pass

    @property
    def MilligramsPerSecond(self) -> float:
        """ Get MassFlow in MilligramsPerSecond.
        """
        pass

    @property
    def NanogramsPerDay(self) -> float:
        """ Get MassFlow in NanogramsPerDay.
        """
        pass

    @property
    def NanogramsPerSecond(self) -> float:
        """ Get MassFlow in NanogramsPerSecond.
        """
        pass

    @property
    def PoundsPerDay(self) -> float:
        """ Get MassFlow in PoundsPerDay.
        """
        pass

    @property
    def PoundsPerHour(self) -> float:
        """ Get MassFlow in PoundsPerHour.
        """
        pass

    @property
    def PoundsPerMinute(self) -> float:
        """ Get MassFlow in PoundsPerMinute.
        """
        pass

    @property
    def PoundsPerSecond(self) -> float:
        """ Get MassFlow in PoundsPerSecond.
        """
        pass

    @property
    def ShortTonsPerHour(self) -> float:
        """ Get MassFlow in ShortTonsPerHour.
        """
        pass

    @property
    def TonnesPerDay(self) -> float:
        """ Get MassFlow in TonnesPerDay.
        """
        pass

    @property
    def TonnesPerHour(self) -> float:
        """ Get MassFlow in TonnesPerHour.
        """
        pass

    def __init__(self, value: float, unit: MassFlowUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassFlowUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromKilogramsPerSecond(kilogramspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from KilogramsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegagramsPerDay(megagramsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from MegagramsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsPerDay(megapoundsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from MegapoundsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsPerHour(megapoundsperhour: QuantityValue) -> MassFlow:
        """ Get MassFlow from MegapoundsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsPerMinute(megapoundsperminute: QuantityValue) -> MassFlow:
        """ Get MassFlow from MegapoundsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsPerSecond(megapoundspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from MegapoundsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerDay(microgramsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from MicrogramsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerSecond(microgramspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from MicrogramsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerDay(milligramsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from MilligramsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerSecond(milligramspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from MilligramsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerDay(nanogramsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from NanogramsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerSecond(nanogramspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from NanogramsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerDay(poundsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from PoundsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerHour(poundsperhour: QuantityValue) -> MassFlow:
        """ Get MassFlow from PoundsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerMinute(poundsperminute: QuantityValue) -> MassFlow:
        """ Get MassFlow from PoundsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerSecond(poundspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from PoundsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromShortTonsPerHour(shorttonsperhour: QuantityValue) -> MassFlow:
        """ Get MassFlow from ShortTonsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerDay(tonnesperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from TonnesPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesPerHour(tonnesperhour: QuantityValue) -> MassFlow:
        """ Get MassFlow from TonnesPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassFlowUnit) -> MassFlow:
        """ Dynamically convert from value and unit enum "MassFlowUnit" to "MassFlow".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassFlowUnit
        :return: MassFlow unit value.
        :rtype: MassFlow
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MassFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MassFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MassFlow) -> typing.Tuple[MassFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFlow
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MassFlow) -> typing.Tuple[MassFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFlow
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassFlowUnit) -> typing.Tuple[MassFlowUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassFlowUnit) -> typing.Tuple[MassFlowUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassFlowUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MassFlow) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFlow) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFlow, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MassFlow within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MassFlow
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MassFlow.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassFlowUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassFlowUnit) -> MassFlow:
        """ Converts this MassFlow to another MassFlow with the unit representation .

        :return: A MassFlow with the specified unit.
        :rtype: MassFlow
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MassFlow:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFlowUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFlowUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFlowUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFlowUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerDay(centigramsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from CentigramsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerSecond(centigramspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from CentigramsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagramsPerDay(decagramsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from DecagramsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagramsPerSecond(decagramspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from DecagramsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerDay(decigramsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from DecigramsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerSecond(decigramspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from DecigramsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerDay(gramsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from GramsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerHour(gramsperhour: QuantityValue) -> MassFlow:
        """ Get MassFlow from GramsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerSecond(gramspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from GramsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectogramsPerDay(hectogramsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from HectogramsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectogramsPerSecond(hectogramspersecond: QuantityValue) -> MassFlow:
        """ Get MassFlow from HectogramsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerDay(kilogramsperday: QuantityValue) -> MassFlow:
        """ Get MassFlow from KilogramsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerHour(kilogramsperhour: QuantityValue) -> MassFlow:
        """ Get MassFlow from KilogramsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerMinute(kilogramsperminute: QuantityValue) -> MassFlow:
        """ Get MassFlow from KilogramsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class MassFlux(ValueType, IQuantity[MassFluxUnit], IQuantity, IFormattable, IEquatable[MassFlux], IComparable, IComparable[MassFlux], IConvertible):
    """ Mass flux is the mass flow rate per unit area.
    """

    Info: typing.ClassVar[QuantityInfo[MassFluxUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassFluxUnit]

    MaxValue: typing.ClassVar[MassFlux]

    MinValue: typing.ClassVar[MassFlux]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassFluxUnit]]

    Zero: typing.ClassVar[MassFlux]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassFluxUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassFluxUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GramsPerHourPerSquareCentimeter(self) -> float:
        """ Get MassFlux in GramsPerHourPerSquareCentimeter.
        """
        pass

    @property
    def GramsPerHourPerSquareMeter(self) -> float:
        """ Get MassFlux in GramsPerHourPerSquareMeter.
        """
        pass

    @property
    def GramsPerHourPerSquareMillimeter(self) -> float:
        """ Get MassFlux in GramsPerHourPerSquareMillimeter.
        """
        pass

    @property
    def GramsPerSecondPerSquareCentimeter(self) -> float:
        """ Get MassFlux in GramsPerSecondPerSquareCentimeter.
        """
        pass

    @property
    def GramsPerSecondPerSquareMeter(self) -> float:
        """ Get MassFlux in GramsPerSecondPerSquareMeter.
        """
        pass

    @property
    def GramsPerSecondPerSquareMillimeter(self) -> float:
        """ Get MassFlux in GramsPerSecondPerSquareMillimeter.
        """
        pass

    @property
    def KilogramsPerHourPerSquareCentimeter(self) -> float:
        """ Get MassFlux in KilogramsPerHourPerSquareCentimeter.
        """
        pass

    @property
    def KilogramsPerHourPerSquareMeter(self) -> float:
        """ Get MassFlux in KilogramsPerHourPerSquareMeter.
        """
        pass

    @property
    def KilogramsPerHourPerSquareMillimeter(self) -> float:
        """ Get MassFlux in KilogramsPerHourPerSquareMillimeter.
        """
        pass

    @property
    def KilogramsPerSecondPerSquareCentimeter(self) -> float:
        """ Get MassFlux in KilogramsPerSecondPerSquareCentimeter.
        """
        pass

    @property
    def KilogramsPerSecondPerSquareMeter(self) -> float:
        """ Get MassFlux in KilogramsPerSecondPerSquareMeter.
        """
        pass

    @property
    def KilogramsPerSecondPerSquareMillimeter(self) -> float:
        """ Get MassFlux in KilogramsPerSecondPerSquareMillimeter.
        """
        pass

    def __init__(self, value: float, unit: MassFluxUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassFluxUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unit: MassFluxUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassFluxUnit) -> MassFlux:
        """ Converts this MassFlux to another MassFlux with the unit representation .

        :return: A MassFlux with the specified unit.
        :rtype: MassFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MassFlux:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFluxUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFluxUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFluxUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFluxUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramsPerHourPerSquareCentimeter(gramsperhourpersquarecentimeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from GramsPerHourPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerHourPerSquareMeter(gramsperhourpersquaremeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from GramsPerHourPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerHourPerSquareMillimeter(gramsperhourpersquaremillimeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from GramsPerHourPerSquareMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerSecondPerSquareCentimeter(gramspersecondpersquarecentimeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from GramsPerSecondPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerSecondPerSquareMeter(gramspersecondpersquaremeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from GramsPerSecondPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerSecondPerSquareMillimeter(gramspersecondpersquaremillimeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from GramsPerSecondPerSquareMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerHourPerSquareCentimeter(kilogramsperhourpersquarecentimeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from KilogramsPerHourPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerHourPerSquareMeter(kilogramsperhourpersquaremeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from KilogramsPerHourPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerHourPerSquareMillimeter(kilogramsperhourpersquaremillimeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from KilogramsPerHourPerSquareMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerSecondPerSquareCentimeter(kilogramspersecondpersquarecentimeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from KilogramsPerSecondPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerSecondPerSquareMeter(kilogramspersecondpersquaremeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from KilogramsPerSecondPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerSecondPerSquareMillimeter(kilogramspersecondpersquaremillimeter: QuantityValue) -> MassFlux:
        """ Get MassFlux from KilogramsPerSecondPerSquareMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassFluxUnit) -> MassFlux:
        """ Dynamically convert from value and unit enum "MassFluxUnit" to "MassFlux".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassFluxUnit
        :return: MassFlux unit value.
        :rtype: MassFlux
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MassFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MassFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MassFlux) -> typing.Tuple[MassFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFlux
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MassFlux) -> typing.Tuple[MassFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFlux
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassFluxUnit) -> typing.Tuple[MassFluxUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassFluxUnit) -> typing.Tuple[MassFluxUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassFluxUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MassFlux) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFlux) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFlux, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MassFlux within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MassFlux
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MassFlux.
        :rtype: int
        """
        pass


# noinspection PyPep8Naming
class MassFraction(ValueType, IQuantity[MassFractionUnit], IQuantity, IFormattable, IEquatable[MassFraction], IComparable, IComparable[MassFraction], IConvertible):
    """ The mass fraction is defined as the mass of a constituent divided by the total mass of the mixture.
     https://en.wikipedia.org/wiki/Mass_fraction_(chemistry)
    """

    Info: typing.ClassVar[QuantityInfo[MassFractionUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassFractionUnit]

    MaxValue: typing.ClassVar[MassFraction]

    MinValue: typing.ClassVar[MassFraction]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassFractionUnit]]

    Zero: typing.ClassVar[MassFraction]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassFractionUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassFractionUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentigramsPerGram(self) -> float:
        """ Get MassFraction in CentigramsPerGram.
        """
        pass

    @property
    def CentigramsPerKilogram(self) -> float:
        """ Get MassFraction in CentigramsPerKilogram.
        """
        pass

    @property
    def DecagramsPerGram(self) -> float:
        """ Get MassFraction in DecagramsPerGram.
        """
        pass

    @property
    def DecagramsPerKilogram(self) -> float:
        """ Get MassFraction in DecagramsPerKilogram.
        """
        pass

    @property
    def DecigramsPerGram(self) -> float:
        """ Get MassFraction in DecigramsPerGram.
        """
        pass

    @property
    def DecigramsPerKilogram(self) -> float:
        """ Get MassFraction in DecigramsPerKilogram.
        """
        pass

    @property
    def DecimalFractions(self) -> float:
        """ Get MassFraction in DecimalFractions.
        """
        pass

    @property
    def GramsPerGram(self) -> float:
        """ Get MassFraction in GramsPerGram.
        """
        pass

    @property
    def GramsPerKilogram(self) -> float:
        """ Get MassFraction in GramsPerKilogram.
        """
        pass

    @property
    def HectogramsPerGram(self) -> float:
        """ Get MassFraction in HectogramsPerGram.
        """
        pass

    @property
    def HectogramsPerKilogram(self) -> float:
        """ Get MassFraction in HectogramsPerKilogram.
        """
        pass

    @property
    def KilogramsPerGram(self) -> float:
        """ Get MassFraction in KilogramsPerGram.
        """
        pass

    @property
    def KilogramsPerKilogram(self) -> float:
        """ Get MassFraction in KilogramsPerKilogram.
        """
        pass

    @property
    def MicrogramsPerGram(self) -> float:
        """ Get MassFraction in MicrogramsPerGram.
        """
        pass

    @property
    def MicrogramsPerKilogram(self) -> float:
        """ Get MassFraction in MicrogramsPerKilogram.
        """
        pass

    @property
    def MilligramsPerGram(self) -> float:
        """ Get MassFraction in MilligramsPerGram.
        """
        pass

    @property
    def MilligramsPerKilogram(self) -> float:
        """ Get MassFraction in MilligramsPerKilogram.
        """
        pass

    @property
    def NanogramsPerGram(self) -> float:
        """ Get MassFraction in NanogramsPerGram.
        """
        pass

    @property
    def NanogramsPerKilogram(self) -> float:
        """ Get MassFraction in NanogramsPerKilogram.
        """
        pass

    @property
    def PartsPerBillion(self) -> float:
        """ Get MassFraction in PartsPerBillion.
        """
        pass

    @property
    def PartsPerMillion(self) -> float:
        """ Get MassFraction in PartsPerMillion.
        """
        pass

    @property
    def PartsPerThousand(self) -> float:
        """ Get MassFraction in PartsPerThousand.
        """
        pass

    @property
    def PartsPerTrillion(self) -> float:
        """ Get MassFraction in PartsPerTrillion.
        """
        pass

    @property
    def Percent(self) -> float:
        """ Get MassFraction in Percent.
        """
        pass

    def __init__(self, value: float, unit: MassFractionUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassFractionUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MassFraction) -> typing.Tuple[MassFraction, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFraction
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassFractionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassFractionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassFractionUnit) -> typing.Tuple[MassFractionUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassFractionUnit) -> typing.Tuple[MassFractionUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassFractionUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MassFraction) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFraction) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassFraction, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MassFraction within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MassFraction
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MassFraction.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassFractionUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassFractionUnit) -> MassFraction:
        """ Converts this MassFraction to another MassFraction with the unit representation .

        :return: A MassFraction with the specified unit.
        :rtype: MassFraction
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MassFraction:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def GetComponentMass(self, totalMass: Mass) -> Mass:
        """Get the "Mass" of the component by multiplying the "Mass" of the mixture and this "MassFraction".

        :param totalMass: The total mass of the mixture
        :type totalMass: Mass
        :return: The actual mass of the component involved in this mixture
        :rtype: Mass
        """
        pass

    def GetTotalMass(self, componentMass: Mass) -> Mass:
        """Get the total "Mass" of the mixture by dividing the "Mass" of the component by this "MassFraction"

        :param componentMass: The actual mass of the component involved in this mixture
        :type componentMass: Mass
        :return: The total mass of the mixture
        :rtype: Mass
        """
        pass

    @staticmethod
    def FromMasses(componentMass: Mass, mixtureMass: Mass) -> MassFraction:
        """ Get "MassFraction" from a component "Mass" and total mixture "Mass" .
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFractionUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFractionUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassFractionUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassFractionUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerGram(centigramspergram: QuantityValue) -> MassFraction:
        """ Get MassFraction from CentigramsPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentigramsPerKilogram(centigramsperkilogram: QuantityValue) -> MassFraction:
        """ Get MassFraction from CentigramsPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagramsPerGram(decagramspergram: QuantityValue) -> MassFraction:
        """ Get MassFraction from DecagramsPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagramsPerKilogram(decagramsperkilogram: QuantityValue) -> MassFraction:
        """ Get MassFraction from DecagramsPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerGram(decigramspergram: QuantityValue) -> MassFraction:
        """ Get MassFraction from DecigramsPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerKilogram(decigramsperkilogram: QuantityValue) -> MassFraction:
        """ Get MassFraction from DecigramsPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimalFractions(decimalfractions: QuantityValue) -> MassFraction:
        """ Get MassFraction from DecimalFractions.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerGram(gramspergram: QuantityValue) -> MassFraction:
        """ Get MassFraction from GramsPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerKilogram(gramsperkilogram: QuantityValue) -> MassFraction:
        """ Get MassFraction from GramsPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectogramsPerGram(hectogramspergram: QuantityValue) -> MassFraction:
        """ Get MassFraction from HectogramsPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectogramsPerKilogram(hectogramsperkilogram: QuantityValue) -> MassFraction:
        """ Get MassFraction from HectogramsPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerGram(kilogramspergram: QuantityValue) -> MassFraction:
        """ Get MassFraction from KilogramsPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerKilogram(kilogramsperkilogram: QuantityValue) -> MassFraction:
        """ Get MassFraction from KilogramsPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerGram(microgramspergram: QuantityValue) -> MassFraction:
        """ Get MassFraction from MicrogramsPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerKilogram(microgramsperkilogram: QuantityValue) -> MassFraction:
        """ Get MassFraction from MicrogramsPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerGram(milligramspergram: QuantityValue) -> MassFraction:
        """ Get MassFraction from MilligramsPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerKilogram(milligramsperkilogram: QuantityValue) -> MassFraction:
        """ Get MassFraction from MilligramsPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerGram(nanogramspergram: QuantityValue) -> MassFraction:
        """ Get MassFraction from NanogramsPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerKilogram(nanogramsperkilogram: QuantityValue) -> MassFraction:
        """ Get MassFraction from NanogramsPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerBillion(partsperbillion: QuantityValue) -> MassFraction:
        """ Get MassFraction from PartsPerBillion.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerMillion(partspermillion: QuantityValue) -> MassFraction:
        """ Get MassFraction from PartsPerMillion.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerThousand(partsperthousand: QuantityValue) -> MassFraction:
        """ Get MassFraction from PartsPerThousand.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerTrillion(partspertrillion: QuantityValue) -> MassFraction:
        """ Get MassFraction from PartsPerTrillion.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPercent(percent: QuantityValue) -> MassFraction:
        """ Get MassFraction from Percent.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassFractionUnit) -> MassFraction:
        """ Dynamically convert from value and unit enum "MassFractionUnit" to "MassFraction".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassFractionUnit
        :return: MassFraction unit value.
        :rtype: MassFraction
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MassFraction:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MassFraction:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MassFraction) -> typing.Tuple[MassFraction, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassFraction
        """
        pass


# noinspection PyPep8Naming
class Molarity(ValueType, IQuantity[MolarityUnit], IQuantity, IFormattable, IEquatable[Molarity], IComparable, IComparable[Molarity], IConvertible):
    """ Molar concentration, also called molarity, amount concentration or substance concentration, is a measure of the concentration of a solute in a solution, or of any chemical species, in terms of amount of substance in a given volume.
     https://en.wikipedia.org/wiki/Molar_concentration
    """

    Info: typing.ClassVar[QuantityInfo[MolarityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MolarityUnit]

    MaxValue: typing.ClassVar[Molarity]

    MinValue: typing.ClassVar[Molarity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MolarityUnit]]

    Zero: typing.ClassVar[Molarity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MolarityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MolarityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimolesPerLiter(self) -> float:
        """ Get Molarity in CentimolesPerLiter.
        """
        pass

    @property
    def DecimolesPerLiter(self) -> float:
        """ Get Molarity in DecimolesPerLiter.
        """
        pass

    @property
    def MicromolesPerLiter(self) -> float:
        """ Get Molarity in MicromolesPerLiter.
        """
        pass

    @property
    def MillimolesPerLiter(self) -> float:
        """ Get Molarity in MillimolesPerLiter.
        """
        pass

    @property
    def MolesPerCubicMeter(self) -> float:
        """ Get Molarity in MolesPerCubicMeter.
        """
        pass

    @property
    def MolesPerLiter(self) -> float:
        """ Get Molarity in MolesPerLiter.
        """
        pass

    @property
    def NanomolesPerLiter(self) -> float:
        """ Get Molarity in NanomolesPerLiter.
        """
        pass

    @property
    def PicomolesPerLiter(self) -> float:
        """ Get Molarity in PicomolesPerLiter.
        """
        pass

    def __init__(self, density: Density, molecularWeight: Mass) -> None:
        """ Construct from "Density" divided by "Mass".
        """
        pass

    def __init__(self, value: float, unit: MolarityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MolarityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unit: MolarityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarityUnit) -> Molarity:
        """ Converts this Molarity to another Molarity with the unit representation .

        :return: A Molarity with the specified unit.
        :rtype: Molarity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Molarity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToDensity(self, molecularWeight: Mass) -> Density:
        """ Get a "Density" from this "Molarity".

        :param molecularWeight:
        :type molecularWeight: Mass
        """
        pass

    def ToMassConcentration(self, molecularWeight: MolarMass) -> MassConcentration:
        """ Get a "MassConcentration" from this "Molarity".

        :param molecularWeight:
        :type molecularWeight: MolarMass
        """
        pass

    def ToVolumeConcentration(self, componentDensity: Density, componentMass: MolarMass) -> VolumeConcentration:
        """ Get a "MassConcentration" from this "Molarity".

        :param componentDensity:
        :type componentDensity: Density
        :param componentMass:
        :type componentMass: MolarMass
        """
        pass

    @staticmethod
    def FromDensity(density: Density, molecularWeight: Mass) -> Molarity:
        """ Get "Molarity" from "Density".

        :param density:
        :type density: Density
        :param molecularWeight:
        :type molecularWeight: Mass
        """
        pass

    @staticmethod
    def FromVolumeConcentration(volumeConcentration: VolumeConcentration, componentDensity: Density, componentMass: MolarMass) -> Molarity:
        """ Get "Molarity" from "VolumeConcentration" and known component "Density" and "MolarMass".

        :param volumeConcentration:
        :type volumeConcentration: VolumeConcentration
        :param componentDensity:
        :type componentDensity: Density
        :param componentMass:
        :type componentMass: MolarMass
        :return:
        :rtype: Molarity
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimolesPerLiter(centimolesperliter: QuantityValue) -> Molarity:
        """ Get Molarity from CentimolesPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimolesPerLiter(decimolesperliter: QuantityValue) -> Molarity:
        """ Get Molarity from DecimolesPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicromolesPerLiter(micromolesperliter: QuantityValue) -> Molarity:
        """ Get Molarity from MicromolesPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimolesPerLiter(millimolesperliter: QuantityValue) -> Molarity:
        """ Get Molarity from MillimolesPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMolesPerCubicMeter(molespercubicmeter: QuantityValue) -> Molarity:
        """ Get Molarity from MolesPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMolesPerLiter(molesperliter: QuantityValue) -> Molarity:
        """ Get Molarity from MolesPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanomolesPerLiter(nanomolesperliter: QuantityValue) -> Molarity:
        """ Get Molarity from NanomolesPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicomolesPerLiter(picomolesperliter: QuantityValue) -> Molarity:
        """ Get Molarity from PicomolesPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MolarityUnit) -> Molarity:
        """ Dynamically convert from value and unit enum "MolarityUnit" to "Molarity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MolarityUnit
        :return: Molarity unit value.
        :rtype: Molarity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Molarity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Molarity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Molarity) -> typing.Tuple[Molarity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Molarity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Molarity) -> typing.Tuple[Molarity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Molarity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MolarityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MolarityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MolarityUnit) -> typing.Tuple[MolarityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MolarityUnit) -> typing.Tuple[MolarityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MolarityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Molarity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Molarity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Molarity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Molarity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Molarity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Molarity.
        :rtype: int
        """
        pass


# noinspection PyPep8Naming
class Power(ValueType, IQuantity[PowerUnit], IQuantity, IFormattable, IDecimalQuantity, IEquatable[Power], IComparable, IComparable[Power], IConvertible):
    """ In physics, power is the rate of doing work. It is equivalent to an amount of energy consumed per unit time.
    """

    Info: typing.ClassVar[QuantityInfo[PowerUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PowerUnit]

    MaxValue: typing.ClassVar[Power]

    MinValue: typing.ClassVar[Power]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PowerUnit]]

    Zero: typing.ClassVar[Power]

    @property
    def Value(self) -> Decimal:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PowerUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PowerUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BoilerHorsepower(self) -> float:
        """ Get Power in BoilerHorsepower.
        """
        pass

    @property
    def BritishThermalUnitsPerHour(self) -> float:
        """ Get Power in BritishThermalUnitsPerHour.
        """
        pass

    @property
    def Decawatts(self) -> float:
        """ Get Power in Decawatts.
        """
        pass

    @property
    def Deciwatts(self) -> float:
        """ Get Power in Deciwatts.
        """
        pass

    @property
    def ElectricalHorsepower(self) -> float:
        """ Get Power in ElectricalHorsepower.
        """
        pass

    @property
    def Femtowatts(self) -> float:
        """ Get Power in Femtowatts.
        """
        pass

    @property
    def GigajoulesPerHour(self) -> float:
        """ Get Power in GigajoulesPerHour.
        """
        pass

    @property
    def Gigawatts(self) -> float:
        """ Get Power in Gigawatts.
        """
        pass

    @property
    def HydraulicHorsepower(self) -> float:
        """ Get Power in HydraulicHorsepower.
        """
        pass

    @property
    def JoulesPerHour(self) -> float:
        """ Get Power in JoulesPerHour.
        """
        pass

    @property
    def KilobritishThermalUnitsPerHour(self) -> float:
        """ Get Power in KilobritishThermalUnitsPerHour.
        """
        pass

    @property
    def KilojoulesPerHour(self) -> float:
        """ Get Power in KilojoulesPerHour.
        """
        pass

    @property
    def Kilowatts(self) -> float:
        """ Get Power in Kilowatts.
        """
        pass

    @property
    def MechanicalHorsepower(self) -> float:
        """ Get Power in MechanicalHorsepower.
        """
        pass

    @property
    def MegajoulesPerHour(self) -> float:
        """ Get Power in MegajoulesPerHour.
        """
        pass

    @property
    def Megawatts(self) -> float:
        """ Get Power in Megawatts.
        """
        pass

    @property
    def MetricHorsepower(self) -> float:
        """ Get Power in MetricHorsepower.
        """
        pass

    @property
    def Microwatts(self) -> float:
        """ Get Power in Microwatts.
        """
        pass

    @property
    def MillijoulesPerHour(self) -> float:
        """ Get Power in MillijoulesPerHour.
        """
        pass

    @property
    def Milliwatts(self) -> float:
        """ Get Power in Milliwatts.
        """
        pass

    @property
    def Nanowatts(self) -> float:
        """ Get Power in Nanowatts.
        """
        pass

    @property
    def Petawatts(self) -> float:
        """ Get Power in Petawatts.
        """
        pass

    @property
    def Picowatts(self) -> float:
        """ Get Power in Picowatts.
        """
        pass

    @property
    def Terawatts(self) -> float:
        """ Get Power in Terawatts.
        """
        pass

    @property
    def Watts(self) -> float:
        """ Get Power in Watts.
        """
        pass

    def __init__(self, value: Decimal, unit: PowerUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unit: The unit representation to construct this quantity with.
        :type unit: PowerUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: Decimal, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromMechanicalHorsepower(mechanicalhorsepower: QuantityValue) -> Power:
        """ Get Power from MechanicalHorsepower.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerHour(megajoulesperhour: QuantityValue) -> Power:
        """ Get Power from MegajoulesPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawatts(megawatts: QuantityValue) -> Power:
        """ Get Power from Megawatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetricHorsepower(metrichorsepower: QuantityValue) -> Power:
        """ Get Power from MetricHorsepower.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowatts(microwatts: QuantityValue) -> Power:
        """ Get Power from Microwatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillijoulesPerHour(millijoulesperhour: QuantityValue) -> Power:
        """ Get Power from MillijoulesPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwatts(milliwatts: QuantityValue) -> Power:
        """ Get Power from Milliwatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowatts(nanowatts: QuantityValue) -> Power:
        """ Get Power from Nanowatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetawatts(petawatts: QuantityValue) -> Power:
        """ Get Power from Petawatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowatts(picowatts: QuantityValue) -> Power:
        """ Get Power from Picowatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawatts(terawatts: QuantityValue) -> Power:
        """ Get Power from Terawatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWatts(watts: QuantityValue) -> Power:
        """ Get Power from Watts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PowerUnit) -> Power:
        """ Dynamically convert from value and unit enum "PowerUnit" to "Power".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PowerUnit
        :return: Power unit value.
        :rtype: Power
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Power:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Power:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Power) -> typing.Tuple[Power, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Power
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Power) -> typing.Tuple[Power, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Power
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PowerUnit) -> typing.Tuple[PowerUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PowerUnit) -> typing.Tuple[PowerUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PowerUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Power) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Power) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Power, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Power within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Power
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Power.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PowerUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PowerUnit) -> Power:
        """ Converts this Power to another Power with the unit representation .

        :return: A Power with the specified unit.
        :rtype: Power
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Power:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToPowerRatio(self) -> PowerRatio:
        """ Gets a "PowerRatio" from this "Power" relative to one watt.
         Provides a nicer syntax for converting a power to a power ratio (relative to 1 watt).
         var powerRatio = power.ToPowerRatio();
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBoilerHorsepower(boilerhorsepower: QuantityValue) -> Power:
        """ Get Power from BoilerHorsepower.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBritishThermalUnitsPerHour(britishthermalunitsperhour: QuantityValue) -> Power:
        """ Get Power from BritishThermalUnitsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecawatts(decawatts: QuantityValue) -> Power:
        """ Get Power from Decawatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwatts(deciwatts: QuantityValue) -> Power:
        """ Get Power from Deciwatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromElectricalHorsepower(electricalhorsepower: QuantityValue) -> Power:
        """ Get Power from ElectricalHorsepower.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFemtowatts(femtowatts: QuantityValue) -> Power:
        """ Get Power from Femtowatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigajoulesPerHour(gigajoulesperhour: QuantityValue) -> Power:
        """ Get Power from GigajoulesPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawatts(gigawatts: QuantityValue) -> Power:
        """ Get Power from Gigawatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHydraulicHorsepower(hydraulichorsepower: QuantityValue) -> Power:
        """ Get Power from HydraulicHorsepower.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerHour(joulesperhour: QuantityValue) -> Power:
        """ Get Power from JoulesPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobritishThermalUnitsPerHour(kilobritishthermalunitsperhour: QuantityValue) -> Power:
        """ Get Power from KilobritishThermalUnitsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerHour(kilojoulesperhour: QuantityValue) -> Power:
        """ Get Power from KilojoulesPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowatts(kilowatts: QuantityValue) -> Power:
        """ Get Power from Kilowatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class PowerRatio(ValueType, IQuantity[PowerRatioUnit], IQuantity, IFormattable, IEquatable[PowerRatio], IComparable, IComparable[PowerRatio], IConvertible):
    """ The strength of a signal expressed in decibels (dB) relative to one watt.
    """

    Info: typing.ClassVar[QuantityInfo[PowerRatioUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PowerRatioUnit]

    MaxValue: typing.ClassVar[PowerRatio]

    MinValue: typing.ClassVar[PowerRatio]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PowerRatioUnit]]

    Zero: typing.ClassVar[PowerRatio]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PowerRatioUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PowerRatioUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DecibelMilliwatts(self) -> float:
        """ Get PowerRatio in DecibelMilliwatts.
        """
        pass

    @property
    def DecibelWatts(self) -> float:
        """ Get PowerRatio in DecibelWatts.
        """
        pass

    def __init__(self, power: Power) -> None:
        """ Initializes a new instance of the "PowerRatio" struct from the specified power referenced to one watt.

        :param power: The power relative to one watt.
        :type power: Power
        """
        pass

    def __init__(self, value: float, unit: PowerRatioUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PowerRatioUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToPower(self) -> Power:
        """ Gets a "Power" from this "PowerRatio" (which is a power level relative to one watt).
         Provides a nicer syntax for converting a power ratio back to a power.
         var power = powerRatio.ToPower();
        """
        pass

    def ToAmplitudeRatio(self, impedance: ElectricResistance) -> AmplitudeRatio:
        """ Gets a "AmplitudeRatio" from this "PowerRatio".

        :param impedance: The input impedance of the load. This is usually 50, 75 or 600 ohms.
        :type impedance: ElectricResistance
        """
        pass

    @staticmethod
    def FromPower(power: Power) -> PowerRatio:
        """ Gets a "PowerRatio" from a "Power" relative to one watt.

        :param power: The power relative to one watt.
        :type power: Power
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerRatioUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerRatioUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerRatioUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerRatioUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecibelMilliwatts(decibelmilliwatts: QuantityValue) -> PowerRatio:
        """ Get PowerRatio from DecibelMilliwatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecibelWatts(decibelwatts: QuantityValue) -> PowerRatio:
        """ Get PowerRatio from DecibelWatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PowerRatioUnit) -> PowerRatio:
        """ Dynamically convert from value and unit enum "PowerRatioUnit" to "PowerRatio".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PowerRatioUnit
        :return: PowerRatio unit value.
        :rtype: PowerRatio
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> PowerRatio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> PowerRatio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: PowerRatio) -> typing.Tuple[PowerRatio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PowerRatio
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: PowerRatio) -> typing.Tuple[PowerRatio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PowerRatio
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PowerRatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PowerRatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PowerRatioUnit) -> typing.Tuple[PowerRatioUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PowerRatioUnit) -> typing.Tuple[PowerRatioUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PowerRatioUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: PowerRatio) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PowerRatio) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PowerRatio, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another PowerRatio within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: PowerRatio
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current PowerRatio.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PowerRatioUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PowerRatioUnit) -> PowerRatio:
        """ Converts this PowerRatio to another PowerRatio with the unit representation .

        :return: A PowerRatio with the specified unit.
        :rtype: PowerRatio
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> PowerRatio:
        """
        """
        pass


# noinspection PyPep8Naming
class Pressure(ValueType, IQuantity[PressureUnit], IQuantity, IFormattable, IEquatable[Pressure], IComparable, IComparable[Pressure], IConvertible):
    """ Pressure (symbol: P or p) is the ratio of force to the area over which that force is distributed. Pressure is force per unit area applied in a direction perpendicular to the surface of an object. Gauge pressure (also spelled gage pressure)[a] is the pressure relative to the local atmospheric or ambient pressure. Pressure is measured in any unit of force divided by any unit of area. The SI unit of pressure is the newton per square metre, which is called the pascal (Pa) after the seventeenth-century philosopher and scientist Blaise Pascal. A pressure of 1 Pa is small; it approximately equals the pressure exerted by a dollar bill resting flat on a table. Everyday pressures are often stated in kilopascals (1 kPa = 1000 Pa).
    """

    Info: typing.ClassVar[QuantityInfo[PressureUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PressureUnit]

    MaxValue: typing.ClassVar[Pressure]

    MinValue: typing.ClassVar[Pressure]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PressureUnit]]

    Zero: typing.ClassVar[Pressure]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PressureUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PressureUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Atmospheres(self) -> float:
        """ Get Pressure in Atmospheres.
        """
        pass

    @property
    def Bars(self) -> float:
        """ Get Pressure in Bars.
        """
        pass

    @property
    def Centibars(self) -> float:
        """ Get Pressure in Centibars.
        """
        pass

    @property
    def Decapascals(self) -> float:
        """ Get Pressure in Decapascals.
        """
        pass

    @property
    def Decibars(self) -> float:
        """ Get Pressure in Decibars.
        """
        pass

    @property
    def DynesPerSquareCentimeter(self) -> float:
        """ Get Pressure in DynesPerSquareCentimeter.
        """
        pass

    @property
    def FeetOfElevation(self) -> float:
        """ Get Pressure in FeetOfElevation.
        """
        pass

    @property
    def FeetOfHead(self) -> float:
        """ Get Pressure in FeetOfHead.
        """
        pass

    @property
    def Gigapascals(self) -> float:
        """ Get Pressure in Gigapascals.
        """
        pass

    @property
    def Hectopascals(self) -> float:
        """ Get Pressure in Hectopascals.
        """
        pass

    @property
    def InchesOfMercury(self) -> float:
        """ Get Pressure in InchesOfMercury.
        """
        pass

    @property
    def InchesOfWaterColumn(self) -> float:
        """ Get Pressure in InchesOfWaterColumn.
        """
        pass

    @property
    def Kilobars(self) -> float:
        """ Get Pressure in Kilobars.
        """
        pass

    @property
    def KilogramsForcePerSquareCentimeter(self) -> float:
        """ Get Pressure in KilogramsForcePerSquareCentimeter.
        """
        pass

    @property
    def KilogramsForcePerSquareMeter(self) -> float:
        """ Get Pressure in KilogramsForcePerSquareMeter.
        """
        pass

    @property
    def KilogramsForcePerSquareMillimeter(self) -> float:
        """ Get Pressure in KilogramsForcePerSquareMillimeter.
        """
        pass

    @property
    def KilonewtonsPerSquareCentimeter(self) -> float:
        """ Get Pressure in KilonewtonsPerSquareCentimeter.
        """
        pass

    @property
    def KilonewtonsPerSquareMeter(self) -> float:
        """ Get Pressure in KilonewtonsPerSquareMeter.
        """
        pass

    @property
    def KilonewtonsPerSquareMillimeter(self) -> float:
        """ Get Pressure in KilonewtonsPerSquareMillimeter.
        """
        pass

    @property
    def Kilopascals(self) -> float:
        """ Get Pressure in Kilopascals.
        """
        pass

    @property
    def KilopoundsForcePerSquareFoot(self) -> float:
        """ Get Pressure in KilopoundsForcePerSquareFoot.
        """
        pass

    @property
    def KilopoundsForcePerSquareInch(self) -> float:
        """ Get Pressure in KilopoundsForcePerSquareInch.
        """
        pass

    @property
    def Megabars(self) -> float:
        """ Get Pressure in Megabars.
        """
        pass

    @property
    def MeganewtonsPerSquareMeter(self) -> float:
        """ Get Pressure in MeganewtonsPerSquareMeter.
        """
        pass

    @property
    def Megapascals(self) -> float:
        """ Get Pressure in Megapascals.
        """
        pass

    @property
    def MetersOfElevation(self) -> float:
        """ Get Pressure in MetersOfElevation.
        """
        pass

    @property
    def MetersOfHead(self) -> float:
        """ Get Pressure in MetersOfHead.
        """
        pass

    @property
    def Microbars(self) -> float:
        """ Get Pressure in Microbars.
        """
        pass

    @property
    def Micropascals(self) -> float:
        """ Get Pressure in Micropascals.
        """
        pass

    @property
    def Millibars(self) -> float:
        """ Get Pressure in Millibars.
        """
        pass

    @property
    def MillimetersOfMercury(self) -> float:
        """ Get Pressure in MillimetersOfMercury.
        """
        pass

    @property
    def Millipascals(self) -> float:
        """ Get Pressure in Millipascals.
        """
        pass

    @property
    def NewtonsPerSquareCentimeter(self) -> float:
        """ Get Pressure in NewtonsPerSquareCentimeter.
        """
        pass

    @property
    def NewtonsPerSquareMeter(self) -> float:
        """ Get Pressure in NewtonsPerSquareMeter.
        """
        pass

    @property
    def NewtonsPerSquareMillimeter(self) -> float:
        """ Get Pressure in NewtonsPerSquareMillimeter.
        """
        pass

    @property
    def Pascals(self) -> float:
        """ Get Pressure in Pascals.
        """
        pass

    @property
    def PoundsForcePerSquareFoot(self) -> float:
        """ Get Pressure in PoundsForcePerSquareFoot.
        """
        pass

    @property
    def PoundsForcePerSquareInch(self) -> float:
        """ Get Pressure in PoundsForcePerSquareInch.
        """
        pass

    @property
    def PoundsPerInchSecondSquared(self) -> float:
        """ Get Pressure in PoundsPerInchSecondSquared.
        """
        pass

    @property
    def TechnicalAtmospheres(self) -> float:
        """ Get Pressure in TechnicalAtmospheres.
        """
        pass

    @property
    def TonnesForcePerSquareCentimeter(self) -> float:
        """ Get Pressure in TonnesForcePerSquareCentimeter.
        """
        pass

    @property
    def TonnesForcePerSquareMeter(self) -> float:
        """ Get Pressure in TonnesForcePerSquareMeter.
        """
        pass

    @property
    def TonnesForcePerSquareMillimeter(self) -> float:
        """ Get Pressure in TonnesForcePerSquareMillimeter.
        """
        pass

    @property
    def Torrs(self) -> float:
        """ Get Pressure in Torrs.
        """
        pass

    def __init__(self, value: float, unit: PressureUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PressureUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromInchesOfMercury(inchesofmercury: QuantityValue) -> Pressure:
        """ Get Pressure from InchesOfMercury.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesOfWaterColumn(inchesofwatercolumn: QuantityValue) -> Pressure:
        """ Get Pressure from InchesOfWaterColumn.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobars(kilobars: QuantityValue) -> Pressure:
        """ Get Pressure from Kilobars.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerSquareCentimeter(kilogramsforcepersquarecentimeter: QuantityValue) -> Pressure:
        """ Get Pressure from KilogramsForcePerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerSquareMeter(kilogramsforcepersquaremeter: QuantityValue) -> Pressure:
        """ Get Pressure from KilogramsForcePerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerSquareMillimeter(kilogramsforcepersquaremillimeter: QuantityValue) -> Pressure:
        """ Get Pressure from KilogramsForcePerSquareMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerSquareCentimeter(kilonewtonspersquarecentimeter: QuantityValue) -> Pressure:
        """ Get Pressure from KilonewtonsPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerSquareMeter(kilonewtonspersquaremeter: QuantityValue) -> Pressure:
        """ Get Pressure from KilonewtonsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerSquareMillimeter(kilonewtonspersquaremillimeter: QuantityValue) -> Pressure:
        """ Get Pressure from KilonewtonsPerSquareMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopascals(kilopascals: QuantityValue) -> Pressure:
        """ Get Pressure from Kilopascals.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSquareFoot(kilopoundsforcepersquarefoot: QuantityValue) -> Pressure:
        """ Get Pressure from KilopoundsForcePerSquareFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSquareInch(kilopoundsforcepersquareinch: QuantityValue) -> Pressure:
        """ Get Pressure from KilopoundsForcePerSquareInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabars(megabars: QuantityValue) -> Pressure:
        """ Get Pressure from Megabars.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonsPerSquareMeter(meganewtonspersquaremeter: QuantityValue) -> Pressure:
        """ Get Pressure from MeganewtonsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapascals(megapascals: QuantityValue) -> Pressure:
        """ Get Pressure from Megapascals.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersOfElevation(metersofelevation: QuantityValue) -> Pressure:
        """ Get Pressure from MetersOfElevation.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersOfHead(metersofhead: QuantityValue) -> Pressure:
        """ Get Pressure from MetersOfHead.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrobars(microbars: QuantityValue) -> Pressure:
        """ Get Pressure from Microbars.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicropascals(micropascals: QuantityValue) -> Pressure:
        """ Get Pressure from Micropascals.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillibars(millibars: QuantityValue) -> Pressure:
        """ Get Pressure from Millibars.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersOfMercury(millimetersofmercury: QuantityValue) -> Pressure:
        """ Get Pressure from MillimetersOfMercury.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillipascals(millipascals: QuantityValue) -> Pressure:
        """ Get Pressure from Millipascals.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerSquareCentimeter(newtonspersquarecentimeter: QuantityValue) -> Pressure:
        """ Get Pressure from NewtonsPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerSquareMeter(newtonspersquaremeter: QuantityValue) -> Pressure:
        """ Get Pressure from NewtonsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerSquareMillimeter(newtonspersquaremillimeter: QuantityValue) -> Pressure:
        """ Get Pressure from NewtonsPerSquareMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPascals(pascals: QuantityValue) -> Pressure:
        """ Get Pressure from Pascals.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSquareFoot(poundsforcepersquarefoot: QuantityValue) -> Pressure:
        """ Get Pressure from PoundsForcePerSquareFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSquareInch(poundsforcepersquareinch: QuantityValue) -> Pressure:
        """ Get Pressure from PoundsForcePerSquareInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerInchSecondSquared(poundsperinchsecondsquared: QuantityValue) -> Pressure:
        """ Get Pressure from PoundsPerInchSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTechnicalAtmospheres(technicalatmospheres: QuantityValue) -> Pressure:
        """ Get Pressure from TechnicalAtmospheres.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerSquareCentimeter(tonnesforcepersquarecentimeter: QuantityValue) -> Pressure:
        """ Get Pressure from TonnesForcePerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerSquareMeter(tonnesforcepersquaremeter: QuantityValue) -> Pressure:
        """ Get Pressure from TonnesForcePerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerSquareMillimeter(tonnesforcepersquaremillimeter: QuantityValue) -> Pressure:
        """ Get Pressure from TonnesForcePerSquareMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTorrs(torrs: QuantityValue) -> Pressure:
        """ Get Pressure from Torrs.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PressureUnit) -> Pressure:
        """ Dynamically convert from value and unit enum "PressureUnit" to "Pressure".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PressureUnit
        :return: Pressure unit value.
        :rtype: Pressure
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Pressure:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Pressure:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Pressure) -> typing.Tuple[Pressure, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Pressure
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Pressure) -> typing.Tuple[Pressure, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Pressure
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PressureUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PressureUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PressureUnit) -> typing.Tuple[PressureUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PressureUnit) -> typing.Tuple[PressureUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PressureUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Pressure) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Pressure) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Pressure, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Pressure within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Pressure
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Pressure.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PressureUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PressureUnit) -> Pressure:
        """ Converts this Pressure to another Pressure with the unit representation .

        :return: A Pressure with the specified unit.
        :rtype: Pressure
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Pressure:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PressureUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PressureUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PressureUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PressureUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAtmospheres(atmospheres: QuantityValue) -> Pressure:
        """ Get Pressure from Atmospheres.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBars(bars: QuantityValue) -> Pressure:
        """ Get Pressure from Bars.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentibars(centibars: QuantityValue) -> Pressure:
        """ Get Pressure from Centibars.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecapascals(decapascals: QuantityValue) -> Pressure:
        """ Get Pressure from Decapascals.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecibars(decibars: QuantityValue) -> Pressure:
        """ Get Pressure from Decibars.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDynesPerSquareCentimeter(dynespersquarecentimeter: QuantityValue) -> Pressure:
        """ Get Pressure from DynesPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetOfElevation(feetofelevation: QuantityValue) -> Pressure:
        """ Get Pressure from FeetOfElevation.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetOfHead(feetofhead: QuantityValue) -> Pressure:
        """ Get Pressure from FeetOfHead.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigapascals(gigapascals: QuantityValue) -> Pressure:
        """ Get Pressure from Gigapascals.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectopascals(hectopascals: QuantityValue) -> Pressure:
        """ Get Pressure from Hectopascals.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class RotationalSpeed(ValueType, IQuantity[RotationalSpeedUnit], IQuantity, IFormattable, IEquatable[RotationalSpeed], IComparable, IComparable[RotationalSpeed], IConvertible):
    """ Rotational speed (sometimes called speed of revolution) is the number of complete rotations, revolutions, cycles, or turns per time unit. Rotational speed is a cyclic frequency, measured in radians per second or in hertz in the SI System by scientists, or in revolutions per minute (rpm or min-1) or revolutions per second in everyday life. The symbol for rotational speed is ω (the Greek lowercase letter "omega").
    """

    Info: typing.ClassVar[QuantityInfo[RotationalSpeedUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RotationalSpeedUnit]

    MaxValue: typing.ClassVar[RotationalSpeed]

    MinValue: typing.ClassVar[RotationalSpeed]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RotationalSpeedUnit]]

    Zero: typing.ClassVar[RotationalSpeed]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RotationalSpeedUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RotationalSpeedUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentiradiansPerSecond(self) -> float:
        """ Get RotationalSpeed in CentiradiansPerSecond.
        """
        pass

    @property
    def DeciradiansPerSecond(self) -> float:
        """ Get RotationalSpeed in DeciradiansPerSecond.
        """
        pass

    @property
    def DegreesPerMinute(self) -> float:
        """ Get RotationalSpeed in DegreesPerMinute.
        """
        pass

    @property
    def DegreesPerSecond(self) -> float:
        """ Get RotationalSpeed in DegreesPerSecond.
        """
        pass

    @property
    def MicrodegreesPerSecond(self) -> float:
        """ Get RotationalSpeed in MicrodegreesPerSecond.
        """
        pass

    @property
    def MicroradiansPerSecond(self) -> float:
        """ Get RotationalSpeed in MicroradiansPerSecond.
        """
        pass

    @property
    def MillidegreesPerSecond(self) -> float:
        """ Get RotationalSpeed in MillidegreesPerSecond.
        """
        pass

    @property
    def MilliradiansPerSecond(self) -> float:
        """ Get RotationalSpeed in MilliradiansPerSecond.
        """
        pass

    @property
    def NanodegreesPerSecond(self) -> float:
        """ Get RotationalSpeed in NanodegreesPerSecond.
        """
        pass

    @property
    def NanoradiansPerSecond(self) -> float:
        """ Get RotationalSpeed in NanoradiansPerSecond.
        """
        pass

    @property
    def RadiansPerSecond(self) -> float:
        """ Get RotationalSpeed in RadiansPerSecond.
        """
        pass

    @property
    def RevolutionsPerMinute(self) -> float:
        """ Get RotationalSpeed in RevolutionsPerMinute.
        """
        pass

    @property
    def RevolutionsPerSecond(self) -> float:
        """ Get RotationalSpeed in RevolutionsPerSecond.
        """
        pass

    def __init__(self, value: float, unit: RotationalSpeedUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RotationalSpeedUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalSpeed) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalSpeed, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RotationalSpeed within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RotationalSpeed
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RotationalSpeed.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RotationalSpeedUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalSpeedUnit) -> RotationalSpeed:
        """ Converts this RotationalSpeed to another RotationalSpeed with the unit representation .

        :return: A RotationalSpeed with the specified unit.
        :rtype: RotationalSpeed
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RotationalSpeed:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalSpeedUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalSpeedUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalSpeedUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalSpeedUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentiradiansPerSecond(centiradianspersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from CentiradiansPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciradiansPerSecond(deciradianspersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from DeciradiansPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesPerMinute(degreesperminute: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from DegreesPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesPerSecond(degreespersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from DegreesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrodegreesPerSecond(microdegreespersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from MicrodegreesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroradiansPerSecond(microradianspersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from MicroradiansPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidegreesPerSecond(millidegreespersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from MillidegreesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliradiansPerSecond(milliradianspersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from MilliradiansPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanodegreesPerSecond(nanodegreespersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from NanodegreesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoradiansPerSecond(nanoradianspersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from NanoradiansPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRadiansPerSecond(radianspersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from RadiansPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRevolutionsPerMinute(revolutionsperminute: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from RevolutionsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRevolutionsPerSecond(revolutionspersecond: QuantityValue) -> RotationalSpeed:
        """ Get RotationalSpeed from RevolutionsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RotationalSpeedUnit) -> RotationalSpeed:
        """ Dynamically convert from value and unit enum "RotationalSpeedUnit" to "RotationalSpeed".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RotationalSpeedUnit
        :return: RotationalSpeed unit value.
        :rtype: RotationalSpeed
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RotationalSpeed:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RotationalSpeed:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RotationalSpeed) -> typing.Tuple[RotationalSpeed, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalSpeed
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RotationalSpeed) -> typing.Tuple[RotationalSpeed, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalSpeed
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RotationalSpeedUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RotationalSpeedUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RotationalSpeedUnit) -> typing.Tuple[RotationalSpeedUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RotationalSpeedUnit) -> typing.Tuple[RotationalSpeedUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RotationalSpeedUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RotationalSpeed) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass


# noinspection PyPep8Naming
class RotationalStiffness(ValueType, IQuantity[RotationalStiffnessUnit], IQuantity, IFormattable, IEquatable[RotationalStiffness], IComparable, IComparable[RotationalStiffness], IConvertible):
    """ https://en.wikipedia.org/wiki/Stiffness#Rotational_stiffness
    """

    Info: typing.ClassVar[QuantityInfo[RotationalStiffnessUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RotationalStiffnessUnit]

    MaxValue: typing.ClassVar[RotationalStiffness]

    MinValue: typing.ClassVar[RotationalStiffness]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RotationalStiffnessUnit]]

    Zero: typing.ClassVar[RotationalStiffness]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RotationalStiffnessUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RotationalStiffnessUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentinewtonMetersPerDegree(self) -> float:
        """ Get RotationalStiffness in CentinewtonMetersPerDegree.
        """
        pass

    @property
    def CentinewtonMillimetersPerDegree(self) -> float:
        """ Get RotationalStiffness in CentinewtonMillimetersPerDegree.
        """
        pass

    @property
    def CentinewtonMillimetersPerRadian(self) -> float:
        """ Get RotationalStiffness in CentinewtonMillimetersPerRadian.
        """
        pass

    @property
    def DecanewtonMetersPerDegree(self) -> float:
        """ Get RotationalStiffness in DecanewtonMetersPerDegree.
        """
        pass

    @property
    def DecanewtonMillimetersPerDegree(self) -> float:
        """ Get RotationalStiffness in DecanewtonMillimetersPerDegree.
        """
        pass

    @property
    def DecanewtonMillimetersPerRadian(self) -> float:
        """ Get RotationalStiffness in DecanewtonMillimetersPerRadian.
        """
        pass

    @property
    def DecinewtonMetersPerDegree(self) -> float:
        """ Get RotationalStiffness in DecinewtonMetersPerDegree.
        """
        pass

    @property
    def DecinewtonMillimetersPerDegree(self) -> float:
        """ Get RotationalStiffness in DecinewtonMillimetersPerDegree.
        """
        pass

    @property
    def DecinewtonMillimetersPerRadian(self) -> float:
        """ Get RotationalStiffness in DecinewtonMillimetersPerRadian.
        """
        pass

    @property
    def KilonewtonMetersPerDegree(self) -> float:
        """ Get RotationalStiffness in KilonewtonMetersPerDegree.
        """
        pass

    @property
    def KilonewtonMetersPerRadian(self) -> float:
        """ Get RotationalStiffness in KilonewtonMetersPerRadian.
        """
        pass

    @property
    def KilonewtonMillimetersPerDegree(self) -> float:
        """ Get RotationalStiffness in KilonewtonMillimetersPerDegree.
        """
        pass

    @property
    def KilonewtonMillimetersPerRadian(self) -> float:
        """ Get RotationalStiffness in KilonewtonMillimetersPerRadian.
        """
        pass

    @property
    def KilopoundForceFeetPerDegrees(self) -> float:
        """ Get RotationalStiffness in KilopoundForceFeetPerDegrees.
        """
        pass

    @property
    def MeganewtonMetersPerDegree(self) -> float:
        """ Get RotationalStiffness in MeganewtonMetersPerDegree.
        """
        pass

    @property
    def MeganewtonMetersPerRadian(self) -> float:
        """ Get RotationalStiffness in MeganewtonMetersPerRadian.
        """
        pass

    @property
    def MeganewtonMillimetersPerDegree(self) -> float:
        """ Get RotationalStiffness in MeganewtonMillimetersPerDegree.
        """
        pass

    @property
    def MeganewtonMillimetersPerRadian(self) -> float:
        """ Get RotationalStiffness in MeganewtonMillimetersPerRadian.
        """
        pass

    @property
    def MicronewtonMetersPerDegree(self) -> float:
        """ Get RotationalStiffness in MicronewtonMetersPerDegree.
        """
        pass

    @property
    def MicronewtonMillimetersPerDegree(self) -> float:
        """ Get RotationalStiffness in MicronewtonMillimetersPerDegree.
        """
        pass

    @property
    def MicronewtonMillimetersPerRadian(self) -> float:
        """ Get RotationalStiffness in MicronewtonMillimetersPerRadian.
        """
        pass

    @property
    def MillinewtonMetersPerDegree(self) -> float:
        """ Get RotationalStiffness in MillinewtonMetersPerDegree.
        """
        pass

    @property
    def MillinewtonMillimetersPerDegree(self) -> float:
        """ Get RotationalStiffness in MillinewtonMillimetersPerDegree.
        """
        pass

    @property
    def MillinewtonMillimetersPerRadian(self) -> float:
        """ Get RotationalStiffness in MillinewtonMillimetersPerRadian.
        """
        pass

    @property
    def NanonewtonMetersPerDegree(self) -> float:
        """ Get RotationalStiffness in NanonewtonMetersPerDegree.
        """
        pass

    @property
    def NanonewtonMillimetersPerDegree(self) -> float:
        """ Get RotationalStiffness in NanonewtonMillimetersPerDegree.
        """
        pass

    @property
    def NanonewtonMillimetersPerRadian(self) -> float:
        """ Get RotationalStiffness in NanonewtonMillimetersPerRadian.
        """
        pass

    @property
    def NewtonMetersPerDegree(self) -> float:
        """ Get RotationalStiffness in NewtonMetersPerDegree.
        """
        pass

    @property
    def NewtonMetersPerRadian(self) -> float:
        """ Get RotationalStiffness in NewtonMetersPerRadian.
        """
        pass

    @property
    def NewtonMillimetersPerDegree(self) -> float:
        """ Get RotationalStiffness in NewtonMillimetersPerDegree.
        """
        pass

    @property
    def NewtonMillimetersPerRadian(self) -> float:
        """ Get RotationalStiffness in NewtonMillimetersPerRadian.
        """
        pass

    @property
    def PoundForceFeetPerRadian(self) -> float:
        """ Get RotationalStiffness in PoundForceFeetPerRadian.
        """
        pass

    @property
    def PoundForceFeetPerDegrees(self) -> float:
        """ Get RotationalStiffness in PoundForceFeetPerDegrees.
        """
        pass

    def __init__(self, value: float, unit: RotationalStiffnessUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RotationalStiffnessUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromMillinewtonMillimetersPerDegree(millinewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from MillinewtonMillimetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonMillimetersPerRadian(millinewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from MillinewtonMillimetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonMetersPerDegree(nanonewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from NanonewtonMetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonMillimetersPerDegree(nanonewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from NanonewtonMillimetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonMillimetersPerRadian(nanonewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from NanonewtonMillimetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMetersPerDegree(newtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from NewtonMetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMetersPerRadian(newtonmetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from NewtonMetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMillimetersPerDegree(newtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from NewtonMillimetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMillimetersPerRadian(newtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from NewtonMillimetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeetPerRadian(poundforcefeetperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from PoundForceFeetPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeetPerDegrees(poundforcefeetperdegrees: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from PoundForceFeetPerDegrees.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RotationalStiffnessUnit) -> RotationalStiffness:
        """ Dynamically convert from value and unit enum "RotationalStiffnessUnit" to "RotationalStiffness".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RotationalStiffnessUnit
        :return: RotationalStiffness unit value.
        :rtype: RotationalStiffness
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RotationalStiffness:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RotationalStiffness:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RotationalStiffness) -> typing.Tuple[RotationalStiffness, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalStiffness
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RotationalStiffness) -> typing.Tuple[RotationalStiffness, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalStiffness
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RotationalStiffnessUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RotationalStiffnessUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RotationalStiffnessUnit) -> typing.Tuple[RotationalStiffnessUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RotationalStiffnessUnit) -> typing.Tuple[RotationalStiffnessUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RotationalStiffnessUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RotationalStiffness) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalStiffness) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalStiffness, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RotationalStiffness within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RotationalStiffness
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RotationalStiffness.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RotationalStiffnessUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalStiffnessUnit) -> RotationalStiffness:
        """ Converts this RotationalStiffness to another RotationalStiffness with the unit representation .

        :return: A RotationalStiffness with the specified unit.
        :rtype: RotationalStiffness
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RotationalStiffness:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalStiffnessUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalStiffnessUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalStiffnessUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalStiffnessUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentinewtonMetersPerDegree(centinewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from CentinewtonMetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentinewtonMillimetersPerDegree(centinewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from CentinewtonMillimetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentinewtonMillimetersPerRadian(centinewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from CentinewtonMillimetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonMetersPerDegree(decanewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from DecanewtonMetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonMillimetersPerDegree(decanewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from DecanewtonMillimetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonMillimetersPerRadian(decanewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from DecanewtonMillimetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonMetersPerDegree(decinewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from DecinewtonMetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonMillimetersPerDegree(decinewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from DecinewtonMillimetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonMillimetersPerRadian(decinewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from DecinewtonMillimetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMetersPerDegree(kilonewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from KilonewtonMetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMetersPerRadian(kilonewtonmetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from KilonewtonMetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMillimetersPerDegree(kilonewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from KilonewtonMillimetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMillimetersPerRadian(kilonewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from KilonewtonMillimetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceFeetPerDegrees(kilopoundforcefeetperdegrees: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from KilopoundForceFeetPerDegrees.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMetersPerDegree(meganewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from MeganewtonMetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMetersPerRadian(meganewtonmetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from MeganewtonMetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMillimetersPerDegree(meganewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from MeganewtonMillimetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMillimetersPerRadian(meganewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from MeganewtonMillimetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonMetersPerDegree(micronewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from MicronewtonMetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonMillimetersPerDegree(micronewtonmillimetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from MicronewtonMillimetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonMillimetersPerRadian(micronewtonmillimetersperradian: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from MicronewtonMillimetersPerRadian.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonMetersPerDegree(millinewtonmetersperdegree: QuantityValue) -> RotationalStiffness:
        """ Get RotationalStiffness from MillinewtonMetersPerDegree.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class RotationalStiffnessPerLength(ValueType, IQuantity[RotationalStiffnessPerLengthUnit], IQuantity, IFormattable, IEquatable[RotationalStiffnessPerLength], IComparable, IComparable[RotationalStiffnessPerLength], IConvertible):
    """ https://en.wikipedia.org/wiki/Stiffness#Rotational_stiffness
    """

    Info: typing.ClassVar[QuantityInfo[RotationalStiffnessPerLengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RotationalStiffnessPerLengthUnit]

    MaxValue: typing.ClassVar[RotationalStiffnessPerLength]

    MinValue: typing.ClassVar[RotationalStiffnessPerLength]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RotationalStiffnessPerLengthUnit]]

    Zero: typing.ClassVar[RotationalStiffnessPerLength]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RotationalStiffnessPerLengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RotationalStiffnessPerLengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilonewtonMetersPerRadianPerMeter(self) -> float:
        """ Get RotationalStiffnessPerLength in KilonewtonMetersPerRadianPerMeter.
        """
        pass

    @property
    def KilopoundForceFeetPerDegreesPerFeet(self) -> float:
        """ Get RotationalStiffnessPerLength in KilopoundForceFeetPerDegreesPerFeet.
        """
        pass

    @property
    def MeganewtonMetersPerRadianPerMeter(self) -> float:
        """ Get RotationalStiffnessPerLength in MeganewtonMetersPerRadianPerMeter.
        """
        pass

    @property
    def NewtonMetersPerRadianPerMeter(self) -> float:
        """ Get RotationalStiffnessPerLength in NewtonMetersPerRadianPerMeter.
        """
        pass

    @property
    def PoundForceFeetPerDegreesPerFeet(self) -> float:
        """ Get RotationalStiffnessPerLength in PoundForceFeetPerDegreesPerFeet.
        """
        pass

    def __init__(self, value: float, unit: RotationalStiffnessPerLengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RotationalStiffnessPerLengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalStiffnessPerLengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalStiffnessPerLengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalStiffnessPerLengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalStiffnessPerLengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilonewtonMetersPerRadianPerMeter(kilonewtonmetersperradianpermeter: QuantityValue) -> RotationalStiffnessPerLength:
        """ Get RotationalStiffnessPerLength from KilonewtonMetersPerRadianPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceFeetPerDegreesPerFeet(kilopoundforcefeetperdegreesperfeet: QuantityValue) -> RotationalStiffnessPerLength:
        """ Get RotationalStiffnessPerLength from KilopoundForceFeetPerDegreesPerFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMetersPerRadianPerMeter(meganewtonmetersperradianpermeter: QuantityValue) -> RotationalStiffnessPerLength:
        """ Get RotationalStiffnessPerLength from MeganewtonMetersPerRadianPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMetersPerRadianPerMeter(newtonmetersperradianpermeter: QuantityValue) -> RotationalStiffnessPerLength:
        """ Get RotationalStiffnessPerLength from NewtonMetersPerRadianPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeetPerDegreesPerFeet(poundforcefeetperdegreesperfeet: QuantityValue) -> RotationalStiffnessPerLength:
        """ Get RotationalStiffnessPerLength from PoundForceFeetPerDegreesPerFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RotationalStiffnessPerLengthUnit) -> RotationalStiffnessPerLength:
        """ Dynamically convert from value and unit enum "RotationalStiffnessPerLengthUnit" to "RotationalStiffnessPerLength".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RotationalStiffnessPerLengthUnit
        :return: RotationalStiffnessPerLength unit value.
        :rtype: RotationalStiffnessPerLength
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RotationalStiffnessPerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RotationalStiffnessPerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RotationalStiffnessPerLength) -> typing.Tuple[RotationalStiffnessPerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalStiffnessPerLength
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RotationalStiffnessPerLength) -> typing.Tuple[RotationalStiffnessPerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalStiffnessPerLength
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RotationalStiffnessPerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RotationalStiffnessPerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RotationalStiffnessPerLengthUnit) -> typing.Tuple[RotationalStiffnessPerLengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RotationalStiffnessPerLengthUnit) -> typing.Tuple[RotationalStiffnessPerLengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RotationalStiffnessPerLengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RotationalStiffnessPerLength) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalStiffnessPerLength) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalStiffnessPerLength, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RotationalStiffnessPerLength within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RotationalStiffnessPerLength
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RotationalStiffnessPerLength.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RotationalStiffnessPerLengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalStiffnessPerLengthUnit) -> RotationalStiffnessPerLength:
        """ Converts this RotationalStiffnessPerLength to another RotationalStiffnessPerLength with the unit representation .

        :return: A RotationalStiffnessPerLength with the specified unit.
        :rtype: RotationalStiffnessPerLength
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RotationalStiffnessPerLength:
        """
        """
        pass


# noinspection PyPep8Naming
class SpecificEnergy(ValueType, IQuantity[SpecificEnergyUnit], IQuantity, IFormattable, IEquatable[SpecificEnergy], IComparable, IComparable[SpecificEnergy], IConvertible):
    """ The SpecificEnergy
     https://en.wikipedia.org/wiki/Specific_energy
    """

    Info: typing.ClassVar[QuantityInfo[SpecificEnergyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpecificEnergyUnit]

    MaxValue: typing.ClassVar[SpecificEnergy]

    MinValue: typing.ClassVar[SpecificEnergy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpecificEnergyUnit]]

    Zero: typing.ClassVar[SpecificEnergy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpecificEnergyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpecificEnergyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtuPerPound(self) -> float:
        """ Get SpecificEnergy in BtuPerPound.
        """
        pass

    @property
    def CaloriesPerGram(self) -> float:
        """ Get SpecificEnergy in CaloriesPerGram.
        """
        pass

    @property
    def GigawattDaysPerKilogram(self) -> float:
        """ Get SpecificEnergy in GigawattDaysPerKilogram.
        """
        pass

    @property
    def GigawattDaysPerShortTon(self) -> float:
        """ Get SpecificEnergy in GigawattDaysPerShortTon.
        """
        pass

    @property
    def GigawattDaysPerTonne(self) -> float:
        """ Get SpecificEnergy in GigawattDaysPerTonne.
        """
        pass

    @property
    def GigawattHoursPerKilogram(self) -> float:
        """ Get SpecificEnergy in GigawattHoursPerKilogram.
        """
        pass

    @property
    def JoulesPerKilogram(self) -> float:
        """ Get SpecificEnergy in JoulesPerKilogram.
        """
        pass

    @property
    def KilocaloriesPerGram(self) -> float:
        """ Get SpecificEnergy in KilocaloriesPerGram.
        """
        pass

    @property
    def KilojoulesPerKilogram(self) -> float:
        """ Get SpecificEnergy in KilojoulesPerKilogram.
        """
        pass

    @property
    def KilowattDaysPerKilogram(self) -> float:
        """ Get SpecificEnergy in KilowattDaysPerKilogram.
        """
        pass

    @property
    def KilowattDaysPerShortTon(self) -> float:
        """ Get SpecificEnergy in KilowattDaysPerShortTon.
        """
        pass

    @property
    def KilowattDaysPerTonne(self) -> float:
        """ Get SpecificEnergy in KilowattDaysPerTonne.
        """
        pass

    @property
    def KilowattHoursPerKilogram(self) -> float:
        """ Get SpecificEnergy in KilowattHoursPerKilogram.
        """
        pass

    @property
    def MegajoulesPerKilogram(self) -> float:
        """ Get SpecificEnergy in MegajoulesPerKilogram.
        """
        pass

    @property
    def MegawattDaysPerKilogram(self) -> float:
        """ Get SpecificEnergy in MegawattDaysPerKilogram.
        """
        pass

    @property
    def MegawattDaysPerShortTon(self) -> float:
        """ Get SpecificEnergy in MegawattDaysPerShortTon.
        """
        pass

    @property
    def MegawattDaysPerTonne(self) -> float:
        """ Get SpecificEnergy in MegawattDaysPerTonne.
        """
        pass

    @property
    def MegawattHoursPerKilogram(self) -> float:
        """ Get SpecificEnergy in MegawattHoursPerKilogram.
        """
        pass

    @property
    def TerawattDaysPerKilogram(self) -> float:
        """ Get SpecificEnergy in TerawattDaysPerKilogram.
        """
        pass

    @property
    def TerawattDaysPerShortTon(self) -> float:
        """ Get SpecificEnergy in TerawattDaysPerShortTon.
        """
        pass

    @property
    def TerawattDaysPerTonne(self) -> float:
        """ Get SpecificEnergy in TerawattDaysPerTonne.
        """
        pass

    @property
    def WattDaysPerKilogram(self) -> float:
        """ Get SpecificEnergy in WattDaysPerKilogram.
        """
        pass

    @property
    def WattDaysPerShortTon(self) -> float:
        """ Get SpecificEnergy in WattDaysPerShortTon.
        """
        pass

    @property
    def WattDaysPerTonne(self) -> float:
        """ Get SpecificEnergy in WattDaysPerTonne.
        """
        pass

    @property
    def WattHoursPerKilogram(self) -> float:
        """ Get SpecificEnergy in WattHoursPerKilogram.
        """
        pass

    def __init__(self, value: float, unit: SpecificEnergyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpecificEnergyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SpecificEnergy) -> typing.Tuple[SpecificEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SpecificEnergy) -> typing.Tuple[SpecificEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificEnergy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpecificEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpecificEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpecificEnergyUnit) -> typing.Tuple[SpecificEnergyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpecificEnergyUnit) -> typing.Tuple[SpecificEnergyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpecificEnergyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SpecificEnergy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificEnergy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificEnergy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SpecificEnergy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SpecificEnergy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SpecificEnergy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpecificEnergyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificEnergyUnit) -> SpecificEnergy:
        """ Converts this SpecificEnergy to another SpecificEnergy with the unit representation .

        :return: A SpecificEnergy with the specified unit.
        :rtype: SpecificEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SpecificEnergy:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificEnergyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificEnergyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificEnergyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificEnergyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtuPerPound(btuperpound: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from BtuPerPound.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCaloriesPerGram(caloriespergram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from CaloriesPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattDaysPerKilogram(gigawattdaysperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from GigawattDaysPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattDaysPerShortTon(gigawattdayspershortton: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from GigawattDaysPerShortTon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattDaysPerTonne(gigawattdayspertonne: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from GigawattDaysPerTonne.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattHoursPerKilogram(gigawatthoursperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from GigawattHoursPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerKilogram(joulesperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from JoulesPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerGram(kilocaloriespergram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from KilocaloriesPerGram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerKilogram(kilojoulesperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from KilojoulesPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattDaysPerKilogram(kilowattdaysperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from KilowattDaysPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattDaysPerShortTon(kilowattdayspershortton: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from KilowattDaysPerShortTon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattDaysPerTonne(kilowattdayspertonne: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from KilowattDaysPerTonne.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattHoursPerKilogram(kilowatthoursperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from KilowattHoursPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerKilogram(megajoulesperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from MegajoulesPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattDaysPerKilogram(megawattdaysperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from MegawattDaysPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattDaysPerShortTon(megawattdayspershortton: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from MegawattDaysPerShortTon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattDaysPerTonne(megawattdayspertonne: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from MegawattDaysPerTonne.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattHoursPerKilogram(megawatthoursperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from MegawattHoursPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattDaysPerKilogram(terawattdaysperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from TerawattDaysPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattDaysPerShortTon(terawattdayspershortton: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from TerawattDaysPerShortTon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattDaysPerTonne(terawattdayspertonne: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from TerawattDaysPerTonne.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattDaysPerKilogram(wattdaysperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from WattDaysPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattDaysPerShortTon(wattdayspershortton: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from WattDaysPerShortTon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattDaysPerTonne(wattdayspertonne: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from WattDaysPerTonne.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattHoursPerKilogram(watthoursperkilogram: QuantityValue) -> SpecificEnergy:
        """ Get SpecificEnergy from WattHoursPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpecificEnergyUnit) -> SpecificEnergy:
        """ Dynamically convert from value and unit enum "SpecificEnergyUnit" to "SpecificEnergy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpecificEnergyUnit
        :return: SpecificEnergy unit value.
        :rtype: SpecificEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SpecificEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SpecificEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass


# noinspection PyPep8Naming
class SpecificVolume(ValueType, IQuantity[SpecificVolumeUnit], IQuantity, IFormattable, IEquatable[SpecificVolume], IComparable, IComparable[SpecificVolume], IConvertible):
    """ In thermodynamics, the specific volume of a substance is the ratio of the substance's volume to its mass. It is the reciprocal of density and an intrinsic property of matter as well.
    """

    Info: typing.ClassVar[QuantityInfo[SpecificVolumeUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpecificVolumeUnit]

    MaxValue: typing.ClassVar[SpecificVolume]

    MinValue: typing.ClassVar[SpecificVolume]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpecificVolumeUnit]]

    Zero: typing.ClassVar[SpecificVolume]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpecificVolumeUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpecificVolumeUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CubicFeetPerPound(self) -> float:
        """ Get SpecificVolume in CubicFeetPerPound.
        """
        pass

    @property
    def CubicMetersPerKilogram(self) -> float:
        """ Get SpecificVolume in CubicMetersPerKilogram.
        """
        pass

    @property
    def MillicubicMetersPerKilogram(self) -> float:
        """ Get SpecificVolume in MillicubicMetersPerKilogram.
        """
        pass

    def __init__(self, value: float, unit: SpecificVolumeUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpecificVolumeUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificVolumeUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificVolumeUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificVolumeUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificVolumeUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCubicFeetPerPound(cubicfeetperpound: QuantityValue) -> SpecificVolume:
        """ Get SpecificVolume from CubicFeetPerPound.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerKilogram(cubicmetersperkilogram: QuantityValue) -> SpecificVolume:
        """ Get SpecificVolume from CubicMetersPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillicubicMetersPerKilogram(millicubicmetersperkilogram: QuantityValue) -> SpecificVolume:
        """ Get SpecificVolume from MillicubicMetersPerKilogram.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpecificVolumeUnit) -> SpecificVolume:
        """ Dynamically convert from value and unit enum "SpecificVolumeUnit" to "SpecificVolume".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpecificVolumeUnit
        :return: SpecificVolume unit value.
        :rtype: SpecificVolume
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SpecificVolume:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SpecificVolume:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SpecificVolume) -> typing.Tuple[SpecificVolume, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificVolume
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SpecificVolume) -> typing.Tuple[SpecificVolume, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificVolume
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpecificVolumeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpecificVolumeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpecificVolumeUnit) -> typing.Tuple[SpecificVolumeUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpecificVolumeUnit) -> typing.Tuple[SpecificVolumeUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpecificVolumeUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SpecificVolume) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificVolume) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificVolume, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SpecificVolume within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SpecificVolume
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SpecificVolume.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpecificVolumeUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificVolumeUnit) -> SpecificVolume:
        """ Converts this SpecificVolume to another SpecificVolume with the unit representation .

        :return: A SpecificVolume with the specified unit.
        :rtype: SpecificVolume
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SpecificVolume:
        """
        """
        pass


# noinspection PyPep8Naming
class SpecificWeight(ValueType, IQuantity[SpecificWeightUnit], IQuantity, IFormattable, IEquatable[SpecificWeight], IComparable, IComparable[SpecificWeight], IConvertible):
    """ The SpecificWeight, or more precisely, the volumetric weight density, of a substance is its weight per unit volume.
     http://en.wikipedia.org/wiki/Specificweight
    """

    Info: typing.ClassVar[QuantityInfo[SpecificWeightUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpecificWeightUnit]

    MaxValue: typing.ClassVar[SpecificWeight]

    MinValue: typing.ClassVar[SpecificWeight]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpecificWeightUnit]]

    Zero: typing.ClassVar[SpecificWeight]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpecificWeightUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpecificWeightUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilogramsForcePerCubicCentimeter(self) -> float:
        """ Get SpecificWeight in KilogramsForcePerCubicCentimeter.
        """
        pass

    @property
    def KilogramsForcePerCubicMeter(self) -> float:
        """ Get SpecificWeight in KilogramsForcePerCubicMeter.
        """
        pass

    @property
    def KilogramsForcePerCubicMillimeter(self) -> float:
        """ Get SpecificWeight in KilogramsForcePerCubicMillimeter.
        """
        pass

    @property
    def KilonewtonsPerCubicCentimeter(self) -> float:
        """ Get SpecificWeight in KilonewtonsPerCubicCentimeter.
        """
        pass

    @property
    def KilonewtonsPerCubicMeter(self) -> float:
        """ Get SpecificWeight in KilonewtonsPerCubicMeter.
        """
        pass

    @property
    def KilonewtonsPerCubicMillimeter(self) -> float:
        """ Get SpecificWeight in KilonewtonsPerCubicMillimeter.
        """
        pass

    @property
    def KilopoundsForcePerCubicFoot(self) -> float:
        """ Get SpecificWeight in KilopoundsForcePerCubicFoot.
        """
        pass

    @property
    def KilopoundsForcePerCubicInch(self) -> float:
        """ Get SpecificWeight in KilopoundsForcePerCubicInch.
        """
        pass

    @property
    def MeganewtonsPerCubicMeter(self) -> float:
        """ Get SpecificWeight in MeganewtonsPerCubicMeter.
        """
        pass

    @property
    def NewtonsPerCubicCentimeter(self) -> float:
        """ Get SpecificWeight in NewtonsPerCubicCentimeter.
        """
        pass

    @property
    def NewtonsPerCubicMeter(self) -> float:
        """ Get SpecificWeight in NewtonsPerCubicMeter.
        """
        pass

    @property
    def NewtonsPerCubicMillimeter(self) -> float:
        """ Get SpecificWeight in NewtonsPerCubicMillimeter.
        """
        pass

    @property
    def PoundsForcePerCubicFoot(self) -> float:
        """ Get SpecificWeight in PoundsForcePerCubicFoot.
        """
        pass

    @property
    def PoundsForcePerCubicInch(self) -> float:
        """ Get SpecificWeight in PoundsForcePerCubicInch.
        """
        pass

    @property
    def TonnesForcePerCubicCentimeter(self) -> float:
        """ Get SpecificWeight in TonnesForcePerCubicCentimeter.
        """
        pass

    @property
    def TonnesForcePerCubicMeter(self) -> float:
        """ Get SpecificWeight in TonnesForcePerCubicMeter.
        """
        pass

    @property
    def TonnesForcePerCubicMillimeter(self) -> float:
        """ Get SpecificWeight in TonnesForcePerCubicMillimeter.
        """
        pass

    def __init__(self, value: float, unit: SpecificWeightUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpecificWeightUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SpecificWeight) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificWeight) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificWeight, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SpecificWeight within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SpecificWeight
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SpecificWeight.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpecificWeightUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificWeightUnit) -> SpecificWeight:
        """ Converts this SpecificWeight to another SpecificWeight with the unit representation .

        :return: A SpecificWeight with the specified unit.
        :rtype: SpecificWeight
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SpecificWeight:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificWeightUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificWeightUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificWeightUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificWeightUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilogramsForcePerCubicCentimeter(kilogramsforcepercubiccentimeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from KilogramsForcePerCubicCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerCubicMeter(kilogramsforcepercubicmeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from KilogramsForcePerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsForcePerCubicMillimeter(kilogramsforcepercubicmillimeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from KilogramsForcePerCubicMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerCubicCentimeter(kilonewtonspercubiccentimeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from KilonewtonsPerCubicCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerCubicMeter(kilonewtonspercubicmeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from KilonewtonsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerCubicMillimeter(kilonewtonspercubicmillimeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from KilonewtonsPerCubicMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerCubicFoot(kilopoundsforcepercubicfoot: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from KilopoundsForcePerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerCubicInch(kilopoundsforcepercubicinch: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from KilopoundsForcePerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonsPerCubicMeter(meganewtonspercubicmeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from MeganewtonsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerCubicCentimeter(newtonspercubiccentimeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from NewtonsPerCubicCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerCubicMeter(newtonspercubicmeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from NewtonsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerCubicMillimeter(newtonspercubicmillimeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from NewtonsPerCubicMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerCubicFoot(poundsforcepercubicfoot: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from PoundsForcePerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerCubicInch(poundsforcepercubicinch: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from PoundsForcePerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerCubicCentimeter(tonnesforcepercubiccentimeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from TonnesForcePerCubicCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerCubicMeter(tonnesforcepercubicmeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from TonnesForcePerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonnesForcePerCubicMillimeter(tonnesforcepercubicmillimeter: QuantityValue) -> SpecificWeight:
        """ Get SpecificWeight from TonnesForcePerCubicMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpecificWeightUnit) -> SpecificWeight:
        """ Dynamically convert from value and unit enum "SpecificWeightUnit" to "SpecificWeight".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpecificWeightUnit
        :return: SpecificWeight unit value.
        :rtype: SpecificWeight
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SpecificWeight:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SpecificWeight:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SpecificWeight) -> typing.Tuple[SpecificWeight, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificWeight
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SpecificWeight) -> typing.Tuple[SpecificWeight, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificWeight
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpecificWeightUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpecificWeightUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpecificWeightUnit) -> typing.Tuple[SpecificWeightUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpecificWeightUnit) -> typing.Tuple[SpecificWeightUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpecificWeightUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class Speed(ValueType, IQuantity[SpeedUnit], IQuantity, IFormattable, IEquatable[Speed], IComparable, IComparable[Speed], IConvertible):
    """ In everyday use and in kinematics, the speed of an object is the magnitude of its velocity (the rate of change of its position); it is thus a scalar quantity.[1] The average speed of an object in an interval of time is the distance travelled by the object divided by the duration of the interval;[2] the instantaneous speed is the limit of the average speed as the duration of the time interval approaches zero.
    """

    Info: typing.ClassVar[QuantityInfo[SpeedUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpeedUnit]

    MaxValue: typing.ClassVar[Speed]

    MinValue: typing.ClassVar[Speed]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpeedUnit]]

    Zero: typing.ClassVar[Speed]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpeedUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpeedUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimetersPerHour(self) -> float:
        """ Get Speed in CentimetersPerHour.
        """
        pass

    @property
    def CentimetersPerMinutes(self) -> float:
        """ Get Speed in CentimetersPerMinutes.
        """
        pass

    @property
    def CentimetersPerSecond(self) -> float:
        """ Get Speed in CentimetersPerSecond.
        """
        pass

    @property
    def DecimetersPerMinutes(self) -> float:
        """ Get Speed in DecimetersPerMinutes.
        """
        pass

    @property
    def DecimetersPerSecond(self) -> float:
        """ Get Speed in DecimetersPerSecond.
        """
        pass

    @property
    def FeetPerHour(self) -> float:
        """ Get Speed in FeetPerHour.
        """
        pass

    @property
    def FeetPerMinute(self) -> float:
        """ Get Speed in FeetPerMinute.
        """
        pass

    @property
    def FeetPerSecond(self) -> float:
        """ Get Speed in FeetPerSecond.
        """
        pass

    @property
    def InchesPerHour(self) -> float:
        """ Get Speed in InchesPerHour.
        """
        pass

    @property
    def InchesPerMinute(self) -> float:
        """ Get Speed in InchesPerMinute.
        """
        pass

    @property
    def InchesPerSecond(self) -> float:
        """ Get Speed in InchesPerSecond.
        """
        pass

    @property
    def KilometersPerHour(self) -> float:
        """ Get Speed in KilometersPerHour.
        """
        pass

    @property
    def KilometersPerMinutes(self) -> float:
        """ Get Speed in KilometersPerMinutes.
        """
        pass

    @property
    def KilometersPerSecond(self) -> float:
        """ Get Speed in KilometersPerSecond.
        """
        pass

    @property
    def Knots(self) -> float:
        """ Get Speed in Knots.
        """
        pass

    @property
    def MetersPerHour(self) -> float:
        """ Get Speed in MetersPerHour.
        """
        pass

    @property
    def MetersPerMinutes(self) -> float:
        """ Get Speed in MetersPerMinutes.
        """
        pass

    @property
    def MetersPerSecond(self) -> float:
        """ Get Speed in MetersPerSecond.
        """
        pass

    @property
    def MicrometersPerMinutes(self) -> float:
        """ Get Speed in MicrometersPerMinutes.
        """
        pass

    @property
    def MicrometersPerSecond(self) -> float:
        """ Get Speed in MicrometersPerSecond.
        """
        pass

    @property
    def MilesPerHour(self) -> float:
        """ Get Speed in MilesPerHour.
        """
        pass

    @property
    def MillimetersPerHour(self) -> float:
        """ Get Speed in MillimetersPerHour.
        """
        pass

    @property
    def MillimetersPerMinutes(self) -> float:
        """ Get Speed in MillimetersPerMinutes.
        """
        pass

    @property
    def MillimetersPerSecond(self) -> float:
        """ Get Speed in MillimetersPerSecond.
        """
        pass

    @property
    def NanometersPerMinutes(self) -> float:
        """ Get Speed in NanometersPerMinutes.
        """
        pass

    @property
    def NanometersPerSecond(self) -> float:
        """ Get Speed in NanometersPerSecond.
        """
        pass

    @property
    def UsSurveyFeetPerHour(self) -> float:
        """ Get Speed in UsSurveyFeetPerHour.
        """
        pass

    @property
    def UsSurveyFeetPerMinute(self) -> float:
        """ Get Speed in UsSurveyFeetPerMinute.
        """
        pass

    @property
    def UsSurveyFeetPerSecond(self) -> float:
        """ Get Speed in UsSurveyFeetPerSecond.
        """
        pass

    @property
    def YardsPerHour(self) -> float:
        """ Get Speed in YardsPerHour.
        """
        pass

    @property
    def YardsPerMinute(self) -> float:
        """ Get Speed in YardsPerMinute.
        """
        pass

    @property
    def YardsPerSecond(self) -> float:
        """ Get Speed in YardsPerSecond.
        """
        pass

    def __init__(self, value: float, unit: SpeedUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpeedUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromMetersPerMinutes(metersperminutes: QuantityValue) -> Speed:
        """ Get Speed from MetersPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersPerSecond(meterspersecond: QuantityValue) -> Speed:
        """ Get Speed from MetersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrometersPerMinutes(micrometersperminutes: QuantityValue) -> Speed:
        """ Get Speed from MicrometersPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrometersPerSecond(micrometerspersecond: QuantityValue) -> Speed:
        """ Get Speed from MicrometersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilesPerHour(milesperhour: QuantityValue) -> Speed:
        """ Get Speed from MilesPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersPerHour(millimetersperhour: QuantityValue) -> Speed:
        """ Get Speed from MillimetersPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersPerMinutes(millimetersperminutes: QuantityValue) -> Speed:
        """ Get Speed from MillimetersPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersPerSecond(millimeterspersecond: QuantityValue) -> Speed:
        """ Get Speed from MillimetersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanometersPerMinutes(nanometersperminutes: QuantityValue) -> Speed:
        """ Get Speed from NanometersPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanometersPerSecond(nanometerspersecond: QuantityValue) -> Speed:
        """ Get Speed from NanometersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsSurveyFeetPerHour(ussurveyfeetperhour: QuantityValue) -> Speed:
        """ Get Speed from UsSurveyFeetPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsSurveyFeetPerMinute(ussurveyfeetperminute: QuantityValue) -> Speed:
        """ Get Speed from UsSurveyFeetPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsSurveyFeetPerSecond(ussurveyfeetpersecond: QuantityValue) -> Speed:
        """ Get Speed from UsSurveyFeetPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromYardsPerHour(yardsperhour: QuantityValue) -> Speed:
        """ Get Speed from YardsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromYardsPerMinute(yardsperminute: QuantityValue) -> Speed:
        """ Get Speed from YardsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromYardsPerSecond(yardspersecond: QuantityValue) -> Speed:
        """ Get Speed from YardsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpeedUnit) -> Speed:
        """ Dynamically convert from value and unit enum "SpeedUnit" to "Speed".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpeedUnit
        :return: Speed unit value.
        :rtype: Speed
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Speed:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Speed:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Speed) -> typing.Tuple[Speed, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Speed
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Speed) -> typing.Tuple[Speed, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Speed
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpeedUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpeedUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpeedUnit) -> typing.Tuple[SpeedUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpeedUnit) -> typing.Tuple[SpeedUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpeedUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Speed) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Speed) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Speed, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Speed within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Speed
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Speed.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpeedUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpeedUnit) -> Speed:
        """ Converts this Speed to another Speed with the unit representation .

        :return: A Speed with the specified unit.
        :rtype: Speed
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Speed:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpeedUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpeedUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpeedUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpeedUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimetersPerHour(centimetersperhour: QuantityValue) -> Speed:
        """ Get Speed from CentimetersPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentimetersPerMinutes(centimetersperminutes: QuantityValue) -> Speed:
        """ Get Speed from CentimetersPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentimetersPerSecond(centimeterspersecond: QuantityValue) -> Speed:
        """ Get Speed from CentimetersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersPerMinutes(decimetersperminutes: QuantityValue) -> Speed:
        """ Get Speed from DecimetersPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersPerSecond(decimeterspersecond: QuantityValue) -> Speed:
        """ Get Speed from DecimetersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetPerHour(feetperhour: QuantityValue) -> Speed:
        """ Get Speed from FeetPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetPerMinute(feetperminute: QuantityValue) -> Speed:
        """ Get Speed from FeetPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetPerSecond(feetpersecond: QuantityValue) -> Speed:
        """ Get Speed from FeetPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesPerHour(inchesperhour: QuantityValue) -> Speed:
        """ Get Speed from InchesPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesPerMinute(inchesperminute: QuantityValue) -> Speed:
        """ Get Speed from InchesPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesPerSecond(inchespersecond: QuantityValue) -> Speed:
        """ Get Speed from InchesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilometersPerHour(kilometersperhour: QuantityValue) -> Speed:
        """ Get Speed from KilometersPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilometersPerMinutes(kilometersperminutes: QuantityValue) -> Speed:
        """ Get Speed from KilometersPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilometersPerSecond(kilometerspersecond: QuantityValue) -> Speed:
        """ Get Speed from KilometersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKnots(knots: QuantityValue) -> Speed:
        """ Get Speed from Knots.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersPerHour(metersperhour: QuantityValue) -> Speed:
        """ Get Speed from MetersPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class Temperature(ValueType, IQuantity[TemperatureUnit], IQuantity, IFormattable, IEquatable[Temperature], IComparable, IComparable[Temperature], IConvertible):
    """ A temperature is a numerical measure of hot or cold. Its measurement is by detection of heat radiation or particle velocity or kinetic energy, or by the bulk behavior of a thermometric material. It may be calibrated in any of various temperature scales, Celsius, Fahrenheit, Kelvin, etc. The fundamental physical definition of temperature is provided by thermodynamics.
    """

    Info: typing.ClassVar[QuantityInfo[TemperatureUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TemperatureUnit]

    MaxValue: typing.ClassVar[Temperature]

    MinValue: typing.ClassVar[Temperature]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TemperatureUnit]]

    Zero: typing.ClassVar[Temperature]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TemperatureUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TemperatureUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DegreesCelsius(self) -> float:
        """ Get Temperature in DegreesCelsius.
        """
        pass

    @property
    def DegreesDelisle(self) -> float:
        """ Get Temperature in DegreesDelisle.
        """
        pass

    @property
    def DegreesFahrenheit(self) -> float:
        """ Get Temperature in DegreesFahrenheit.
        """
        pass

    @property
    def DegreesNewton(self) -> float:
        """ Get Temperature in DegreesNewton.
        """
        pass

    @property
    def DegreesRankine(self) -> float:
        """ Get Temperature in DegreesRankine.
        """
        pass

    @property
    def DegreesReaumur(self) -> float:
        """ Get Temperature in DegreesReaumur.
        """
        pass

    @property
    def DegreesRoemer(self) -> float:
        """ Get Temperature in DegreesRoemer.
        """
        pass

    @property
    def Kelvins(self) -> float:
        """ Get Temperature in Kelvins.
        """
        pass

    @property
    def MillidegreesCelsius(self) -> float:
        """ Get Temperature in MillidegreesCelsius.
        """
        pass

    @property
    def SolarTemperatures(self) -> float:
        """ Get Temperature in SolarTemperatures.
        """
        pass

    def __init__(self, value: float, unit: TemperatureUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TemperatureUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Temperature:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def Multiply(self, factor: float, unit: TemperatureUnit) -> Temperature:
        """ Multiply temperature with a in a given .
         Due to different temperature units having different zero points, we cannot simply
         multiply or divide a temperature by a factor. We must first convert to the desired unit, then perform the
         calculation.

        :param factor: Factor to multiply by.
        :type factor: float
        :param unit: Unit to perform multiplication in.
        :type unit: TemperatureUnit
        :return: The resulting "Temperature".
        :rtype: Temperature
        """
        pass

    def Divide(self, divisor: float, unit: TemperatureUnit) -> Temperature:
        """ Divide temperature by a in a given .
         Due to different temperature units having different zero points, we cannot simply
         multiply or divide a temperature by a factor. We must first convert to the desired unit, then perform the
         calculation.

        :param divisor: Factor to multiply by.
        :type divisor: float
        :param unit: Unit to perform multiplication in.
        :type unit: TemperatureUnit
        :return: The resulting "Temperature".
        :rtype: Temperature
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDegreesCelsius(degreescelsius: QuantityValue) -> Temperature:
        """ Get Temperature from DegreesCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesDelisle(degreesdelisle: QuantityValue) -> Temperature:
        """ Get Temperature from DegreesDelisle.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesFahrenheit(degreesfahrenheit: QuantityValue) -> Temperature:
        """ Get Temperature from DegreesFahrenheit.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesNewton(degreesnewton: QuantityValue) -> Temperature:
        """ Get Temperature from DegreesNewton.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesRankine(degreesrankine: QuantityValue) -> Temperature:
        """ Get Temperature from DegreesRankine.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesReaumur(degreesreaumur: QuantityValue) -> Temperature:
        """ Get Temperature from DegreesReaumur.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesRoemer(degreesroemer: QuantityValue) -> Temperature:
        """ Get Temperature from DegreesRoemer.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKelvins(kelvins: QuantityValue) -> Temperature:
        """ Get Temperature from Kelvins.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidegreesCelsius(millidegreescelsius: QuantityValue) -> Temperature:
        """ Get Temperature from MillidegreesCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSolarTemperatures(solartemperatures: QuantityValue) -> Temperature:
        """ Get Temperature from SolarTemperatures.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TemperatureUnit) -> Temperature:
        """ Dynamically convert from value and unit enum "TemperatureUnit" to "Temperature".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TemperatureUnit
        :return: Temperature unit value.
        :rtype: Temperature
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Temperature:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Temperature:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Temperature) -> typing.Tuple[Temperature, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Temperature
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Temperature) -> typing.Tuple[Temperature, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Temperature
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TemperatureUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TemperatureUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TemperatureUnit) -> typing.Tuple[TemperatureUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TemperatureUnit) -> typing.Tuple[TemperatureUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TemperatureUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Temperature) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Temperature) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Temperature, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Temperature within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Temperature
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Temperature.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TemperatureUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureUnit) -> Temperature:
        """ Converts this Temperature to another Temperature with the unit representation .

        :return: A Temperature with the specified unit.
        :rtype: Temperature
        """
        pass


# noinspection PyPep8Naming
class TemperatureDelta(ValueType, IQuantity[TemperatureDeltaUnit], IQuantity, IFormattable, IEquatable[TemperatureDelta], IComparable, IComparable[TemperatureDelta], IConvertible):
    """ Difference between two temperatures. The conversions are different than for Temperature.
    """

    Info: typing.ClassVar[QuantityInfo[TemperatureDeltaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TemperatureDeltaUnit]

    MaxValue: typing.ClassVar[TemperatureDelta]

    MinValue: typing.ClassVar[TemperatureDelta]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TemperatureDeltaUnit]]

    Zero: typing.ClassVar[TemperatureDelta]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TemperatureDeltaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TemperatureDeltaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DegreesCelsius(self) -> float:
        """ Get TemperatureDelta in DegreesCelsius.
        """
        pass

    @property
    def DegreesDelisle(self) -> float:
        """ Get TemperatureDelta in DegreesDelisle.
        """
        pass

    @property
    def DegreesFahrenheit(self) -> float:
        """ Get TemperatureDelta in DegreesFahrenheit.
        """
        pass

    @property
    def DegreesNewton(self) -> float:
        """ Get TemperatureDelta in DegreesNewton.
        """
        pass

    @property
    def DegreesRankine(self) -> float:
        """ Get TemperatureDelta in DegreesRankine.
        """
        pass

    @property
    def DegreesReaumur(self) -> float:
        """ Get TemperatureDelta in DegreesReaumur.
        """
        pass

    @property
    def DegreesRoemer(self) -> float:
        """ Get TemperatureDelta in DegreesRoemer.
        """
        pass

    @property
    def Kelvins(self) -> float:
        """ Get TemperatureDelta in Kelvins.
        """
        pass

    @property
    def MillidegreesCelsius(self) -> float:
        """ Get TemperatureDelta in MillidegreesCelsius.
        """
        pass

    def __init__(self, value: float, unit: TemperatureDeltaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TemperatureDeltaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureDeltaUnit) -> TemperatureDelta:
        """ Converts this TemperatureDelta to another TemperatureDelta with the unit representation .

        :return: A TemperatureDelta with the specified unit.
        :rtype: TemperatureDelta
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> TemperatureDelta:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureDeltaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureDeltaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureDeltaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureDeltaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDegreesCelsius(degreescelsius: QuantityValue) -> TemperatureDelta:
        """ Get TemperatureDelta from DegreesCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesDelisle(degreesdelisle: QuantityValue) -> TemperatureDelta:
        """ Get TemperatureDelta from DegreesDelisle.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesFahrenheit(degreesfahrenheit: QuantityValue) -> TemperatureDelta:
        """ Get TemperatureDelta from DegreesFahrenheit.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesNewton(degreesnewton: QuantityValue) -> TemperatureDelta:
        """ Get TemperatureDelta from DegreesNewton.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesRankine(degreesrankine: QuantityValue) -> TemperatureDelta:
        """ Get TemperatureDelta from DegreesRankine.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesReaumur(degreesreaumur: QuantityValue) -> TemperatureDelta:
        """ Get TemperatureDelta from DegreesReaumur.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesRoemer(degreesroemer: QuantityValue) -> TemperatureDelta:
        """ Get TemperatureDelta from DegreesRoemer.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKelvins(kelvins: QuantityValue) -> TemperatureDelta:
        """ Get TemperatureDelta from Kelvins.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidegreesCelsius(millidegreescelsius: QuantityValue) -> TemperatureDelta:
        """ Get TemperatureDelta from MillidegreesCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TemperatureDeltaUnit) -> TemperatureDelta:
        """ Dynamically convert from value and unit enum "TemperatureDeltaUnit" to "TemperatureDelta".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TemperatureDeltaUnit
        :return: TemperatureDelta unit value.
        :rtype: TemperatureDelta
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> TemperatureDelta:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> TemperatureDelta:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: TemperatureDelta) -> typing.Tuple[TemperatureDelta, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TemperatureDelta
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: TemperatureDelta) -> typing.Tuple[TemperatureDelta, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TemperatureDelta
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TemperatureDeltaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TemperatureDeltaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TemperatureDeltaUnit) -> typing.Tuple[TemperatureDeltaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TemperatureDeltaUnit) -> typing.Tuple[TemperatureDeltaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TemperatureDeltaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: TemperatureDelta) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TemperatureDelta) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TemperatureDelta, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another TemperatureDelta within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: TemperatureDelta
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current TemperatureDelta.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TemperatureDeltaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass


# noinspection PyPep8Naming
class Torque(ValueType, IQuantity[TorqueUnit], IQuantity, IFormattable, IEquatable[Torque], IComparable, IComparable[Torque], IConvertible):
    """ Torque, moment or moment of force (see the terminology below), is the tendency of a force to rotate an object about an axis,[1] fulcrum, or pivot. Just as a force is a push or a pull, a torque can be thought of as a twist to an object. Mathematically, torque is defined as the cross product of the lever-arm distance and force, which tends to produce rotation. Loosely speaking, torque is a measure of the turning force on an object such as a bolt or a flywheel. For example, pushing or pulling the handle of a wrench connected to a nut or bolt produces a torque (turning force) that loosens or tightens the nut or bolt.
    """

    Info: typing.ClassVar[QuantityInfo[TorqueUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TorqueUnit]

    MaxValue: typing.ClassVar[Torque]

    MinValue: typing.ClassVar[Torque]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TorqueUnit]]

    Zero: typing.ClassVar[Torque]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TorqueUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TorqueUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilogramForceCentimeters(self) -> float:
        """ Get Torque in KilogramForceCentimeters.
        """
        pass

    @property
    def KilogramForceMeters(self) -> float:
        """ Get Torque in KilogramForceMeters.
        """
        pass

    @property
    def KilogramForceMillimeters(self) -> float:
        """ Get Torque in KilogramForceMillimeters.
        """
        pass

    @property
    def KilonewtonCentimeters(self) -> float:
        """ Get Torque in KilonewtonCentimeters.
        """
        pass

    @property
    def KilonewtonMeters(self) -> float:
        """ Get Torque in KilonewtonMeters.
        """
        pass

    @property
    def KilonewtonMillimeters(self) -> float:
        """ Get Torque in KilonewtonMillimeters.
        """
        pass

    @property
    def KilopoundForceFeet(self) -> float:
        """ Get Torque in KilopoundForceFeet.
        """
        pass

    @property
    def KilopoundForceInches(self) -> float:
        """ Get Torque in KilopoundForceInches.
        """
        pass

    @property
    def MeganewtonCentimeters(self) -> float:
        """ Get Torque in MeganewtonCentimeters.
        """
        pass

    @property
    def MeganewtonMeters(self) -> float:
        """ Get Torque in MeganewtonMeters.
        """
        pass

    @property
    def MeganewtonMillimeters(self) -> float:
        """ Get Torque in MeganewtonMillimeters.
        """
        pass

    @property
    def MegapoundForceFeet(self) -> float:
        """ Get Torque in MegapoundForceFeet.
        """
        pass

    @property
    def MegapoundForceInches(self) -> float:
        """ Get Torque in MegapoundForceInches.
        """
        pass

    @property
    def NewtonCentimeters(self) -> float:
        """ Get Torque in NewtonCentimeters.
        """
        pass

    @property
    def NewtonMeters(self) -> float:
        """ Get Torque in NewtonMeters.
        """
        pass

    @property
    def NewtonMillimeters(self) -> float:
        """ Get Torque in NewtonMillimeters.
        """
        pass

    @property
    def PoundalFeet(self) -> float:
        """ Get Torque in PoundalFeet.
        """
        pass

    @property
    def PoundForceFeet(self) -> float:
        """ Get Torque in PoundForceFeet.
        """
        pass

    @property
    def PoundForceInches(self) -> float:
        """ Get Torque in PoundForceInches.
        """
        pass

    @property
    def TonneForceCentimeters(self) -> float:
        """ Get Torque in TonneForceCentimeters.
        """
        pass

    @property
    def TonneForceMeters(self) -> float:
        """ Get Torque in TonneForceMeters.
        """
        pass

    @property
    def TonneForceMillimeters(self) -> float:
        """ Get Torque in TonneForceMillimeters.
        """
        pass

    def __init__(self, value: float, unit: TorqueUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TorqueUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Torque) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Torque) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Torque, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Torque within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Torque
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Torque.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TorqueUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TorqueUnit) -> Torque:
        """ Converts this Torque to another Torque with the unit representation .

        :return: A Torque with the specified unit.
        :rtype: Torque
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Torque:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TorqueUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TorqueUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TorqueUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TorqueUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilogramForceCentimeters(kilogramforcecentimeters: QuantityValue) -> Torque:
        """ Get Torque from KilogramForceCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceMeters(kilogramforcemeters: QuantityValue) -> Torque:
        """ Get Torque from KilogramForceMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceMillimeters(kilogramforcemillimeters: QuantityValue) -> Torque:
        """ Get Torque from KilogramForceMillimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonCentimeters(kilonewtoncentimeters: QuantityValue) -> Torque:
        """ Get Torque from KilonewtonCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMeters(kilonewtonmeters: QuantityValue) -> Torque:
        """ Get Torque from KilonewtonMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMillimeters(kilonewtonmillimeters: QuantityValue) -> Torque:
        """ Get Torque from KilonewtonMillimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceFeet(kilopoundforcefeet: QuantityValue) -> Torque:
        """ Get Torque from KilopoundForceFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceInches(kilopoundforceinches: QuantityValue) -> Torque:
        """ Get Torque from KilopoundForceInches.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonCentimeters(meganewtoncentimeters: QuantityValue) -> Torque:
        """ Get Torque from MeganewtonCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMeters(meganewtonmeters: QuantityValue) -> Torque:
        """ Get Torque from MeganewtonMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMillimeters(meganewtonmillimeters: QuantityValue) -> Torque:
        """ Get Torque from MeganewtonMillimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundForceFeet(megapoundforcefeet: QuantityValue) -> Torque:
        """ Get Torque from MegapoundForceFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundForceInches(megapoundforceinches: QuantityValue) -> Torque:
        """ Get Torque from MegapoundForceInches.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonCentimeters(newtoncentimeters: QuantityValue) -> Torque:
        """ Get Torque from NewtonCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMeters(newtonmeters: QuantityValue) -> Torque:
        """ Get Torque from NewtonMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMillimeters(newtonmillimeters: QuantityValue) -> Torque:
        """ Get Torque from NewtonMillimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundalFeet(poundalfeet: QuantityValue) -> Torque:
        """ Get Torque from PoundalFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeet(poundforcefeet: QuantityValue) -> Torque:
        """ Get Torque from PoundForceFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceInches(poundforceinches: QuantityValue) -> Torque:
        """ Get Torque from PoundForceInches.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceCentimeters(tonneforcecentimeters: QuantityValue) -> Torque:
        """ Get Torque from TonneForceCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceMeters(tonneforcemeters: QuantityValue) -> Torque:
        """ Get Torque from TonneForceMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceMillimeters(tonneforcemillimeters: QuantityValue) -> Torque:
        """ Get Torque from TonneForceMillimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TorqueUnit) -> Torque:
        """ Dynamically convert from value and unit enum "TorqueUnit" to "Torque".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TorqueUnit
        :return: Torque unit value.
        :rtype: Torque
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Torque:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Torque:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Torque) -> typing.Tuple[Torque, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Torque
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Torque) -> typing.Tuple[Torque, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Torque
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TorqueUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TorqueUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TorqueUnit) -> typing.Tuple[TorqueUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TorqueUnit) -> typing.Tuple[TorqueUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TorqueUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class Volume(ValueType, IQuantity[VolumeUnit], IQuantity, IFormattable, IEquatable[Volume], IComparable, IComparable[Volume], IConvertible):
    """ Volume is the quantity of three-dimensional space enclosed by some closed boundary, for example, the space that a substance (solid, liquid, gas, or plasma) or shape occupies or contains.[1] Volume is often quantified numerically using the SI derived unit, the cubic metre. The volume of a container is generally understood to be the capacity of the container, i. e. the amount of fluid (gas or liquid) that the container could hold, rather than the amount of space the container itself displaces.
    """

    Info: typing.ClassVar[QuantityInfo[VolumeUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VolumeUnit]

    MaxValue: typing.ClassVar[Volume]

    MinValue: typing.ClassVar[Volume]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VolumeUnit]]

    Zero: typing.ClassVar[Volume]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VolumeUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VolumeUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AcreFeet(self) -> float:
        """ Get Volume in AcreFeet.
        """
        pass

    @property
    def AuTablespoons(self) -> float:
        """ Get Volume in AuTablespoons.
        """
        pass

    @property
    def BoardFeet(self) -> float:
        """ Get Volume in BoardFeet.
        """
        pass

    @property
    def Centiliters(self) -> float:
        """ Get Volume in Centiliters.
        """
        pass

    @property
    def CubicCentimeters(self) -> float:
        """ Get Volume in CubicCentimeters.
        """
        pass

    @property
    def CubicDecimeters(self) -> float:
        """ Get Volume in CubicDecimeters.
        """
        pass

    @property
    def CubicFeet(self) -> float:
        """ Get Volume in CubicFeet.
        """
        pass

    @property
    def CubicHectometers(self) -> float:
        """ Get Volume in CubicHectometers.
        """
        pass

    @property
    def CubicInches(self) -> float:
        """ Get Volume in CubicInches.
        """
        pass

    @property
    def CubicKilometers(self) -> float:
        """ Get Volume in CubicKilometers.
        """
        pass

    @property
    def CubicMeters(self) -> float:
        """ Get Volume in CubicMeters.
        """
        pass

    @property
    def CubicMicrometers(self) -> float:
        """ Get Volume in CubicMicrometers.
        """
        pass

    @property
    def CubicMiles(self) -> float:
        """ Get Volume in CubicMiles.
        """
        pass

    @property
    def CubicMillimeters(self) -> float:
        """ Get Volume in CubicMillimeters.
        """
        pass

    @property
    def CubicYards(self) -> float:
        """ Get Volume in CubicYards.
        """
        pass

    @property
    def DecausGallons(self) -> float:
        """ Get Volume in DecausGallons.
        """
        pass

    @property
    def Deciliters(self) -> float:
        """ Get Volume in Deciliters.
        """
        pass

    @property
    def DeciusGallons(self) -> float:
        """ Get Volume in DeciusGallons.
        """
        pass

    @property
    def HectocubicFeet(self) -> float:
        """ Get Volume in HectocubicFeet.
        """
        pass

    @property
    def HectocubicMeters(self) -> float:
        """ Get Volume in HectocubicMeters.
        """
        pass

    @property
    def Hectoliters(self) -> float:
        """ Get Volume in Hectoliters.
        """
        pass

    @property
    def HectousGallons(self) -> float:
        """ Get Volume in HectousGallons.
        """
        pass

    @property
    def ImperialBeerBarrels(self) -> float:
        """ Get Volume in ImperialBeerBarrels.
        """
        pass

    @property
    def ImperialGallons(self) -> float:
        """ Get Volume in ImperialGallons.
        """
        pass

    @property
    def ImperialOunces(self) -> float:
        """ Get Volume in ImperialOunces.
        """
        pass

    @property
    def ImperialPints(self) -> float:
        """ Get Volume in ImperialPints.
        """
        pass

    @property
    def KilocubicFeet(self) -> float:
        """ Get Volume in KilocubicFeet.
        """
        pass

    @property
    def KilocubicMeters(self) -> float:
        """ Get Volume in KilocubicMeters.
        """
        pass

    @property
    def KiloimperialGallons(self) -> float:
        """ Get Volume in KiloimperialGallons.
        """
        pass

    @property
    def Kiloliters(self) -> float:
        """ Get Volume in Kiloliters.
        """
        pass

    @property
    def KilousGallons(self) -> float:
        """ Get Volume in KilousGallons.
        """
        pass

    @property
    def Liters(self) -> float:
        """ Get Volume in Liters.
        """
        pass

    @property
    def MegacubicFeet(self) -> float:
        """ Get Volume in MegacubicFeet.
        """
        pass

    @property
    def MegaimperialGallons(self) -> float:
        """ Get Volume in MegaimperialGallons.
        """
        pass

    @property
    def Megaliters(self) -> float:
        """ Get Volume in Megaliters.
        """
        pass

    @property
    def MegausGallons(self) -> float:
        """ Get Volume in MegausGallons.
        """
        pass

    @property
    def MetricCups(self) -> float:
        """ Get Volume in MetricCups.
        """
        pass

    @property
    def MetricTeaspoons(self) -> float:
        """ Get Volume in MetricTeaspoons.
        """
        pass

    @property
    def Microliters(self) -> float:
        """ Get Volume in Microliters.
        """
        pass

    @property
    def Milliliters(self) -> float:
        """ Get Volume in Milliliters.
        """
        pass

    @property
    def OilBarrels(self) -> float:
        """ Get Volume in OilBarrels.
        """
        pass

    @property
    def UkTablespoons(self) -> float:
        """ Get Volume in UkTablespoons.
        """
        pass

    @property
    def UsBeerBarrels(self) -> float:
        """ Get Volume in UsBeerBarrels.
        """
        pass

    @property
    def UsCustomaryCups(self) -> float:
        """ Get Volume in UsCustomaryCups.
        """
        pass

    @property
    def UsGallons(self) -> float:
        """ Get Volume in UsGallons.
        """
        pass

    @property
    def UsLegalCups(self) -> float:
        """ Get Volume in UsLegalCups.
        """
        pass

    @property
    def UsOunces(self) -> float:
        """ Get Volume in UsOunces.
        """
        pass

    @property
    def UsPints(self) -> float:
        """ Get Volume in UsPints.
        """
        pass

    @property
    def UsQuarts(self) -> float:
        """ Get Volume in UsQuarts.
        """
        pass

    @property
    def UsTablespoons(self) -> float:
        """ Get Volume in UsTablespoons.
        """
        pass

    @property
    def UsTeaspoons(self) -> float:
        """ Get Volume in UsTeaspoons.
        """
        pass

    def __init__(self, value: float, unit: VolumeUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VolumeUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeUnit) -> Volume:
        """ Converts this Volume to another Volume with the unit representation .

        :return: A Volume with the specified unit.
        :rtype: Volume
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Volume:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBoardFeet(boardfeet: QuantityValue) -> Volume:
        """ Get Volume from BoardFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentiliters(centiliters: QuantityValue) -> Volume:
        """ Get Volume from Centiliters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicCentimeters(cubiccentimeters: QuantityValue) -> Volume:
        """ Get Volume from CubicCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicDecimeters(cubicdecimeters: QuantityValue) -> Volume:
        """ Get Volume from CubicDecimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicFeet(cubicfeet: QuantityValue) -> Volume:
        """ Get Volume from CubicFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicHectometers(cubichectometers: QuantityValue) -> Volume:
        """ Get Volume from CubicHectometers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicInches(cubicinches: QuantityValue) -> Volume:
        """ Get Volume from CubicInches.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicKilometers(cubickilometers: QuantityValue) -> Volume:
        """ Get Volume from CubicKilometers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMeters(cubicmeters: QuantityValue) -> Volume:
        """ Get Volume from CubicMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMicrometers(cubicmicrometers: QuantityValue) -> Volume:
        """ Get Volume from CubicMicrometers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMiles(cubicmiles: QuantityValue) -> Volume:
        """ Get Volume from CubicMiles.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMillimeters(cubicmillimeters: QuantityValue) -> Volume:
        """ Get Volume from CubicMillimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYards(cubicyards: QuantityValue) -> Volume:
        """ Get Volume from CubicYards.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecausGallons(decausgallons: QuantityValue) -> Volume:
        """ Get Volume from DecausGallons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciliters(deciliters: QuantityValue) -> Volume:
        """ Get Volume from Deciliters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciusGallons(deciusgallons: QuantityValue) -> Volume:
        """ Get Volume from DeciusGallons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectocubicFeet(hectocubicfeet: QuantityValue) -> Volume:
        """ Get Volume from HectocubicFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectocubicMeters(hectocubicmeters: QuantityValue) -> Volume:
        """ Get Volume from HectocubicMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectoliters(hectoliters: QuantityValue) -> Volume:
        """ Get Volume from Hectoliters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectousGallons(hectousgallons: QuantityValue) -> Volume:
        """ Get Volume from HectousGallons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromImperialBeerBarrels(imperialbeerbarrels: QuantityValue) -> Volume:
        """ Get Volume from ImperialBeerBarrels.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromImperialGallons(imperialgallons: QuantityValue) -> Volume:
        """ Get Volume from ImperialGallons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromImperialOunces(imperialounces: QuantityValue) -> Volume:
        """ Get Volume from ImperialOunces.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromImperialPints(imperialpints: QuantityValue) -> Volume:
        """ Get Volume from ImperialPints.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocubicFeet(kilocubicfeet: QuantityValue) -> Volume:
        """ Get Volume from KilocubicFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocubicMeters(kilocubicmeters: QuantityValue) -> Volume:
        """ Get Volume from KilocubicMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloimperialGallons(kiloimperialgallons: QuantityValue) -> Volume:
        """ Get Volume from KiloimperialGallons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloliters(kiloliters: QuantityValue) -> Volume:
        """ Get Volume from Kiloliters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilousGallons(kilousgallons: QuantityValue) -> Volume:
        """ Get Volume from KilousGallons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLiters(liters: QuantityValue) -> Volume:
        """ Get Volume from Liters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegacubicFeet(megacubicfeet: QuantityValue) -> Volume:
        """ Get Volume from MegacubicFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaimperialGallons(megaimperialgallons: QuantityValue) -> Volume:
        """ Get Volume from MegaimperialGallons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaliters(megaliters: QuantityValue) -> Volume:
        """ Get Volume from Megaliters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegausGallons(megausgallons: QuantityValue) -> Volume:
        """ Get Volume from MegausGallons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetricCups(metriccups: QuantityValue) -> Volume:
        """ Get Volume from MetricCups.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetricTeaspoons(metricteaspoons: QuantityValue) -> Volume:
        """ Get Volume from MetricTeaspoons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroliters(microliters: QuantityValue) -> Volume:
        """ Get Volume from Microliters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliliters(milliliters: QuantityValue) -> Volume:
        """ Get Volume from Milliliters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrels(oilbarrels: QuantityValue) -> Volume:
        """ Get Volume from OilBarrels.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUkTablespoons(uktablespoons: QuantityValue) -> Volume:
        """ Get Volume from UkTablespoons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsBeerBarrels(usbeerbarrels: QuantityValue) -> Volume:
        """ Get Volume from UsBeerBarrels.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsCustomaryCups(uscustomarycups: QuantityValue) -> Volume:
        """ Get Volume from UsCustomaryCups.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsGallons(usgallons: QuantityValue) -> Volume:
        """ Get Volume from UsGallons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsLegalCups(uslegalcups: QuantityValue) -> Volume:
        """ Get Volume from UsLegalCups.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsOunces(usounces: QuantityValue) -> Volume:
        """ Get Volume from UsOunces.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsPints(uspints: QuantityValue) -> Volume:
        """ Get Volume from UsPints.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsQuarts(usquarts: QuantityValue) -> Volume:
        """ Get Volume from UsQuarts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsTablespoons(ustablespoons: QuantityValue) -> Volume:
        """ Get Volume from UsTablespoons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsTeaspoons(usteaspoons: QuantityValue) -> Volume:
        """ Get Volume from UsTeaspoons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VolumeUnit) -> Volume:
        """ Dynamically convert from value and unit enum "VolumeUnit" to "Volume".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VolumeUnit
        :return: Volume unit value.
        :rtype: Volume
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Volume:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Volume:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Volume) -> typing.Tuple[Volume, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Volume
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Volume) -> typing.Tuple[Volume, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Volume
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VolumeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VolumeUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VolumeUnit) -> typing.Tuple[VolumeUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VolumeUnit) -> typing.Tuple[VolumeUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VolumeUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Volume) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Volume) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Volume, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Volume within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Volume
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Volume.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VolumeUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAcreFeet(acrefeet: QuantityValue) -> Volume:
        """ Get Volume from AcreFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAuTablespoons(autablespoons: QuantityValue) -> Volume:
        """ Get Volume from AuTablespoons.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class VolumeConcentration(ValueType, IQuantity[VolumeConcentrationUnit], IQuantity, IFormattable, IEquatable[VolumeConcentration], IComparable, IComparable[VolumeConcentration], IConvertible):
    """ The volume concentration (not to be confused with volume fraction) is defined as the volume of a constituent divided by the total volume of the mixture.
     https://en.wikipedia.org/wiki/Concentration#Volume_concentration
    """

    Info: typing.ClassVar[QuantityInfo[VolumeConcentrationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VolumeConcentrationUnit]

    MaxValue: typing.ClassVar[VolumeConcentration]

    MinValue: typing.ClassVar[VolumeConcentration]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VolumeConcentrationUnit]]

    Zero: typing.ClassVar[VolumeConcentration]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VolumeConcentrationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VolumeConcentrationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentilitersPerLiter(self) -> float:
        """ Get VolumeConcentration in CentilitersPerLiter.
        """
        pass

    @property
    def CentilitersPerMililiter(self) -> float:
        """ Get VolumeConcentration in CentilitersPerMililiter.
        """
        pass

    @property
    def DecilitersPerLiter(self) -> float:
        """ Get VolumeConcentration in DecilitersPerLiter.
        """
        pass

    @property
    def DecilitersPerMililiter(self) -> float:
        """ Get VolumeConcentration in DecilitersPerMililiter.
        """
        pass

    @property
    def DecimalFractions(self) -> float:
        """ Get VolumeConcentration in DecimalFractions.
        """
        pass

    @property
    def LitersPerLiter(self) -> float:
        """ Get VolumeConcentration in LitersPerLiter.
        """
        pass

    @property
    def LitersPerMililiter(self) -> float:
        """ Get VolumeConcentration in LitersPerMililiter.
        """
        pass

    @property
    def MicrolitersPerLiter(self) -> float:
        """ Get VolumeConcentration in MicrolitersPerLiter.
        """
        pass

    @property
    def MicrolitersPerMililiter(self) -> float:
        """ Get VolumeConcentration in MicrolitersPerMililiter.
        """
        pass

    @property
    def MillilitersPerLiter(self) -> float:
        """ Get VolumeConcentration in MillilitersPerLiter.
        """
        pass

    @property
    def MillilitersPerMililiter(self) -> float:
        """ Get VolumeConcentration in MillilitersPerMililiter.
        """
        pass

    @property
    def NanolitersPerLiter(self) -> float:
        """ Get VolumeConcentration in NanolitersPerLiter.
        """
        pass

    @property
    def NanolitersPerMililiter(self) -> float:
        """ Get VolumeConcentration in NanolitersPerMililiter.
        """
        pass

    @property
    def PartsPerBillion(self) -> float:
        """ Get VolumeConcentration in PartsPerBillion.
        """
        pass

    @property
    def PartsPerMillion(self) -> float:
        """ Get VolumeConcentration in PartsPerMillion.
        """
        pass

    @property
    def PartsPerThousand(self) -> float:
        """ Get VolumeConcentration in PartsPerThousand.
        """
        pass

    @property
    def PartsPerTrillion(self) -> float:
        """ Get VolumeConcentration in PartsPerTrillion.
        """
        pass

    @property
    def Percent(self) -> float:
        """ Get VolumeConcentration in Percent.
        """
        pass

    @property
    def PicolitersPerLiter(self) -> float:
        """ Get VolumeConcentration in PicolitersPerLiter.
        """
        pass

    @property
    def PicolitersPerMililiter(self) -> float:
        """ Get VolumeConcentration in PicolitersPerMililiter.
        """
        pass

    def __init__(self, value: float, unit: VolumeConcentrationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VolumeConcentrationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: VolumeConcentration) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumeConcentration) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumeConcentration, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another VolumeConcentration within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: VolumeConcentration
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current VolumeConcentration.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VolumeConcentrationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeConcentrationUnit) -> VolumeConcentration:
        """ Converts this VolumeConcentration to another VolumeConcentration with the unit representation .

        :return: A VolumeConcentration with the specified unit.
        :rtype: VolumeConcentration
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> VolumeConcentration:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    def ToMassConcentration(self, componentDensity: Density) -> MassConcentration:
        """Get "MassConcentration" from this "VolumeConcentration" and component "Density" .

        :param componentDensity:
        :type componentDensity: Density
        :return:
        :rtype: MassConcentration
        """
        pass

    def ToMolarity(self, componentDensity: Density, compontMolarMass: MolarMass) -> Molarity:
        """Get "Molarity" from this "VolumeConcentration" and component "Density" and "MolarMass" .

        :param componentDensity:
        :type componentDensity: Density
        :param compontMolarMass:
        :type compontMolarMass: MolarMass
        :return:
        :rtype: Molarity
        """
        pass

    @staticmethod
    def FromVolumes(componentVolume: Volume, mixtureMass: Volume) -> VolumeConcentration:
        """ Get "VolumeConcentration" from a component "Volume" and total mixture "Volume" .
        """
        pass

    @staticmethod
    def FromMolarity(molarity: Molarity, componentDensity: Density, componentMolarMass: MolarMass) -> VolumeConcentration:
        """ Get a "VolumeConcentration" from "Molarity" and a component "Density" and "MolarMass".

        :param molarity:
        :type molarity: Molarity
        :param componentDensity:
        :type componentDensity: Density
        :param componentMolarMass:
        :type componentMolarMass: MolarMass
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeConcentrationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeConcentrationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeConcentrationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeConcentrationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentilitersPerLiter(centilitersperliter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from CentilitersPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentilitersPerMililiter(centiliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from CentilitersPerMililiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerLiter(decilitersperliter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from DecilitersPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerMililiter(deciliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from DecilitersPerMililiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimalFractions(decimalfractions: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from DecimalFractions.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerLiter(litersperliter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from LitersPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerMililiter(literspermililiter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from LitersPerMililiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerLiter(microlitersperliter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from MicrolitersPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerMililiter(microliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from MicrolitersPerMililiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerLiter(millilitersperliter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from MillilitersPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerMililiter(milliliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from MillilitersPerMililiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerLiter(nanolitersperliter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from NanolitersPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerMililiter(nanoliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from NanolitersPerMililiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerBillion(partsperbillion: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from PartsPerBillion.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerMillion(partspermillion: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from PartsPerMillion.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerThousand(partsperthousand: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from PartsPerThousand.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerTrillion(partspertrillion: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from PartsPerTrillion.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPercent(percent: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from Percent.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicolitersPerLiter(picolitersperliter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from PicolitersPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicolitersPerMililiter(picoliterspermililiter: QuantityValue) -> VolumeConcentration:
        """ Get VolumeConcentration from PicolitersPerMililiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VolumeConcentrationUnit) -> VolumeConcentration:
        """ Dynamically convert from value and unit enum "VolumeConcentrationUnit" to "VolumeConcentration".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VolumeConcentrationUnit
        :return: VolumeConcentration unit value.
        :rtype: VolumeConcentration
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> VolumeConcentration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> VolumeConcentration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: VolumeConcentration) -> typing.Tuple[VolumeConcentration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumeConcentration
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: VolumeConcentration) -> typing.Tuple[VolumeConcentration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumeConcentration
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VolumeConcentrationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VolumeConcentrationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VolumeConcentrationUnit) -> typing.Tuple[VolumeConcentrationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VolumeConcentrationUnit) -> typing.Tuple[VolumeConcentrationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VolumeConcentrationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class VolumeFlow(ValueType, IQuantity[VolumeFlowUnit], IQuantity, IFormattable, IEquatable[VolumeFlow], IComparable, IComparable[VolumeFlow], IConvertible):
    """ In physics and engineering, in particular fluid dynamics and hydrometry, the volumetric flow rate, (also known as volume flow rate, rate of fluid flow or volume velocity) is the volume of fluid which passes through a given surface per unit time. The SI unit is m³/s (cubic meters per second). In US Customary Units and British Imperial Units, volumetric flow rate is often expressed as ft³/s (cubic feet per second). It is usually represented by the symbol Q.
    """

    Info: typing.ClassVar[QuantityInfo[VolumeFlowUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VolumeFlowUnit]

    MaxValue: typing.ClassVar[VolumeFlow]

    MinValue: typing.ClassVar[VolumeFlow]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VolumeFlowUnit]]

    Zero: typing.ClassVar[VolumeFlow]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VolumeFlowUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VolumeFlowUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AcreFeetPerDay(self) -> float:
        """ Get VolumeFlow in AcreFeetPerDay.
        """
        pass

    @property
    def AcreFeetPerHour(self) -> float:
        """ Get VolumeFlow in AcreFeetPerHour.
        """
        pass

    @property
    def AcreFeetPerMinute(self) -> float:
        """ Get VolumeFlow in AcreFeetPerMinute.
        """
        pass

    @property
    def AcreFeetPerSecond(self) -> float:
        """ Get VolumeFlow in AcreFeetPerSecond.
        """
        pass

    @property
    def CentilitersPerDay(self) -> float:
        """ Get VolumeFlow in CentilitersPerDay.
        """
        pass

    @property
    def CentilitersPerMinute(self) -> float:
        """ Get VolumeFlow in CentilitersPerMinute.
        """
        pass

    @property
    def CentilitersPerSecond(self) -> float:
        """ Get VolumeFlow in CentilitersPerSecond.
        """
        pass

    @property
    def CubicCentimetersPerMinute(self) -> float:
        """ Get VolumeFlow in CubicCentimetersPerMinute.
        """
        pass

    @property
    def CubicDecimetersPerMinute(self) -> float:
        """ Get VolumeFlow in CubicDecimetersPerMinute.
        """
        pass

    @property
    def CubicFeetPerHour(self) -> float:
        """ Get VolumeFlow in CubicFeetPerHour.
        """
        pass

    @property
    def CubicFeetPerMinute(self) -> float:
        """ Get VolumeFlow in CubicFeetPerMinute.
        """
        pass

    @property
    def CubicFeetPerSecond(self) -> float:
        """ Get VolumeFlow in CubicFeetPerSecond.
        """
        pass

    @property
    def CubicMetersPerDay(self) -> float:
        """ Get VolumeFlow in CubicMetersPerDay.
        """
        pass

    @property
    def CubicMetersPerHour(self) -> float:
        """ Get VolumeFlow in CubicMetersPerHour.
        """
        pass

    @property
    def CubicMetersPerMinute(self) -> float:
        """ Get VolumeFlow in CubicMetersPerMinute.
        """
        pass

    @property
    def CubicMetersPerSecond(self) -> float:
        """ Get VolumeFlow in CubicMetersPerSecond.
        """
        pass

    @property
    def CubicMillimetersPerSecond(self) -> float:
        """ Get VolumeFlow in CubicMillimetersPerSecond.
        """
        pass

    @property
    def CubicYardsPerDay(self) -> float:
        """ Get VolumeFlow in CubicYardsPerDay.
        """
        pass

    @property
    def CubicYardsPerHour(self) -> float:
        """ Get VolumeFlow in CubicYardsPerHour.
        """
        pass

    @property
    def CubicYardsPerMinute(self) -> float:
        """ Get VolumeFlow in CubicYardsPerMinute.
        """
        pass

    @property
    def CubicYardsPerSecond(self) -> float:
        """ Get VolumeFlow in CubicYardsPerSecond.
        """
        pass

    @property
    def DecilitersPerDay(self) -> float:
        """ Get VolumeFlow in DecilitersPerDay.
        """
        pass

    @property
    def DecilitersPerMinute(self) -> float:
        """ Get VolumeFlow in DecilitersPerMinute.
        """
        pass

    @property
    def DecilitersPerSecond(self) -> float:
        """ Get VolumeFlow in DecilitersPerSecond.
        """
        pass

    @property
    def KilolitersPerDay(self) -> float:
        """ Get VolumeFlow in KilolitersPerDay.
        """
        pass

    @property
    def KilolitersPerMinute(self) -> float:
        """ Get VolumeFlow in KilolitersPerMinute.
        """
        pass

    @property
    def KilolitersPerSecond(self) -> float:
        """ Get VolumeFlow in KilolitersPerSecond.
        """
        pass

    @property
    def KilousGallonsPerMinute(self) -> float:
        """ Get VolumeFlow in KilousGallonsPerMinute.
        """
        pass

    @property
    def LitersPerDay(self) -> float:
        """ Get VolumeFlow in LitersPerDay.
        """
        pass

    @property
    def LitersPerHour(self) -> float:
        """ Get VolumeFlow in LitersPerHour.
        """
        pass

    @property
    def LitersPerMinute(self) -> float:
        """ Get VolumeFlow in LitersPerMinute.
        """
        pass

    @property
    def LitersPerSecond(self) -> float:
        """ Get VolumeFlow in LitersPerSecond.
        """
        pass

    @property
    def MegalitersPerDay(self) -> float:
        """ Get VolumeFlow in MegalitersPerDay.
        """
        pass

    @property
    def MegaukGallonsPerSecond(self) -> float:
        """ Get VolumeFlow in MegaukGallonsPerSecond.
        """
        pass

    @property
    def MicrolitersPerDay(self) -> float:
        """ Get VolumeFlow in MicrolitersPerDay.
        """
        pass

    @property
    def MicrolitersPerMinute(self) -> float:
        """ Get VolumeFlow in MicrolitersPerMinute.
        """
        pass

    @property
    def MicrolitersPerSecond(self) -> float:
        """ Get VolumeFlow in MicrolitersPerSecond.
        """
        pass

    @property
    def MillilitersPerDay(self) -> float:
        """ Get VolumeFlow in MillilitersPerDay.
        """
        pass

    @property
    def MillilitersPerMinute(self) -> float:
        """ Get VolumeFlow in MillilitersPerMinute.
        """
        pass

    @property
    def MillilitersPerSecond(self) -> float:
        """ Get VolumeFlow in MillilitersPerSecond.
        """
        pass

    @property
    def MillionUsGallonsPerDay(self) -> float:
        """ Get VolumeFlow in MillionUsGallonsPerDay.
        """
        pass

    @property
    def NanolitersPerDay(self) -> float:
        """ Get VolumeFlow in NanolitersPerDay.
        """
        pass

    @property
    def NanolitersPerMinute(self) -> float:
        """ Get VolumeFlow in NanolitersPerMinute.
        """
        pass

    @property
    def NanolitersPerSecond(self) -> float:
        """ Get VolumeFlow in NanolitersPerSecond.
        """
        pass

    @property
    def OilBarrelsPerDay(self) -> float:
        """ Get VolumeFlow in OilBarrelsPerDay.
        """
        pass

    @property
    def OilBarrelsPerHour(self) -> float:
        """ Get VolumeFlow in OilBarrelsPerHour.
        """
        pass

    @property
    def OilBarrelsPerMinute(self) -> float:
        """ Get VolumeFlow in OilBarrelsPerMinute.
        """
        pass

    @property
    def OilBarrelsPerSecond(self) -> float:
        """ Get VolumeFlow in OilBarrelsPerSecond.
        """
        pass

    @property
    def UkGallonsPerDay(self) -> float:
        """ Get VolumeFlow in UkGallonsPerDay.
        """
        pass

    @property
    def UkGallonsPerHour(self) -> float:
        """ Get VolumeFlow in UkGallonsPerHour.
        """
        pass

    @property
    def UkGallonsPerMinute(self) -> float:
        """ Get VolumeFlow in UkGallonsPerMinute.
        """
        pass

    @property
    def UkGallonsPerSecond(self) -> float:
        """ Get VolumeFlow in UkGallonsPerSecond.
        """
        pass

    @property
    def UsGallonsPerDay(self) -> float:
        """ Get VolumeFlow in UsGallonsPerDay.
        """
        pass

    @property
    def UsGallonsPerHour(self) -> float:
        """ Get VolumeFlow in UsGallonsPerHour.
        """
        pass

    @property
    def UsGallonsPerMinute(self) -> float:
        """ Get VolumeFlow in UsGallonsPerMinute.
        """
        pass

    @property
    def UsGallonsPerSecond(self) -> float:
        """ Get VolumeFlow in UsGallonsPerSecond.
        """
        pass

    def __init__(self, value: float, unit: VolumeFlowUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VolumeFlowUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumeFlow) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumeFlow, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another VolumeFlow within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: VolumeFlow
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current VolumeFlow.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VolumeFlowUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumeFlowUnit) -> VolumeFlow:
        """ Converts this VolumeFlow to another VolumeFlow with the unit representation .

        :return: A VolumeFlow with the specified unit.
        :rtype: VolumeFlow
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> VolumeFlow:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeFlowUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeFlowUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumeFlowUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumeFlowUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAcreFeetPerDay(acrefeetperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from AcreFeetPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAcreFeetPerHour(acrefeetperhour: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from AcreFeetPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAcreFeetPerMinute(acrefeetperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from AcreFeetPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAcreFeetPerSecond(acrefeetpersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from AcreFeetPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentilitersPerDay(centilitersperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CentilitersPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentilitersPerMinute(centilitersperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CentilitersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCentilitersPerSecond(centiliterspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CentilitersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicCentimetersPerMinute(cubiccentimetersperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicCentimetersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicDecimetersPerMinute(cubicdecimetersperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicDecimetersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicFeetPerHour(cubicfeetperhour: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicFeetPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicFeetPerMinute(cubicfeetperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicFeetPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicFeetPerSecond(cubicfeetpersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicFeetPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerDay(cubicmetersperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicMetersPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerHour(cubicmetersperhour: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicMetersPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerMinute(cubicmetersperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicMetersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMetersPerSecond(cubicmeterspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicMetersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicMillimetersPerSecond(cubicmillimeterspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicMillimetersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerDay(cubicyardsperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicYardsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerHour(cubicyardsperhour: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicYardsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerMinute(cubicyardsperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicYardsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerSecond(cubicyardspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from CubicYardsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerDay(decilitersperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from DecilitersPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerMinute(decilitersperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from DecilitersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecilitersPerSecond(deciliterspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from DecilitersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilolitersPerDay(kilolitersperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from KilolitersPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilolitersPerMinute(kilolitersperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from KilolitersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilolitersPerSecond(kiloliterspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from KilolitersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilousGallonsPerMinute(kilousgallonsperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from KilousGallonsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerDay(litersperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from LitersPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerHour(litersperhour: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from LitersPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerMinute(litersperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from LitersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerSecond(literspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from LitersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegalitersPerDay(megalitersperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from MegalitersPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaukGallonsPerSecond(megaukgallonspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from MegaukGallonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerDay(microlitersperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from MicrolitersPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerMinute(microlitersperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from MicrolitersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrolitersPerSecond(microliterspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from MicrolitersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerDay(millilitersperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from MillilitersPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerMinute(millilitersperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from MillilitersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilitersPerSecond(milliliterspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from MillilitersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillionUsGallonsPerDay(millionusgallonsperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from MillionUsGallonsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerDay(nanolitersperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from NanolitersPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerMinute(nanolitersperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from NanolitersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanolitersPerSecond(nanoliterspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from NanolitersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrelsPerDay(oilbarrelsperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from OilBarrelsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrelsPerHour(oilbarrelsperhour: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from OilBarrelsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrelsPerMinute(oilbarrelsperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from OilBarrelsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrelsPerSecond(oilbarrelspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from OilBarrelsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUkGallonsPerDay(ukgallonsperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from UkGallonsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUkGallonsPerHour(ukgallonsperhour: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from UkGallonsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUkGallonsPerMinute(ukgallonsperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from UkGallonsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUkGallonsPerSecond(ukgallonspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from UkGallonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsGallonsPerDay(usgallonsperday: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from UsGallonsPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsGallonsPerHour(usgallonsperhour: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from UsGallonsPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsGallonsPerMinute(usgallonsperminute: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from UsGallonsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromUsGallonsPerSecond(usgallonspersecond: QuantityValue) -> VolumeFlow:
        """ Get VolumeFlow from UsGallonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VolumeFlowUnit) -> VolumeFlow:
        """ Dynamically convert from value and unit enum "VolumeFlowUnit" to "VolumeFlow".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VolumeFlowUnit
        :return: VolumeFlow unit value.
        :rtype: VolumeFlow
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> VolumeFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> VolumeFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: VolumeFlow) -> typing.Tuple[VolumeFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumeFlow
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: VolumeFlow) -> typing.Tuple[VolumeFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumeFlow
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VolumeFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VolumeFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VolumeFlowUnit) -> typing.Tuple[VolumeFlowUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VolumeFlowUnit) -> typing.Tuple[VolumeFlowUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VolumeFlowUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: VolumeFlow) -> int:
        """
        """
        pass


# noinspection PyPep8Naming
class Quantity(metaclass=ABCMeta):
    """ Dynamically parse or construct quantities when types are only known at runtime.
    """

    ByName: IDictionary[str, QuantityInfo] = ...
    """All QuantityInfo instances mapped by quantity name that are present in UnitsNet by default.
    """

    Types: typing.ClassVar[Array[QuantityType]]

    Names: typing.ClassVar[Array[str]]

    Infos: typing.ClassVar[Array[QuantityInfo]]

    @staticmethod
    def From(value: QuantityValue, unit: Enum) -> IQuantity:
        """ Dynamically construct a quantity.

        :param value: Numeric value.
        :type value: QuantityValue
        :param unit: Unit enum value.
        :type unit: Enum
        :return: An "IQuantity" object.
        :rtype: IQuantity

        :exception ArgumentException: Unit value is not a know unit enum type.
        """
        pass

    @staticmethod
    @typing.overload
    def TryFrom(value: float, unit: Enum, quantity: IQuantity) -> typing.Tuple[IQuantity, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(quantityType: Type, quantityString: str) -> IQuantity:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(formatProvider: IFormatProvider, quantityType: Type, quantityString: str) -> IQuantity:
        """ Dynamically parse a quantity string representation.

        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param quantityType: Type of quantity, such as "Length".
        :type quantityType: Type
        :param quantityString: Quantity string representation, such as "1.5 kg". Must be compatible with given quantity type.
        :type quantityString: str
        :return: The parsed quantity.
        :rtype: IQuantity

        :exception ArgumentException: Type must be of type UnitsNet.IQuantity -or- Type is not a known quantity type.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(quantityType: Type, quantityString: str, quantity: IQuantity) -> typing.Tuple[IQuantity, bool]:
        """
        """
        pass

    @staticmethod
    def GetInfo(quantityType: QuantityType) -> QuantityInfo:
        """ Get information about the given quantity type.

        :param quantityType: The quantity type enum value.
        :type quantityType: QuantityType
        :return: Information about the quantity and its units.
        :rtype: QuantityInfo
        """
        pass

    @staticmethod
    def GetQuantitiesWithBaseDimensions(baseDimensions: BaseDimensions) -> IEnumerable[QuantityInfo]:
        """ Get a list of quantities that has the given base dimensions.

        :param baseDimensions: The base dimensions to match.
        :type baseDimensions: BaseDimensions
        """
        pass

    @staticmethod
    def FromQuantityType(quantityType: QuantityType, value: QuantityValue) -> IQuantity:
        """Dynamically constructs a quantity of the given "QuantityType" with the value in the quantity's base units.

        :param quantityType: The "QuantityType" of the quantity to create.
        :type quantityType: QuantityType
        :param value: The value to construct the quantity with.
        :type value: QuantityValue
        :return: The created quantity.
        :rtype: IQuantity
        """
        pass

    @staticmethod
    def FromQuantityInfo(quantityInfo: QuantityInfo, value: QuantityValue) -> IQuantity:
        """Dynamically constructs a quantity of the given "QuantityInfo" with the value in the quantity's base units.

        :param quantityInfo: The "QuantityInfo" of the quantity to create.
        :type quantityInfo: QuantityInfo
        :param value: The value to construct the quantity with.
        :type value: QuantityValue
        :return: The created quantity.
        :rtype: IQuantity
        """
        pass

    @staticmethod
    @typing.overload
    def TryFrom(value: QuantityValue, unit: Enum, quantity: IQuantity) -> typing.Tuple[IQuantity, bool]:
        """ Try to dynamically construct a quantity.

        :param value: Numeric value.
        :type value: QuantityValue
        :param unit: Unit enum value.
        :type unit: Enum
        :param quantity: The resulting quantity if successful, otherwise default.
        :type quantity: IQuantity
        :return: True if successful with assigned the value, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(formatProvider: IFormatProvider, quantityType: Type, quantityString: str, quantity: IQuantity) -> typing.Tuple[IQuantity, bool]:
        """ Try to dynamically parse a quantity string representation.

        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param quantityType: Type of quantity, such as "Length".
        :type quantityType: Type
        :param quantityString: Quantity string representation, such as "1.5 kg". Must be compatible with given quantity type.
        :type quantityString: str
        :param quantity: The resulting quantity if successful, otherwise default.
        :type quantity: IQuantity
        :return: The parsed quantity.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class UnitAbbreviationsCache:
    """ Cache of the mapping between unit enum values and unit abbreviation strings for one or more cultures.
     A static instance "Property Default" is used internally for ToString() and Parse() of quantities and units.
    """

    Default: typing.ClassVar[UnitAbbreviationsCache]

    def __init__(self) -> None:
        """ Create an instance of the cache and load all the abbreviations defined in the library.
        """
        pass

    @typing.overload
    def MapUnitToAbbreviation(self, unit: TUnitType, abbreviations: Array[str]) -> None:
        """Adds one or more unit abbreviation for the given unit enum value.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        TUnitType: The type of unit enum.

        :param unit: The unit enum value.
        :type unit: TUnitType
        :param abbreviations: Unit abbreviations to add.
        :type abbreviations: Array[str]
        """
        pass

    @typing.overload
    def MapUnitToDefaultAbbreviation(self, unit: TUnitType, abbreviation: str) -> None:
        """Adds a unit abbreviation for the given unit enum value and sets it as the default.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        TUnitType: The type of unit enum.

        :param unit: The unit enum value.
        :type unit: TUnitType
        :param abbreviation: Unit abbreviations to add as default.
        :type abbreviation: str
        """
        pass

    @typing.overload
    def MapUnitToAbbreviation(self, unit: TUnitType, formatProvider: IFormatProvider, abbreviations: Array[str]) -> None:
        """Adds one or more unit abbreviation for the given unit enum value.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        TUnitType: The type of unit enum.

        :param unit: The unit enum value.
        :type unit: TUnitType
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param abbreviations: Unit abbreviations to add.
        :type abbreviations: Array[str]
        """
        pass

    @typing.overload
    def MapUnitToDefaultAbbreviation(self, unit: TUnitType, formatProvider: IFormatProvider, abbreviation: str) -> None:
        """Adds a unit abbreviation for the given unit enum value and sets it as the default.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        TUnitType: The type of unit enum.

        :param unit: The unit enum value.
        :type unit: TUnitType
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param abbreviation: Unit abbreviation to add as default.
        :type abbreviation: str
        """
        pass

    @typing.overload
    def MapUnitToAbbreviation(self, unitType: Type, unitValue: int, formatProvider: IFormatProvider, abbreviations: Array[str]) -> None:
        """Adds one or more unit abbreviation for the given unit enum value.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        :param unitType: The unit enum type.
        :type unitType: Type
        :param unitValue: The unit enum value.
        :type unitValue: int
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param abbreviations: Unit abbreviations to add.
        :type abbreviations: Array[str]
        """
        pass

    @typing.overload
    def MapUnitToDefaultAbbreviation(self, unitType: Type, unitValue: int, formatProvider: IFormatProvider, abbreviation: str) -> None:
        """Adds a unit abbreviation for the given unit enum value and sets it as the default.
        This is used to dynamically add abbreviations for existing unit enums such as "LengthUnit" or to extend with third-party unit enums
        in order to "Function IFormatProvider)" or "Function IFormatProvider)" on them later.

        :param unitType: The unit enum type.
        :type unitType: Type
        :param unitValue: The unit enum value.
        :type unitValue: int
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param abbreviation: Unit abbreviation to add as default.
        :type abbreviation: str
        """
        pass

    @typing.overload
    def GetDefaultAbbreviation(self, unit: TUnitType, formatProvider: IFormatProvider) -> str:
        """Gets the default abbreviation for a given unit. If a unit has more than one abbreviation defined, then it returns the first one.
        Example: GetDefaultAbbreviation<LengthUnit>(LengthUnit.Kilometer) => "km"

        TUnitType: The type of unit enum.

        :param unit: The unit enum value.
        :type unit: TUnitType
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: The default unit abbreviation string.
        :rtype: str
        """
        pass

    @typing.overload
    def GetDefaultAbbreviation(self, unitType: Type, unitValue: int, formatProvider: IFormatProvider) -> str:
        """Gets the default abbreviation for a given unit type and its numeric enum value.
        If a unit has more than one abbreviation defined, then it returns the first one.
        Example: GetDefaultAbbreviation<LengthUnit>(typeof(LengthUnit), 1) => "cm"

        :param unitType: The unit enum type.
        :type unitType: Type
        :param unitValue: The unit enum value.
        :type unitValue: int
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: The default unit abbreviation string.
        :rtype: str
        """
        pass

    @typing.overload
    def GetUnitAbbreviations(self, unit: TUnitType, formatProvider: IFormatProvider) -> Array[str]:
        """ Get all abbreviations for unit.

        TUnitType: Enum type for units.

        :param unit: Enum value for unit.
        :type unit: TUnitType
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: Unit abbreviations associated with unit.
        :rtype: Array[str]
        """
        pass

    @typing.overload
    def GetUnitAbbreviations(self, unitType: Type, unitValue: int, formatProvider: IFormatProvider) -> Array[str]:
        """ Get all abbreviations for unit.

        :param unitType: Enum type for unit.
        :type unitType: Type
        :param unitValue: Enum value for unit.
        :type unitValue: int
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: Unit abbreviations associated with unit.
        :rtype: Array[str]
        """
        pass

    def GetAllUnitAbbreviationsForQuantity(self, unitEnumType: Type, formatProvider: IFormatProvider) -> Array[str]:
        """ Get all abbreviations for all units of a quantity.

        :param unitEnumType: Enum type for unit.
        :type unitEnumType: Type
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: Unit abbreviations associated with unit.
        :rtype: Array[str]
        """
        pass


# noinspection PyPep8Naming
class UnitParser:
    """ Parses units given a unit abbreviations cache.
     The static instance "Property Default" is used internally to parse quantities and units using the
     default abbreviations cache for all units and abbreviations defined in the library.
    """

    Default: typing.ClassVar[UnitParser]

    def __init__(self, unitAbbreviationsCache: UnitAbbreviationsCache) -> None:
        """ Create a parser using the given unit abbreviations cache.

        :param unitAbbreviationsCache:
        :type unitAbbreviationsCache: UnitAbbreviationsCache
        """
        pass

    @typing.overload
    def Parse(self, unitAbbreviation: str, formatProvider: IFormatProvider) -> TUnitType:
        """Parses a unit abbreviation for a given unit enumeration type.
        Example: Parse<LengthUnit>("km") => LengthUnit.Kilometer

        TUnitType:

        :param unitAbbreviation:
        :type unitAbbreviation: str
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return:
        :rtype: TUnitType
        """
        pass

    @typing.overload
    def Parse(self, unitAbbreviation: str, unitType: Type, formatProvider: IFormatProvider) -> Enum:
        """ Parse a unit abbreviation, such as "kg" or "m", to the unit enum value of the enum type
         .

        :param unitAbbreviation: Unit abbreviation, such as "kg" or "m" for "Field Kilogram" and
        "Field Meter" respectively.
        :type unitAbbreviation: str
        :param unitType: Unit enum type, such as "MassUnit" and "LengthUnit".
        :type unitType: Type
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: Unit enum value, such as "Field Kilogram".
        :rtype: Enum

        :exception UnitNotFoundException: No units match the abbreviation.
        :exception AmbiguousUnitParseException: More than one unit matches the abbreviation.
        """
        pass

    @typing.overload
    def TryParse(self, unitAbbreviation: str, unit: TUnitType) -> typing.Tuple[TUnitType, bool]: ...

    @typing.overload
    def TryParse(self, unitAbbreviation: str, formatProvider: IFormatProvider, unit: TUnitType) -> typing.Tuple[TUnitType, bool]: ...

    @typing.overload
    def TryParse(self, unitAbbreviation: str, unitType: Type, unit: Enum) -> typing.Tuple[Enum, bool]:
        """Try to parse a unit abbreviation.

        :param unitAbbreviation: The string value.
        :type unitAbbreviation: str
        :param unitType: Type of unit enum.
        :type unitType: Type
        :param unit: The unit enum value as out result.
        :type unit: Enum
        :return: True if successful.
        :rtype: bool
        """
        pass

    @typing.overload
    def TryParse(self, unitAbbreviation: str, unitType: Type, formatProvider: IFormatProvider, unit: Enum) -> typing.Tuple[Enum, bool]:
        """Try to parse a unit abbreviation.

        :param unitAbbreviation: The string value.
        :type unitAbbreviation: str
        :param unitType: Type of unit enum.
        :type unitType: Type
        :param formatProvider: The format provider to use for lookup. Defaults to "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :param unit: The unit enum value as out result.
        :type unit: Enum
        :return: True if successful.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class ApparentEnergy(ValueType, IQuantity[ApparentEnergyUnit], IQuantity, IFormattable, IEquatable[ApparentEnergy], IComparable, IComparable[ApparentEnergy], IConvertible):
    """ A unit for expressing the integral of apparent power over time, equal to the product of 1 volt-ampere and 1 hour, or to 3600 joules.
    """

    Info: typing.ClassVar[QuantityInfo[ApparentEnergyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ApparentEnergyUnit]

    MaxValue: typing.ClassVar[ApparentEnergy]

    MinValue: typing.ClassVar[ApparentEnergy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ApparentEnergyUnit]]

    Zero: typing.ClassVar[ApparentEnergy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ApparentEnergyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ApparentEnergyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilovoltampereHours(self) -> float:
        """ Get ApparentEnergy in KilovoltampereHours.
        """
        pass

    @property
    def MegavoltampereHours(self) -> float:
        """ Get ApparentEnergy in MegavoltampereHours.
        """
        pass

    @property
    def VoltampereHours(self) -> float:
        """ Get ApparentEnergy in VoltampereHours.
        """
        pass

    def __init__(self, value: float, unit: ApparentEnergyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ApparentEnergyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ApparentEnergyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ApparentEnergyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ApparentEnergyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ApparentEnergyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovoltampereHours(kilovoltamperehours: QuantityValue) -> ApparentEnergy:
        """ Get ApparentEnergy from KilovoltampereHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltampereHours(megavoltamperehours: QuantityValue) -> ApparentEnergy:
        """ Get ApparentEnergy from MegavoltampereHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltampereHours(voltamperehours: QuantityValue) -> ApparentEnergy:
        """ Get ApparentEnergy from VoltampereHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ApparentEnergyUnit) -> ApparentEnergy:
        """ Dynamically convert from value and unit enum "ApparentEnergyUnit" to "ApparentEnergy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ApparentEnergyUnit
        :return: ApparentEnergy unit value.
        :rtype: ApparentEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ApparentEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ApparentEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ApparentEnergy) -> typing.Tuple[ApparentEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ApparentEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ApparentEnergy) -> typing.Tuple[ApparentEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ApparentEnergy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ApparentEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ApparentEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ApparentEnergyUnit) -> typing.Tuple[ApparentEnergyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ApparentEnergyUnit) -> typing.Tuple[ApparentEnergyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ApparentEnergyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ApparentEnergy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ApparentEnergy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ApparentEnergy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ApparentEnergy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ApparentEnergy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ApparentEnergy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ApparentEnergyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ApparentEnergyUnit) -> ApparentEnergy:
        """ Converts this ApparentEnergy to another ApparentEnergy with the unit representation .

        :return: A ApparentEnergy with the specified unit.
        :rtype: ApparentEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ApparentEnergy:
        """
        """
        pass


# noinspection PyPep8Naming
class ApparentPower(ValueType, IQuantity[ApparentPowerUnit], IQuantity, IFormattable, IEquatable[ApparentPower], IComparable, IComparable[ApparentPower], IConvertible):
    """ Power engineers measure apparent power as the magnitude of the vector sum of active and reactive power. Apparent power is the product of the root-mean-square of voltage and current.
    """

    Info: typing.ClassVar[QuantityInfo[ApparentPowerUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ApparentPowerUnit]

    MaxValue: typing.ClassVar[ApparentPower]

    MinValue: typing.ClassVar[ApparentPower]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ApparentPowerUnit]]

    Zero: typing.ClassVar[ApparentPower]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ApparentPowerUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ApparentPowerUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Gigavoltamperes(self) -> float:
        """ Get ApparentPower in Gigavoltamperes.
        """
        pass

    @property
    def Kilovoltamperes(self) -> float:
        """ Get ApparentPower in Kilovoltamperes.
        """
        pass

    @property
    def Megavoltamperes(self) -> float:
        """ Get ApparentPower in Megavoltamperes.
        """
        pass

    @property
    def Voltamperes(self) -> float:
        """ Get ApparentPower in Voltamperes.
        """
        pass

    def __init__(self, value: float, unit: ApparentPowerUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ApparentPowerUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ApparentPowerUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ApparentPowerUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ApparentPowerUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ApparentPowerUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGigavoltamperes(gigavoltamperes: QuantityValue) -> ApparentPower:
        """ Get ApparentPower from Gigavoltamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilovoltamperes(kilovoltamperes: QuantityValue) -> ApparentPower:
        """ Get ApparentPower from Kilovoltamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltamperes(megavoltamperes: QuantityValue) -> ApparentPower:
        """ Get ApparentPower from Megavoltamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltamperes(voltamperes: QuantityValue) -> ApparentPower:
        """ Get ApparentPower from Voltamperes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ApparentPowerUnit) -> ApparentPower:
        """ Dynamically convert from value and unit enum "ApparentPowerUnit" to "ApparentPower".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ApparentPowerUnit
        :return: ApparentPower unit value.
        :rtype: ApparentPower
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ApparentPower:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ApparentPower:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ApparentPower) -> typing.Tuple[ApparentPower, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ApparentPower
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ApparentPower) -> typing.Tuple[ApparentPower, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ApparentPower
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ApparentPowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ApparentPowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ApparentPowerUnit) -> typing.Tuple[ApparentPowerUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ApparentPowerUnit) -> typing.Tuple[ApparentPowerUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ApparentPowerUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ApparentPower) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ApparentPower) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ApparentPower, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ApparentPower within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ApparentPower
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ApparentPower.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ApparentPowerUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ApparentPowerUnit) -> ApparentPower:
        """ Converts this ApparentPower to another ApparentPower with the unit representation .

        :return: A ApparentPower with the specified unit.
        :rtype: ApparentPower
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ApparentPower:
        """
        """
        pass


# noinspection PyPep8Naming
class AreaDensity(ValueType, IQuantity[AreaDensityUnit], IQuantity, IFormattable, IEquatable[AreaDensity], IComparable, IComparable[AreaDensity], IConvertible):
    """ The area density of a two-dimensional object is calculated as the mass per unit area.
    """

    Info: typing.ClassVar[QuantityInfo[AreaDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[AreaDensityUnit]

    MaxValue: typing.ClassVar[AreaDensity]

    MinValue: typing.ClassVar[AreaDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[AreaDensityUnit]]

    Zero: typing.ClassVar[AreaDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> AreaDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[AreaDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilogramsPerSquareMeter(self) -> float:
        """ Get AreaDensity in KilogramsPerSquareMeter.
        """
        pass

    def __init__(self, value: float, unit: AreaDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: AreaDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: AreaDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: AreaDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilogramsPerSquareMeter(kilogramspersquaremeter: QuantityValue) -> AreaDensity:
        """ Get AreaDensity from KilogramsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: AreaDensityUnit) -> AreaDensity:
        """ Dynamically convert from value and unit enum "AreaDensityUnit" to "AreaDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: AreaDensityUnit
        :return: AreaDensity unit value.
        :rtype: AreaDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> AreaDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> AreaDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: AreaDensity) -> typing.Tuple[AreaDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AreaDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: AreaDensity) -> typing.Tuple[AreaDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: AreaDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> AreaDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> AreaDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: AreaDensityUnit) -> typing.Tuple[AreaDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: AreaDensityUnit) -> typing.Tuple[AreaDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: AreaDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: AreaDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AreaDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: AreaDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another AreaDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: AreaDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current AreaDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: AreaDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: AreaDensityUnit) -> AreaDensity:
        """ Converts this AreaDensity to another AreaDensity with the unit representation .

        :return: A AreaDensity with the specified unit.
        :rtype: AreaDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> AreaDensity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class BitRate(ValueType, IQuantity[BitRateUnit], IQuantity, IFormattable, IDecimalQuantity, IEquatable[BitRate], IComparable, IComparable[BitRate], IConvertible):
    """ In telecommunications and computing, bit rate is the number of bits that are conveyed or processed per unit of time.
     https://en.wikipedia.org/wiki/Bit_rate
    """

    Info: typing.ClassVar[QuantityInfo[BitRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[BitRateUnit]

    MaxValue: typing.ClassVar[BitRate]

    MinValue: typing.ClassVar[BitRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[BitRateUnit]]

    Zero: typing.ClassVar[BitRate]

    @property
    def Value(self) -> Decimal:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> BitRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[BitRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BitsPerSecond(self) -> float:
        """ Get BitRate in BitsPerSecond.
        """
        pass

    @property
    def BytesPerSecond(self) -> float:
        """ Get BitRate in BytesPerSecond.
        """
        pass

    @property
    def ExabitsPerSecond(self) -> float:
        """ Get BitRate in ExabitsPerSecond.
        """
        pass

    @property
    def ExabytesPerSecond(self) -> float:
        """ Get BitRate in ExabytesPerSecond.
        """
        pass

    @property
    def ExbibitsPerSecond(self) -> float:
        """ Get BitRate in ExbibitsPerSecond.
        """
        pass

    @property
    def ExbibytesPerSecond(self) -> float:
        """ Get BitRate in ExbibytesPerSecond.
        """
        pass

    @property
    def GibibitsPerSecond(self) -> float:
        """ Get BitRate in GibibitsPerSecond.
        """
        pass

    @property
    def GibibytesPerSecond(self) -> float:
        """ Get BitRate in GibibytesPerSecond.
        """
        pass

    @property
    def GigabitsPerSecond(self) -> float:
        """ Get BitRate in GigabitsPerSecond.
        """
        pass

    @property
    def GigabytesPerSecond(self) -> float:
        """ Get BitRate in GigabytesPerSecond.
        """
        pass

    @property
    def KibibitsPerSecond(self) -> float:
        """ Get BitRate in KibibitsPerSecond.
        """
        pass

    @property
    def KibibytesPerSecond(self) -> float:
        """ Get BitRate in KibibytesPerSecond.
        """
        pass

    @property
    def KilobitsPerSecond(self) -> float:
        """ Get BitRate in KilobitsPerSecond.
        """
        pass

    @property
    def KilobytesPerSecond(self) -> float:
        """ Get BitRate in KilobytesPerSecond.
        """
        pass

    @property
    def MebibitsPerSecond(self) -> float:
        """ Get BitRate in MebibitsPerSecond.
        """
        pass

    @property
    def MebibytesPerSecond(self) -> float:
        """ Get BitRate in MebibytesPerSecond.
        """
        pass

    @property
    def MegabitsPerSecond(self) -> float:
        """ Get BitRate in MegabitsPerSecond.
        """
        pass

    @property
    def MegabytesPerSecond(self) -> float:
        """ Get BitRate in MegabytesPerSecond.
        """
        pass

    @property
    def PebibitsPerSecond(self) -> float:
        """ Get BitRate in PebibitsPerSecond.
        """
        pass

    @property
    def PebibytesPerSecond(self) -> float:
        """ Get BitRate in PebibytesPerSecond.
        """
        pass

    @property
    def PetabitsPerSecond(self) -> float:
        """ Get BitRate in PetabitsPerSecond.
        """
        pass

    @property
    def PetabytesPerSecond(self) -> float:
        """ Get BitRate in PetabytesPerSecond.
        """
        pass

    @property
    def TebibitsPerSecond(self) -> float:
        """ Get BitRate in TebibitsPerSecond.
        """
        pass

    @property
    def TebibytesPerSecond(self) -> float:
        """ Get BitRate in TebibytesPerSecond.
        """
        pass

    @property
    def TerabitsPerSecond(self) -> float:
        """ Get BitRate in TerabitsPerSecond.
        """
        pass

    @property
    def TerabytesPerSecond(self) -> float:
        """ Get BitRate in TerabytesPerSecond.
        """
        pass

    def __init__(self, value: Decimal, unit: BitRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unit: The unit representation to construct this quantity with.
        :type unit: BitRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: Decimal, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> BitRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> BitRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: BitRate) -> typing.Tuple[BitRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: BitRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: BitRate) -> typing.Tuple[BitRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: BitRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> BitRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> BitRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: BitRateUnit) -> typing.Tuple[BitRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: BitRateUnit) -> typing.Tuple[BitRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: BitRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: BitRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: BitRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: BitRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another BitRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: BitRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current BitRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: BitRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: BitRateUnit) -> BitRate:
        """ Converts this BitRate to another BitRate with the unit representation .

        :return: A BitRate with the specified unit.
        :rtype: BitRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> BitRate:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: BitRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: BitRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: BitRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: BitRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBitsPerSecond(bitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from BitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBytesPerSecond(bytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from BytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExabitsPerSecond(exabitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from ExabitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExabytesPerSecond(exabytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from ExabytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExbibitsPerSecond(exbibitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from ExbibitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExbibytesPerSecond(exbibytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from ExbibytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGibibitsPerSecond(gibibitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from GibibitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGibibytesPerSecond(gibibytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from GibibytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigabitsPerSecond(gigabitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from GigabitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigabytesPerSecond(gigabytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from GigabytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKibibitsPerSecond(kibibitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from KibibitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKibibytesPerSecond(kibibytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from KibibytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobitsPerSecond(kilobitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from KilobitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobytesPerSecond(kilobytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from KilobytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMebibitsPerSecond(mebibitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from MebibitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMebibytesPerSecond(mebibytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from MebibytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabitsPerSecond(megabitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from MegabitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabytesPerSecond(megabytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from MegabytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPebibitsPerSecond(pebibitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from PebibitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPebibytesPerSecond(pebibytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from PebibytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetabitsPerSecond(petabitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from PetabitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetabytesPerSecond(petabytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from PetabytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTebibitsPerSecond(tebibitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from TebibitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTebibytesPerSecond(tebibytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from TebibytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerabitsPerSecond(terabitspersecond: QuantityValue) -> BitRate:
        """ Get BitRate from TerabitsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerabytesPerSecond(terabytespersecond: QuantityValue) -> BitRate:
        """ Get BitRate from TerabytesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: BitRateUnit) -> BitRate:
        """ Dynamically convert from value and unit enum "BitRateUnit" to "BitRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: BitRateUnit
        :return: BitRate unit value.
        :rtype: BitRate
        """
        pass


# noinspection PyPep8Naming
class Capacitance(ValueType, IQuantity[CapacitanceUnit], IQuantity, IFormattable, IEquatable[Capacitance], IComparable, IComparable[Capacitance], IConvertible):
    """ Capacitance is the ability of a body to store an electric charge.
     https://en.wikipedia.org/wiki/Capacitance
    """

    Info: typing.ClassVar[QuantityInfo[CapacitanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[CapacitanceUnit]

    MaxValue: typing.ClassVar[Capacitance]

    MinValue: typing.ClassVar[Capacitance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[CapacitanceUnit]]

    Zero: typing.ClassVar[Capacitance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> CapacitanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[CapacitanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Farads(self) -> float:
        """ Get Capacitance in Farads.
        """
        pass

    @property
    def Kilofarads(self) -> float:
        """ Get Capacitance in Kilofarads.
        """
        pass

    @property
    def Megafarads(self) -> float:
        """ Get Capacitance in Megafarads.
        """
        pass

    @property
    def Microfarads(self) -> float:
        """ Get Capacitance in Microfarads.
        """
        pass

    @property
    def Millifarads(self) -> float:
        """ Get Capacitance in Millifarads.
        """
        pass

    @property
    def Nanofarads(self) -> float:
        """ Get Capacitance in Nanofarads.
        """
        pass

    @property
    def Picofarads(self) -> float:
        """ Get Capacitance in Picofarads.
        """
        pass

    def __init__(self, value: float, unit: CapacitanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: CapacitanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CapacitanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CapacitanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CapacitanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CapacitanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromFarads(farads: QuantityValue) -> Capacitance:
        """ Get Capacitance from Farads.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilofarads(kilofarads: QuantityValue) -> Capacitance:
        """ Get Capacitance from Kilofarads.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegafarads(megafarads: QuantityValue) -> Capacitance:
        """ Get Capacitance from Megafarads.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrofarads(microfarads: QuantityValue) -> Capacitance:
        """ Get Capacitance from Microfarads.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillifarads(millifarads: QuantityValue) -> Capacitance:
        """ Get Capacitance from Millifarads.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanofarads(nanofarads: QuantityValue) -> Capacitance:
        """ Get Capacitance from Nanofarads.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicofarads(picofarads: QuantityValue) -> Capacitance:
        """ Get Capacitance from Picofarads.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: CapacitanceUnit) -> Capacitance:
        """ Dynamically convert from value and unit enum "CapacitanceUnit" to "Capacitance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: CapacitanceUnit
        :return: Capacitance unit value.
        :rtype: Capacitance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Capacitance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Capacitance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Capacitance) -> typing.Tuple[Capacitance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Capacitance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Capacitance) -> typing.Tuple[Capacitance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Capacitance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> CapacitanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> CapacitanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: CapacitanceUnit) -> typing.Tuple[CapacitanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: CapacitanceUnit) -> typing.Tuple[CapacitanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: CapacitanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Capacitance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Capacitance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Capacitance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Capacitance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Capacitance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Capacitance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: CapacitanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: CapacitanceUnit) -> Capacitance:
        """ Converts this Capacitance to another Capacitance with the unit representation .

        :return: A Capacitance with the specified unit.
        :rtype: Capacitance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Capacitance:
        """
        """
        pass


# noinspection PyPep8Naming
class CoefficientOfThermalExpansion(ValueType, IQuantity[CoefficientOfThermalExpansionUnit], IQuantity, IFormattable, IEquatable[CoefficientOfThermalExpansion], IComparable, IComparable[CoefficientOfThermalExpansion], IConvertible):
    """ A unit that represents a fractional change in size in response to a change in temperature.
    """

    Info: typing.ClassVar[QuantityInfo[CoefficientOfThermalExpansionUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[CoefficientOfThermalExpansionUnit]

    MaxValue: typing.ClassVar[CoefficientOfThermalExpansion]

    MinValue: typing.ClassVar[CoefficientOfThermalExpansion]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[CoefficientOfThermalExpansionUnit]]

    Zero: typing.ClassVar[CoefficientOfThermalExpansion]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> CoefficientOfThermalExpansionUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[CoefficientOfThermalExpansionUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def InverseDegreeCelsius(self) -> float:
        """ Get CoefficientOfThermalExpansion in InverseDegreeCelsius.
        """
        pass

    @property
    def InverseDegreeFahrenheit(self) -> float:
        """ Get CoefficientOfThermalExpansion in InverseDegreeFahrenheit.
        """
        pass

    @property
    def InverseKelvin(self) -> float:
        """ Get CoefficientOfThermalExpansion in InverseKelvin.
        """
        pass

    def __init__(self, value: float, unit: CoefficientOfThermalExpansionUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: CoefficientOfThermalExpansionUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CoefficientOfThermalExpansionUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CoefficientOfThermalExpansionUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: CoefficientOfThermalExpansionUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: CoefficientOfThermalExpansionUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromInverseDegreeCelsius(inversedegreecelsius: QuantityValue) -> CoefficientOfThermalExpansion:
        """ Get CoefficientOfThermalExpansion from InverseDegreeCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseDegreeFahrenheit(inversedegreefahrenheit: QuantityValue) -> CoefficientOfThermalExpansion:
        """ Get CoefficientOfThermalExpansion from InverseDegreeFahrenheit.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInverseKelvin(inversekelvin: QuantityValue) -> CoefficientOfThermalExpansion:
        """ Get CoefficientOfThermalExpansion from InverseKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: CoefficientOfThermalExpansionUnit) -> CoefficientOfThermalExpansion:
        """ Dynamically convert from value and unit enum "CoefficientOfThermalExpansionUnit" to "CoefficientOfThermalExpansion".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: CoefficientOfThermalExpansionUnit
        :return: CoefficientOfThermalExpansion unit value.
        :rtype: CoefficientOfThermalExpansion
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> CoefficientOfThermalExpansion:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> CoefficientOfThermalExpansion:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: CoefficientOfThermalExpansion) -> typing.Tuple[CoefficientOfThermalExpansion, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: CoefficientOfThermalExpansion
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: CoefficientOfThermalExpansion) -> typing.Tuple[CoefficientOfThermalExpansion, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: CoefficientOfThermalExpansion
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> CoefficientOfThermalExpansionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> CoefficientOfThermalExpansionUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: CoefficientOfThermalExpansionUnit) -> typing.Tuple[CoefficientOfThermalExpansionUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: CoefficientOfThermalExpansionUnit) -> typing.Tuple[CoefficientOfThermalExpansionUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: CoefficientOfThermalExpansionUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: CoefficientOfThermalExpansion) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: CoefficientOfThermalExpansion) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: CoefficientOfThermalExpansion, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another CoefficientOfThermalExpansion within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: CoefficientOfThermalExpansion
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current CoefficientOfThermalExpansion.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: CoefficientOfThermalExpansionUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: CoefficientOfThermalExpansionUnit) -> CoefficientOfThermalExpansion:
        """ Converts this CoefficientOfThermalExpansion to another CoefficientOfThermalExpansion with the unit representation .

        :return: A CoefficientOfThermalExpansion with the specified unit.
        :rtype: CoefficientOfThermalExpansion
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> CoefficientOfThermalExpansion:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricAdmittance(ValueType, IQuantity[ElectricAdmittanceUnit], IQuantity, IFormattable, IEquatable[ElectricAdmittance], IComparable, IComparable[ElectricAdmittance], IConvertible):
    """ Electric admittance is a measure of how easily a circuit or device will allow a current to flow. It is defined as the inverse of impedance. The SI unit of admittance is the siemens (symbol S).
    """

    Info: typing.ClassVar[QuantityInfo[ElectricAdmittanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricAdmittanceUnit]

    MaxValue: typing.ClassVar[ElectricAdmittance]

    MinValue: typing.ClassVar[ElectricAdmittance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricAdmittanceUnit]]

    Zero: typing.ClassVar[ElectricAdmittance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricAdmittanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricAdmittanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Microsiemens(self) -> float:
        """ Get ElectricAdmittance in Microsiemens.
        """
        pass

    @property
    def Millisiemens(self) -> float:
        """ Get ElectricAdmittance in Millisiemens.
        """
        pass

    @property
    def Nanosiemens(self) -> float:
        """ Get ElectricAdmittance in Nanosiemens.
        """
        pass

    @property
    def Siemens(self) -> float:
        """ Get ElectricAdmittance in Siemens.
        """
        pass

    def __init__(self, value: float, unit: ElectricAdmittanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricAdmittanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricAdmittanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricAdmittanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricAdmittanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricAdmittanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromMicrosiemens(microsiemens: QuantityValue) -> ElectricAdmittance:
        """ Get ElectricAdmittance from Microsiemens.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillisiemens(millisiemens: QuantityValue) -> ElectricAdmittance:
        """ Get ElectricAdmittance from Millisiemens.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanosiemens(nanosiemens: QuantityValue) -> ElectricAdmittance:
        """ Get ElectricAdmittance from Nanosiemens.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSiemens(siemens: QuantityValue) -> ElectricAdmittance:
        """ Get ElectricAdmittance from Siemens.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricAdmittanceUnit) -> ElectricAdmittance:
        """ Dynamically convert from value and unit enum "ElectricAdmittanceUnit" to "ElectricAdmittance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricAdmittanceUnit
        :return: ElectricAdmittance unit value.
        :rtype: ElectricAdmittance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricAdmittance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricAdmittance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricAdmittance) -> typing.Tuple[ElectricAdmittance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricAdmittance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricAdmittance) -> typing.Tuple[ElectricAdmittance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricAdmittance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricAdmittanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricAdmittanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricAdmittanceUnit) -> typing.Tuple[ElectricAdmittanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricAdmittanceUnit) -> typing.Tuple[ElectricAdmittanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricAdmittanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricAdmittance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricAdmittance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricAdmittance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricAdmittance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricAdmittance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricAdmittance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricAdmittanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricAdmittanceUnit) -> ElectricAdmittance:
        """ Converts this ElectricAdmittance to another ElectricAdmittance with the unit representation .

        :return: A ElectricAdmittance with the specified unit.
        :rtype: ElectricAdmittance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricAdmittance:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricChargeDensity(ValueType, IQuantity[ElectricChargeDensityUnit], IQuantity, IFormattable, IEquatable[ElectricChargeDensity], IComparable, IComparable[ElectricChargeDensity], IConvertible):
    """ In electromagnetism, charge density is a measure of the amount of electric charge per volume.
     https://en.wikipedia.org/wiki/Charge_density
    """

    Info: typing.ClassVar[QuantityInfo[ElectricChargeDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricChargeDensityUnit]

    MaxValue: typing.ClassVar[ElectricChargeDensity]

    MinValue: typing.ClassVar[ElectricChargeDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricChargeDensityUnit]]

    Zero: typing.ClassVar[ElectricChargeDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricChargeDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricChargeDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CoulombsPerCubicMeter(self) -> float:
        """ Get ElectricChargeDensity in CoulombsPerCubicMeter.
        """
        pass

    def __init__(self, value: float, unit: ElectricChargeDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricChargeDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricChargeDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricChargeDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricChargeDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricChargeDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCoulombsPerCubicMeter(coulombspercubicmeter: QuantityValue) -> ElectricChargeDensity:
        """ Get ElectricChargeDensity from CoulombsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricChargeDensityUnit) -> ElectricChargeDensity:
        """ Dynamically convert from value and unit enum "ElectricChargeDensityUnit" to "ElectricChargeDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricChargeDensityUnit
        :return: ElectricChargeDensity unit value.
        :rtype: ElectricChargeDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricChargeDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricChargeDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricChargeDensity) -> typing.Tuple[ElectricChargeDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricChargeDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricChargeDensity) -> typing.Tuple[ElectricChargeDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricChargeDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricChargeDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricChargeDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricChargeDensityUnit) -> typing.Tuple[ElectricChargeDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricChargeDensityUnit) -> typing.Tuple[ElectricChargeDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricChargeDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricChargeDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricChargeDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricChargeDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricChargeDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricChargeDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricChargeDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricChargeDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricChargeDensityUnit) -> ElectricChargeDensity:
        """ Converts this ElectricChargeDensity to another ElectricChargeDensity with the unit representation .

        :return: A ElectricChargeDensity with the specified unit.
        :rtype: ElectricChargeDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricChargeDensity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class ElectricConductance(ValueType, IQuantity[ElectricConductanceUnit], IQuantity, IFormattable, IEquatable[ElectricConductance], IComparable, IComparable[ElectricConductance], IConvertible):
    """ The electrical conductance of an electrical conductor is a measure of the easeness to pass an electric current through that conductor.
     https://en.wikipedia.org/wiki/Electrical_resistance_and_conductance
    """

    Info: typing.ClassVar[QuantityInfo[ElectricConductanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricConductanceUnit]

    MaxValue: typing.ClassVar[ElectricConductance]

    MinValue: typing.ClassVar[ElectricConductance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricConductanceUnit]]

    Zero: typing.ClassVar[ElectricConductance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricConductanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricConductanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Microsiemens(self) -> float:
        """ Get ElectricConductance in Microsiemens.
        """
        pass

    @property
    def Millisiemens(self) -> float:
        """ Get ElectricConductance in Millisiemens.
        """
        pass

    @property
    def Siemens(self) -> float:
        """ Get ElectricConductance in Siemens.
        """
        pass

    def __init__(self, value: float, unit: ElectricConductanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricConductanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricConductanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricConductanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricConductanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricConductanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromMicrosiemens(microsiemens: QuantityValue) -> ElectricConductance:
        """ Get ElectricConductance from Microsiemens.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillisiemens(millisiemens: QuantityValue) -> ElectricConductance:
        """ Get ElectricConductance from Millisiemens.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSiemens(siemens: QuantityValue) -> ElectricConductance:
        """ Get ElectricConductance from Siemens.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricConductanceUnit) -> ElectricConductance:
        """ Dynamically convert from value and unit enum "ElectricConductanceUnit" to "ElectricConductance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricConductanceUnit
        :return: ElectricConductance unit value.
        :rtype: ElectricConductance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricConductance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricConductance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricConductance) -> typing.Tuple[ElectricConductance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricConductance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricConductance) -> typing.Tuple[ElectricConductance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricConductance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricConductanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricConductanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricConductanceUnit) -> typing.Tuple[ElectricConductanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricConductanceUnit) -> typing.Tuple[ElectricConductanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricConductanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricConductance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricConductance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricConductance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricConductance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricConductance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricConductance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricConductanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricConductanceUnit) -> ElectricConductance:
        """ Converts this ElectricConductance to another ElectricConductance with the unit representation .

        :return: A ElectricConductance with the specified unit.
        :rtype: ElectricConductance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricConductance:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricConductivity(ValueType, IQuantity[ElectricConductivityUnit], IQuantity, IFormattable, IEquatable[ElectricConductivity], IComparable, IComparable[ElectricConductivity], IConvertible):
    """ Electrical conductivity or specific conductance is the reciprocal of electrical resistivity, and measures a material's ability to conduct an electric current.
     https://en.wikipedia.org/wiki/Electrical_resistivity_and_conductivity
    """

    Info: typing.ClassVar[QuantityInfo[ElectricConductivityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricConductivityUnit]

    MaxValue: typing.ClassVar[ElectricConductivity]

    MinValue: typing.ClassVar[ElectricConductivity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricConductivityUnit]]

    Zero: typing.ClassVar[ElectricConductivity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricConductivityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricConductivityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def SiemensPerFoot(self) -> float:
        """ Get ElectricConductivity in SiemensPerFoot.
        """
        pass

    @property
    def SiemensPerInch(self) -> float:
        """ Get ElectricConductivity in SiemensPerInch.
        """
        pass

    @property
    def SiemensPerMeter(self) -> float:
        """ Get ElectricConductivity in SiemensPerMeter.
        """
        pass

    def __init__(self, value: float, unit: ElectricConductivityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricConductivityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricConductivityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricConductivityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricConductivityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricConductivityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromSiemensPerFoot(siemensperfoot: QuantityValue) -> ElectricConductivity:
        """ Get ElectricConductivity from SiemensPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSiemensPerInch(siemensperinch: QuantityValue) -> ElectricConductivity:
        """ Get ElectricConductivity from SiemensPerInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSiemensPerMeter(siemenspermeter: QuantityValue) -> ElectricConductivity:
        """ Get ElectricConductivity from SiemensPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricConductivityUnit) -> ElectricConductivity:
        """ Dynamically convert from value and unit enum "ElectricConductivityUnit" to "ElectricConductivity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricConductivityUnit
        :return: ElectricConductivity unit value.
        :rtype: ElectricConductivity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricConductivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricConductivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricConductivity) -> typing.Tuple[ElectricConductivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricConductivity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricConductivity) -> typing.Tuple[ElectricConductivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricConductivity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricConductivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricConductivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricConductivityUnit) -> typing.Tuple[ElectricConductivityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricConductivityUnit) -> typing.Tuple[ElectricConductivityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricConductivityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricConductivity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricConductivity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricConductivity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricConductivity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricConductivity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricConductivity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricConductivityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricConductivityUnit) -> ElectricConductivity:
        """ Converts this ElectricConductivity to another ElectricConductivity with the unit representation .

        :return: A ElectricConductivity with the specified unit.
        :rtype: ElectricConductivity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricConductivity:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricCurrentDensity(ValueType, IQuantity[ElectricCurrentDensityUnit], IQuantity, IFormattable, IEquatable[ElectricCurrentDensity], IComparable, IComparable[ElectricCurrentDensity], IConvertible):
    """ In electromagnetism, current density is the electric current per unit area of cross section.
     https://en.wikipedia.org/wiki/Current_density
    """

    Info: typing.ClassVar[QuantityInfo[ElectricCurrentDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricCurrentDensityUnit]

    MaxValue: typing.ClassVar[ElectricCurrentDensity]

    MinValue: typing.ClassVar[ElectricCurrentDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricCurrentDensityUnit]]

    Zero: typing.ClassVar[ElectricCurrentDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricCurrentDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricCurrentDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AmperesPerSquareFoot(self) -> float:
        """ Get ElectricCurrentDensity in AmperesPerSquareFoot.
        """
        pass

    @property
    def AmperesPerSquareInch(self) -> float:
        """ Get ElectricCurrentDensity in AmperesPerSquareInch.
        """
        pass

    @property
    def AmperesPerSquareMeter(self) -> float:
        """ Get ElectricCurrentDensity in AmperesPerSquareMeter.
        """
        pass

    def __init__(self, value: float, unit: ElectricCurrentDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricCurrentDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmperesPerSquareFoot(amperespersquarefoot: QuantityValue) -> ElectricCurrentDensity:
        """ Get ElectricCurrentDensity from AmperesPerSquareFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAmperesPerSquareInch(amperespersquareinch: QuantityValue) -> ElectricCurrentDensity:
        """ Get ElectricCurrentDensity from AmperesPerSquareInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAmperesPerSquareMeter(amperespersquaremeter: QuantityValue) -> ElectricCurrentDensity:
        """ Get ElectricCurrentDensity from AmperesPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricCurrentDensityUnit) -> ElectricCurrentDensity:
        """ Dynamically convert from value and unit enum "ElectricCurrentDensityUnit" to "ElectricCurrentDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricCurrentDensityUnit
        :return: ElectricCurrentDensity unit value.
        :rtype: ElectricCurrentDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricCurrentDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricCurrentDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricCurrentDensity) -> typing.Tuple[ElectricCurrentDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrentDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricCurrentDensity) -> typing.Tuple[ElectricCurrentDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrentDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricCurrentDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricCurrentDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricCurrentDensityUnit) -> typing.Tuple[ElectricCurrentDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricCurrentDensityUnit) -> typing.Tuple[ElectricCurrentDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricCurrentDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricCurrentDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrentDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrentDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricCurrentDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricCurrentDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricCurrentDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricCurrentDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricCurrentDensityUnit) -> ElectricCurrentDensity:
        """ Converts this ElectricCurrentDensity to another ElectricCurrentDensity with the unit representation .

        :return: A ElectricCurrentDensity with the specified unit.
        :rtype: ElectricCurrentDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricCurrentDensity:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricCurrentGradient(ValueType, IQuantity[ElectricCurrentGradientUnit], IQuantity, IFormattable, IEquatable[ElectricCurrentGradient], IComparable, IComparable[ElectricCurrentGradient], IConvertible):
    """ In electromagnetism, the current gradient describes how the current changes in time.
    """

    Info: typing.ClassVar[QuantityInfo[ElectricCurrentGradientUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricCurrentGradientUnit]

    MaxValue: typing.ClassVar[ElectricCurrentGradient]

    MinValue: typing.ClassVar[ElectricCurrentGradient]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricCurrentGradientUnit]]

    Zero: typing.ClassVar[ElectricCurrentGradient]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricCurrentGradientUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricCurrentGradientUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AmperesPerMicrosecond(self) -> float:
        """ Get ElectricCurrentGradient in AmperesPerMicrosecond.
        """
        pass

    @property
    def AmperesPerMillisecond(self) -> float:
        """ Get ElectricCurrentGradient in AmperesPerMillisecond.
        """
        pass

    @property
    def AmperesPerNanosecond(self) -> float:
        """ Get ElectricCurrentGradient in AmperesPerNanosecond.
        """
        pass

    @property
    def AmperesPerSecond(self) -> float:
        """ Get ElectricCurrentGradient in AmperesPerSecond.
        """
        pass

    def __init__(self, value: float, unit: ElectricCurrentGradientUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricCurrentGradientUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentGradientUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentGradientUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricCurrentGradientUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricCurrentGradientUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmperesPerMicrosecond(amperespermicrosecond: QuantityValue) -> ElectricCurrentGradient:
        """ Get ElectricCurrentGradient from AmperesPerMicrosecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAmperesPerMillisecond(amperespermillisecond: QuantityValue) -> ElectricCurrentGradient:
        """ Get ElectricCurrentGradient from AmperesPerMillisecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAmperesPerNanosecond(amperespernanosecond: QuantityValue) -> ElectricCurrentGradient:
        """ Get ElectricCurrentGradient from AmperesPerNanosecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromAmperesPerSecond(amperespersecond: QuantityValue) -> ElectricCurrentGradient:
        """ Get ElectricCurrentGradient from AmperesPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricCurrentGradientUnit) -> ElectricCurrentGradient:
        """ Dynamically convert from value and unit enum "ElectricCurrentGradientUnit" to "ElectricCurrentGradient".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricCurrentGradientUnit
        :return: ElectricCurrentGradient unit value.
        :rtype: ElectricCurrentGradient
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricCurrentGradient:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricCurrentGradient:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricCurrentGradient) -> typing.Tuple[ElectricCurrentGradient, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrentGradient
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricCurrentGradient) -> typing.Tuple[ElectricCurrentGradient, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricCurrentGradient
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricCurrentGradientUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricCurrentGradientUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricCurrentGradientUnit) -> typing.Tuple[ElectricCurrentGradientUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricCurrentGradientUnit) -> typing.Tuple[ElectricCurrentGradientUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricCurrentGradientUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricCurrentGradient) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrentGradient) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricCurrentGradient, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricCurrentGradient within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricCurrentGradient
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricCurrentGradient.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricCurrentGradientUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricCurrentGradientUnit) -> ElectricCurrentGradient:
        """ Converts this ElectricCurrentGradient to another ElectricCurrentGradient with the unit representation .

        :return: A ElectricCurrentGradient with the specified unit.
        :rtype: ElectricCurrentGradient
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricCurrentGradient:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricField(ValueType, IQuantity[ElectricFieldUnit], IQuantity, IFormattable, IEquatable[ElectricField], IComparable, IComparable[ElectricField], IConvertible):
    """ An electric field is a force field that surrounds electric charges that attracts or repels other electric charges.
     https://en.wikipedia.org/wiki/Electric_field
    """

    Info: typing.ClassVar[QuantityInfo[ElectricFieldUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricFieldUnit]

    MaxValue: typing.ClassVar[ElectricField]

    MinValue: typing.ClassVar[ElectricField]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricFieldUnit]]

    Zero: typing.ClassVar[ElectricField]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricFieldUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricFieldUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def VoltsPerMeter(self) -> float:
        """ Get ElectricField in VoltsPerMeter.
        """
        pass

    def __init__(self, value: float, unit: ElectricFieldUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricFieldUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricFieldUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricFieldUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricFieldUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricFieldUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromVoltsPerMeter(voltspermeter: QuantityValue) -> ElectricField:
        """ Get ElectricField from VoltsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricFieldUnit) -> ElectricField:
        """ Dynamically convert from value and unit enum "ElectricFieldUnit" to "ElectricField".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricFieldUnit
        :return: ElectricField unit value.
        :rtype: ElectricField
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricField:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricField:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricField) -> typing.Tuple[ElectricField, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricField
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricField) -> typing.Tuple[ElectricField, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricField
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricFieldUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricFieldUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricFieldUnit) -> typing.Tuple[ElectricFieldUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricFieldUnit) -> typing.Tuple[ElectricFieldUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricFieldUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricField) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricField) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricField, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricField within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricField
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricField.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricFieldUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricFieldUnit) -> ElectricField:
        """ Converts this ElectricField to another ElectricField with the unit representation .

        :return: A ElectricField with the specified unit.
        :rtype: ElectricField
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricField:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class ElectricInductance(ValueType, IQuantity[ElectricInductanceUnit], IQuantity, IFormattable, IEquatable[ElectricInductance], IComparable, IComparable[ElectricInductance], IConvertible):
    """ Inductance is a property of an electrical conductor which opposes a change in current.
     https://en.wikipedia.org/wiki/Inductance
    """

    Info: typing.ClassVar[QuantityInfo[ElectricInductanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricInductanceUnit]

    MaxValue: typing.ClassVar[ElectricInductance]

    MinValue: typing.ClassVar[ElectricInductance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricInductanceUnit]]

    Zero: typing.ClassVar[ElectricInductance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricInductanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricInductanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Henries(self) -> float:
        """ Get ElectricInductance in Henries.
        """
        pass

    @property
    def Microhenries(self) -> float:
        """ Get ElectricInductance in Microhenries.
        """
        pass

    @property
    def Millihenries(self) -> float:
        """ Get ElectricInductance in Millihenries.
        """
        pass

    @property
    def Nanohenries(self) -> float:
        """ Get ElectricInductance in Nanohenries.
        """
        pass

    def __init__(self, value: float, unit: ElectricInductanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricInductanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricInductanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricInductanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricInductanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricInductanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromHenries(henries: QuantityValue) -> ElectricInductance:
        """ Get ElectricInductance from Henries.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrohenries(microhenries: QuantityValue) -> ElectricInductance:
        """ Get ElectricInductance from Microhenries.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillihenries(millihenries: QuantityValue) -> ElectricInductance:
        """ Get ElectricInductance from Millihenries.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanohenries(nanohenries: QuantityValue) -> ElectricInductance:
        """ Get ElectricInductance from Nanohenries.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricInductanceUnit) -> ElectricInductance:
        """ Dynamically convert from value and unit enum "ElectricInductanceUnit" to "ElectricInductance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricInductanceUnit
        :return: ElectricInductance unit value.
        :rtype: ElectricInductance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricInductance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricInductance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricInductance) -> typing.Tuple[ElectricInductance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricInductance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricInductance) -> typing.Tuple[ElectricInductance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricInductance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricInductanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricInductanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricInductanceUnit) -> typing.Tuple[ElectricInductanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricInductanceUnit) -> typing.Tuple[ElectricInductanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricInductanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricInductance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricInductance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricInductance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricInductance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricInductance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricInductance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricInductanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricInductanceUnit) -> ElectricInductance:
        """ Converts this ElectricInductance to another ElectricInductance with the unit representation .

        :return: A ElectricInductance with the specified unit.
        :rtype: ElectricInductance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricInductance:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricPotentialAc(ValueType, IQuantity[ElectricPotentialAcUnit], IQuantity, IFormattable, IEquatable[ElectricPotentialAc], IComparable, IComparable[ElectricPotentialAc], IConvertible):
    """ The Electric Potential of a system known to use Alternating Current.
    """

    Info: typing.ClassVar[QuantityInfo[ElectricPotentialAcUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricPotentialAcUnit]

    MaxValue: typing.ClassVar[ElectricPotentialAc]

    MinValue: typing.ClassVar[ElectricPotentialAc]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricPotentialAcUnit]]

    Zero: typing.ClassVar[ElectricPotentialAc]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricPotentialAcUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricPotentialAcUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilovoltsAc(self) -> float:
        """ Get ElectricPotentialAc in KilovoltsAc.
        """
        pass

    @property
    def MegavoltsAc(self) -> float:
        """ Get ElectricPotentialAc in MegavoltsAc.
        """
        pass

    @property
    def MicrovoltsAc(self) -> float:
        """ Get ElectricPotentialAc in MicrovoltsAc.
        """
        pass

    @property
    def MillivoltsAc(self) -> float:
        """ Get ElectricPotentialAc in MillivoltsAc.
        """
        pass

    @property
    def VoltsAc(self) -> float:
        """ Get ElectricPotentialAc in VoltsAc.
        """
        pass

    def __init__(self, value: float, unit: ElectricPotentialAcUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricPotentialAcUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialAcUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialAcUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialAcUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialAcUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovoltsAc(kilovoltsac: QuantityValue) -> ElectricPotentialAc:
        """ Get ElectricPotentialAc from KilovoltsAc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsAc(megavoltsac: QuantityValue) -> ElectricPotentialAc:
        """ Get ElectricPotentialAc from MegavoltsAc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsAc(microvoltsac: QuantityValue) -> ElectricPotentialAc:
        """ Get ElectricPotentialAc from MicrovoltsAc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsAc(millivoltsac: QuantityValue) -> ElectricPotentialAc:
        """ Get ElectricPotentialAc from MillivoltsAc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsAc(voltsac: QuantityValue) -> ElectricPotentialAc:
        """ Get ElectricPotentialAc from VoltsAc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricPotentialAcUnit) -> ElectricPotentialAc:
        """ Dynamically convert from value and unit enum "ElectricPotentialAcUnit" to "ElectricPotentialAc".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricPotentialAcUnit
        :return: ElectricPotentialAc unit value.
        :rtype: ElectricPotentialAc
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricPotentialAc:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricPotentialAc:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricPotentialAc) -> typing.Tuple[ElectricPotentialAc, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialAc
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricPotentialAc) -> typing.Tuple[ElectricPotentialAc, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialAc
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricPotentialAcUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricPotentialAcUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricPotentialAcUnit) -> typing.Tuple[ElectricPotentialAcUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricPotentialAcUnit) -> typing.Tuple[ElectricPotentialAcUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricPotentialAcUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricPotentialAc) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialAc) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialAc, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricPotentialAc within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricPotentialAc
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricPotentialAc.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricPotentialAcUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialAcUnit) -> ElectricPotentialAc:
        """ Converts this ElectricPotentialAc to another ElectricPotentialAc with the unit representation .

        :return: A ElectricPotentialAc with the specified unit.
        :rtype: ElectricPotentialAc
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricPotentialAc:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricPotentialChangeRate(ValueType, IQuantity[ElectricPotentialChangeRateUnit], IQuantity, IFormattable, IEquatable[ElectricPotentialChangeRate], IComparable, IComparable[ElectricPotentialChangeRate], IConvertible):
    """ ElectricPotential change rate is the ratio of the electric potential change to the time during which the change occurred (value of electric potential changes per unit time).
    """

    Info: typing.ClassVar[QuantityInfo[ElectricPotentialChangeRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricPotentialChangeRateUnit]

    MaxValue: typing.ClassVar[ElectricPotentialChangeRate]

    MinValue: typing.ClassVar[ElectricPotentialChangeRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricPotentialChangeRateUnit]]

    Zero: typing.ClassVar[ElectricPotentialChangeRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricPotentialChangeRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricPotentialChangeRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilovoltsPerHours(self) -> float:
        """ Get ElectricPotentialChangeRate in KilovoltsPerHours.
        """
        pass

    @property
    def KilovoltsPerMicroseconds(self) -> float:
        """ Get ElectricPotentialChangeRate in KilovoltsPerMicroseconds.
        """
        pass

    @property
    def KilovoltsPerMinutes(self) -> float:
        """ Get ElectricPotentialChangeRate in KilovoltsPerMinutes.
        """
        pass

    @property
    def KilovoltsPerSeconds(self) -> float:
        """ Get ElectricPotentialChangeRate in KilovoltsPerSeconds.
        """
        pass

    @property
    def MegavoltsPerHours(self) -> float:
        """ Get ElectricPotentialChangeRate in MegavoltsPerHours.
        """
        pass

    @property
    def MegavoltsPerMicroseconds(self) -> float:
        """ Get ElectricPotentialChangeRate in MegavoltsPerMicroseconds.
        """
        pass

    @property
    def MegavoltsPerMinutes(self) -> float:
        """ Get ElectricPotentialChangeRate in MegavoltsPerMinutes.
        """
        pass

    @property
    def MegavoltsPerSeconds(self) -> float:
        """ Get ElectricPotentialChangeRate in MegavoltsPerSeconds.
        """
        pass

    @property
    def MicrovoltsPerHours(self) -> float:
        """ Get ElectricPotentialChangeRate in MicrovoltsPerHours.
        """
        pass

    @property
    def MicrovoltsPerMicroseconds(self) -> float:
        """ Get ElectricPotentialChangeRate in MicrovoltsPerMicroseconds.
        """
        pass

    @property
    def MicrovoltsPerMinutes(self) -> float:
        """ Get ElectricPotentialChangeRate in MicrovoltsPerMinutes.
        """
        pass

    @property
    def MicrovoltsPerSeconds(self) -> float:
        """ Get ElectricPotentialChangeRate in MicrovoltsPerSeconds.
        """
        pass

    @property
    def MillivoltsPerHours(self) -> float:
        """ Get ElectricPotentialChangeRate in MillivoltsPerHours.
        """
        pass

    @property
    def MillivoltsPerMicroseconds(self) -> float:
        """ Get ElectricPotentialChangeRate in MillivoltsPerMicroseconds.
        """
        pass

    @property
    def MillivoltsPerMinutes(self) -> float:
        """ Get ElectricPotentialChangeRate in MillivoltsPerMinutes.
        """
        pass

    @property
    def MillivoltsPerSeconds(self) -> float:
        """ Get ElectricPotentialChangeRate in MillivoltsPerSeconds.
        """
        pass

    @property
    def VoltsPerHours(self) -> float:
        """ Get ElectricPotentialChangeRate in VoltsPerHours.
        """
        pass

    @property
    def VoltsPerMicroseconds(self) -> float:
        """ Get ElectricPotentialChangeRate in VoltsPerMicroseconds.
        """
        pass

    @property
    def VoltsPerMinutes(self) -> float:
        """ Get ElectricPotentialChangeRate in VoltsPerMinutes.
        """
        pass

    @property
    def VoltsPerSeconds(self) -> float:
        """ Get ElectricPotentialChangeRate in VoltsPerSeconds.
        """
        pass

    def __init__(self, value: float, unit: ElectricPotentialChangeRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricPotentialChangeRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricPotentialChangeRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialChangeRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialChangeRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricPotentialChangeRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricPotentialChangeRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricPotentialChangeRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricPotentialChangeRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialChangeRateUnit) -> ElectricPotentialChangeRate:
        """ Converts this ElectricPotentialChangeRate to another ElectricPotentialChangeRate with the unit representation .

        :return: A ElectricPotentialChangeRate with the specified unit.
        :rtype: ElectricPotentialChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricPotentialChangeRate:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialChangeRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialChangeRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialChangeRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialChangeRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovoltsPerHours(kilovoltsperhours: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from KilovoltsPerHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilovoltsPerMicroseconds(kilovoltspermicroseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from KilovoltsPerMicroseconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilovoltsPerMinutes(kilovoltsperminutes: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from KilovoltsPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilovoltsPerSeconds(kilovoltsperseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from KilovoltsPerSeconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsPerHours(megavoltsperhours: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MegavoltsPerHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsPerMicroseconds(megavoltspermicroseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MegavoltsPerMicroseconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsPerMinutes(megavoltsperminutes: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MegavoltsPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsPerSeconds(megavoltsperseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MegavoltsPerSeconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsPerHours(microvoltsperhours: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MicrovoltsPerHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsPerMicroseconds(microvoltspermicroseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MicrovoltsPerMicroseconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsPerMinutes(microvoltsperminutes: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MicrovoltsPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsPerSeconds(microvoltsperseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MicrovoltsPerSeconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsPerHours(millivoltsperhours: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MillivoltsPerHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsPerMicroseconds(millivoltspermicroseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MillivoltsPerMicroseconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsPerMinutes(millivoltsperminutes: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MillivoltsPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsPerSeconds(millivoltsperseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from MillivoltsPerSeconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsPerHours(voltsperhours: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from VoltsPerHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsPerMicroseconds(voltspermicroseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from VoltsPerMicroseconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsPerMinutes(voltsperminutes: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from VoltsPerMinutes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsPerSeconds(voltsperseconds: QuantityValue) -> ElectricPotentialChangeRate:
        """ Get ElectricPotentialChangeRate from VoltsPerSeconds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricPotentialChangeRateUnit) -> ElectricPotentialChangeRate:
        """ Dynamically convert from value and unit enum "ElectricPotentialChangeRateUnit" to "ElectricPotentialChangeRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricPotentialChangeRateUnit
        :return: ElectricPotentialChangeRate unit value.
        :rtype: ElectricPotentialChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricPotentialChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricPotentialChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricPotentialChangeRate) -> typing.Tuple[ElectricPotentialChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricPotentialChangeRate) -> typing.Tuple[ElectricPotentialChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialChangeRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricPotentialChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricPotentialChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricPotentialChangeRateUnit) -> typing.Tuple[ElectricPotentialChangeRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricPotentialChangeRateUnit) -> typing.Tuple[ElectricPotentialChangeRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricPotentialChangeRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class ElectricPotentialDc(ValueType, IQuantity[ElectricPotentialDcUnit], IQuantity, IFormattable, IEquatable[ElectricPotentialDc], IComparable, IComparable[ElectricPotentialDc], IConvertible):
    """ The Electric Potential of a system known to use Direct Current.
    """

    Info: typing.ClassVar[QuantityInfo[ElectricPotentialDcUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricPotentialDcUnit]

    MaxValue: typing.ClassVar[ElectricPotentialDc]

    MinValue: typing.ClassVar[ElectricPotentialDc]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricPotentialDcUnit]]

    Zero: typing.ClassVar[ElectricPotentialDc]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricPotentialDcUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricPotentialDcUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilovoltsDc(self) -> float:
        """ Get ElectricPotentialDc in KilovoltsDc.
        """
        pass

    @property
    def MegavoltsDc(self) -> float:
        """ Get ElectricPotentialDc in MegavoltsDc.
        """
        pass

    @property
    def MicrovoltsDc(self) -> float:
        """ Get ElectricPotentialDc in MicrovoltsDc.
        """
        pass

    @property
    def MillivoltsDc(self) -> float:
        """ Get ElectricPotentialDc in MillivoltsDc.
        """
        pass

    @property
    def VoltsDc(self) -> float:
        """ Get ElectricPotentialDc in VoltsDc.
        """
        pass

    def __init__(self, value: float, unit: ElectricPotentialDcUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricPotentialDcUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialDcUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialDcUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricPotentialDcUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricPotentialDcUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovoltsDc(kilovoltsdc: QuantityValue) -> ElectricPotentialDc:
        """ Get ElectricPotentialDc from KilovoltsDc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltsDc(megavoltsdc: QuantityValue) -> ElectricPotentialDc:
        """ Get ElectricPotentialDc from MegavoltsDc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrovoltsDc(microvoltsdc: QuantityValue) -> ElectricPotentialDc:
        """ Get ElectricPotentialDc from MicrovoltsDc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillivoltsDc(millivoltsdc: QuantityValue) -> ElectricPotentialDc:
        """ Get ElectricPotentialDc from MillivoltsDc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltsDc(voltsdc: QuantityValue) -> ElectricPotentialDc:
        """ Get ElectricPotentialDc from VoltsDc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricPotentialDcUnit) -> ElectricPotentialDc:
        """ Dynamically convert from value and unit enum "ElectricPotentialDcUnit" to "ElectricPotentialDc".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricPotentialDcUnit
        :return: ElectricPotentialDc unit value.
        :rtype: ElectricPotentialDc
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricPotentialDc:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricPotentialDc:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricPotentialDc) -> typing.Tuple[ElectricPotentialDc, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialDc
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricPotentialDc) -> typing.Tuple[ElectricPotentialDc, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricPotentialDc
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricPotentialDcUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricPotentialDcUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricPotentialDcUnit) -> typing.Tuple[ElectricPotentialDcUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricPotentialDcUnit) -> typing.Tuple[ElectricPotentialDcUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricPotentialDcUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricPotentialDc) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialDc) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricPotentialDc, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricPotentialDc within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricPotentialDc
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricPotentialDc.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricPotentialDcUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricPotentialDcUnit) -> ElectricPotentialDc:
        """ Converts this ElectricPotentialDc to another ElectricPotentialDc with the unit representation .

        :return: A ElectricPotentialDc with the specified unit.
        :rtype: ElectricPotentialDc
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricPotentialDc:
        """
        """
        pass


# noinspection PyPep8Naming
class ElectricResistivity(ValueType, IQuantity[ElectricResistivityUnit], IQuantity, IFormattable, IEquatable[ElectricResistivity], IComparable, IComparable[ElectricResistivity], IConvertible):
    """ Electrical resistivity (also known as resistivity, specific electrical resistance, or volume resistivity) is a fundamental property that quantifies how strongly a given material opposes the flow of electric current.
     https://en.wikipedia.org/wiki/Electrical_resistivity_and_conductivity
    """

    Info: typing.ClassVar[QuantityInfo[ElectricResistivityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricResistivityUnit]

    MaxValue: typing.ClassVar[ElectricResistivity]

    MinValue: typing.ClassVar[ElectricResistivity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricResistivityUnit]]

    Zero: typing.ClassVar[ElectricResistivity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricResistivityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricResistivityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KiloohmsCentimeter(self) -> float:
        """ Get ElectricResistivity in KiloohmsCentimeter.
        """
        pass

    @property
    def KiloohmMeters(self) -> float:
        """ Get ElectricResistivity in KiloohmMeters.
        """
        pass

    @property
    def MegaohmsCentimeter(self) -> float:
        """ Get ElectricResistivity in MegaohmsCentimeter.
        """
        pass

    @property
    def MegaohmMeters(self) -> float:
        """ Get ElectricResistivity in MegaohmMeters.
        """
        pass

    @property
    def MicroohmsCentimeter(self) -> float:
        """ Get ElectricResistivity in MicroohmsCentimeter.
        """
        pass

    @property
    def MicroohmMeters(self) -> float:
        """ Get ElectricResistivity in MicroohmMeters.
        """
        pass

    @property
    def MilliohmsCentimeter(self) -> float:
        """ Get ElectricResistivity in MilliohmsCentimeter.
        """
        pass

    @property
    def MilliohmMeters(self) -> float:
        """ Get ElectricResistivity in MilliohmMeters.
        """
        pass

    @property
    def NanoohmsCentimeter(self) -> float:
        """ Get ElectricResistivity in NanoohmsCentimeter.
        """
        pass

    @property
    def NanoohmMeters(self) -> float:
        """ Get ElectricResistivity in NanoohmMeters.
        """
        pass

    @property
    def OhmsCentimeter(self) -> float:
        """ Get ElectricResistivity in OhmsCentimeter.
        """
        pass

    @property
    def OhmMeters(self) -> float:
        """ Get ElectricResistivity in OhmMeters.
        """
        pass

    @property
    def PicoohmsCentimeter(self) -> float:
        """ Get ElectricResistivity in PicoohmsCentimeter.
        """
        pass

    @property
    def PicoohmMeters(self) -> float:
        """ Get ElectricResistivity in PicoohmMeters.
        """
        pass

    def __init__(self, value: float, unit: ElectricResistivityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricResistivityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricResistivity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricResistivityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricResistivityUnit) -> ElectricResistivity:
        """ Converts this ElectricResistivity to another ElectricResistivity with the unit representation .

        :return: A ElectricResistivity with the specified unit.
        :rtype: ElectricResistivity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricResistivity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricResistivityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricResistivityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricResistivityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricResistivityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKiloohmsCentimeter(kiloohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from KiloohmsCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloohmMeters(kiloohmmeters: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from KiloohmMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaohmsCentimeter(megaohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from MegaohmsCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaohmMeters(megaohmmeters: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from MegaohmMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroohmsCentimeter(microohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from MicroohmsCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroohmMeters(microohmmeters: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from MicroohmMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliohmsCentimeter(milliohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from MilliohmsCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliohmMeters(milliohmmeters: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from MilliohmMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoohmsCentimeter(nanoohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from NanoohmsCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoohmMeters(nanoohmmeters: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from NanoohmMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOhmsCentimeter(ohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from OhmsCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOhmMeters(ohmmeters: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from OhmMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicoohmsCentimeter(picoohmscentimeter: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from PicoohmsCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicoohmMeters(picoohmmeters: QuantityValue) -> ElectricResistivity:
        """ Get ElectricResistivity from PicoohmMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricResistivityUnit) -> ElectricResistivity:
        """ Dynamically convert from value and unit enum "ElectricResistivityUnit" to "ElectricResistivity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricResistivityUnit
        :return: ElectricResistivity unit value.
        :rtype: ElectricResistivity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricResistivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricResistivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricResistivity) -> typing.Tuple[ElectricResistivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricResistivity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricResistivity) -> typing.Tuple[ElectricResistivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricResistivity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricResistivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricResistivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricResistivityUnit) -> typing.Tuple[ElectricResistivityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricResistivityUnit) -> typing.Tuple[ElectricResistivityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricResistivityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricResistivity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricResistivity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricResistivity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricResistivity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricResistivity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class ElectricSurfaceChargeDensity(ValueType, IQuantity[ElectricSurfaceChargeDensityUnit], IQuantity, IFormattable, IEquatable[ElectricSurfaceChargeDensity], IComparable, IComparable[ElectricSurfaceChargeDensity], IConvertible):
    """ In electromagnetism, surface charge density is a measure of the amount of electric charge per surface area.
     https://en.wikipedia.org/wiki/Charge_density
    """

    Info: typing.ClassVar[QuantityInfo[ElectricSurfaceChargeDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ElectricSurfaceChargeDensityUnit]

    MaxValue: typing.ClassVar[ElectricSurfaceChargeDensity]

    MinValue: typing.ClassVar[ElectricSurfaceChargeDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ElectricSurfaceChargeDensityUnit]]

    Zero: typing.ClassVar[ElectricSurfaceChargeDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ElectricSurfaceChargeDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ElectricSurfaceChargeDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CoulombsPerSquareCentimeter(self) -> float:
        """ Get ElectricSurfaceChargeDensity in CoulombsPerSquareCentimeter.
        """
        pass

    @property
    def CoulombsPerSquareInch(self) -> float:
        """ Get ElectricSurfaceChargeDensity in CoulombsPerSquareInch.
        """
        pass

    @property
    def CoulombsPerSquareMeter(self) -> float:
        """ Get ElectricSurfaceChargeDensity in CoulombsPerSquareMeter.
        """
        pass

    def __init__(self, value: float, unit: ElectricSurfaceChargeDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ElectricSurfaceChargeDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricSurfaceChargeDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricSurfaceChargeDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ElectricSurfaceChargeDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ElectricSurfaceChargeDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCoulombsPerSquareCentimeter(coulombspersquarecentimeter: QuantityValue) -> ElectricSurfaceChargeDensity:
        """ Get ElectricSurfaceChargeDensity from CoulombsPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCoulombsPerSquareInch(coulombspersquareinch: QuantityValue) -> ElectricSurfaceChargeDensity:
        """ Get ElectricSurfaceChargeDensity from CoulombsPerSquareInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCoulombsPerSquareMeter(coulombspersquaremeter: QuantityValue) -> ElectricSurfaceChargeDensity:
        """ Get ElectricSurfaceChargeDensity from CoulombsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ElectricSurfaceChargeDensityUnit) -> ElectricSurfaceChargeDensity:
        """ Dynamically convert from value and unit enum "ElectricSurfaceChargeDensityUnit" to "ElectricSurfaceChargeDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ElectricSurfaceChargeDensityUnit
        :return: ElectricSurfaceChargeDensity unit value.
        :rtype: ElectricSurfaceChargeDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ElectricSurfaceChargeDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ElectricSurfaceChargeDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ElectricSurfaceChargeDensity) -> typing.Tuple[ElectricSurfaceChargeDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricSurfaceChargeDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ElectricSurfaceChargeDensity) -> typing.Tuple[ElectricSurfaceChargeDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ElectricSurfaceChargeDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ElectricSurfaceChargeDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ElectricSurfaceChargeDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ElectricSurfaceChargeDensityUnit) -> typing.Tuple[ElectricSurfaceChargeDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ElectricSurfaceChargeDensityUnit) -> typing.Tuple[ElectricSurfaceChargeDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ElectricSurfaceChargeDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ElectricSurfaceChargeDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricSurfaceChargeDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ElectricSurfaceChargeDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ElectricSurfaceChargeDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ElectricSurfaceChargeDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ElectricSurfaceChargeDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ElectricSurfaceChargeDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ElectricSurfaceChargeDensityUnit) -> ElectricSurfaceChargeDensity:
        """ Converts this ElectricSurfaceChargeDensity to another ElectricSurfaceChargeDensity with the unit representation .

        :return: A ElectricSurfaceChargeDensity with the specified unit.
        :rtype: ElectricSurfaceChargeDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ElectricSurfaceChargeDensity:
        """
        """
        pass


# noinspection PyPep8Naming
class Energy(ValueType, IQuantity[EnergyUnit], IQuantity, IFormattable, IEquatable[Energy], IComparable, IComparable[Energy], IConvertible):
    """ The joule, symbol J, is a derived unit of energy, work, or amount of heat in the International System of Units. It is equal to the energy transferred (or work done) when applying a force of one newton through a distance of one metre (1 newton metre or N·m), or in passing an electric current of one ampere through a resistance of one ohm for one second. Many other units of energy are included. Please do not confuse this definition of the calorie with the one colloquially used by the food industry, the large calorie, which is equivalent to 1 kcal. Thermochemical definition of the calorie is used. For BTU, the IT definition is used.
    """

    Info: typing.ClassVar[QuantityInfo[EnergyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[EnergyUnit]

    MaxValue: typing.ClassVar[Energy]

    MinValue: typing.ClassVar[Energy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[EnergyUnit]]

    Zero: typing.ClassVar[Energy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> EnergyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[EnergyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BritishThermalUnits(self) -> float:
        """ Get Energy in BritishThermalUnits.
        """
        pass

    @property
    def Calories(self) -> float:
        """ Get Energy in Calories.
        """
        pass

    @property
    def DecathermsEc(self) -> float:
        """ Get Energy in DecathermsEc.
        """
        pass

    @property
    def DecathermsImperial(self) -> float:
        """ Get Energy in DecathermsImperial.
        """
        pass

    @property
    def DecathermsUs(self) -> float:
        """ Get Energy in DecathermsUs.
        """
        pass

    @property
    def ElectronVolts(self) -> float:
        """ Get Energy in ElectronVolts.
        """
        pass

    @property
    def Ergs(self) -> float:
        """ Get Energy in Ergs.
        """
        pass

    @property
    def FootPounds(self) -> float:
        """ Get Energy in FootPounds.
        """
        pass

    @property
    def GigabritishThermalUnits(self) -> float:
        """ Get Energy in GigabritishThermalUnits.
        """
        pass

    @property
    def GigaelectronVolts(self) -> float:
        """ Get Energy in GigaelectronVolts.
        """
        pass

    @property
    def Gigajoules(self) -> float:
        """ Get Energy in Gigajoules.
        """
        pass

    @property
    def GigawattDays(self) -> float:
        """ Get Energy in GigawattDays.
        """
        pass

    @property
    def GigawattHours(self) -> float:
        """ Get Energy in GigawattHours.
        """
        pass

    @property
    def HorsepowerHours(self) -> float:
        """ Get Energy in HorsepowerHours.
        """
        pass

    @property
    def Joules(self) -> float:
        """ Get Energy in Joules.
        """
        pass

    @property
    def KilobritishThermalUnits(self) -> float:
        """ Get Energy in KilobritishThermalUnits.
        """
        pass

    @property
    def Kilocalories(self) -> float:
        """ Get Energy in Kilocalories.
        """
        pass

    @property
    def KiloelectronVolts(self) -> float:
        """ Get Energy in KiloelectronVolts.
        """
        pass

    @property
    def Kilojoules(self) -> float:
        """ Get Energy in Kilojoules.
        """
        pass

    @property
    def KilowattDays(self) -> float:
        """ Get Energy in KilowattDays.
        """
        pass

    @property
    def KilowattHours(self) -> float:
        """ Get Energy in KilowattHours.
        """
        pass

    @property
    def MegabritishThermalUnits(self) -> float:
        """ Get Energy in MegabritishThermalUnits.
        """
        pass

    @property
    def Megacalories(self) -> float:
        """ Get Energy in Megacalories.
        """
        pass

    @property
    def MegaelectronVolts(self) -> float:
        """ Get Energy in MegaelectronVolts.
        """
        pass

    @property
    def Megajoules(self) -> float:
        """ Get Energy in Megajoules.
        """
        pass

    @property
    def MegawattDays(self) -> float:
        """ Get Energy in MegawattDays.
        """
        pass

    @property
    def MegawattHours(self) -> float:
        """ Get Energy in MegawattHours.
        """
        pass

    @property
    def Millijoules(self) -> float:
        """ Get Energy in Millijoules.
        """
        pass

    @property
    def TeraelectronVolts(self) -> float:
        """ Get Energy in TeraelectronVolts.
        """
        pass

    @property
    def TerawattDays(self) -> float:
        """ Get Energy in TerawattDays.
        """
        pass

    @property
    def TerawattHours(self) -> float:
        """ Get Energy in TerawattHours.
        """
        pass

    @property
    def ThermsEc(self) -> float:
        """ Get Energy in ThermsEc.
        """
        pass

    @property
    def ThermsImperial(self) -> float:
        """ Get Energy in ThermsImperial.
        """
        pass

    @property
    def ThermsUs(self) -> float:
        """ Get Energy in ThermsUs.
        """
        pass

    @property
    def WattDays(self) -> float:
        """ Get Energy in WattDays.
        """
        pass

    @property
    def WattHours(self) -> float:
        """ Get Energy in WattHours.
        """
        pass

    def __init__(self, value: float, unit: EnergyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: EnergyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    def FromMegacalories(megacalories: QuantityValue) -> Energy:
        """ Get Energy from Megacalories.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegaelectronVolts(megaelectronvolts: QuantityValue) -> Energy:
        """ Get Energy from MegaelectronVolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoules(megajoules: QuantityValue) -> Energy:
        """ Get Energy from Megajoules.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattDays(megawattdays: QuantityValue) -> Energy:
        """ Get Energy from MegawattDays.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattHours(megawatthours: QuantityValue) -> Energy:
        """ Get Energy from MegawattHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillijoules(millijoules: QuantityValue) -> Energy:
        """ Get Energy from Millijoules.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTeraelectronVolts(teraelectronvolts: QuantityValue) -> Energy:
        """ Get Energy from TeraelectronVolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattDays(terawattdays: QuantityValue) -> Energy:
        """ Get Energy from TerawattDays.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattHours(terawatthours: QuantityValue) -> Energy:
        """ Get Energy from TerawattHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromThermsEc(thermsec: QuantityValue) -> Energy:
        """ Get Energy from ThermsEc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromThermsImperial(thermsimperial: QuantityValue) -> Energy:
        """ Get Energy from ThermsImperial.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromThermsUs(thermsus: QuantityValue) -> Energy:
        """ Get Energy from ThermsUs.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattDays(wattdays: QuantityValue) -> Energy:
        """ Get Energy from WattDays.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattHours(watthours: QuantityValue) -> Energy:
        """ Get Energy from WattHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: EnergyUnit) -> Energy:
        """ Dynamically convert from value and unit enum "EnergyUnit" to "Energy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: EnergyUnit
        :return: Energy unit value.
        :rtype: Energy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Energy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Energy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Energy) -> typing.Tuple[Energy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Energy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Energy) -> typing.Tuple[Energy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Energy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> EnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> EnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: EnergyUnit) -> typing.Tuple[EnergyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: EnergyUnit) -> typing.Tuple[EnergyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: EnergyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Energy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Energy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Energy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Energy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Energy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Energy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: EnergyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: EnergyUnit) -> Energy:
        """ Converts this Energy to another Energy with the unit representation .

        :return: A Energy with the specified unit.
        :rtype: Energy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Energy:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: EnergyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: EnergyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: EnergyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: EnergyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBritishThermalUnits(britishthermalunits: QuantityValue) -> Energy:
        """ Get Energy from BritishThermalUnits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCalories(calories: QuantityValue) -> Energy:
        """ Get Energy from Calories.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecathermsEc(decathermsec: QuantityValue) -> Energy:
        """ Get Energy from DecathermsEc.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecathermsImperial(decathermsimperial: QuantityValue) -> Energy:
        """ Get Energy from DecathermsImperial.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecathermsUs(decathermsus: QuantityValue) -> Energy:
        """ Get Energy from DecathermsUs.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromElectronVolts(electronvolts: QuantityValue) -> Energy:
        """ Get Energy from ElectronVolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromErgs(ergs: QuantityValue) -> Energy:
        """ Get Energy from Ergs.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFootPounds(footpounds: QuantityValue) -> Energy:
        """ Get Energy from FootPounds.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigabritishThermalUnits(gigabritishthermalunits: QuantityValue) -> Energy:
        """ Get Energy from GigabritishThermalUnits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigaelectronVolts(gigaelectronvolts: QuantityValue) -> Energy:
        """ Get Energy from GigaelectronVolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigajoules(gigajoules: QuantityValue) -> Energy:
        """ Get Energy from Gigajoules.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattDays(gigawattdays: QuantityValue) -> Energy:
        """ Get Energy from GigawattDays.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattHours(gigawatthours: QuantityValue) -> Energy:
        """ Get Energy from GigawattHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHorsepowerHours(horsepowerhours: QuantityValue) -> Energy:
        """ Get Energy from HorsepowerHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoules(joules: QuantityValue) -> Energy:
        """ Get Energy from Joules.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobritishThermalUnits(kilobritishthermalunits: QuantityValue) -> Energy:
        """ Get Energy from KilobritishThermalUnits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocalories(kilocalories: QuantityValue) -> Energy:
        """ Get Energy from Kilocalories.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKiloelectronVolts(kiloelectronvolts: QuantityValue) -> Energy:
        """ Get Energy from KiloelectronVolts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoules(kilojoules: QuantityValue) -> Energy:
        """ Get Energy from Kilojoules.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattDays(kilowattdays: QuantityValue) -> Energy:
        """ Get Energy from KilowattDays.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattHours(kilowatthours: QuantityValue) -> Energy:
        """ Get Energy from KilowattHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabritishThermalUnits(megabritishthermalunits: QuantityValue) -> Energy:
        """ Get Energy from MegabritishThermalUnits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class Entropy(ValueType, IQuantity[EntropyUnit], IQuantity, IFormattable, IEquatable[Entropy], IComparable, IComparable[Entropy], IConvertible):
    """ Entropy is an important concept in the branch of science known as thermodynamics. The idea of "irreversibility" is central to the understanding of entropy. It is often said that entropy is an expression of the disorder, or randomness of a system, or of our lack of information about it. Entropy is an extensive property. It has the dimension of energy divided by temperature, which has a unit of joules per kelvin (J/K) in the International System of Units
    """

    Info: typing.ClassVar[QuantityInfo[EntropyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[EntropyUnit]

    MaxValue: typing.ClassVar[Entropy]

    MinValue: typing.ClassVar[Entropy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[EntropyUnit]]

    Zero: typing.ClassVar[Entropy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> EntropyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[EntropyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CaloriesPerKelvin(self) -> float:
        """ Get Entropy in CaloriesPerKelvin.
        """
        pass

    @property
    def JoulesPerDegreeCelsius(self) -> float:
        """ Get Entropy in JoulesPerDegreeCelsius.
        """
        pass

    @property
    def JoulesPerKelvin(self) -> float:
        """ Get Entropy in JoulesPerKelvin.
        """
        pass

    @property
    def KilocaloriesPerKelvin(self) -> float:
        """ Get Entropy in KilocaloriesPerKelvin.
        """
        pass

    @property
    def KilojoulesPerDegreeCelsius(self) -> float:
        """ Get Entropy in KilojoulesPerDegreeCelsius.
        """
        pass

    @property
    def KilojoulesPerKelvin(self) -> float:
        """ Get Entropy in KilojoulesPerKelvin.
        """
        pass

    @property
    def MegajoulesPerKelvin(self) -> float:
        """ Get Entropy in MegajoulesPerKelvin.
        """
        pass

    def __init__(self, value: float, unit: EntropyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: EntropyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: EntropyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: EntropyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: EntropyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: EntropyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCaloriesPerKelvin(caloriesperkelvin: QuantityValue) -> Entropy:
        """ Get Entropy from CaloriesPerKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerDegreeCelsius(joulesperdegreecelsius: QuantityValue) -> Entropy:
        """ Get Entropy from JoulesPerDegreeCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerKelvin(joulesperkelvin: QuantityValue) -> Entropy:
        """ Get Entropy from JoulesPerKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerKelvin(kilocaloriesperkelvin: QuantityValue) -> Entropy:
        """ Get Entropy from KilocaloriesPerKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerDegreeCelsius(kilojoulesperdegreecelsius: QuantityValue) -> Entropy:
        """ Get Entropy from KilojoulesPerDegreeCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerKelvin(kilojoulesperkelvin: QuantityValue) -> Entropy:
        """ Get Entropy from KilojoulesPerKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerKelvin(megajoulesperkelvin: QuantityValue) -> Entropy:
        """ Get Entropy from MegajoulesPerKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: EntropyUnit) -> Entropy:
        """ Dynamically convert from value and unit enum "EntropyUnit" to "Entropy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: EntropyUnit
        :return: Entropy unit value.
        :rtype: Entropy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Entropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Entropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Entropy) -> typing.Tuple[Entropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Entropy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Entropy) -> typing.Tuple[Entropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Entropy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> EntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> EntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: EntropyUnit) -> typing.Tuple[EntropyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: EntropyUnit) -> typing.Tuple[EntropyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: EntropyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Entropy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Entropy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Entropy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Entropy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Entropy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Entropy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: EntropyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: EntropyUnit) -> Entropy:
        """ Converts this Entropy to another Entropy with the unit representation .

        :return: A Entropy with the specified unit.
        :rtype: Entropy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Entropy:
        """
        """
        pass


# noinspection PyPep8Naming
class ForceChangeRate(ValueType, IQuantity[ForceChangeRateUnit], IQuantity, IFormattable, IEquatable[ForceChangeRate], IComparable, IComparable[ForceChangeRate], IConvertible):
    """ Force change rate is the ratio of the force change to the time during which the change occurred (value of force changes per unit time).
    """

    Info: typing.ClassVar[QuantityInfo[ForceChangeRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ForceChangeRateUnit]

    MaxValue: typing.ClassVar[ForceChangeRate]

    MinValue: typing.ClassVar[ForceChangeRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ForceChangeRateUnit]]

    Zero: typing.ClassVar[ForceChangeRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ForceChangeRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ForceChangeRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentinewtonsPerSecond(self) -> float:
        """ Get ForceChangeRate in CentinewtonsPerSecond.
        """
        pass

    @property
    def DecanewtonsPerMinute(self) -> float:
        """ Get ForceChangeRate in DecanewtonsPerMinute.
        """
        pass

    @property
    def DecanewtonsPerSecond(self) -> float:
        """ Get ForceChangeRate in DecanewtonsPerSecond.
        """
        pass

    @property
    def DecinewtonsPerSecond(self) -> float:
        """ Get ForceChangeRate in DecinewtonsPerSecond.
        """
        pass

    @property
    def KilonewtonsPerMinute(self) -> float:
        """ Get ForceChangeRate in KilonewtonsPerMinute.
        """
        pass

    @property
    def KilonewtonsPerSecond(self) -> float:
        """ Get ForceChangeRate in KilonewtonsPerSecond.
        """
        pass

    @property
    def KilopoundsForcePerMinute(self) -> float:
        """ Get ForceChangeRate in KilopoundsForcePerMinute.
        """
        pass

    @property
    def KilopoundsForcePerSecond(self) -> float:
        """ Get ForceChangeRate in KilopoundsForcePerSecond.
        """
        pass

    @property
    def MicronewtonsPerSecond(self) -> float:
        """ Get ForceChangeRate in MicronewtonsPerSecond.
        """
        pass

    @property
    def MillinewtonsPerSecond(self) -> float:
        """ Get ForceChangeRate in MillinewtonsPerSecond.
        """
        pass

    @property
    def NanonewtonsPerSecond(self) -> float:
        """ Get ForceChangeRate in NanonewtonsPerSecond.
        """
        pass

    @property
    def NewtonsPerMinute(self) -> float:
        """ Get ForceChangeRate in NewtonsPerMinute.
        """
        pass

    @property
    def NewtonsPerSecond(self) -> float:
        """ Get ForceChangeRate in NewtonsPerSecond.
        """
        pass

    @property
    def PoundsForcePerMinute(self) -> float:
        """ Get ForceChangeRate in PoundsForcePerMinute.
        """
        pass

    @property
    def PoundsForcePerSecond(self) -> float:
        """ Get ForceChangeRate in PoundsForcePerSecond.
        """
        pass

    def __init__(self, value: float, unit: ForceChangeRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ForceChangeRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def Equals(self, other: ForceChangeRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ForceChangeRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ForceChangeRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ForceChangeRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ForceChangeRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ForceChangeRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ForceChangeRateUnit) -> ForceChangeRate:
        """ Converts this ForceChangeRate to another ForceChangeRate with the unit representation .

        :return: A ForceChangeRate with the specified unit.
        :rtype: ForceChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ForceChangeRate:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForceChangeRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForceChangeRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ForceChangeRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ForceChangeRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentinewtonsPerSecond(centinewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from CentinewtonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonsPerMinute(decanewtonsperminute: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from DecanewtonsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecanewtonsPerSecond(decanewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from DecanewtonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecinewtonsPerSecond(decinewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from DecinewtonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerMinute(kilonewtonsperminute: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from KilonewtonsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonsPerSecond(kilonewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from KilonewtonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerMinute(kilopoundsforceperminute: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from KilopoundsForcePerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSecond(kilopoundsforcepersecond: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from KilopoundsForcePerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicronewtonsPerSecond(micronewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from MicronewtonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillinewtonsPerSecond(millinewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from MillinewtonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanonewtonsPerSecond(nanonewtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from NanonewtonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerMinute(newtonsperminute: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from NewtonsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonsPerSecond(newtonspersecond: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from NewtonsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerMinute(poundsforceperminute: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from PoundsForcePerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSecond(poundsforcepersecond: QuantityValue) -> ForceChangeRate:
        """ Get ForceChangeRate from PoundsForcePerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ForceChangeRateUnit) -> ForceChangeRate:
        """ Dynamically convert from value and unit enum "ForceChangeRateUnit" to "ForceChangeRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ForceChangeRateUnit
        :return: ForceChangeRate unit value.
        :rtype: ForceChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ForceChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ForceChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ForceChangeRate) -> typing.Tuple[ForceChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ForceChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ForceChangeRate) -> typing.Tuple[ForceChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ForceChangeRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ForceChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ForceChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ForceChangeRateUnit) -> typing.Tuple[ForceChangeRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ForceChangeRateUnit) -> typing.Tuple[ForceChangeRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ForceChangeRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ForceChangeRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass


# noinspection PyPep8Naming
class Frequency(ValueType, IQuantity[FrequencyUnit], IQuantity, IFormattable, IEquatable[Frequency], IComparable, IComparable[Frequency], IConvertible):
    """ The number of occurrences of a repeating event per unit time.
    """

    Info: typing.ClassVar[QuantityInfo[FrequencyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[FrequencyUnit]

    MaxValue: typing.ClassVar[Frequency]

    MinValue: typing.ClassVar[Frequency]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[FrequencyUnit]]

    Zero: typing.ClassVar[Frequency]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> FrequencyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[FrequencyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BeatsPerMinute(self) -> float:
        """ Get Frequency in BeatsPerMinute.
        """
        pass

    @property
    def BUnits(self) -> float:
        """ Get Frequency in BUnits.
        """
        pass

    @property
    def CyclesPerHour(self) -> float:
        """ Get Frequency in CyclesPerHour.
        """
        pass

    @property
    def CyclesPerMinute(self) -> float:
        """ Get Frequency in CyclesPerMinute.
        """
        pass

    @property
    def Gigahertz(self) -> float:
        """ Get Frequency in Gigahertz.
        """
        pass

    @property
    def Hertz(self) -> float:
        """ Get Frequency in Hertz.
        """
        pass

    @property
    def Kilohertz(self) -> float:
        """ Get Frequency in Kilohertz.
        """
        pass

    @property
    def Megahertz(self) -> float:
        """ Get Frequency in Megahertz.
        """
        pass

    @property
    def PerSecond(self) -> float:
        """ Get Frequency in PerSecond.
        """
        pass

    @property
    def RadiansPerSecond(self) -> float:
        """ Get Frequency in RadiansPerSecond.
        """
        pass

    @property
    def Terahertz(self) -> float:
        """ Get Frequency in Terahertz.
        """
        pass

    def __init__(self, value: float, unit: FrequencyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: FrequencyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: FrequencyUnit) -> Frequency:
        """ Converts this Frequency to another Frequency with the unit representation .

        :return: A Frequency with the specified unit.
        :rtype: Frequency
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Frequency:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: FrequencyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: FrequencyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: FrequencyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: FrequencyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBeatsPerMinute(beatsperminute: QuantityValue) -> Frequency:
        """ Get Frequency from BeatsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBUnits(bunits: QuantityValue) -> Frequency:
        """ Get Frequency from BUnits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCyclesPerHour(cyclesperhour: QuantityValue) -> Frequency:
        """ Get Frequency from CyclesPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCyclesPerMinute(cyclesperminute: QuantityValue) -> Frequency:
        """ Get Frequency from CyclesPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigahertz(gigahertz: QuantityValue) -> Frequency:
        """ Get Frequency from Gigahertz.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHertz(hertz: QuantityValue) -> Frequency:
        """ Get Frequency from Hertz.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilohertz(kilohertz: QuantityValue) -> Frequency:
        """ Get Frequency from Kilohertz.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegahertz(megahertz: QuantityValue) -> Frequency:
        """ Get Frequency from Megahertz.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPerSecond(persecond: QuantityValue) -> Frequency:
        """ Get Frequency from PerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRadiansPerSecond(radianspersecond: QuantityValue) -> Frequency:
        """ Get Frequency from RadiansPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerahertz(terahertz: QuantityValue) -> Frequency:
        """ Get Frequency from Terahertz.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: FrequencyUnit) -> Frequency:
        """ Dynamically convert from value and unit enum "FrequencyUnit" to "Frequency".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: FrequencyUnit
        :return: Frequency unit value.
        :rtype: Frequency
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Frequency:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Frequency:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Frequency) -> typing.Tuple[Frequency, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Frequency
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Frequency) -> typing.Tuple[Frequency, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Frequency
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> FrequencyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> FrequencyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: FrequencyUnit) -> typing.Tuple[FrequencyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: FrequencyUnit) -> typing.Tuple[FrequencyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: FrequencyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Frequency) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Frequency) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Frequency, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Frequency within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Frequency
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Frequency.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: FrequencyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass


# noinspection PyPep8Naming
class FuelEfficiency(ValueType, IQuantity[FuelEfficiencyUnit], IQuantity, IFormattable, IEquatable[FuelEfficiency], IComparable, IComparable[FuelEfficiency], IConvertible):
    """ Fuel efficiency is a form of thermal efficiency, meaning the ratio from effort to result of a process that converts chemical potential energy contained in a carrier (fuel) into kinetic energy or work. Fuel economy is stated as "fuel consumption" in liters per 100 kilometers (L/100 km). In countries using non-metric system, fuel economy is expressed in miles per gallon (mpg) (imperial galon or US galon).
     https://en.wikipedia.org/wiki/Fuel_efficiency
    """

    Info: typing.ClassVar[QuantityInfo[FuelEfficiencyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[FuelEfficiencyUnit]

    MaxValue: typing.ClassVar[FuelEfficiency]

    MinValue: typing.ClassVar[FuelEfficiency]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[FuelEfficiencyUnit]]

    Zero: typing.ClassVar[FuelEfficiency]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> FuelEfficiencyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[FuelEfficiencyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilometersPerLiters(self) -> float:
        """ Get FuelEfficiency in KilometersPerLiters.
        """
        pass

    @property
    def LitersPer100Kilometers(self) -> float:
        """ Get FuelEfficiency in LitersPer100Kilometers.
        """
        pass

    @property
    def MilesPerUkGallon(self) -> float:
        """ Get FuelEfficiency in MilesPerUkGallon.
        """
        pass

    @property
    def MilesPerUsGallon(self) -> float:
        """ Get FuelEfficiency in MilesPerUsGallon.
        """
        pass

    def __init__(self, value: float, unit: FuelEfficiencyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: FuelEfficiencyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: FuelEfficiencyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: FuelEfficiencyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: FuelEfficiencyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: FuelEfficiencyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilometersPerLiters(kilometersperliters: QuantityValue) -> FuelEfficiency:
        """ Get FuelEfficiency from KilometersPerLiters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPer100Kilometers(litersper100kilometers: QuantityValue) -> FuelEfficiency:
        """ Get FuelEfficiency from LitersPer100Kilometers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilesPerUkGallon(milesperukgallon: QuantityValue) -> FuelEfficiency:
        """ Get FuelEfficiency from MilesPerUkGallon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilesPerUsGallon(milesperusgallon: QuantityValue) -> FuelEfficiency:
        """ Get FuelEfficiency from MilesPerUsGallon.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: FuelEfficiencyUnit) -> FuelEfficiency:
        """ Dynamically convert from value and unit enum "FuelEfficiencyUnit" to "FuelEfficiency".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: FuelEfficiencyUnit
        :return: FuelEfficiency unit value.
        :rtype: FuelEfficiency
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> FuelEfficiency:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> FuelEfficiency:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: FuelEfficiency) -> typing.Tuple[FuelEfficiency, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: FuelEfficiency
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: FuelEfficiency) -> typing.Tuple[FuelEfficiency, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: FuelEfficiency
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> FuelEfficiencyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> FuelEfficiencyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: FuelEfficiencyUnit) -> typing.Tuple[FuelEfficiencyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: FuelEfficiencyUnit) -> typing.Tuple[FuelEfficiencyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: FuelEfficiencyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: FuelEfficiency) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: FuelEfficiency) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: FuelEfficiency, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another FuelEfficiency within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: FuelEfficiency
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current FuelEfficiency.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: FuelEfficiencyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: FuelEfficiencyUnit) -> FuelEfficiency:
        """ Converts this FuelEfficiency to another FuelEfficiency with the unit representation .

        :return: A FuelEfficiency with the specified unit.
        :rtype: FuelEfficiency
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> FuelEfficiency:
        """
        """
        pass


# noinspection PyPep8Naming
class HeatTransferCoefficient(ValueType, IQuantity[HeatTransferCoefficientUnit], IQuantity, IFormattable, IEquatable[HeatTransferCoefficient], IComparable, IComparable[HeatTransferCoefficient], IConvertible):
    """ The heat transfer coefficient or film coefficient, or film effectiveness, in thermodynamics and in mechanics is the proportionality constant between the heat flux and the thermodynamic driving force for the flow of heat (i.e., the temperature difference, ΔT)
    """

    Info: typing.ClassVar[QuantityInfo[HeatTransferCoefficientUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[HeatTransferCoefficientUnit]

    MaxValue: typing.ClassVar[HeatTransferCoefficient]

    MinValue: typing.ClassVar[HeatTransferCoefficient]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[HeatTransferCoefficientUnit]]

    Zero: typing.ClassVar[HeatTransferCoefficient]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> HeatTransferCoefficientUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[HeatTransferCoefficientUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtusPerSquareFootDegreeFahrenheit(self) -> float:
        """ Get HeatTransferCoefficient in BtusPerSquareFootDegreeFahrenheit.
        """
        pass

    @property
    def WattsPerSquareMeterCelsius(self) -> float:
        """ Get HeatTransferCoefficient in WattsPerSquareMeterCelsius.
        """
        pass

    @property
    def WattsPerSquareMeterKelvin(self) -> float:
        """ Get HeatTransferCoefficient in WattsPerSquareMeterKelvin.
        """
        pass

    def __init__(self, value: float, unit: HeatTransferCoefficientUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: HeatTransferCoefficientUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: HeatTransferCoefficientUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: HeatTransferCoefficientUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: HeatTransferCoefficientUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: HeatTransferCoefficientUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtusPerSquareFootDegreeFahrenheit(btuspersquarefootdegreefahrenheit: QuantityValue) -> HeatTransferCoefficient:
        """ Get HeatTransferCoefficient from BtusPerSquareFootDegreeFahrenheit.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareMeterCelsius(wattspersquaremetercelsius: QuantityValue) -> HeatTransferCoefficient:
        """ Get HeatTransferCoefficient from WattsPerSquareMeterCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareMeterKelvin(wattspersquaremeterkelvin: QuantityValue) -> HeatTransferCoefficient:
        """ Get HeatTransferCoefficient from WattsPerSquareMeterKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: HeatTransferCoefficientUnit) -> HeatTransferCoefficient:
        """ Dynamically convert from value and unit enum "HeatTransferCoefficientUnit" to "HeatTransferCoefficient".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: HeatTransferCoefficientUnit
        :return: HeatTransferCoefficient unit value.
        :rtype: HeatTransferCoefficient
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> HeatTransferCoefficient:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> HeatTransferCoefficient:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: HeatTransferCoefficient) -> typing.Tuple[HeatTransferCoefficient, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: HeatTransferCoefficient
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: HeatTransferCoefficient) -> typing.Tuple[HeatTransferCoefficient, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: HeatTransferCoefficient
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> HeatTransferCoefficientUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> HeatTransferCoefficientUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: HeatTransferCoefficientUnit) -> typing.Tuple[HeatTransferCoefficientUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: HeatTransferCoefficientUnit) -> typing.Tuple[HeatTransferCoefficientUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: HeatTransferCoefficientUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: HeatTransferCoefficient) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: HeatTransferCoefficient) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: HeatTransferCoefficient, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another HeatTransferCoefficient within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: HeatTransferCoefficient
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current HeatTransferCoefficient.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: HeatTransferCoefficientUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: HeatTransferCoefficientUnit) -> HeatTransferCoefficient:
        """ Converts this HeatTransferCoefficient to another HeatTransferCoefficient with the unit representation .

        :return: A HeatTransferCoefficient with the specified unit.
        :rtype: HeatTransferCoefficient
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> HeatTransferCoefficient:
        """
        """
        pass


# noinspection PyPep8Naming
class Illuminance(ValueType, IQuantity[IlluminanceUnit], IQuantity, IFormattable, IEquatable[Illuminance], IComparable, IComparable[Illuminance], IConvertible):
    """ In photometry, illuminance is the total luminous flux incident on a surface, per unit area.
     https://en.wikipedia.org/wiki/Illuminance
    """

    Info: typing.ClassVar[QuantityInfo[IlluminanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[IlluminanceUnit]

    MaxValue: typing.ClassVar[Illuminance]

    MinValue: typing.ClassVar[Illuminance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[IlluminanceUnit]]

    Zero: typing.ClassVar[Illuminance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> IlluminanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[IlluminanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Kilolux(self) -> float:
        """ Get Illuminance in Kilolux.
        """
        pass

    @property
    def Lux(self) -> float:
        """ Get Illuminance in Lux.
        """
        pass

    @property
    def Megalux(self) -> float:
        """ Get Illuminance in Megalux.
        """
        pass

    @property
    def Millilux(self) -> float:
        """ Get Illuminance in Millilux.
        """
        pass

    def __init__(self, value: float, unit: IlluminanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: IlluminanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IlluminanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IlluminanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IlluminanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IlluminanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilolux(kilolux: QuantityValue) -> Illuminance:
        """ Get Illuminance from Kilolux.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLux(lux: QuantityValue) -> Illuminance:
        """ Get Illuminance from Lux.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegalux(megalux: QuantityValue) -> Illuminance:
        """ Get Illuminance from Megalux.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillilux(millilux: QuantityValue) -> Illuminance:
        """ Get Illuminance from Millilux.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: IlluminanceUnit) -> Illuminance:
        """ Dynamically convert from value and unit enum "IlluminanceUnit" to "Illuminance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: IlluminanceUnit
        :return: Illuminance unit value.
        :rtype: Illuminance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Illuminance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Illuminance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Illuminance) -> typing.Tuple[Illuminance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Illuminance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Illuminance) -> typing.Tuple[Illuminance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Illuminance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> IlluminanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> IlluminanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: IlluminanceUnit) -> typing.Tuple[IlluminanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: IlluminanceUnit) -> typing.Tuple[IlluminanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: IlluminanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Illuminance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Illuminance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Illuminance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Illuminance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Illuminance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Illuminance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: IlluminanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: IlluminanceUnit) -> Illuminance:
        """ Converts this Illuminance to another Illuminance with the unit representation .

        :return: A Illuminance with the specified unit.
        :rtype: Illuminance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Illuminance:
        """
        """
        pass


# noinspection PyPep8Naming
class Information(ValueType, IQuantity[InformationUnit], IQuantity, IFormattable, IDecimalQuantity, IEquatable[Information], IComparable, IComparable[Information], IConvertible):
    """ In computing and telecommunications, a unit of information is the capacity of some standard data storage system or communication channel, used to measure the capacities of other systems and channels. In information theory, units of information are also used to measure the information contents or entropy of random variables.
    """

    Info: typing.ClassVar[QuantityInfo[InformationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[InformationUnit]

    MaxValue: typing.ClassVar[Information]

    MinValue: typing.ClassVar[Information]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[InformationUnit]]

    Zero: typing.ClassVar[Information]

    @property
    def Value(self) -> Decimal:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> InformationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[InformationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Bits(self) -> float:
        """ Get Information in Bits.
        """
        pass

    @property
    def Bytes(self) -> float:
        """ Get Information in Bytes.
        """
        pass

    @property
    def Exabits(self) -> float:
        """ Get Information in Exabits.
        """
        pass

    @property
    def Exabytes(self) -> float:
        """ Get Information in Exabytes.
        """
        pass

    @property
    def Exbibits(self) -> float:
        """ Get Information in Exbibits.
        """
        pass

    @property
    def Exbibytes(self) -> float:
        """ Get Information in Exbibytes.
        """
        pass

    @property
    def Gibibits(self) -> float:
        """ Get Information in Gibibits.
        """
        pass

    @property
    def Gibibytes(self) -> float:
        """ Get Information in Gibibytes.
        """
        pass

    @property
    def Gigabits(self) -> float:
        """ Get Information in Gigabits.
        """
        pass

    @property
    def Gigabytes(self) -> float:
        """ Get Information in Gigabytes.
        """
        pass

    @property
    def Kibibits(self) -> float:
        """ Get Information in Kibibits.
        """
        pass

    @property
    def Kibibytes(self) -> float:
        """ Get Information in Kibibytes.
        """
        pass

    @property
    def Kilobits(self) -> float:
        """ Get Information in Kilobits.
        """
        pass

    @property
    def Kilobytes(self) -> float:
        """ Get Information in Kilobytes.
        """
        pass

    @property
    def Mebibits(self) -> float:
        """ Get Information in Mebibits.
        """
        pass

    @property
    def Mebibytes(self) -> float:
        """ Get Information in Mebibytes.
        """
        pass

    @property
    def Megabits(self) -> float:
        """ Get Information in Megabits.
        """
        pass

    @property
    def Megabytes(self) -> float:
        """ Get Information in Megabytes.
        """
        pass

    @property
    def Pebibits(self) -> float:
        """ Get Information in Pebibits.
        """
        pass

    @property
    def Pebibytes(self) -> float:
        """ Get Information in Pebibytes.
        """
        pass

    @property
    def Petabits(self) -> float:
        """ Get Information in Petabits.
        """
        pass

    @property
    def Petabytes(self) -> float:
        """ Get Information in Petabytes.
        """
        pass

    @property
    def Tebibits(self) -> float:
        """ Get Information in Tebibits.
        """
        pass

    @property
    def Tebibytes(self) -> float:
        """ Get Information in Tebibytes.
        """
        pass

    @property
    def Terabits(self) -> float:
        """ Get Information in Terabits.
        """
        pass

    @property
    def Terabytes(self) -> float:
        """ Get Information in Terabytes.
        """
        pass

    def __init__(self, value: Decimal, unit: InformationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unit: The unit representation to construct this quantity with.
        :type unit: InformationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: Decimal, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: Decimal
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Information:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Information:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Information) -> typing.Tuple[Information, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Information
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Information) -> typing.Tuple[Information, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Information
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> InformationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> InformationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: InformationUnit) -> typing.Tuple[InformationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: InformationUnit) -> typing.Tuple[InformationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: InformationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Information) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Information) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Information, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Information within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Information
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Information.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: InformationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: InformationUnit) -> Information:
        """ Converts this Information to another Information with the unit representation .

        :return: A Information with the specified unit.
        :rtype: Information
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Information:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: InformationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: InformationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: InformationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: InformationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBits(bits: QuantityValue) -> Information:
        """ Get Information from Bits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromBytes(bytes: QuantityValue) -> Information:
        """ Get Information from Bytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExabits(exabits: QuantityValue) -> Information:
        """ Get Information from Exabits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExabytes(exabytes: QuantityValue) -> Information:
        """ Get Information from Exabytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExbibits(exbibits: QuantityValue) -> Information:
        """ Get Information from Exbibits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromExbibytes(exbibytes: QuantityValue) -> Information:
        """ Get Information from Exbibytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGibibits(gibibits: QuantityValue) -> Information:
        """ Get Information from Gibibits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGibibytes(gibibytes: QuantityValue) -> Information:
        """ Get Information from Gibibytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigabits(gigabits: QuantityValue) -> Information:
        """ Get Information from Gigabits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigabytes(gigabytes: QuantityValue) -> Information:
        """ Get Information from Gigabytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKibibits(kibibits: QuantityValue) -> Information:
        """ Get Information from Kibibits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKibibytes(kibibytes: QuantityValue) -> Information:
        """ Get Information from Kibibytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobits(kilobits: QuantityValue) -> Information:
        """ Get Information from Kilobits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilobytes(kilobytes: QuantityValue) -> Information:
        """ Get Information from Kilobytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMebibits(mebibits: QuantityValue) -> Information:
        """ Get Information from Mebibits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMebibytes(mebibytes: QuantityValue) -> Information:
        """ Get Information from Mebibytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabits(megabits: QuantityValue) -> Information:
        """ Get Information from Megabits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegabytes(megabytes: QuantityValue) -> Information:
        """ Get Information from Megabytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPebibits(pebibits: QuantityValue) -> Information:
        """ Get Information from Pebibits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPebibytes(pebibytes: QuantityValue) -> Information:
        """ Get Information from Pebibytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetabits(petabits: QuantityValue) -> Information:
        """ Get Information from Petabits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetabytes(petabytes: QuantityValue) -> Information:
        """ Get Information from Petabytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTebibits(tebibits: QuantityValue) -> Information:
        """ Get Information from Tebibits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTebibytes(tebibytes: QuantityValue) -> Information:
        """ Get Information from Tebibytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerabits(terabits: QuantityValue) -> Information:
        """ Get Information from Terabits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerabytes(terabytes: QuantityValue) -> Information:
        """ Get Information from Terabytes.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: InformationUnit) -> Information:
        """ Dynamically convert from value and unit enum "InformationUnit" to "Information".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: InformationUnit
        :return: Information unit value.
        :rtype: Information
        """
        pass


# noinspection PyPep8Naming
class Irradiance(ValueType, IQuantity[IrradianceUnit], IQuantity, IFormattable, IEquatable[Irradiance], IComparable, IComparable[Irradiance], IConvertible):
    """ Irradiance is the intensity of ultraviolet (UV) or visible light incident on a surface.
    """

    Info: typing.ClassVar[QuantityInfo[IrradianceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[IrradianceUnit]

    MaxValue: typing.ClassVar[Irradiance]

    MinValue: typing.ClassVar[Irradiance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[IrradianceUnit]]

    Zero: typing.ClassVar[Irradiance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> IrradianceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[IrradianceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilowattsPerSquareCentimeter(self) -> float:
        """ Get Irradiance in KilowattsPerSquareCentimeter.
        """
        pass

    @property
    def KilowattsPerSquareMeter(self) -> float:
        """ Get Irradiance in KilowattsPerSquareMeter.
        """
        pass

    @property
    def MegawattsPerSquareCentimeter(self) -> float:
        """ Get Irradiance in MegawattsPerSquareCentimeter.
        """
        pass

    @property
    def MegawattsPerSquareMeter(self) -> float:
        """ Get Irradiance in MegawattsPerSquareMeter.
        """
        pass

    @property
    def MicrowattsPerSquareCentimeter(self) -> float:
        """ Get Irradiance in MicrowattsPerSquareCentimeter.
        """
        pass

    @property
    def MicrowattsPerSquareMeter(self) -> float:
        """ Get Irradiance in MicrowattsPerSquareMeter.
        """
        pass

    @property
    def MilliwattsPerSquareCentimeter(self) -> float:
        """ Get Irradiance in MilliwattsPerSquareCentimeter.
        """
        pass

    @property
    def MilliwattsPerSquareMeter(self) -> float:
        """ Get Irradiance in MilliwattsPerSquareMeter.
        """
        pass

    @property
    def NanowattsPerSquareCentimeter(self) -> float:
        """ Get Irradiance in NanowattsPerSquareCentimeter.
        """
        pass

    @property
    def NanowattsPerSquareMeter(self) -> float:
        """ Get Irradiance in NanowattsPerSquareMeter.
        """
        pass

    @property
    def PicowattsPerSquareCentimeter(self) -> float:
        """ Get Irradiance in PicowattsPerSquareCentimeter.
        """
        pass

    @property
    def PicowattsPerSquareMeter(self) -> float:
        """ Get Irradiance in PicowattsPerSquareMeter.
        """
        pass

    @property
    def WattsPerSquareCentimeter(self) -> float:
        """ Get Irradiance in WattsPerSquareCentimeter.
        """
        pass

    @property
    def WattsPerSquareMeter(self) -> float:
        """ Get Irradiance in WattsPerSquareMeter.
        """
        pass

    def __init__(self, value: float, unit: IrradianceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: IrradianceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Irradiance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: IrradianceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: IrradianceUnit) -> Irradiance:
        """ Converts this Irradiance to another Irradiance with the unit representation .

        :return: A Irradiance with the specified unit.
        :rtype: Irradiance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Irradiance:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IrradianceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IrradianceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IrradianceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IrradianceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilowattsPerSquareCentimeter(kilowattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from KilowattsPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerSquareMeter(kilowattspersquaremeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from KilowattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerSquareCentimeter(megawattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from MegawattsPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerSquareMeter(megawattspersquaremeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from MegawattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerSquareCentimeter(microwattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from MicrowattsPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerSquareMeter(microwattspersquaremeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from MicrowattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerSquareCentimeter(milliwattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from MilliwattsPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerSquareMeter(milliwattspersquaremeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from MilliwattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerSquareCentimeter(nanowattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from NanowattsPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerSquareMeter(nanowattspersquaremeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from NanowattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerSquareCentimeter(picowattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from PicowattsPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerSquareMeter(picowattspersquaremeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from PicowattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareCentimeter(wattspersquarecentimeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from WattsPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerSquareMeter(wattspersquaremeter: QuantityValue) -> Irradiance:
        """ Get Irradiance from WattsPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: IrradianceUnit) -> Irradiance:
        """ Dynamically convert from value and unit enum "IrradianceUnit" to "Irradiance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: IrradianceUnit
        :return: Irradiance unit value.
        :rtype: Irradiance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Irradiance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Irradiance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Irradiance) -> typing.Tuple[Irradiance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Irradiance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Irradiance) -> typing.Tuple[Irradiance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Irradiance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> IrradianceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> IrradianceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: IrradianceUnit) -> typing.Tuple[IrradianceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: IrradianceUnit) -> typing.Tuple[IrradianceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: IrradianceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Irradiance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Irradiance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Irradiance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Irradiance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Irradiance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class Irradiation(ValueType, IQuantity[IrradiationUnit], IQuantity, IFormattable, IEquatable[Irradiation], IComparable, IComparable[Irradiation], IConvertible):
    """ Irradiation is the process by which an object is exposed to radiation. The exposure can originate from various sources, including natural sources.
     https://en.wikipedia.org/wiki/Irradiation
    """

    Info: typing.ClassVar[QuantityInfo[IrradiationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[IrradiationUnit]

    MaxValue: typing.ClassVar[Irradiation]

    MinValue: typing.ClassVar[Irradiation]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[IrradiationUnit]]

    Zero: typing.ClassVar[Irradiation]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> IrradiationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[IrradiationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def JoulesPerSquareCentimeter(self) -> float:
        """ Get Irradiation in JoulesPerSquareCentimeter.
        """
        pass

    @property
    def JoulesPerSquareMeter(self) -> float:
        """ Get Irradiation in JoulesPerSquareMeter.
        """
        pass

    @property
    def JoulesPerSquareMillimeter(self) -> float:
        """ Get Irradiation in JoulesPerSquareMillimeter.
        """
        pass

    @property
    def KilojoulesPerSquareMeter(self) -> float:
        """ Get Irradiation in KilojoulesPerSquareMeter.
        """
        pass

    @property
    def KilowattHoursPerSquareMeter(self) -> float:
        """ Get Irradiation in KilowattHoursPerSquareMeter.
        """
        pass

    @property
    def MillijoulesPerSquareCentimeter(self) -> float:
        """ Get Irradiation in MillijoulesPerSquareCentimeter.
        """
        pass

    @property
    def WattHoursPerSquareMeter(self) -> float:
        """ Get Irradiation in WattHoursPerSquareMeter.
        """
        pass

    def __init__(self, value: float, unit: IrradiationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: IrradiationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IrradiationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IrradiationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: IrradiationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: IrradiationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromJoulesPerSquareCentimeter(joulespersquarecentimeter: QuantityValue) -> Irradiation:
        """ Get Irradiation from JoulesPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerSquareMeter(joulespersquaremeter: QuantityValue) -> Irradiation:
        """ Get Irradiation from JoulesPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerSquareMillimeter(joulespersquaremillimeter: QuantityValue) -> Irradiation:
        """ Get Irradiation from JoulesPerSquareMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerSquareMeter(kilojoulespersquaremeter: QuantityValue) -> Irradiation:
        """ Get Irradiation from KilojoulesPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattHoursPerSquareMeter(kilowatthourspersquaremeter: QuantityValue) -> Irradiation:
        """ Get Irradiation from KilowattHoursPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillijoulesPerSquareCentimeter(millijoulespersquarecentimeter: QuantityValue) -> Irradiation:
        """ Get Irradiation from MillijoulesPerSquareCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattHoursPerSquareMeter(watthourspersquaremeter: QuantityValue) -> Irradiation:
        """ Get Irradiation from WattHoursPerSquareMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: IrradiationUnit) -> Irradiation:
        """ Dynamically convert from value and unit enum "IrradiationUnit" to "Irradiation".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: IrradiationUnit
        :return: Irradiation unit value.
        :rtype: Irradiation
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Irradiation:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Irradiation:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Irradiation) -> typing.Tuple[Irradiation, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Irradiation
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Irradiation) -> typing.Tuple[Irradiation, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Irradiation
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> IrradiationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> IrradiationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: IrradiationUnit) -> typing.Tuple[IrradiationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: IrradiationUnit) -> typing.Tuple[IrradiationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: IrradiationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Irradiation) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Irradiation) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Irradiation, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Irradiation within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Irradiation
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Irradiation.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: IrradiationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: IrradiationUnit) -> Irradiation:
        """ Converts this Irradiation to another Irradiation with the unit representation .

        :return: A Irradiation with the specified unit.
        :rtype: Irradiation
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Irradiation:
        """
        """
        pass


# noinspection PyPep8Naming
class LinearPowerDensity(ValueType, IQuantity[LinearPowerDensityUnit], IQuantity, IFormattable, IEquatable[LinearPowerDensity], IComparable, IComparable[LinearPowerDensity], IConvertible):
    """ The Linear Power Density of a substance is its power per unit length. The term linear density is most often used when describing the characteristics of one-dimensional objects, although linear density can also be used to describe the density of a three-dimensional quantity along one particular dimension.
     http://en.wikipedia.org/wiki/Linear_density
    """

    Info: typing.ClassVar[QuantityInfo[LinearPowerDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LinearPowerDensityUnit]

    MaxValue: typing.ClassVar[LinearPowerDensity]

    MinValue: typing.ClassVar[LinearPowerDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LinearPowerDensityUnit]]

    Zero: typing.ClassVar[LinearPowerDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LinearPowerDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LinearPowerDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GigawattsPerCentimeter(self) -> float:
        """ Get LinearPowerDensity in GigawattsPerCentimeter.
        """
        pass

    @property
    def GigawattsPerFoot(self) -> float:
        """ Get LinearPowerDensity in GigawattsPerFoot.
        """
        pass

    @property
    def GigawattsPerInch(self) -> float:
        """ Get LinearPowerDensity in GigawattsPerInch.
        """
        pass

    @property
    def GigawattsPerMeter(self) -> float:
        """ Get LinearPowerDensity in GigawattsPerMeter.
        """
        pass

    @property
    def GigawattsPerMillimeter(self) -> float:
        """ Get LinearPowerDensity in GigawattsPerMillimeter.
        """
        pass

    @property
    def KilowattsPerCentimeter(self) -> float:
        """ Get LinearPowerDensity in KilowattsPerCentimeter.
        """
        pass

    @property
    def KilowattsPerFoot(self) -> float:
        """ Get LinearPowerDensity in KilowattsPerFoot.
        """
        pass

    @property
    def KilowattsPerInch(self) -> float:
        """ Get LinearPowerDensity in KilowattsPerInch.
        """
        pass

    @property
    def KilowattsPerMeter(self) -> float:
        """ Get LinearPowerDensity in KilowattsPerMeter.
        """
        pass

    @property
    def KilowattsPerMillimeter(self) -> float:
        """ Get LinearPowerDensity in KilowattsPerMillimeter.
        """
        pass

    @property
    def MegawattsPerCentimeter(self) -> float:
        """ Get LinearPowerDensity in MegawattsPerCentimeter.
        """
        pass

    @property
    def MegawattsPerFoot(self) -> float:
        """ Get LinearPowerDensity in MegawattsPerFoot.
        """
        pass

    @property
    def MegawattsPerInch(self) -> float:
        """ Get LinearPowerDensity in MegawattsPerInch.
        """
        pass

    @property
    def MegawattsPerMeter(self) -> float:
        """ Get LinearPowerDensity in MegawattsPerMeter.
        """
        pass

    @property
    def MegawattsPerMillimeter(self) -> float:
        """ Get LinearPowerDensity in MegawattsPerMillimeter.
        """
        pass

    @property
    def MilliwattsPerCentimeter(self) -> float:
        """ Get LinearPowerDensity in MilliwattsPerCentimeter.
        """
        pass

    @property
    def MilliwattsPerFoot(self) -> float:
        """ Get LinearPowerDensity in MilliwattsPerFoot.
        """
        pass

    @property
    def MilliwattsPerInch(self) -> float:
        """ Get LinearPowerDensity in MilliwattsPerInch.
        """
        pass

    @property
    def MilliwattsPerMeter(self) -> float:
        """ Get LinearPowerDensity in MilliwattsPerMeter.
        """
        pass

    @property
    def MilliwattsPerMillimeter(self) -> float:
        """ Get LinearPowerDensity in MilliwattsPerMillimeter.
        """
        pass

    @property
    def WattsPerCentimeter(self) -> float:
        """ Get LinearPowerDensity in WattsPerCentimeter.
        """
        pass

    @property
    def WattsPerFoot(self) -> float:
        """ Get LinearPowerDensity in WattsPerFoot.
        """
        pass

    @property
    def WattsPerInch(self) -> float:
        """ Get LinearPowerDensity in WattsPerInch.
        """
        pass

    @property
    def WattsPerMeter(self) -> float:
        """ Get LinearPowerDensity in WattsPerMeter.
        """
        pass

    @property
    def WattsPerMillimeter(self) -> float:
        """ Get LinearPowerDensity in WattsPerMillimeter.
        """
        pass

    def __init__(self, value: float, unit: LinearPowerDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LinearPowerDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LinearPowerDensityUnit) -> typing.Tuple[LinearPowerDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LinearPowerDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: LinearPowerDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LinearPowerDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LinearPowerDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another LinearPowerDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: LinearPowerDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current LinearPowerDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LinearPowerDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LinearPowerDensityUnit) -> LinearPowerDensity:
        """ Converts this LinearPowerDensity to another LinearPowerDensity with the unit representation .

        :return: A LinearPowerDensity with the specified unit.
        :rtype: LinearPowerDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> LinearPowerDensity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LinearPowerDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LinearPowerDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LinearPowerDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LinearPowerDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGigawattsPerCentimeter(gigawattspercentimeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from GigawattsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerFoot(gigawattsperfoot: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from GigawattsPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerInch(gigawattsperinch: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from GigawattsPerInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerMeter(gigawattspermeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from GigawattsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerMillimeter(gigawattspermillimeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from GigawattsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerCentimeter(kilowattspercentimeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from KilowattsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerFoot(kilowattsperfoot: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from KilowattsPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerInch(kilowattsperinch: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from KilowattsPerInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerMeter(kilowattspermeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from KilowattsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerMillimeter(kilowattspermillimeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from KilowattsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerCentimeter(megawattspercentimeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from MegawattsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerFoot(megawattsperfoot: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from MegawattsPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerInch(megawattsperinch: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from MegawattsPerInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerMeter(megawattspermeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from MegawattsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerMillimeter(megawattspermillimeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from MegawattsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerCentimeter(milliwattspercentimeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from MilliwattsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerFoot(milliwattsperfoot: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from MilliwattsPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerInch(milliwattsperinch: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from MilliwattsPerInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerMeter(milliwattspermeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from MilliwattsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerMillimeter(milliwattspermillimeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from MilliwattsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerCentimeter(wattspercentimeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from WattsPerCentimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerFoot(wattsperfoot: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from WattsPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerInch(wattsperinch: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from WattsPerInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerMeter(wattspermeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from WattsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerMillimeter(wattspermillimeter: QuantityValue) -> LinearPowerDensity:
        """ Get LinearPowerDensity from WattsPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LinearPowerDensityUnit) -> LinearPowerDensity:
        """ Dynamically convert from value and unit enum "LinearPowerDensityUnit" to "LinearPowerDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LinearPowerDensityUnit
        :return: LinearPowerDensity unit value.
        :rtype: LinearPowerDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> LinearPowerDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> LinearPowerDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: LinearPowerDensity) -> typing.Tuple[LinearPowerDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LinearPowerDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: LinearPowerDensity) -> typing.Tuple[LinearPowerDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LinearPowerDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LinearPowerDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LinearPowerDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LinearPowerDensityUnit) -> typing.Tuple[LinearPowerDensityUnit, bool]:
        """
        """
        pass


# noinspection PyPep8Naming
class Luminosity(ValueType, IQuantity[LuminosityUnit], IQuantity, IFormattable, IEquatable[Luminosity], IComparable, IComparable[Luminosity], IConvertible):
    """ Luminosity is an absolute measure of radiated electromagnetic power (light), the radiant power emitted by a light-emitting object.
     https://en.wikipedia.org/wiki/Luminosity
    """

    Info: typing.ClassVar[QuantityInfo[LuminosityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LuminosityUnit]

    MaxValue: typing.ClassVar[Luminosity]

    MinValue: typing.ClassVar[Luminosity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LuminosityUnit]]

    Zero: typing.ClassVar[Luminosity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LuminosityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LuminosityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Decawatts(self) -> float:
        """ Get Luminosity in Decawatts.
        """
        pass

    @property
    def Deciwatts(self) -> float:
        """ Get Luminosity in Deciwatts.
        """
        pass

    @property
    def Femtowatts(self) -> float:
        """ Get Luminosity in Femtowatts.
        """
        pass

    @property
    def Gigawatts(self) -> float:
        """ Get Luminosity in Gigawatts.
        """
        pass

    @property
    def Kilowatts(self) -> float:
        """ Get Luminosity in Kilowatts.
        """
        pass

    @property
    def Megawatts(self) -> float:
        """ Get Luminosity in Megawatts.
        """
        pass

    @property
    def Microwatts(self) -> float:
        """ Get Luminosity in Microwatts.
        """
        pass

    @property
    def Milliwatts(self) -> float:
        """ Get Luminosity in Milliwatts.
        """
        pass

    @property
    def Nanowatts(self) -> float:
        """ Get Luminosity in Nanowatts.
        """
        pass

    @property
    def Petawatts(self) -> float:
        """ Get Luminosity in Petawatts.
        """
        pass

    @property
    def Picowatts(self) -> float:
        """ Get Luminosity in Picowatts.
        """
        pass

    @property
    def SolarLuminosities(self) -> float:
        """ Get Luminosity in SolarLuminosities.
        """
        pass

    @property
    def Terawatts(self) -> float:
        """ Get Luminosity in Terawatts.
        """
        pass

    @property
    def Watts(self) -> float:
        """ Get Luminosity in Watts.
        """
        pass

    def __init__(self, value: float, unit: LuminosityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LuminosityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Luminosity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LuminosityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminosityUnit) -> Luminosity:
        """ Converts this Luminosity to another Luminosity with the unit representation .

        :return: A Luminosity with the specified unit.
        :rtype: Luminosity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Luminosity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminosityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminosityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminosityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminosityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecawatts(decawatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Decawatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwatts(deciwatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Deciwatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFemtowatts(femtowatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Femtowatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawatts(gigawatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Gigawatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowatts(kilowatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Kilowatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawatts(megawatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Megawatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowatts(microwatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Microwatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwatts(milliwatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Milliwatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowatts(nanowatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Nanowatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPetawatts(petawatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Petawatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowatts(picowatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Picowatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSolarLuminosities(solarluminosities: QuantityValue) -> Luminosity:
        """ Get Luminosity from SolarLuminosities.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawatts(terawatts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Terawatts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWatts(watts: QuantityValue) -> Luminosity:
        """ Get Luminosity from Watts.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LuminosityUnit) -> Luminosity:
        """ Dynamically convert from value and unit enum "LuminosityUnit" to "Luminosity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LuminosityUnit
        :return: Luminosity unit value.
        :rtype: Luminosity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Luminosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Luminosity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Luminosity) -> typing.Tuple[Luminosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Luminosity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Luminosity) -> typing.Tuple[Luminosity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Luminosity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LuminosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LuminosityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LuminosityUnit) -> typing.Tuple[LuminosityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LuminosityUnit) -> typing.Tuple[LuminosityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LuminosityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Luminosity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Luminosity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Luminosity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Luminosity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Luminosity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class LuminousFlux(ValueType, IQuantity[LuminousFluxUnit], IQuantity, IFormattable, IEquatable[LuminousFlux], IComparable, IComparable[LuminousFlux], IConvertible):
    """ In photometry, luminous flux or luminous power is the measure of the perceived power of light.
     https://en.wikipedia.org/wiki/Luminous_flux
    """

    Info: typing.ClassVar[QuantityInfo[LuminousFluxUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LuminousFluxUnit]

    MaxValue: typing.ClassVar[LuminousFlux]

    MinValue: typing.ClassVar[LuminousFlux]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LuminousFluxUnit]]

    Zero: typing.ClassVar[LuminousFlux]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LuminousFluxUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LuminousFluxUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Lumens(self) -> float:
        """ Get LuminousFlux in Lumens.
        """
        pass

    def __init__(self, value: float, unit: LuminousFluxUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LuminousFluxUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminousFluxUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminousFluxUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminousFluxUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminousFluxUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromLumens(lumens: QuantityValue) -> LuminousFlux:
        """ Get LuminousFlux from Lumens.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LuminousFluxUnit) -> LuminousFlux:
        """ Dynamically convert from value and unit enum "LuminousFluxUnit" to "LuminousFlux".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LuminousFluxUnit
        :return: LuminousFlux unit value.
        :rtype: LuminousFlux
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> LuminousFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> LuminousFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: LuminousFlux) -> typing.Tuple[LuminousFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LuminousFlux
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: LuminousFlux) -> typing.Tuple[LuminousFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LuminousFlux
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LuminousFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LuminousFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LuminousFluxUnit) -> typing.Tuple[LuminousFluxUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LuminousFluxUnit) -> typing.Tuple[LuminousFluxUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LuminousFluxUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: LuminousFlux) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LuminousFlux) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LuminousFlux, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another LuminousFlux within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: LuminousFlux
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current LuminousFlux.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LuminousFluxUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminousFluxUnit) -> LuminousFlux:
        """ Converts this LuminousFlux to another LuminousFlux with the unit representation .

        :return: A LuminousFlux with the specified unit.
        :rtype: LuminousFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> LuminousFlux:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class LuminousIntensity(ValueType, IQuantity[LuminousIntensityUnit], IQuantity, IFormattable, IEquatable[LuminousIntensity], IComparable, IComparable[LuminousIntensity], IConvertible):
    """ In photometry, luminous intensity is a measure of the wavelength-weighted power emitted by a light source in a particular direction per unit solid angle, based on the luminosity function, a standardized model of the sensitivity of the human eye.
     https://en.wikipedia.org/wiki/Luminous_intensity
    """

    Info: typing.ClassVar[QuantityInfo[LuminousIntensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[LuminousIntensityUnit]

    MaxValue: typing.ClassVar[LuminousIntensity]

    MinValue: typing.ClassVar[LuminousIntensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[LuminousIntensityUnit]]

    Zero: typing.ClassVar[LuminousIntensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> LuminousIntensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[LuminousIntensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Candela(self) -> float:
        """ Get LuminousIntensity in Candela.
        """
        pass

    def __init__(self, value: float, unit: LuminousIntensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: LuminousIntensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminousIntensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminousIntensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: LuminousIntensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: LuminousIntensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCandela(candela: QuantityValue) -> LuminousIntensity:
        """ Get LuminousIntensity from Candela.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: LuminousIntensityUnit) -> LuminousIntensity:
        """ Dynamically convert from value and unit enum "LuminousIntensityUnit" to "LuminousIntensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: LuminousIntensityUnit
        :return: LuminousIntensity unit value.
        :rtype: LuminousIntensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> LuminousIntensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> LuminousIntensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: LuminousIntensity) -> typing.Tuple[LuminousIntensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LuminousIntensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: LuminousIntensity) -> typing.Tuple[LuminousIntensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: LuminousIntensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> LuminousIntensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> LuminousIntensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: LuminousIntensityUnit) -> typing.Tuple[LuminousIntensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: LuminousIntensityUnit) -> typing.Tuple[LuminousIntensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: LuminousIntensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: LuminousIntensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LuminousIntensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: LuminousIntensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another LuminousIntensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: LuminousIntensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current LuminousIntensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: LuminousIntensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: LuminousIntensityUnit) -> LuminousIntensity:
        """ Converts this LuminousIntensity to another LuminousIntensity with the unit representation .

        :return: A LuminousIntensity with the specified unit.
        :rtype: LuminousIntensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> LuminousIntensity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class MagneticField(ValueType, IQuantity[MagneticFieldUnit], IQuantity, IFormattable, IEquatable[MagneticField], IComparable, IComparable[MagneticField], IConvertible):
    """ A magnetic field is a force field that is created by moving electric charges (electric currents) and magnetic dipoles, and exerts a force on other nearby moving charges and magnetic dipoles.
     https://en.wikipedia.org/wiki/Magnetic_field
    """

    Info: typing.ClassVar[QuantityInfo[MagneticFieldUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MagneticFieldUnit]

    MaxValue: typing.ClassVar[MagneticField]

    MinValue: typing.ClassVar[MagneticField]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MagneticFieldUnit]]

    Zero: typing.ClassVar[MagneticField]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MagneticFieldUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MagneticFieldUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Gausses(self) -> float:
        """ Get MagneticField in Gausses.
        """
        pass

    @property
    def Microteslas(self) -> float:
        """ Get MagneticField in Microteslas.
        """
        pass

    @property
    def Milligausses(self) -> float:
        """ Get MagneticField in Milligausses.
        """
        pass

    @property
    def Milliteslas(self) -> float:
        """ Get MagneticField in Milliteslas.
        """
        pass

    @property
    def Nanoteslas(self) -> float:
        """ Get MagneticField in Nanoteslas.
        """
        pass

    @property
    def Teslas(self) -> float:
        """ Get MagneticField in Teslas.
        """
        pass

    def __init__(self, value: float, unit: MagneticFieldUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MagneticFieldUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagneticFieldUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagneticFieldUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagneticFieldUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagneticFieldUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGausses(gausses: QuantityValue) -> MagneticField:
        """ Get MagneticField from Gausses.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicroteslas(microteslas: QuantityValue) -> MagneticField:
        """ Get MagneticField from Microteslas.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligausses(milligausses: QuantityValue) -> MagneticField:
        """ Get MagneticField from Milligausses.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliteslas(milliteslas: QuantityValue) -> MagneticField:
        """ Get MagneticField from Milliteslas.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanoteslas(nanoteslas: QuantityValue) -> MagneticField:
        """ Get MagneticField from Nanoteslas.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTeslas(teslas: QuantityValue) -> MagneticField:
        """ Get MagneticField from Teslas.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MagneticFieldUnit) -> MagneticField:
        """ Dynamically convert from value and unit enum "MagneticFieldUnit" to "MagneticField".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MagneticFieldUnit
        :return: MagneticField unit value.
        :rtype: MagneticField
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MagneticField:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MagneticField:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MagneticField) -> typing.Tuple[MagneticField, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MagneticField
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MagneticField) -> typing.Tuple[MagneticField, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MagneticField
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MagneticFieldUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MagneticFieldUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MagneticFieldUnit) -> typing.Tuple[MagneticFieldUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MagneticFieldUnit) -> typing.Tuple[MagneticFieldUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MagneticFieldUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MagneticField) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MagneticField) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MagneticField, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MagneticField within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MagneticField
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MagneticField.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MagneticFieldUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MagneticFieldUnit) -> MagneticField:
        """ Converts this MagneticField to another MagneticField with the unit representation .

        :return: A MagneticField with the specified unit.
        :rtype: MagneticField
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MagneticField:
        """
        """
        pass


# noinspection PyPep8Naming
class MagneticFlux(ValueType, IQuantity[MagneticFluxUnit], IQuantity, IFormattable, IEquatable[MagneticFlux], IComparable, IComparable[MagneticFlux], IConvertible):
    """ In physics, specifically electromagnetism, the magnetic flux through a surface is the surface integral of the normal component of the magnetic field B passing through that surface.
     https://en.wikipedia.org/wiki/Magnetic_flux
    """

    Info: typing.ClassVar[QuantityInfo[MagneticFluxUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MagneticFluxUnit]

    MaxValue: typing.ClassVar[MagneticFlux]

    MinValue: typing.ClassVar[MagneticFlux]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MagneticFluxUnit]]

    Zero: typing.ClassVar[MagneticFlux]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MagneticFluxUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MagneticFluxUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Webers(self) -> float:
        """ Get MagneticFlux in Webers.
        """
        pass

    def __init__(self, value: float, unit: MagneticFluxUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MagneticFluxUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagneticFluxUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagneticFluxUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagneticFluxUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagneticFluxUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromWebers(webers: QuantityValue) -> MagneticFlux:
        """ Get MagneticFlux from Webers.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MagneticFluxUnit) -> MagneticFlux:
        """ Dynamically convert from value and unit enum "MagneticFluxUnit" to "MagneticFlux".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MagneticFluxUnit
        :return: MagneticFlux unit value.
        :rtype: MagneticFlux
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MagneticFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MagneticFlux:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MagneticFlux) -> typing.Tuple[MagneticFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MagneticFlux
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MagneticFlux) -> typing.Tuple[MagneticFlux, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MagneticFlux
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MagneticFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MagneticFluxUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MagneticFluxUnit) -> typing.Tuple[MagneticFluxUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MagneticFluxUnit) -> typing.Tuple[MagneticFluxUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MagneticFluxUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MagneticFlux) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MagneticFlux) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MagneticFlux, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MagneticFlux within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MagneticFlux
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MagneticFlux.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MagneticFluxUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MagneticFluxUnit) -> MagneticFlux:
        """ Converts this MagneticFlux to another MagneticFlux with the unit representation .

        :return: A MagneticFlux with the specified unit.
        :rtype: MagneticFlux
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MagneticFlux:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class Magnetization(ValueType, IQuantity[MagnetizationUnit], IQuantity, IFormattable, IEquatable[Magnetization], IComparable, IComparable[Magnetization], IConvertible):
    """ In classical electromagnetism, magnetization is the vector field that expresses the density of permanent or induced magnetic dipole moments in a magnetic material.
     https://en.wikipedia.org/wiki/Magnetization
    """

    Info: typing.ClassVar[QuantityInfo[MagnetizationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MagnetizationUnit]

    MaxValue: typing.ClassVar[Magnetization]

    MinValue: typing.ClassVar[Magnetization]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MagnetizationUnit]]

    Zero: typing.ClassVar[Magnetization]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MagnetizationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MagnetizationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AmperesPerMeter(self) -> float:
        """ Get Magnetization in AmperesPerMeter.
        """
        pass

    def __init__(self, value: float, unit: MagnetizationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MagnetizationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagnetizationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagnetizationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MagnetizationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MagnetizationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmperesPerMeter(amperespermeter: QuantityValue) -> Magnetization:
        """ Get Magnetization from AmperesPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MagnetizationUnit) -> Magnetization:
        """ Dynamically convert from value and unit enum "MagnetizationUnit" to "Magnetization".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MagnetizationUnit
        :return: Magnetization unit value.
        :rtype: Magnetization
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Magnetization:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Magnetization:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Magnetization) -> typing.Tuple[Magnetization, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Magnetization
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Magnetization) -> typing.Tuple[Magnetization, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Magnetization
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MagnetizationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MagnetizationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MagnetizationUnit) -> typing.Tuple[MagnetizationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MagnetizationUnit) -> typing.Tuple[MagnetizationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MagnetizationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Magnetization) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Magnetization) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Magnetization, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Magnetization within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Magnetization
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Magnetization.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MagnetizationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MagnetizationUnit) -> Magnetization:
        """ Converts this Magnetization to another Magnetization with the unit representation .

        :return: A Magnetization with the specified unit.
        :rtype: Magnetization
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Magnetization:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class MassMomentOfInertia(ValueType, IQuantity[MassMomentOfInertiaUnit], IQuantity, IFormattable, IEquatable[MassMomentOfInertia], IComparable, IComparable[MassMomentOfInertia], IConvertible):
    """ A property of body reflects how its mass is distributed with regard to an axis.
    """

    Info: typing.ClassVar[QuantityInfo[MassMomentOfInertiaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MassMomentOfInertiaUnit]

    MaxValue: typing.ClassVar[MassMomentOfInertia]

    MinValue: typing.ClassVar[MassMomentOfInertia]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MassMomentOfInertiaUnit]]

    Zero: typing.ClassVar[MassMomentOfInertia]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MassMomentOfInertiaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MassMomentOfInertiaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GramSquareCentimeters(self) -> float:
        """ Get MassMomentOfInertia in GramSquareCentimeters.
        """
        pass

    @property
    def GramSquareDecimeters(self) -> float:
        """ Get MassMomentOfInertia in GramSquareDecimeters.
        """
        pass

    @property
    def GramSquareMeters(self) -> float:
        """ Get MassMomentOfInertia in GramSquareMeters.
        """
        pass

    @property
    def GramSquareMillimeters(self) -> float:
        """ Get MassMomentOfInertia in GramSquareMillimeters.
        """
        pass

    @property
    def KilogramSquareCentimeters(self) -> float:
        """ Get MassMomentOfInertia in KilogramSquareCentimeters.
        """
        pass

    @property
    def KilogramSquareDecimeters(self) -> float:
        """ Get MassMomentOfInertia in KilogramSquareDecimeters.
        """
        pass

    @property
    def KilogramSquareMeters(self) -> float:
        """ Get MassMomentOfInertia in KilogramSquareMeters.
        """
        pass

    @property
    def KilogramSquareMillimeters(self) -> float:
        """ Get MassMomentOfInertia in KilogramSquareMillimeters.
        """
        pass

    @property
    def KilotonneSquareCentimeters(self) -> float:
        """ Get MassMomentOfInertia in KilotonneSquareCentimeters.
        """
        pass

    @property
    def KilotonneSquareDecimeters(self) -> float:
        """ Get MassMomentOfInertia in KilotonneSquareDecimeters.
        """
        pass

    @property
    def KilotonneSquareMeters(self) -> float:
        """ Get MassMomentOfInertia in KilotonneSquareMeters.
        """
        pass

    @property
    def KilotonneSquareMilimeters(self) -> float:
        """ Get MassMomentOfInertia in KilotonneSquareMilimeters.
        """
        pass

    @property
    def MegatonneSquareCentimeters(self) -> float:
        """ Get MassMomentOfInertia in MegatonneSquareCentimeters.
        """
        pass

    @property
    def MegatonneSquareDecimeters(self) -> float:
        """ Get MassMomentOfInertia in MegatonneSquareDecimeters.
        """
        pass

    @property
    def MegatonneSquareMeters(self) -> float:
        """ Get MassMomentOfInertia in MegatonneSquareMeters.
        """
        pass

    @property
    def MegatonneSquareMilimeters(self) -> float:
        """ Get MassMomentOfInertia in MegatonneSquareMilimeters.
        """
        pass

    @property
    def MilligramSquareCentimeters(self) -> float:
        """ Get MassMomentOfInertia in MilligramSquareCentimeters.
        """
        pass

    @property
    def MilligramSquareDecimeters(self) -> float:
        """ Get MassMomentOfInertia in MilligramSquareDecimeters.
        """
        pass

    @property
    def MilligramSquareMeters(self) -> float:
        """ Get MassMomentOfInertia in MilligramSquareMeters.
        """
        pass

    @property
    def MilligramSquareMillimeters(self) -> float:
        """ Get MassMomentOfInertia in MilligramSquareMillimeters.
        """
        pass

    @property
    def PoundSquareFeet(self) -> float:
        """ Get MassMomentOfInertia in PoundSquareFeet.
        """
        pass

    @property
    def PoundSquareInches(self) -> float:
        """ Get MassMomentOfInertia in PoundSquareInches.
        """
        pass

    @property
    def SlugSquareFeet(self) -> float:
        """ Get MassMomentOfInertia in SlugSquareFeet.
        """
        pass

    @property
    def SlugSquareInches(self) -> float:
        """ Get MassMomentOfInertia in SlugSquareInches.
        """
        pass

    @property
    def TonneSquareCentimeters(self) -> float:
        """ Get MassMomentOfInertia in TonneSquareCentimeters.
        """
        pass

    @property
    def TonneSquareDecimeters(self) -> float:
        """ Get MassMomentOfInertia in TonneSquareDecimeters.
        """
        pass

    @property
    def TonneSquareMeters(self) -> float:
        """ Get MassMomentOfInertia in TonneSquareMeters.
        """
        pass

    @property
    def TonneSquareMilimeters(self) -> float:
        """ Get MassMomentOfInertia in TonneSquareMilimeters.
        """
        pass

    def __init__(self, value: float, unit: MassMomentOfInertiaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MassMomentOfInertiaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MassMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MassMomentOfInertia) -> typing.Tuple[MassMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MassMomentOfInertia) -> typing.Tuple[MassMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MassMomentOfInertia
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MassMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MassMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MassMomentOfInertiaUnit) -> typing.Tuple[MassMomentOfInertiaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MassMomentOfInertiaUnit) -> typing.Tuple[MassMomentOfInertiaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MassMomentOfInertiaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MassMomentOfInertia) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassMomentOfInertia) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MassMomentOfInertia, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MassMomentOfInertia within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MassMomentOfInertia
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MassMomentOfInertia.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MassMomentOfInertiaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MassMomentOfInertiaUnit) -> MassMomentOfInertia:
        """ Converts this MassMomentOfInertia to another MassMomentOfInertia with the unit representation .

        :return: A MassMomentOfInertia with the specified unit.
        :rtype: MassMomentOfInertia
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MassMomentOfInertia:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassMomentOfInertiaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassMomentOfInertiaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MassMomentOfInertiaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MassMomentOfInertiaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGramSquareCentimeters(gramsquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from GramSquareCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramSquareDecimeters(gramsquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from GramSquareDecimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramSquareMeters(gramsquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from GramSquareMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramSquareMillimeters(gramsquaremillimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from GramSquareMillimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramSquareCentimeters(kilogramsquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from KilogramSquareCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramSquareDecimeters(kilogramsquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from KilogramSquareDecimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramSquareMeters(kilogramsquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from KilogramSquareMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramSquareMillimeters(kilogramsquaremillimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from KilogramSquareMillimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilotonneSquareCentimeters(kilotonnesquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from KilotonneSquareCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilotonneSquareDecimeters(kilotonnesquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from KilotonneSquareDecimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilotonneSquareMeters(kilotonnesquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from KilotonneSquareMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilotonneSquareMilimeters(kilotonnesquaremilimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from KilotonneSquareMilimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegatonneSquareCentimeters(megatonnesquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from MegatonneSquareCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegatonneSquareDecimeters(megatonnesquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from MegatonneSquareDecimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegatonneSquareMeters(megatonnesquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from MegatonneSquareMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegatonneSquareMilimeters(megatonnesquaremilimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from MegatonneSquareMilimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramSquareCentimeters(milligramsquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from MilligramSquareCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramSquareDecimeters(milligramsquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from MilligramSquareDecimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramSquareMeters(milligramsquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from MilligramSquareMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramSquareMillimeters(milligramsquaremillimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from MilligramSquareMillimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundSquareFeet(poundsquarefeet: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from PoundSquareFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundSquareInches(poundsquareinches: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from PoundSquareInches.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugSquareFeet(slugsquarefeet: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from SlugSquareFeet.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSlugSquareInches(slugsquareinches: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from SlugSquareInches.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneSquareCentimeters(tonnesquarecentimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from TonneSquareCentimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneSquareDecimeters(tonnesquaredecimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from TonneSquareDecimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneSquareMeters(tonnesquaremeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from TonneSquareMeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneSquareMilimeters(tonnesquaremilimeters: QuantityValue) -> MassMomentOfInertia:
        """ Get MassMomentOfInertia from TonneSquareMilimeters.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MassMomentOfInertiaUnit) -> MassMomentOfInertia:
        """ Dynamically convert from value and unit enum "MassMomentOfInertiaUnit" to "MassMomentOfInertia".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MassMomentOfInertiaUnit
        :return: MassMomentOfInertia unit value.
        :rtype: MassMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MassMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass


# noinspection PyPep8Naming
class MolarEnergy(ValueType, IQuantity[MolarEnergyUnit], IQuantity, IFormattable, IEquatable[MolarEnergy], IComparable, IComparable[MolarEnergy], IConvertible):
    """ Molar energy is the amount of energy stored in 1 mole of a substance.
    """

    Info: typing.ClassVar[QuantityInfo[MolarEnergyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MolarEnergyUnit]

    MaxValue: typing.ClassVar[MolarEnergy]

    MinValue: typing.ClassVar[MolarEnergy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MolarEnergyUnit]]

    Zero: typing.ClassVar[MolarEnergy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MolarEnergyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MolarEnergyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def JoulesPerMole(self) -> float:
        """ Get MolarEnergy in JoulesPerMole.
        """
        pass

    @property
    def KilojoulesPerMole(self) -> float:
        """ Get MolarEnergy in KilojoulesPerMole.
        """
        pass

    @property
    def MegajoulesPerMole(self) -> float:
        """ Get MolarEnergy in MegajoulesPerMole.
        """
        pass

    def __init__(self, value: float, unit: MolarEnergyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MolarEnergyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarEnergyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarEnergyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarEnergyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarEnergyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromJoulesPerMole(joulespermole: QuantityValue) -> MolarEnergy:
        """ Get MolarEnergy from JoulesPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerMole(kilojoulespermole: QuantityValue) -> MolarEnergy:
        """ Get MolarEnergy from KilojoulesPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerMole(megajoulespermole: QuantityValue) -> MolarEnergy:
        """ Get MolarEnergy from MegajoulesPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MolarEnergyUnit) -> MolarEnergy:
        """ Dynamically convert from value and unit enum "MolarEnergyUnit" to "MolarEnergy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MolarEnergyUnit
        :return: MolarEnergy unit value.
        :rtype: MolarEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MolarEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MolarEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MolarEnergy) -> typing.Tuple[MolarEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MolarEnergy) -> typing.Tuple[MolarEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarEnergy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MolarEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MolarEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MolarEnergyUnit) -> typing.Tuple[MolarEnergyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MolarEnergyUnit) -> typing.Tuple[MolarEnergyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MolarEnergyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MolarEnergy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarEnergy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarEnergy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MolarEnergy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MolarEnergy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MolarEnergy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MolarEnergyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarEnergyUnit) -> MolarEnergy:
        """ Converts this MolarEnergy to another MolarEnergy with the unit representation .

        :return: A MolarEnergy with the specified unit.
        :rtype: MolarEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MolarEnergy:
        """
        """
        pass


# noinspection PyPep8Naming
class MolarEntropy(ValueType, IQuantity[MolarEntropyUnit], IQuantity, IFormattable, IEquatable[MolarEntropy], IComparable, IComparable[MolarEntropy], IConvertible):
    """ Molar entropy is amount of energy required to increase temperature of 1 mole substance by 1 Kelvin.
    """

    Info: typing.ClassVar[QuantityInfo[MolarEntropyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MolarEntropyUnit]

    MaxValue: typing.ClassVar[MolarEntropy]

    MinValue: typing.ClassVar[MolarEntropy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MolarEntropyUnit]]

    Zero: typing.ClassVar[MolarEntropy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MolarEntropyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MolarEntropyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def JoulesPerMoleKelvin(self) -> float:
        """ Get MolarEntropy in JoulesPerMoleKelvin.
        """
        pass

    @property
    def KilojoulesPerMoleKelvin(self) -> float:
        """ Get MolarEntropy in KilojoulesPerMoleKelvin.
        """
        pass

    @property
    def MegajoulesPerMoleKelvin(self) -> float:
        """ Get MolarEntropy in MegajoulesPerMoleKelvin.
        """
        pass

    def __init__(self, value: float, unit: MolarEntropyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MolarEntropyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarEntropyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarEntropyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarEntropyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarEntropyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromJoulesPerMoleKelvin(joulespermolekelvin: QuantityValue) -> MolarEntropy:
        """ Get MolarEntropy from JoulesPerMoleKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerMoleKelvin(kilojoulespermolekelvin: QuantityValue) -> MolarEntropy:
        """ Get MolarEntropy from KilojoulesPerMoleKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerMoleKelvin(megajoulespermolekelvin: QuantityValue) -> MolarEntropy:
        """ Get MolarEntropy from MegajoulesPerMoleKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MolarEntropyUnit) -> MolarEntropy:
        """ Dynamically convert from value and unit enum "MolarEntropyUnit" to "MolarEntropy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MolarEntropyUnit
        :return: MolarEntropy unit value.
        :rtype: MolarEntropy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MolarEntropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MolarEntropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MolarEntropy) -> typing.Tuple[MolarEntropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarEntropy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MolarEntropy) -> typing.Tuple[MolarEntropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarEntropy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MolarEntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MolarEntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MolarEntropyUnit) -> typing.Tuple[MolarEntropyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MolarEntropyUnit) -> typing.Tuple[MolarEntropyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MolarEntropyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MolarEntropy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarEntropy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarEntropy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MolarEntropy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MolarEntropy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MolarEntropy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MolarEntropyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarEntropyUnit) -> MolarEntropy:
        """ Converts this MolarEntropy to another MolarEntropy with the unit representation .

        :return: A MolarEntropy with the specified unit.
        :rtype: MolarEntropy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MolarEntropy:
        """
        """
        pass


# noinspection PyPep8Naming
class MolarMass(ValueType, IQuantity[MolarMassUnit], IQuantity, IFormattable, IEquatable[MolarMass], IComparable, IComparable[MolarMass], IConvertible):
    """ In chemistry, the molar mass M is a physical property defined as the mass of a given substance (chemical element or chemical compound) divided by the amount of substance.
    """

    Info: typing.ClassVar[QuantityInfo[MolarMassUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[MolarMassUnit]

    MaxValue: typing.ClassVar[MolarMass]

    MinValue: typing.ClassVar[MolarMass]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[MolarMassUnit]]

    Zero: typing.ClassVar[MolarMass]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> MolarMassUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[MolarMassUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentigramsPerMole(self) -> float:
        """ Get MolarMass in CentigramsPerMole.
        """
        pass

    @property
    def DecagramsPerMole(self) -> float:
        """ Get MolarMass in DecagramsPerMole.
        """
        pass

    @property
    def DecigramsPerMole(self) -> float:
        """ Get MolarMass in DecigramsPerMole.
        """
        pass

    @property
    def GramsPerMole(self) -> float:
        """ Get MolarMass in GramsPerMole.
        """
        pass

    @property
    def HectogramsPerMole(self) -> float:
        """ Get MolarMass in HectogramsPerMole.
        """
        pass

    @property
    def KilogramsPerMole(self) -> float:
        """ Get MolarMass in KilogramsPerMole.
        """
        pass

    @property
    def KilopoundsPerMole(self) -> float:
        """ Get MolarMass in KilopoundsPerMole.
        """
        pass

    @property
    def MegapoundsPerMole(self) -> float:
        """ Get MolarMass in MegapoundsPerMole.
        """
        pass

    @property
    def MicrogramsPerMole(self) -> float:
        """ Get MolarMass in MicrogramsPerMole.
        """
        pass

    @property
    def MilligramsPerMole(self) -> float:
        """ Get MolarMass in MilligramsPerMole.
        """
        pass

    @property
    def NanogramsPerMole(self) -> float:
        """ Get MolarMass in NanogramsPerMole.
        """
        pass

    @property
    def PoundsPerMole(self) -> float:
        """ Get MolarMass in PoundsPerMole.
        """
        pass

    def __init__(self, value: float, unit: MolarMassUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: MolarMassUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: MolarMassUnit) -> MolarMass:
        """ Converts this MolarMass to another MolarMass with the unit representation .

        :return: A MolarMass with the specified unit.
        :rtype: MolarMass
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> MolarMass:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarMassUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarMassUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: MolarMassUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: MolarMassUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentigramsPerMole(centigramspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from CentigramsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecagramsPerMole(decagramspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from DecagramsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecigramsPerMole(decigramspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from DecigramsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGramsPerMole(gramspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from GramsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectogramsPerMole(hectogramspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from HectogramsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramsPerMole(kilogramspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from KilogramsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsPerMole(kilopoundspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from KilopoundsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsPerMole(megapoundspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from MegapoundsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrogramsPerMole(microgramspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from MicrogramsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilligramsPerMole(milligramspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from MilligramsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanogramsPerMole(nanogramspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from NanogramsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsPerMole(poundspermole: QuantityValue) -> MolarMass:
        """ Get MolarMass from PoundsPerMole.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: MolarMassUnit) -> MolarMass:
        """ Dynamically convert from value and unit enum "MolarMassUnit" to "MolarMass".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: MolarMassUnit
        :return: MolarMass unit value.
        :rtype: MolarMass
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> MolarMass:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> MolarMass:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: MolarMass) -> typing.Tuple[MolarMass, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarMass
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: MolarMass) -> typing.Tuple[MolarMass, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: MolarMass
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> MolarMassUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> MolarMassUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: MolarMassUnit) -> typing.Tuple[MolarMassUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: MolarMassUnit) -> typing.Tuple[MolarMassUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: MolarMassUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: MolarMass) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarMass) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: MolarMass, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another MolarMass within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: MolarMass
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current MolarMass.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: MolarMassUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass


# noinspection PyPep8Naming
class Permeability(ValueType, IQuantity[PermeabilityUnit], IQuantity, IFormattable, IEquatable[Permeability], IComparable, IComparable[Permeability], IConvertible):
    """ In electromagnetism, permeability is the measure of the ability of a material to support the formation of a magnetic field within itself.
     https://en.wikipedia.org/wiki/Permeability_(electromagnetism)
    """

    Info: typing.ClassVar[QuantityInfo[PermeabilityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PermeabilityUnit]

    MaxValue: typing.ClassVar[Permeability]

    MinValue: typing.ClassVar[Permeability]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PermeabilityUnit]]

    Zero: typing.ClassVar[Permeability]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PermeabilityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PermeabilityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def HenriesPerMeter(self) -> float:
        """ Get Permeability in HenriesPerMeter.
        """
        pass

    def __init__(self, value: float, unit: PermeabilityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PermeabilityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PermeabilityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PermeabilityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PermeabilityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PermeabilityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromHenriesPerMeter(henriespermeter: QuantityValue) -> Permeability:
        """ Get Permeability from HenriesPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PermeabilityUnit) -> Permeability:
        """ Dynamically convert from value and unit enum "PermeabilityUnit" to "Permeability".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PermeabilityUnit
        :return: Permeability unit value.
        :rtype: Permeability
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Permeability:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Permeability:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Permeability) -> typing.Tuple[Permeability, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Permeability
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Permeability) -> typing.Tuple[Permeability, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Permeability
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PermeabilityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PermeabilityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PermeabilityUnit) -> typing.Tuple[PermeabilityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PermeabilityUnit) -> typing.Tuple[PermeabilityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PermeabilityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Permeability) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Permeability) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Permeability, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Permeability within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Permeability
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Permeability.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PermeabilityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PermeabilityUnit) -> Permeability:
        """ Converts this Permeability to another Permeability with the unit representation .

        :return: A Permeability with the specified unit.
        :rtype: Permeability
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Permeability:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class Permittivity(ValueType, IQuantity[PermittivityUnit], IQuantity, IFormattable, IEquatable[Permittivity], IComparable, IComparable[Permittivity], IConvertible):
    """ In electromagnetism, permittivity is the measure of resistance that is encountered when forming an electric field in a particular medium.
     https://en.wikipedia.org/wiki/Permittivity
    """

    Info: typing.ClassVar[QuantityInfo[PermittivityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PermittivityUnit]

    MaxValue: typing.ClassVar[Permittivity]

    MinValue: typing.ClassVar[Permittivity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PermittivityUnit]]

    Zero: typing.ClassVar[Permittivity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PermittivityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PermittivityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def FaradsPerMeter(self) -> float:
        """ Get Permittivity in FaradsPerMeter.
        """
        pass

    def __init__(self, value: float, unit: PermittivityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PermittivityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PermittivityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PermittivityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PermittivityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PermittivityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromFaradsPerMeter(faradspermeter: QuantityValue) -> Permittivity:
        """ Get Permittivity from FaradsPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PermittivityUnit) -> Permittivity:
        """ Dynamically convert from value and unit enum "PermittivityUnit" to "Permittivity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PermittivityUnit
        :return: Permittivity unit value.
        :rtype: Permittivity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Permittivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Permittivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Permittivity) -> typing.Tuple[Permittivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Permittivity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Permittivity) -> typing.Tuple[Permittivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Permittivity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PermittivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PermittivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PermittivityUnit) -> typing.Tuple[PermittivityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PermittivityUnit) -> typing.Tuple[PermittivityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PermittivityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Permittivity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Permittivity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Permittivity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Permittivity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Permittivity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Permittivity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PermittivityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PermittivityUnit) -> Permittivity:
        """ Converts this Permittivity to another Permittivity with the unit representation .

        :return: A Permittivity with the specified unit.
        :rtype: Permittivity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Permittivity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class PowerDensity(ValueType, IQuantity[PowerDensityUnit], IQuantity, IFormattable, IEquatable[PowerDensity], IComparable, IComparable[PowerDensity], IConvertible):
    """ The amount of power in a volume.
    """

    Info: typing.ClassVar[QuantityInfo[PowerDensityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PowerDensityUnit]

    MaxValue: typing.ClassVar[PowerDensity]

    MinValue: typing.ClassVar[PowerDensity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PowerDensityUnit]]

    Zero: typing.ClassVar[PowerDensity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PowerDensityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PowerDensityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DecawattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in DecawattsPerCubicFoot.
        """
        pass

    @property
    def DecawattsPerCubicInch(self) -> float:
        """ Get PowerDensity in DecawattsPerCubicInch.
        """
        pass

    @property
    def DecawattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in DecawattsPerCubicMeter.
        """
        pass

    @property
    def DecawattsPerLiter(self) -> float:
        """ Get PowerDensity in DecawattsPerLiter.
        """
        pass

    @property
    def DeciwattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in DeciwattsPerCubicFoot.
        """
        pass

    @property
    def DeciwattsPerCubicInch(self) -> float:
        """ Get PowerDensity in DeciwattsPerCubicInch.
        """
        pass

    @property
    def DeciwattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in DeciwattsPerCubicMeter.
        """
        pass

    @property
    def DeciwattsPerLiter(self) -> float:
        """ Get PowerDensity in DeciwattsPerLiter.
        """
        pass

    @property
    def GigawattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in GigawattsPerCubicFoot.
        """
        pass

    @property
    def GigawattsPerCubicInch(self) -> float:
        """ Get PowerDensity in GigawattsPerCubicInch.
        """
        pass

    @property
    def GigawattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in GigawattsPerCubicMeter.
        """
        pass

    @property
    def GigawattsPerLiter(self) -> float:
        """ Get PowerDensity in GigawattsPerLiter.
        """
        pass

    @property
    def KilowattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in KilowattsPerCubicFoot.
        """
        pass

    @property
    def KilowattsPerCubicInch(self) -> float:
        """ Get PowerDensity in KilowattsPerCubicInch.
        """
        pass

    @property
    def KilowattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in KilowattsPerCubicMeter.
        """
        pass

    @property
    def KilowattsPerLiter(self) -> float:
        """ Get PowerDensity in KilowattsPerLiter.
        """
        pass

    @property
    def MegawattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in MegawattsPerCubicFoot.
        """
        pass

    @property
    def MegawattsPerCubicInch(self) -> float:
        """ Get PowerDensity in MegawattsPerCubicInch.
        """
        pass

    @property
    def MegawattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in MegawattsPerCubicMeter.
        """
        pass

    @property
    def MegawattsPerLiter(self) -> float:
        """ Get PowerDensity in MegawattsPerLiter.
        """
        pass

    @property
    def MicrowattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in MicrowattsPerCubicFoot.
        """
        pass

    @property
    def MicrowattsPerCubicInch(self) -> float:
        """ Get PowerDensity in MicrowattsPerCubicInch.
        """
        pass

    @property
    def MicrowattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in MicrowattsPerCubicMeter.
        """
        pass

    @property
    def MicrowattsPerLiter(self) -> float:
        """ Get PowerDensity in MicrowattsPerLiter.
        """
        pass

    @property
    def MilliwattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in MilliwattsPerCubicFoot.
        """
        pass

    @property
    def MilliwattsPerCubicInch(self) -> float:
        """ Get PowerDensity in MilliwattsPerCubicInch.
        """
        pass

    @property
    def MilliwattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in MilliwattsPerCubicMeter.
        """
        pass

    @property
    def MilliwattsPerLiter(self) -> float:
        """ Get PowerDensity in MilliwattsPerLiter.
        """
        pass

    @property
    def NanowattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in NanowattsPerCubicFoot.
        """
        pass

    @property
    def NanowattsPerCubicInch(self) -> float:
        """ Get PowerDensity in NanowattsPerCubicInch.
        """
        pass

    @property
    def NanowattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in NanowattsPerCubicMeter.
        """
        pass

    @property
    def NanowattsPerLiter(self) -> float:
        """ Get PowerDensity in NanowattsPerLiter.
        """
        pass

    @property
    def PicowattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in PicowattsPerCubicFoot.
        """
        pass

    @property
    def PicowattsPerCubicInch(self) -> float:
        """ Get PowerDensity in PicowattsPerCubicInch.
        """
        pass

    @property
    def PicowattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in PicowattsPerCubicMeter.
        """
        pass

    @property
    def PicowattsPerLiter(self) -> float:
        """ Get PowerDensity in PicowattsPerLiter.
        """
        pass

    @property
    def TerawattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in TerawattsPerCubicFoot.
        """
        pass

    @property
    def TerawattsPerCubicInch(self) -> float:
        """ Get PowerDensity in TerawattsPerCubicInch.
        """
        pass

    @property
    def TerawattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in TerawattsPerCubicMeter.
        """
        pass

    @property
    def TerawattsPerLiter(self) -> float:
        """ Get PowerDensity in TerawattsPerLiter.
        """
        pass

    @property
    def WattsPerCubicFoot(self) -> float:
        """ Get PowerDensity in WattsPerCubicFoot.
        """
        pass

    @property
    def WattsPerCubicInch(self) -> float:
        """ Get PowerDensity in WattsPerCubicInch.
        """
        pass

    @property
    def WattsPerCubicMeter(self) -> float:
        """ Get PowerDensity in WattsPerCubicMeter.
        """
        pass

    @property
    def WattsPerLiter(self) -> float:
        """ Get PowerDensity in WattsPerLiter.
        """
        pass

    def __init__(self, value: float, unit: PowerDensityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PowerDensityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilowattsPerCubicMeter(kilowattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from KilowattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerLiter(kilowattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from KilowattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerCubicFoot(megawattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MegawattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerCubicInch(megawattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MegawattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerCubicMeter(megawattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MegawattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegawattsPerLiter(megawattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MegawattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerCubicFoot(microwattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MicrowattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerCubicInch(microwattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MicrowattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerCubicMeter(microwattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MicrowattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrowattsPerLiter(microwattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MicrowattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerCubicFoot(milliwattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MilliwattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerCubicInch(milliwattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MilliwattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerCubicMeter(milliwattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MilliwattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMilliwattsPerLiter(milliwattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from MilliwattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerCubicFoot(nanowattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from NanowattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerCubicInch(nanowattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from NanowattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerCubicMeter(nanowattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from NanowattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanowattsPerLiter(nanowattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from NanowattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerCubicFoot(picowattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from PicowattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerCubicInch(picowattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from PicowattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerCubicMeter(picowattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from PicowattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPicowattsPerLiter(picowattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from PicowattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattsPerCubicFoot(terawattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from TerawattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattsPerCubicInch(terawattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from TerawattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattsPerCubicMeter(terawattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from TerawattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTerawattsPerLiter(terawattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from TerawattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerCubicFoot(wattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from WattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerCubicInch(wattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from WattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerCubicMeter(wattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from WattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerLiter(wattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from WattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PowerDensityUnit) -> PowerDensity:
        """ Dynamically convert from value and unit enum "PowerDensityUnit" to "PowerDensity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PowerDensityUnit
        :return: PowerDensity unit value.
        :rtype: PowerDensity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> PowerDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> PowerDensity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: PowerDensity) -> typing.Tuple[PowerDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PowerDensity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: PowerDensity) -> typing.Tuple[PowerDensity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PowerDensity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PowerDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PowerDensityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PowerDensityUnit) -> typing.Tuple[PowerDensityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PowerDensityUnit) -> typing.Tuple[PowerDensityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PowerDensityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: PowerDensity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PowerDensity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PowerDensity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another PowerDensity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: PowerDensity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current PowerDensity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: PowerDensityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PowerDensityUnit) -> PowerDensity:
        """ Converts this PowerDensity to another PowerDensity with the unit representation .

        :return: A PowerDensity with the specified unit.
        :rtype: PowerDensity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> PowerDensity:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerDensityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerDensityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PowerDensityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PowerDensityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecawattsPerCubicFoot(decawattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from DecawattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecawattsPerCubicInch(decawattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from DecawattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecawattsPerCubicMeter(decawattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from DecawattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecawattsPerLiter(decawattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from DecawattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwattsPerCubicFoot(deciwattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from DeciwattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwattsPerCubicInch(deciwattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from DeciwattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwattsPerCubicMeter(deciwattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from DeciwattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDeciwattsPerLiter(deciwattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from DeciwattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerCubicFoot(gigawattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from GigawattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerCubicInch(gigawattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from GigawattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerCubicMeter(gigawattspercubicmeter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from GigawattsPerCubicMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromGigawattsPerLiter(gigawattsperliter: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from GigawattsPerLiter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerCubicFoot(kilowattspercubicfoot: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from KilowattsPerCubicFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilowattsPerCubicInch(kilowattspercubicinch: QuantityValue) -> PowerDensity:
        """ Get PowerDensity from KilowattsPerCubicInch.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass


# noinspection PyPep8Naming
class PressureChangeRate(ValueType, IQuantity[PressureChangeRateUnit], IQuantity, IFormattable, IEquatable[PressureChangeRate], IComparable, IComparable[PressureChangeRate], IConvertible):
    """ Pressure change rate is the ratio of the pressure change to the time during which the change occurred (value of pressure changes per unit time).
    """

    Info: typing.ClassVar[QuantityInfo[PressureChangeRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[PressureChangeRateUnit]

    MaxValue: typing.ClassVar[PressureChangeRate]

    MinValue: typing.ClassVar[PressureChangeRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[PressureChangeRateUnit]]

    Zero: typing.ClassVar[PressureChangeRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> PressureChangeRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[PressureChangeRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def AtmospheresPerSecond(self) -> float:
        """ Get PressureChangeRate in AtmospheresPerSecond.
        """
        pass

    @property
    def KilopascalsPerMinute(self) -> float:
        """ Get PressureChangeRate in KilopascalsPerMinute.
        """
        pass

    @property
    def KilopascalsPerSecond(self) -> float:
        """ Get PressureChangeRate in KilopascalsPerSecond.
        """
        pass

    @property
    def KilopoundsForcePerSquareInchPerMinute(self) -> float:
        """ Get PressureChangeRate in KilopoundsForcePerSquareInchPerMinute.
        """
        pass

    @property
    def KilopoundsForcePerSquareInchPerSecond(self) -> float:
        """ Get PressureChangeRate in KilopoundsForcePerSquareInchPerSecond.
        """
        pass

    @property
    def MegapascalsPerMinute(self) -> float:
        """ Get PressureChangeRate in MegapascalsPerMinute.
        """
        pass

    @property
    def MegapascalsPerSecond(self) -> float:
        """ Get PressureChangeRate in MegapascalsPerSecond.
        """
        pass

    @property
    def MegapoundsForcePerSquareInchPerMinute(self) -> float:
        """ Get PressureChangeRate in MegapoundsForcePerSquareInchPerMinute.
        """
        pass

    @property
    def MegapoundsForcePerSquareInchPerSecond(self) -> float:
        """ Get PressureChangeRate in MegapoundsForcePerSquareInchPerSecond.
        """
        pass

    @property
    def PascalsPerMinute(self) -> float:
        """ Get PressureChangeRate in PascalsPerMinute.
        """
        pass

    @property
    def PascalsPerSecond(self) -> float:
        """ Get PressureChangeRate in PascalsPerSecond.
        """
        pass

    @property
    def PoundsForcePerSquareInchPerMinute(self) -> float:
        """ Get PressureChangeRate in PoundsForcePerSquareInchPerMinute.
        """
        pass

    @property
    def PoundsForcePerSquareInchPerSecond(self) -> float:
        """ Get PressureChangeRate in PoundsForcePerSquareInchPerSecond.
        """
        pass

    def __init__(self, value: float, unit: PressureChangeRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: PressureChangeRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def As(self, unit: PressureChangeRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: PressureChangeRateUnit) -> PressureChangeRate:
        """ Converts this PressureChangeRate to another PressureChangeRate with the unit representation .

        :return: A PressureChangeRate with the specified unit.
        :rtype: PressureChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> PressureChangeRate:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PressureChangeRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PressureChangeRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: PressureChangeRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: PressureChangeRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAtmospheresPerSecond(atmospherespersecond: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from AtmospheresPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopascalsPerMinute(kilopascalsperminute: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from KilopascalsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopascalsPerSecond(kilopascalspersecond: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from KilopascalsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSquareInchPerMinute(kilopoundsforcepersquareinchperminute: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from KilopoundsForcePerSquareInchPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundsForcePerSquareInchPerSecond(kilopoundsforcepersquareinchpersecond: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from KilopoundsForcePerSquareInchPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapascalsPerMinute(megapascalsperminute: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from MegapascalsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapascalsPerSecond(megapascalspersecond: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from MegapascalsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsForcePerSquareInchPerMinute(megapoundsforcepersquareinchperminute: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from MegapoundsForcePerSquareInchPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundsForcePerSquareInchPerSecond(megapoundsforcepersquareinchpersecond: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from MegapoundsForcePerSquareInchPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPascalsPerMinute(pascalsperminute: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from PascalsPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPascalsPerSecond(pascalspersecond: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from PascalsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSquareInchPerMinute(poundsforcepersquareinchperminute: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from PoundsForcePerSquareInchPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundsForcePerSquareInchPerSecond(poundsforcepersquareinchpersecond: QuantityValue) -> PressureChangeRate:
        """ Get PressureChangeRate from PoundsForcePerSquareInchPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: PressureChangeRateUnit) -> PressureChangeRate:
        """ Dynamically convert from value and unit enum "PressureChangeRateUnit" to "PressureChangeRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: PressureChangeRateUnit
        :return: PressureChangeRate unit value.
        :rtype: PressureChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> PressureChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> PressureChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: PressureChangeRate) -> typing.Tuple[PressureChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PressureChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: PressureChangeRate) -> typing.Tuple[PressureChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: PressureChangeRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> PressureChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> PressureChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: PressureChangeRateUnit) -> typing.Tuple[PressureChangeRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: PressureChangeRateUnit) -> typing.Tuple[PressureChangeRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: PressureChangeRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: PressureChangeRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PressureChangeRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: PressureChangeRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another PressureChangeRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: PressureChangeRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current PressureChangeRate.
        :rtype: int
        """
        pass


# noinspection PyPep8Naming
class Ratio(ValueType, IQuantity[RatioUnit], IQuantity, IFormattable, IEquatable[Ratio], IComparable, IComparable[Ratio], IConvertible):
    """ In mathematics, a ratio is a relationship between two numbers of the same kind (e.g., objects, persons, students, spoonfuls, units of whatever identical dimension), usually expressed as "a to b" or a:b, sometimes expressed arithmetically as a dimensionless quotient of the two that explicitly indicates how many times the first number contains the second (not necessarily an integer).
    """

    Info: typing.ClassVar[QuantityInfo[RatioUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RatioUnit]

    MaxValue: typing.ClassVar[Ratio]

    MinValue: typing.ClassVar[Ratio]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RatioUnit]]

    Zero: typing.ClassVar[Ratio]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RatioUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RatioUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DecimalFractions(self) -> float:
        """ Get Ratio in DecimalFractions.
        """
        pass

    @property
    def PartsPerBillion(self) -> float:
        """ Get Ratio in PartsPerBillion.
        """
        pass

    @property
    def PartsPerMillion(self) -> float:
        """ Get Ratio in PartsPerMillion.
        """
        pass

    @property
    def PartsPerThousand(self) -> float:
        """ Get Ratio in PartsPerThousand.
        """
        pass

    @property
    def PartsPerTrillion(self) -> float:
        """ Get Ratio in PartsPerTrillion.
        """
        pass

    @property
    def Percent(self) -> float:
        """ Get Ratio in Percent.
        """
        pass

    def __init__(self, value: float, unit: RatioUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RatioUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RatioUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RatioUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RatioUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RatioUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecimalFractions(decimalfractions: QuantityValue) -> Ratio:
        """ Get Ratio from DecimalFractions.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerBillion(partsperbillion: QuantityValue) -> Ratio:
        """ Get Ratio from PartsPerBillion.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerMillion(partspermillion: QuantityValue) -> Ratio:
        """ Get Ratio from PartsPerMillion.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerThousand(partsperthousand: QuantityValue) -> Ratio:
        """ Get Ratio from PartsPerThousand.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPartsPerTrillion(partspertrillion: QuantityValue) -> Ratio:
        """ Get Ratio from PartsPerTrillion.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPercent(percent: QuantityValue) -> Ratio:
        """ Get Ratio from Percent.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RatioUnit) -> Ratio:
        """ Dynamically convert from value and unit enum "RatioUnit" to "Ratio".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RatioUnit
        :return: Ratio unit value.
        :rtype: Ratio
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Ratio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Ratio:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Ratio) -> typing.Tuple[Ratio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Ratio
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Ratio) -> typing.Tuple[Ratio, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Ratio
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RatioUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RatioUnit) -> typing.Tuple[RatioUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RatioUnit) -> typing.Tuple[RatioUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RatioUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Ratio) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Ratio) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Ratio, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Ratio within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Ratio
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Ratio.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RatioUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RatioUnit) -> Ratio:
        """ Converts this Ratio to another Ratio with the unit representation .

        :return: A Ratio with the specified unit.
        :rtype: Ratio
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Ratio:
        """
        """
        pass


# noinspection PyPep8Naming
class RatioChangeRate(ValueType, IQuantity[RatioChangeRateUnit], IQuantity, IFormattable, IEquatable[RatioChangeRate], IComparable, IComparable[RatioChangeRate], IConvertible):
    """ The change in ratio per unit of time.
    """

    Info: typing.ClassVar[QuantityInfo[RatioChangeRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RatioChangeRateUnit]

    MaxValue: typing.ClassVar[RatioChangeRate]

    MinValue: typing.ClassVar[RatioChangeRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RatioChangeRateUnit]]

    Zero: typing.ClassVar[RatioChangeRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RatioChangeRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RatioChangeRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DecimalFractionsPerSecond(self) -> float:
        """ Get RatioChangeRate in DecimalFractionsPerSecond.
        """
        pass

    @property
    def PercentsPerSecond(self) -> float:
        """ Get RatioChangeRate in PercentsPerSecond.
        """
        pass

    def __init__(self, value: float, unit: RatioChangeRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RatioChangeRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RatioChangeRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RatioChangeRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RatioChangeRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RatioChangeRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDecimalFractionsPerSecond(decimalfractionspersecond: QuantityValue) -> RatioChangeRate:
        """ Get RatioChangeRate from DecimalFractionsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPercentsPerSecond(percentspersecond: QuantityValue) -> RatioChangeRate:
        """ Get RatioChangeRate from PercentsPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RatioChangeRateUnit) -> RatioChangeRate:
        """ Dynamically convert from value and unit enum "RatioChangeRateUnit" to "RatioChangeRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RatioChangeRateUnit
        :return: RatioChangeRate unit value.
        :rtype: RatioChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RatioChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RatioChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RatioChangeRate) -> typing.Tuple[RatioChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RatioChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RatioChangeRate) -> typing.Tuple[RatioChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RatioChangeRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RatioChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RatioChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RatioChangeRateUnit) -> typing.Tuple[RatioChangeRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RatioChangeRateUnit) -> typing.Tuple[RatioChangeRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RatioChangeRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RatioChangeRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RatioChangeRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RatioChangeRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RatioChangeRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RatioChangeRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RatioChangeRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RatioChangeRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RatioChangeRateUnit) -> RatioChangeRate:
        """ Converts this RatioChangeRate to another RatioChangeRate with the unit representation .

        :return: A RatioChangeRate with the specified unit.
        :rtype: RatioChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RatioChangeRate:
        """
        """
        pass


# noinspection PyPep8Naming
class ReactiveEnergy(ValueType, IQuantity[ReactiveEnergyUnit], IQuantity, IFormattable, IEquatable[ReactiveEnergy], IComparable, IComparable[ReactiveEnergy], IConvertible):
    """ The Volt-ampere reactive hour (expressed as varh) is the reactive power of one Volt-ampere reactive produced in one hour.
    """

    Info: typing.ClassVar[QuantityInfo[ReactiveEnergyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ReactiveEnergyUnit]

    MaxValue: typing.ClassVar[ReactiveEnergy]

    MinValue: typing.ClassVar[ReactiveEnergy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ReactiveEnergyUnit]]

    Zero: typing.ClassVar[ReactiveEnergy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ReactiveEnergyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ReactiveEnergyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilovoltampereReactiveHours(self) -> float:
        """ Get ReactiveEnergy in KilovoltampereReactiveHours.
        """
        pass

    @property
    def MegavoltampereReactiveHours(self) -> float:
        """ Get ReactiveEnergy in MegavoltampereReactiveHours.
        """
        pass

    @property
    def VoltampereReactiveHours(self) -> float:
        """ Get ReactiveEnergy in VoltampereReactiveHours.
        """
        pass

    def __init__(self, value: float, unit: ReactiveEnergyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ReactiveEnergyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReactiveEnergyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReactiveEnergyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReactiveEnergyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReactiveEnergyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilovoltampereReactiveHours(kilovoltamperereactivehours: QuantityValue) -> ReactiveEnergy:
        """ Get ReactiveEnergy from KilovoltampereReactiveHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltampereReactiveHours(megavoltamperereactivehours: QuantityValue) -> ReactiveEnergy:
        """ Get ReactiveEnergy from MegavoltampereReactiveHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltampereReactiveHours(voltamperereactivehours: QuantityValue) -> ReactiveEnergy:
        """ Get ReactiveEnergy from VoltampereReactiveHours.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ReactiveEnergyUnit) -> ReactiveEnergy:
        """ Dynamically convert from value and unit enum "ReactiveEnergyUnit" to "ReactiveEnergy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ReactiveEnergyUnit
        :return: ReactiveEnergy unit value.
        :rtype: ReactiveEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ReactiveEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ReactiveEnergy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ReactiveEnergy) -> typing.Tuple[ReactiveEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReactiveEnergy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ReactiveEnergy) -> typing.Tuple[ReactiveEnergy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReactiveEnergy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ReactiveEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ReactiveEnergyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ReactiveEnergyUnit) -> typing.Tuple[ReactiveEnergyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ReactiveEnergyUnit) -> typing.Tuple[ReactiveEnergyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ReactiveEnergyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ReactiveEnergy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReactiveEnergy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReactiveEnergy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ReactiveEnergy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ReactiveEnergy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ReactiveEnergy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ReactiveEnergyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ReactiveEnergyUnit) -> ReactiveEnergy:
        """ Converts this ReactiveEnergy to another ReactiveEnergy with the unit representation .

        :return: A ReactiveEnergy with the specified unit.
        :rtype: ReactiveEnergy
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ReactiveEnergy:
        """
        """
        pass


# noinspection PyPep8Naming
class ReactivePower(ValueType, IQuantity[ReactivePowerUnit], IQuantity, IFormattable, IEquatable[ReactivePower], IComparable, IComparable[ReactivePower], IConvertible):
    """ Volt-ampere reactive (var) is a unit by which reactive power is expressed in an AC electric power system. Reactive power exists in an AC circuit when the current and voltage are not in phase.
    """

    Info: typing.ClassVar[QuantityInfo[ReactivePowerUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ReactivePowerUnit]

    MaxValue: typing.ClassVar[ReactivePower]

    MinValue: typing.ClassVar[ReactivePower]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ReactivePowerUnit]]

    Zero: typing.ClassVar[ReactivePower]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ReactivePowerUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ReactivePowerUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def GigavoltamperesReactive(self) -> float:
        """ Get ReactivePower in GigavoltamperesReactive.
        """
        pass

    @property
    def KilovoltamperesReactive(self) -> float:
        """ Get ReactivePower in KilovoltamperesReactive.
        """
        pass

    @property
    def MegavoltamperesReactive(self) -> float:
        """ Get ReactivePower in MegavoltamperesReactive.
        """
        pass

    @property
    def VoltamperesReactive(self) -> float:
        """ Get ReactivePower in VoltamperesReactive.
        """
        pass

    def __init__(self, value: float, unit: ReactivePowerUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ReactivePowerUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReactivePowerUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReactivePowerUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ReactivePowerUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ReactivePowerUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromGigavoltamperesReactive(gigavoltamperesreactive: QuantityValue) -> ReactivePower:
        """ Get ReactivePower from GigavoltamperesReactive.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilovoltamperesReactive(kilovoltamperesreactive: QuantityValue) -> ReactivePower:
        """ Get ReactivePower from KilovoltamperesReactive.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegavoltamperesReactive(megavoltamperesreactive: QuantityValue) -> ReactivePower:
        """ Get ReactivePower from MegavoltamperesReactive.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromVoltamperesReactive(voltamperesreactive: QuantityValue) -> ReactivePower:
        """ Get ReactivePower from VoltamperesReactive.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ReactivePowerUnit) -> ReactivePower:
        """ Dynamically convert from value and unit enum "ReactivePowerUnit" to "ReactivePower".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ReactivePowerUnit
        :return: ReactivePower unit value.
        :rtype: ReactivePower
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ReactivePower:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ReactivePower:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ReactivePower) -> typing.Tuple[ReactivePower, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReactivePower
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ReactivePower) -> typing.Tuple[ReactivePower, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ReactivePower
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ReactivePowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ReactivePowerUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ReactivePowerUnit) -> typing.Tuple[ReactivePowerUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ReactivePowerUnit) -> typing.Tuple[ReactivePowerUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ReactivePowerUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ReactivePower) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReactivePower) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ReactivePower, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ReactivePower within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ReactivePower
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ReactivePower.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ReactivePowerUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ReactivePowerUnit) -> ReactivePower:
        """ Converts this ReactivePower to another ReactivePower with the unit representation .

        :return: A ReactivePower with the specified unit.
        :rtype: ReactivePower
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ReactivePower:
        """
        """
        pass


# noinspection PyPep8Naming
class RelativeHumidity(ValueType, IQuantity[RelativeHumidityUnit], IQuantity, IFormattable, IEquatable[RelativeHumidity], IComparable, IComparable[RelativeHumidity], IConvertible):
    """ Relative humidity is a ratio of the actual water vapor present in the air to the maximum water vapor in the air at the given temperature.
    """

    Info: typing.ClassVar[QuantityInfo[RelativeHumidityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RelativeHumidityUnit]

    MaxValue: typing.ClassVar[RelativeHumidity]

    MinValue: typing.ClassVar[RelativeHumidity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RelativeHumidityUnit]]

    Zero: typing.ClassVar[RelativeHumidity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RelativeHumidityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RelativeHumidityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Percent(self) -> float:
        """ Get RelativeHumidity in Percent.
        """
        pass

    def __init__(self, value: float, unit: RelativeHumidityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RelativeHumidityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RelativeHumidityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RelativeHumidityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RelativeHumidityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RelativeHumidityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromPercent(percent: QuantityValue) -> RelativeHumidity:
        """ Get RelativeHumidity from Percent.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RelativeHumidityUnit) -> RelativeHumidity:
        """ Dynamically convert from value and unit enum "RelativeHumidityUnit" to "RelativeHumidity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RelativeHumidityUnit
        :return: RelativeHumidity unit value.
        :rtype: RelativeHumidity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RelativeHumidity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RelativeHumidity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RelativeHumidity) -> typing.Tuple[RelativeHumidity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RelativeHumidity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RelativeHumidity) -> typing.Tuple[RelativeHumidity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RelativeHumidity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RelativeHumidityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RelativeHumidityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RelativeHumidityUnit) -> typing.Tuple[RelativeHumidityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RelativeHumidityUnit) -> typing.Tuple[RelativeHumidityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RelativeHumidityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RelativeHumidity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RelativeHumidity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RelativeHumidity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RelativeHumidity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RelativeHumidity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RelativeHumidity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RelativeHumidityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RelativeHumidityUnit) -> RelativeHumidity:
        """ Converts this RelativeHumidity to another RelativeHumidity with the unit representation .

        :return: A RelativeHumidity with the specified unit.
        :rtype: RelativeHumidity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RelativeHumidity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class RotationalAcceleration(ValueType, IQuantity[RotationalAccelerationUnit], IQuantity, IFormattable, IEquatable[RotationalAcceleration], IComparable, IComparable[RotationalAcceleration], IConvertible):
    """ Angular acceleration is the rate of change of rotational speed.
    """

    Info: typing.ClassVar[QuantityInfo[RotationalAccelerationUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[RotationalAccelerationUnit]

    MaxValue: typing.ClassVar[RotationalAcceleration]

    MinValue: typing.ClassVar[RotationalAcceleration]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[RotationalAccelerationUnit]]

    Zero: typing.ClassVar[RotationalAcceleration]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> RotationalAccelerationUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[RotationalAccelerationUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def DegreesPerSecondSquared(self) -> float:
        """ Get RotationalAcceleration in DegreesPerSecondSquared.
        """
        pass

    @property
    def RadiansPerSecondSquared(self) -> float:
        """ Get RotationalAcceleration in RadiansPerSecondSquared.
        """
        pass

    @property
    def RevolutionsPerMinutePerSecond(self) -> float:
        """ Get RotationalAcceleration in RevolutionsPerMinutePerSecond.
        """
        pass

    @property
    def RevolutionsPerSecondSquared(self) -> float:
        """ Get RotationalAcceleration in RevolutionsPerSecondSquared.
        """
        pass

    def __init__(self, value: float, unit: RotationalAccelerationUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: RotationalAccelerationUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalAccelerationUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalAccelerationUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: RotationalAccelerationUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: RotationalAccelerationUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromDegreesPerSecondSquared(degreespersecondsquared: QuantityValue) -> RotationalAcceleration:
        """ Get RotationalAcceleration from DegreesPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRadiansPerSecondSquared(radianspersecondsquared: QuantityValue) -> RotationalAcceleration:
        """ Get RotationalAcceleration from RadiansPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRevolutionsPerMinutePerSecond(revolutionsperminutepersecond: QuantityValue) -> RotationalAcceleration:
        """ Get RotationalAcceleration from RevolutionsPerMinutePerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromRevolutionsPerSecondSquared(revolutionspersecondsquared: QuantityValue) -> RotationalAcceleration:
        """ Get RotationalAcceleration from RevolutionsPerSecondSquared.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: RotationalAccelerationUnit) -> RotationalAcceleration:
        """ Dynamically convert from value and unit enum "RotationalAccelerationUnit" to "RotationalAcceleration".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: RotationalAccelerationUnit
        :return: RotationalAcceleration unit value.
        :rtype: RotationalAcceleration
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> RotationalAcceleration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> RotationalAcceleration:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: RotationalAcceleration) -> typing.Tuple[RotationalAcceleration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalAcceleration
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: RotationalAcceleration) -> typing.Tuple[RotationalAcceleration, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: RotationalAcceleration
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> RotationalAccelerationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> RotationalAccelerationUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: RotationalAccelerationUnit) -> typing.Tuple[RotationalAccelerationUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: RotationalAccelerationUnit) -> typing.Tuple[RotationalAccelerationUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: RotationalAccelerationUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: RotationalAcceleration) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalAcceleration) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: RotationalAcceleration, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another RotationalAcceleration within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: RotationalAcceleration
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current RotationalAcceleration.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: RotationalAccelerationUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: RotationalAccelerationUnit) -> RotationalAcceleration:
        """ Converts this RotationalAcceleration to another RotationalAcceleration with the unit representation .

        :return: A RotationalAcceleration with the specified unit.
        :rtype: RotationalAcceleration
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> RotationalAcceleration:
        """
        """
        pass


# noinspection PyPep8Naming
class Scalar(ValueType, IQuantity[ScalarUnit], IQuantity, IFormattable, IEquatable[Scalar], IComparable, IComparable[Scalar], IConvertible):
    """ A way of representing a number of items.
    """

    Info: typing.ClassVar[QuantityInfo[ScalarUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ScalarUnit]

    MaxValue: typing.ClassVar[Scalar]

    MinValue: typing.ClassVar[Scalar]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ScalarUnit]]

    Zero: typing.ClassVar[Scalar]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ScalarUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ScalarUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Amount(self) -> float:
        """ Get Scalar in Amount.
        """
        pass

    def __init__(self, value: float, unit: ScalarUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ScalarUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ScalarUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ScalarUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ScalarUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ScalarUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromAmount(amount: QuantityValue) -> Scalar:
        """ Get Scalar from Amount.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ScalarUnit) -> Scalar:
        """ Dynamically convert from value and unit enum "ScalarUnit" to "Scalar".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ScalarUnit
        :return: Scalar unit value.
        :rtype: Scalar
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Scalar:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Scalar:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Scalar) -> typing.Tuple[Scalar, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Scalar
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Scalar) -> typing.Tuple[Scalar, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Scalar
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ScalarUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ScalarUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ScalarUnit) -> typing.Tuple[ScalarUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ScalarUnit) -> typing.Tuple[ScalarUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ScalarUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Scalar) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Scalar) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Scalar, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Scalar within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Scalar
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Scalar.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ScalarUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ScalarUnit) -> Scalar:
        """ Converts this Scalar to another Scalar with the unit representation .

        :return: A Scalar with the specified unit.
        :rtype: Scalar
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Scalar:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class SolidAngle(ValueType, IQuantity[SolidAngleUnit], IQuantity, IFormattable, IEquatable[SolidAngle], IComparable, IComparable[SolidAngle], IConvertible):
    """ In geometry, a solid angle is the two-dimensional angle in three-dimensional space that an object subtends at a point.
     https://en.wikipedia.org/wiki/Solid_angle
    """

    Info: typing.ClassVar[QuantityInfo[SolidAngleUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SolidAngleUnit]

    MaxValue: typing.ClassVar[SolidAngle]

    MinValue: typing.ClassVar[SolidAngle]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SolidAngleUnit]]

    Zero: typing.ClassVar[SolidAngle]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SolidAngleUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SolidAngleUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def Steradians(self) -> float:
        """ Get SolidAngle in Steradians.
        """
        pass

    def __init__(self, value: float, unit: SolidAngleUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SolidAngleUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SolidAngleUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SolidAngleUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SolidAngleUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SolidAngleUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromSteradians(steradians: QuantityValue) -> SolidAngle:
        """ Get SolidAngle from Steradians.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SolidAngleUnit) -> SolidAngle:
        """ Dynamically convert from value and unit enum "SolidAngleUnit" to "SolidAngle".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SolidAngleUnit
        :return: SolidAngle unit value.
        :rtype: SolidAngle
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SolidAngle:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SolidAngle:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SolidAngle) -> typing.Tuple[SolidAngle, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SolidAngle
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SolidAngle) -> typing.Tuple[SolidAngle, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SolidAngle
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SolidAngleUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SolidAngleUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SolidAngleUnit) -> typing.Tuple[SolidAngleUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SolidAngleUnit) -> typing.Tuple[SolidAngleUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SolidAngleUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SolidAngle) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SolidAngle) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SolidAngle, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SolidAngle within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SolidAngle
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SolidAngle.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SolidAngleUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SolidAngleUnit) -> SolidAngle:
        """ Converts this SolidAngle to another SolidAngle with the unit representation .

        :return: A SolidAngle with the specified unit.
        :rtype: SolidAngle
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SolidAngle:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class SpecificEntropy(ValueType, IQuantity[SpecificEntropyUnit], IQuantity, IFormattable, IEquatable[SpecificEntropy], IComparable, IComparable[SpecificEntropy], IConvertible):
    """ Specific entropy is an amount of energy required to raise temperature of a substance by 1 Kelvin per unit mass.
    """

    Info: typing.ClassVar[QuantityInfo[SpecificEntropyUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[SpecificEntropyUnit]

    MaxValue: typing.ClassVar[SpecificEntropy]

    MinValue: typing.ClassVar[SpecificEntropy]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[SpecificEntropyUnit]]

    Zero: typing.ClassVar[SpecificEntropy]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> SpecificEntropyUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[SpecificEntropyUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtusPerPoundFahrenheit(self) -> float:
        """ Get SpecificEntropy in BtusPerPoundFahrenheit.
        """
        pass

    @property
    def CaloriesPerGramKelvin(self) -> float:
        """ Get SpecificEntropy in CaloriesPerGramKelvin.
        """
        pass

    @property
    def JoulesPerKilogramDegreeCelsius(self) -> float:
        """ Get SpecificEntropy in JoulesPerKilogramDegreeCelsius.
        """
        pass

    @property
    def JoulesPerKilogramKelvin(self) -> float:
        """ Get SpecificEntropy in JoulesPerKilogramKelvin.
        """
        pass

    @property
    def KilocaloriesPerGramKelvin(self) -> float:
        """ Get SpecificEntropy in KilocaloriesPerGramKelvin.
        """
        pass

    @property
    def KilojoulesPerKilogramDegreeCelsius(self) -> float:
        """ Get SpecificEntropy in KilojoulesPerKilogramDegreeCelsius.
        """
        pass

    @property
    def KilojoulesPerKilogramKelvin(self) -> float:
        """ Get SpecificEntropy in KilojoulesPerKilogramKelvin.
        """
        pass

    @property
    def MegajoulesPerKilogramDegreeCelsius(self) -> float:
        """ Get SpecificEntropy in MegajoulesPerKilogramDegreeCelsius.
        """
        pass

    @property
    def MegajoulesPerKilogramKelvin(self) -> float:
        """ Get SpecificEntropy in MegajoulesPerKilogramKelvin.
        """
        pass

    def __init__(self, value: float, unit: SpecificEntropyUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: SpecificEntropyUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> SpecificEntropy:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificEntropyUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificEntropyUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: SpecificEntropyUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: SpecificEntropyUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtusPerPoundFahrenheit(btusperpoundfahrenheit: QuantityValue) -> SpecificEntropy:
        """ Get SpecificEntropy from BtusPerPoundFahrenheit.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCaloriesPerGramKelvin(caloriespergramkelvin: QuantityValue) -> SpecificEntropy:
        """ Get SpecificEntropy from CaloriesPerGramKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerKilogramDegreeCelsius(joulesperkilogramdegreecelsius: QuantityValue) -> SpecificEntropy:
        """ Get SpecificEntropy from JoulesPerKilogramDegreeCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromJoulesPerKilogramKelvin(joulesperkilogramkelvin: QuantityValue) -> SpecificEntropy:
        """ Get SpecificEntropy from JoulesPerKilogramKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilocaloriesPerGramKelvin(kilocaloriespergramkelvin: QuantityValue) -> SpecificEntropy:
        """ Get SpecificEntropy from KilocaloriesPerGramKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerKilogramDegreeCelsius(kilojoulesperkilogramdegreecelsius: QuantityValue) -> SpecificEntropy:
        """ Get SpecificEntropy from KilojoulesPerKilogramDegreeCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilojoulesPerKilogramKelvin(kilojoulesperkilogramkelvin: QuantityValue) -> SpecificEntropy:
        """ Get SpecificEntropy from KilojoulesPerKilogramKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerKilogramDegreeCelsius(megajoulesperkilogramdegreecelsius: QuantityValue) -> SpecificEntropy:
        """ Get SpecificEntropy from MegajoulesPerKilogramDegreeCelsius.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegajoulesPerKilogramKelvin(megajoulesperkilogramkelvin: QuantityValue) -> SpecificEntropy:
        """ Get SpecificEntropy from MegajoulesPerKilogramKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: SpecificEntropyUnit) -> SpecificEntropy:
        """ Dynamically convert from value and unit enum "SpecificEntropyUnit" to "SpecificEntropy".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: SpecificEntropyUnit
        :return: SpecificEntropy unit value.
        :rtype: SpecificEntropy
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> SpecificEntropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> SpecificEntropy:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: SpecificEntropy) -> typing.Tuple[SpecificEntropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificEntropy
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: SpecificEntropy) -> typing.Tuple[SpecificEntropy, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: SpecificEntropy
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> SpecificEntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> SpecificEntropyUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: SpecificEntropyUnit) -> typing.Tuple[SpecificEntropyUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: SpecificEntropyUnit) -> typing.Tuple[SpecificEntropyUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: SpecificEntropyUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: SpecificEntropy) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificEntropy) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: SpecificEntropy, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another SpecificEntropy within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: SpecificEntropy
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current SpecificEntropy.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: SpecificEntropyUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: SpecificEntropyUnit) -> SpecificEntropy:
        """ Converts this SpecificEntropy to another SpecificEntropy with the unit representation .

        :return: A SpecificEntropy with the specified unit.
        :rtype: SpecificEntropy
        """
        pass


# noinspection PyPep8Naming
class StandardVolumeFlow(ValueType, IQuantity[StandardVolumeFlowUnit], IQuantity, IFormattable, IEquatable[StandardVolumeFlow], IComparable, IComparable[StandardVolumeFlow], IConvertible):
    """ The molar flow rate of a gas corrected to standardized conditions of temperature and pressure thus representing a fixed number of moles of gas regardless of composition and actual flow conditions.
    """

    Info: typing.ClassVar[QuantityInfo[StandardVolumeFlowUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[StandardVolumeFlowUnit]

    MaxValue: typing.ClassVar[StandardVolumeFlow]

    MinValue: typing.ClassVar[StandardVolumeFlow]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[StandardVolumeFlowUnit]]

    Zero: typing.ClassVar[StandardVolumeFlow]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> StandardVolumeFlowUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[StandardVolumeFlowUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def StandardCubicCentimetersPerMinute(self) -> float:
        """ Get StandardVolumeFlow in StandardCubicCentimetersPerMinute.
        """
        pass

    @property
    def StandardCubicFeetPerHour(self) -> float:
        """ Get StandardVolumeFlow in StandardCubicFeetPerHour.
        """
        pass

    @property
    def StandardCubicFeetPerMinute(self) -> float:
        """ Get StandardVolumeFlow in StandardCubicFeetPerMinute.
        """
        pass

    @property
    def StandardCubicFeetPerSecond(self) -> float:
        """ Get StandardVolumeFlow in StandardCubicFeetPerSecond.
        """
        pass

    @property
    def StandardCubicMetersPerDay(self) -> float:
        """ Get StandardVolumeFlow in StandardCubicMetersPerDay.
        """
        pass

    @property
    def StandardCubicMetersPerHour(self) -> float:
        """ Get StandardVolumeFlow in StandardCubicMetersPerHour.
        """
        pass

    @property
    def StandardCubicMetersPerMinute(self) -> float:
        """ Get StandardVolumeFlow in StandardCubicMetersPerMinute.
        """
        pass

    @property
    def StandardCubicMetersPerSecond(self) -> float:
        """ Get StandardVolumeFlow in StandardCubicMetersPerSecond.
        """
        pass

    @property
    def StandardLitersPerMinute(self) -> float:
        """ Get StandardVolumeFlow in StandardLitersPerMinute.
        """
        pass

    def __init__(self, value: float, unit: StandardVolumeFlowUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: StandardVolumeFlowUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> StandardVolumeFlow:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: StandardVolumeFlowUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: StandardVolumeFlowUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: StandardVolumeFlowUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: StandardVolumeFlowUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromStandardCubicCentimetersPerMinute(standardcubiccentimetersperminute: QuantityValue) -> StandardVolumeFlow:
        """ Get StandardVolumeFlow from StandardCubicCentimetersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicFeetPerHour(standardcubicfeetperhour: QuantityValue) -> StandardVolumeFlow:
        """ Get StandardVolumeFlow from StandardCubicFeetPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicFeetPerMinute(standardcubicfeetperminute: QuantityValue) -> StandardVolumeFlow:
        """ Get StandardVolumeFlow from StandardCubicFeetPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicFeetPerSecond(standardcubicfeetpersecond: QuantityValue) -> StandardVolumeFlow:
        """ Get StandardVolumeFlow from StandardCubicFeetPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicMetersPerDay(standardcubicmetersperday: QuantityValue) -> StandardVolumeFlow:
        """ Get StandardVolumeFlow from StandardCubicMetersPerDay.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicMetersPerHour(standardcubicmetersperhour: QuantityValue) -> StandardVolumeFlow:
        """ Get StandardVolumeFlow from StandardCubicMetersPerHour.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicMetersPerMinute(standardcubicmetersperminute: QuantityValue) -> StandardVolumeFlow:
        """ Get StandardVolumeFlow from StandardCubicMetersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardCubicMetersPerSecond(standardcubicmeterspersecond: QuantityValue) -> StandardVolumeFlow:
        """ Get StandardVolumeFlow from StandardCubicMetersPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromStandardLitersPerMinute(standardlitersperminute: QuantityValue) -> StandardVolumeFlow:
        """ Get StandardVolumeFlow from StandardLitersPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: StandardVolumeFlowUnit) -> StandardVolumeFlow:
        """ Dynamically convert from value and unit enum "StandardVolumeFlowUnit" to "StandardVolumeFlow".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: StandardVolumeFlowUnit
        :return: StandardVolumeFlow unit value.
        :rtype: StandardVolumeFlow
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> StandardVolumeFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> StandardVolumeFlow:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: StandardVolumeFlow) -> typing.Tuple[StandardVolumeFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: StandardVolumeFlow
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: StandardVolumeFlow) -> typing.Tuple[StandardVolumeFlow, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: StandardVolumeFlow
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> StandardVolumeFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> StandardVolumeFlowUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: StandardVolumeFlowUnit) -> typing.Tuple[StandardVolumeFlowUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: StandardVolumeFlowUnit) -> typing.Tuple[StandardVolumeFlowUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: StandardVolumeFlowUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: StandardVolumeFlow) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: StandardVolumeFlow) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: StandardVolumeFlow, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another StandardVolumeFlow within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: StandardVolumeFlow
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current StandardVolumeFlow.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: StandardVolumeFlowUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: StandardVolumeFlowUnit) -> StandardVolumeFlow:
        """ Converts this StandardVolumeFlow to another StandardVolumeFlow with the unit representation .

        :return: A StandardVolumeFlow with the specified unit.
        :rtype: StandardVolumeFlow
        """
        pass


# noinspection PyPep8Naming
class TemperatureChangeRate(ValueType, IQuantity[TemperatureChangeRateUnit], IQuantity, IFormattable, IEquatable[TemperatureChangeRate], IComparable, IComparable[TemperatureChangeRate], IConvertible):
    """ Temperature change rate is the ratio of the temperature change to the time during which the change occurred (value of temperature changes per unit time).
    """

    Info: typing.ClassVar[QuantityInfo[TemperatureChangeRateUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TemperatureChangeRateUnit]

    MaxValue: typing.ClassVar[TemperatureChangeRate]

    MinValue: typing.ClassVar[TemperatureChangeRate]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TemperatureChangeRateUnit]]

    Zero: typing.ClassVar[TemperatureChangeRate]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TemperatureChangeRateUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TemperatureChangeRateUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentidegreesCelsiusPerSecond(self) -> float:
        """ Get TemperatureChangeRate in CentidegreesCelsiusPerSecond.
        """
        pass

    @property
    def DecadegreesCelsiusPerSecond(self) -> float:
        """ Get TemperatureChangeRate in DecadegreesCelsiusPerSecond.
        """
        pass

    @property
    def DecidegreesCelsiusPerSecond(self) -> float:
        """ Get TemperatureChangeRate in DecidegreesCelsiusPerSecond.
        """
        pass

    @property
    def DegreesCelsiusPerMinute(self) -> float:
        """ Get TemperatureChangeRate in DegreesCelsiusPerMinute.
        """
        pass

    @property
    def DegreesCelsiusPerSecond(self) -> float:
        """ Get TemperatureChangeRate in DegreesCelsiusPerSecond.
        """
        pass

    @property
    def HectodegreesCelsiusPerSecond(self) -> float:
        """ Get TemperatureChangeRate in HectodegreesCelsiusPerSecond.
        """
        pass

    @property
    def KilodegreesCelsiusPerSecond(self) -> float:
        """ Get TemperatureChangeRate in KilodegreesCelsiusPerSecond.
        """
        pass

    @property
    def MicrodegreesCelsiusPerSecond(self) -> float:
        """ Get TemperatureChangeRate in MicrodegreesCelsiusPerSecond.
        """
        pass

    @property
    def MillidegreesCelsiusPerSecond(self) -> float:
        """ Get TemperatureChangeRate in MillidegreesCelsiusPerSecond.
        """
        pass

    @property
    def NanodegreesCelsiusPerSecond(self) -> float:
        """ Get TemperatureChangeRate in NanodegreesCelsiusPerSecond.
        """
        pass

    def __init__(self, value: float, unit: TemperatureChangeRateUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TemperatureChangeRateUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TemperatureChangeRateUnit) -> TemperatureChangeRate:
        """ Converts this TemperatureChangeRate to another TemperatureChangeRate with the unit representation .

        :return: A TemperatureChangeRate with the specified unit.
        :rtype: TemperatureChangeRate
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> TemperatureChangeRate:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureChangeRateUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureChangeRateUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TemperatureChangeRateUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TemperatureChangeRateUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentidegreesCelsiusPerSecond(centidegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Get TemperatureChangeRate from CentidegreesCelsiusPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecadegreesCelsiusPerSecond(decadegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Get TemperatureChangeRate from DecadegreesCelsiusPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecidegreesCelsiusPerSecond(decidegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Get TemperatureChangeRate from DecidegreesCelsiusPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesCelsiusPerMinute(degreescelsiusperminute: QuantityValue) -> TemperatureChangeRate:
        """ Get TemperatureChangeRate from DegreesCelsiusPerMinute.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDegreesCelsiusPerSecond(degreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Get TemperatureChangeRate from DegreesCelsiusPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromHectodegreesCelsiusPerSecond(hectodegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Get TemperatureChangeRate from HectodegreesCelsiusPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilodegreesCelsiusPerSecond(kilodegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Get TemperatureChangeRate from KilodegreesCelsiusPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMicrodegreesCelsiusPerSecond(microdegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Get TemperatureChangeRate from MicrodegreesCelsiusPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillidegreesCelsiusPerSecond(millidegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Get TemperatureChangeRate from MillidegreesCelsiusPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNanodegreesCelsiusPerSecond(nanodegreescelsiuspersecond: QuantityValue) -> TemperatureChangeRate:
        """ Get TemperatureChangeRate from NanodegreesCelsiusPerSecond.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TemperatureChangeRateUnit) -> TemperatureChangeRate:
        """ Dynamically convert from value and unit enum "TemperatureChangeRateUnit" to "TemperatureChangeRate".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TemperatureChangeRateUnit
        :return: TemperatureChangeRate unit value.
        :rtype: TemperatureChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> TemperatureChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> TemperatureChangeRate:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: TemperatureChangeRate) -> typing.Tuple[TemperatureChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TemperatureChangeRate
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: TemperatureChangeRate) -> typing.Tuple[TemperatureChangeRate, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TemperatureChangeRate
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TemperatureChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TemperatureChangeRateUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TemperatureChangeRateUnit) -> typing.Tuple[TemperatureChangeRateUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TemperatureChangeRateUnit) -> typing.Tuple[TemperatureChangeRateUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TemperatureChangeRateUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: TemperatureChangeRate) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TemperatureChangeRate) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TemperatureChangeRate, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another TemperatureChangeRate within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: TemperatureChangeRate
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current TemperatureChangeRate.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TemperatureChangeRateUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass


# noinspection PyPep8Naming
class ThermalConductivity(ValueType, IQuantity[ThermalConductivityUnit], IQuantity, IFormattable, IEquatable[ThermalConductivity], IComparable, IComparable[ThermalConductivity], IConvertible):
    """ Thermal conductivity is the property of a material to conduct heat.
     https://en.wikipedia.org/wiki/Thermal_Conductivity
    """

    Info: typing.ClassVar[QuantityInfo[ThermalConductivityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ThermalConductivityUnit]

    MaxValue: typing.ClassVar[ThermalConductivity]

    MinValue: typing.ClassVar[ThermalConductivity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ThermalConductivityUnit]]

    Zero: typing.ClassVar[ThermalConductivity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ThermalConductivityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ThermalConductivityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def BtusPerHourFootFahrenheit(self) -> float:
        """ Get ThermalConductivity in BtusPerHourFootFahrenheit.
        """
        pass

    @property
    def WattsPerMeterKelvin(self) -> float:
        """ Get ThermalConductivity in WattsPerMeterKelvin.
        """
        pass

    def __init__(self, value: float, unit: ThermalConductivityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ThermalConductivityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ThermalConductivityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ThermalConductivityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ThermalConductivityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ThermalConductivityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromBtusPerHourFootFahrenheit(btusperhourfootfahrenheit: QuantityValue) -> ThermalConductivity:
        """ Get ThermalConductivity from BtusPerHourFootFahrenheit.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromWattsPerMeterKelvin(wattspermeterkelvin: QuantityValue) -> ThermalConductivity:
        """ Get ThermalConductivity from WattsPerMeterKelvin.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ThermalConductivityUnit) -> ThermalConductivity:
        """ Dynamically convert from value and unit enum "ThermalConductivityUnit" to "ThermalConductivity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ThermalConductivityUnit
        :return: ThermalConductivity unit value.
        :rtype: ThermalConductivity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ThermalConductivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ThermalConductivity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ThermalConductivity) -> typing.Tuple[ThermalConductivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ThermalConductivity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ThermalConductivity) -> typing.Tuple[ThermalConductivity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ThermalConductivity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ThermalConductivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ThermalConductivityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ThermalConductivityUnit) -> typing.Tuple[ThermalConductivityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ThermalConductivityUnit) -> typing.Tuple[ThermalConductivityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ThermalConductivityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ThermalConductivity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ThermalConductivity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ThermalConductivity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ThermalConductivity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ThermalConductivity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ThermalConductivity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ThermalConductivityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ThermalConductivityUnit) -> ThermalConductivity:
        """ Converts this ThermalConductivity to another ThermalConductivity with the unit representation .

        :return: A ThermalConductivity with the specified unit.
        :rtype: ThermalConductivity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ThermalConductivity:
        """
        """
        pass


# noinspection PyPep8Naming
class ThermalResistance(ValueType, IQuantity[ThermalResistanceUnit], IQuantity, IFormattable, IEquatable[ThermalResistance], IComparable, IComparable[ThermalResistance], IConvertible):
    """ Heat Transfer Coefficient or Thermal conductivity - indicates a materials ability to conduct heat.
    """

    Info: typing.ClassVar[QuantityInfo[ThermalResistanceUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[ThermalResistanceUnit]

    MaxValue: typing.ClassVar[ThermalResistance]

    MinValue: typing.ClassVar[ThermalResistance]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[ThermalResistanceUnit]]

    Zero: typing.ClassVar[ThermalResistance]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> ThermalResistanceUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[ThermalResistanceUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def HourSquareFeetDegreesFahrenheitPerBtu(self) -> float:
        """ Get ThermalResistance in HourSquareFeetDegreesFahrenheitPerBtu.
        """
        pass

    @property
    def SquareCentimeterHourDegreesCelsiusPerKilocalorie(self) -> float:
        """ Get ThermalResistance in SquareCentimeterHourDegreesCelsiusPerKilocalorie.
        """
        pass

    @property
    def SquareCentimeterKelvinsPerWatt(self) -> float:
        """ Get ThermalResistance in SquareCentimeterKelvinsPerWatt.
        """
        pass

    @property
    def SquareMeterDegreesCelsiusPerWatt(self) -> float:
        """ Get ThermalResistance in SquareMeterDegreesCelsiusPerWatt.
        """
        pass

    @property
    def SquareMeterKelvinsPerKilowatt(self) -> float:
        """ Get ThermalResistance in SquareMeterKelvinsPerKilowatt.
        """
        pass

    def __init__(self, value: float, unit: ThermalResistanceUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: ThermalResistanceUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ThermalResistanceUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ThermalResistanceUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: ThermalResistanceUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: ThermalResistanceUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromHourSquareFeetDegreesFahrenheitPerBtu(hoursquarefeetdegreesfahrenheitperbtu: QuantityValue) -> ThermalResistance:
        """ Get ThermalResistance from HourSquareFeetDegreesFahrenheitPerBtu.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareCentimeterHourDegreesCelsiusPerKilocalorie(squarecentimeterhourdegreescelsiusperkilocalorie: QuantityValue) -> ThermalResistance:
        """ Get ThermalResistance from SquareCentimeterHourDegreesCelsiusPerKilocalorie.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareCentimeterKelvinsPerWatt(squarecentimeterkelvinsperwatt: QuantityValue) -> ThermalResistance:
        """ Get ThermalResistance from SquareCentimeterKelvinsPerWatt.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMeterDegreesCelsiusPerWatt(squaremeterdegreescelsiusperwatt: QuantityValue) -> ThermalResistance:
        """ Get ThermalResistance from SquareMeterDegreesCelsiusPerWatt.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromSquareMeterKelvinsPerKilowatt(squaremeterkelvinsperkilowatt: QuantityValue) -> ThermalResistance:
        """ Get ThermalResistance from SquareMeterKelvinsPerKilowatt.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: ThermalResistanceUnit) -> ThermalResistance:
        """ Dynamically convert from value and unit enum "ThermalResistanceUnit" to "ThermalResistance".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: ThermalResistanceUnit
        :return: ThermalResistance unit value.
        :rtype: ThermalResistance
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> ThermalResistance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> ThermalResistance:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: ThermalResistance) -> typing.Tuple[ThermalResistance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ThermalResistance
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: ThermalResistance) -> typing.Tuple[ThermalResistance, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: ThermalResistance
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> ThermalResistanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> ThermalResistanceUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: ThermalResistanceUnit) -> typing.Tuple[ThermalResistanceUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: ThermalResistanceUnit) -> typing.Tuple[ThermalResistanceUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: ThermalResistanceUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: ThermalResistance) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ThermalResistance) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: ThermalResistance, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another ThermalResistance within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: ThermalResistance
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current ThermalResistance.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: ThermalResistanceUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: ThermalResistanceUnit) -> ThermalResistance:
        """ Converts this ThermalResistance to another ThermalResistance with the unit representation .

        :return: A ThermalResistance with the specified unit.
        :rtype: ThermalResistance
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> ThermalResistance:
        """
        """
        pass


# noinspection PyPep8Naming
class TorquePerLength(ValueType, IQuantity[TorquePerLengthUnit], IQuantity, IFormattable, IEquatable[TorquePerLength], IComparable, IComparable[TorquePerLength], IConvertible):
    """ The magnitude of torque per unit length.
    """

    Info: typing.ClassVar[QuantityInfo[TorquePerLengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TorquePerLengthUnit]

    MaxValue: typing.ClassVar[TorquePerLength]

    MinValue: typing.ClassVar[TorquePerLength]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TorquePerLengthUnit]]

    Zero: typing.ClassVar[TorquePerLength]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TorquePerLengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TorquePerLengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def KilogramForceCentimetersPerMeter(self) -> float:
        """ Get TorquePerLength in KilogramForceCentimetersPerMeter.
        """
        pass

    @property
    def KilogramForceMetersPerMeter(self) -> float:
        """ Get TorquePerLength in KilogramForceMetersPerMeter.
        """
        pass

    @property
    def KilogramForceMillimetersPerMeter(self) -> float:
        """ Get TorquePerLength in KilogramForceMillimetersPerMeter.
        """
        pass

    @property
    def KilonewtonCentimetersPerMeter(self) -> float:
        """ Get TorquePerLength in KilonewtonCentimetersPerMeter.
        """
        pass

    @property
    def KilonewtonMetersPerMeter(self) -> float:
        """ Get TorquePerLength in KilonewtonMetersPerMeter.
        """
        pass

    @property
    def KilonewtonMillimetersPerMeter(self) -> float:
        """ Get TorquePerLength in KilonewtonMillimetersPerMeter.
        """
        pass

    @property
    def KilopoundForceFeetPerFoot(self) -> float:
        """ Get TorquePerLength in KilopoundForceFeetPerFoot.
        """
        pass

    @property
    def KilopoundForceInchesPerFoot(self) -> float:
        """ Get TorquePerLength in KilopoundForceInchesPerFoot.
        """
        pass

    @property
    def MeganewtonCentimetersPerMeter(self) -> float:
        """ Get TorquePerLength in MeganewtonCentimetersPerMeter.
        """
        pass

    @property
    def MeganewtonMetersPerMeter(self) -> float:
        """ Get TorquePerLength in MeganewtonMetersPerMeter.
        """
        pass

    @property
    def MeganewtonMillimetersPerMeter(self) -> float:
        """ Get TorquePerLength in MeganewtonMillimetersPerMeter.
        """
        pass

    @property
    def MegapoundForceFeetPerFoot(self) -> float:
        """ Get TorquePerLength in MegapoundForceFeetPerFoot.
        """
        pass

    @property
    def MegapoundForceInchesPerFoot(self) -> float:
        """ Get TorquePerLength in MegapoundForceInchesPerFoot.
        """
        pass

    @property
    def NewtonCentimetersPerMeter(self) -> float:
        """ Get TorquePerLength in NewtonCentimetersPerMeter.
        """
        pass

    @property
    def NewtonMetersPerMeter(self) -> float:
        """ Get TorquePerLength in NewtonMetersPerMeter.
        """
        pass

    @property
    def NewtonMillimetersPerMeter(self) -> float:
        """ Get TorquePerLength in NewtonMillimetersPerMeter.
        """
        pass

    @property
    def PoundForceFeetPerFoot(self) -> float:
        """ Get TorquePerLength in PoundForceFeetPerFoot.
        """
        pass

    @property
    def PoundForceInchesPerFoot(self) -> float:
        """ Get TorquePerLength in PoundForceInchesPerFoot.
        """
        pass

    @property
    def TonneForceCentimetersPerMeter(self) -> float:
        """ Get TorquePerLength in TonneForceCentimetersPerMeter.
        """
        pass

    @property
    def TonneForceMetersPerMeter(self) -> float:
        """ Get TorquePerLength in TonneForceMetersPerMeter.
        """
        pass

    @property
    def TonneForceMillimetersPerMeter(self) -> float:
        """ Get TorquePerLength in TonneForceMillimetersPerMeter.
        """
        pass

    def __init__(self, value: float, unit: TorquePerLengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TorquePerLengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: TorquePerLength) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TorquePerLength) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: TorquePerLength, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another TorquePerLength within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: TorquePerLength
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current TorquePerLength.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TorquePerLengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TorquePerLengthUnit) -> TorquePerLength:
        """ Converts this TorquePerLength to another TorquePerLength with the unit representation .

        :return: A TorquePerLength with the specified unit.
        :rtype: TorquePerLength
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> TorquePerLength:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TorquePerLengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TorquePerLengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TorquePerLengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TorquePerLengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromKilogramForceCentimetersPerMeter(kilogramforcecentimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from KilogramForceCentimetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceMetersPerMeter(kilogramforcemeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from KilogramForceMetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilogramForceMillimetersPerMeter(kilogramforcemillimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from KilogramForceMillimetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonCentimetersPerMeter(kilonewtoncentimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from KilonewtonCentimetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMetersPerMeter(kilonewtonmeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from KilonewtonMetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilonewtonMillimetersPerMeter(kilonewtonmillimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from KilonewtonMillimetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceFeetPerFoot(kilopoundforcefeetperfoot: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from KilopoundForceFeetPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromKilopoundForceInchesPerFoot(kilopoundforceinchesperfoot: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from KilopoundForceInchesPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonCentimetersPerMeter(meganewtoncentimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from MeganewtonCentimetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMetersPerMeter(meganewtonmeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from MeganewtonMetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMeganewtonMillimetersPerMeter(meganewtonmillimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from MeganewtonMillimetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundForceFeetPerFoot(megapoundforcefeetperfoot: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from MegapoundForceFeetPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMegapoundForceInchesPerFoot(megapoundforceinchesperfoot: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from MegapoundForceInchesPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonCentimetersPerMeter(newtoncentimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from NewtonCentimetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMetersPerMeter(newtonmeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from NewtonMetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromNewtonMillimetersPerMeter(newtonmillimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from NewtonMillimetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceFeetPerFoot(poundforcefeetperfoot: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from PoundForceFeetPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromPoundForceInchesPerFoot(poundforceinchesperfoot: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from PoundForceInchesPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceCentimetersPerMeter(tonneforcecentimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from TonneForceCentimetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceMetersPerMeter(tonneforcemeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from TonneForceMetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromTonneForceMillimetersPerMeter(tonneforcemillimeterspermeter: QuantityValue) -> TorquePerLength:
        """ Get TorquePerLength from TonneForceMillimetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TorquePerLengthUnit) -> TorquePerLength:
        """ Dynamically convert from value and unit enum "TorquePerLengthUnit" to "TorquePerLength".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TorquePerLengthUnit
        :return: TorquePerLength unit value.
        :rtype: TorquePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> TorquePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> TorquePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: TorquePerLength) -> typing.Tuple[TorquePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TorquePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: TorquePerLength) -> typing.Tuple[TorquePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: TorquePerLength
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TorquePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TorquePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TorquePerLengthUnit) -> typing.Tuple[TorquePerLengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TorquePerLengthUnit) -> typing.Tuple[TorquePerLengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TorquePerLengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class Turbidity(ValueType, IQuantity[TurbidityUnit], IQuantity, IFormattable, IEquatable[Turbidity], IComparable, IComparable[Turbidity], IConvertible):
    """ Turbidity is the cloudiness or haziness of a fluid caused by large numbers of individual particles that are generally invisible to the naked eye, similar to smoke in air. The measurement of turbidity is a key test of water quality.
     https://en.wikipedia.org/wiki/Turbidity
    """

    Info: typing.ClassVar[QuantityInfo[TurbidityUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[TurbidityUnit]

    MaxValue: typing.ClassVar[Turbidity]

    MinValue: typing.ClassVar[Turbidity]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[TurbidityUnit]]

    Zero: typing.ClassVar[Turbidity]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> TurbidityUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TurbidityUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def NTU(self) -> float:
        """ Get Turbidity in NTU.
        """
        pass

    def __init__(self, value: float, unit: TurbidityUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: TurbidityUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TurbidityUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TurbidityUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: TurbidityUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: TurbidityUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromNTU(ntu: QuantityValue) -> Turbidity:
        """ Get Turbidity from NTU.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: TurbidityUnit) -> Turbidity:
        """ Dynamically convert from value and unit enum "TurbidityUnit" to "Turbidity".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: TurbidityUnit
        :return: Turbidity unit value.
        :rtype: Turbidity
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> Turbidity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> Turbidity:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: Turbidity) -> typing.Tuple[Turbidity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Turbidity
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: Turbidity) -> typing.Tuple[Turbidity, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: Turbidity
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> TurbidityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> TurbidityUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: TurbidityUnit) -> typing.Tuple[TurbidityUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: TurbidityUnit) -> typing.Tuple[TurbidityUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: TurbidityUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: Turbidity) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Turbidity) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: Turbidity, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another Turbidity within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: Turbidity
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current Turbidity.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: TurbidityUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: TurbidityUnit) -> Turbidity:
        """ Converts this Turbidity to another Turbidity with the unit representation .

        :return: A Turbidity with the specified unit.
        :rtype: Turbidity
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> Turbidity:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class VitaminA(ValueType, IQuantity[VitaminAUnit], IQuantity, IFormattable, IEquatable[VitaminA], IComparable, IComparable[VitaminA], IConvertible):
    """ Vitamin A: 1 IU is the biological equivalent of 0.3 µg retinol, or of 0.6 µg beta-carotene.
    """

    Info: typing.ClassVar[QuantityInfo[VitaminAUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VitaminAUnit]

    MaxValue: typing.ClassVar[VitaminA]

    MinValue: typing.ClassVar[VitaminA]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VitaminAUnit]]

    Zero: typing.ClassVar[VitaminA]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VitaminAUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VitaminAUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def InternationalUnits(self) -> float:
        """ Get VitaminA in InternationalUnits.
        """
        pass

    def __init__(self, value: float, unit: VitaminAUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VitaminAUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VitaminAUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VitaminAUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VitaminAUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VitaminAUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromInternationalUnits(internationalunits: QuantityValue) -> VitaminA:
        """ Get VitaminA from InternationalUnits.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VitaminAUnit) -> VitaminA:
        """ Dynamically convert from value and unit enum "VitaminAUnit" to "VitaminA".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VitaminAUnit
        :return: VitaminA unit value.
        :rtype: VitaminA
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> VitaminA:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> VitaminA:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: VitaminA) -> typing.Tuple[VitaminA, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VitaminA
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: VitaminA) -> typing.Tuple[VitaminA, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VitaminA
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VitaminAUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VitaminAUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VitaminAUnit) -> typing.Tuple[VitaminAUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VitaminAUnit) -> typing.Tuple[VitaminAUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VitaminAUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: VitaminA) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VitaminA) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VitaminA, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another VitaminA within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: VitaminA
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current VitaminA.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VitaminAUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VitaminAUnit) -> VitaminA:
        """ Converts this VitaminA to another VitaminA with the unit representation .

        :return: A VitaminA with the specified unit.
        :rtype: VitaminA
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> VitaminA:
        """
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class VolumePerLength(ValueType, IQuantity[VolumePerLengthUnit], IQuantity, IFormattable, IEquatable[VolumePerLength], IComparable, IComparable[VolumePerLength], IConvertible):
    """ Volume, typically of fluid, that a container can hold within a unit of length.
    """

    Info: typing.ClassVar[QuantityInfo[VolumePerLengthUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[VolumePerLengthUnit]

    MaxValue: typing.ClassVar[VolumePerLength]

    MinValue: typing.ClassVar[VolumePerLength]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[VolumePerLengthUnit]]

    Zero: typing.ClassVar[VolumePerLength]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> VolumePerLengthUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[VolumePerLengthUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CubicMetersPerMeter(self) -> float:
        """ Get VolumePerLength in CubicMetersPerMeter.
        """
        pass

    @property
    def CubicYardsPerFoot(self) -> float:
        """ Get VolumePerLength in CubicYardsPerFoot.
        """
        pass

    @property
    def CubicYardsPerUsSurveyFoot(self) -> float:
        """ Get VolumePerLength in CubicYardsPerUsSurveyFoot.
        """
        pass

    @property
    def LitersPerKilometer(self) -> float:
        """ Get VolumePerLength in LitersPerKilometer.
        """
        pass

    @property
    def LitersPerMeter(self) -> float:
        """ Get VolumePerLength in LitersPerMeter.
        """
        pass

    @property
    def LitersPerMillimeter(self) -> float:
        """ Get VolumePerLength in LitersPerMillimeter.
        """
        pass

    @property
    def OilBarrelsPerFoot(self) -> float:
        """ Get VolumePerLength in OilBarrelsPerFoot.
        """
        pass

    def __init__(self, value: float, unit: VolumePerLengthUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: VolumePerLengthUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumePerLengthUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumePerLengthUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: VolumePerLengthUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: VolumePerLengthUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCubicMetersPerMeter(cubicmeterspermeter: QuantityValue) -> VolumePerLength:
        """ Get VolumePerLength from CubicMetersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerFoot(cubicyardsperfoot: QuantityValue) -> VolumePerLength:
        """ Get VolumePerLength from CubicYardsPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromCubicYardsPerUsSurveyFoot(cubicyardsperussurveyfoot: QuantityValue) -> VolumePerLength:
        """ Get VolumePerLength from CubicYardsPerUsSurveyFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerKilometer(litersperkilometer: QuantityValue) -> VolumePerLength:
        """ Get VolumePerLength from LitersPerKilometer.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerMeter(literspermeter: QuantityValue) -> VolumePerLength:
        """ Get VolumePerLength from LitersPerMeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromLitersPerMillimeter(literspermillimeter: QuantityValue) -> VolumePerLength:
        """ Get VolumePerLength from LitersPerMillimeter.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromOilBarrelsPerFoot(oilbarrelsperfoot: QuantityValue) -> VolumePerLength:
        """ Get VolumePerLength from OilBarrelsPerFoot.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: VolumePerLengthUnit) -> VolumePerLength:
        """ Dynamically convert from value and unit enum "VolumePerLengthUnit" to "VolumePerLength".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: VolumePerLengthUnit
        :return: VolumePerLength unit value.
        :rtype: VolumePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> VolumePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> VolumePerLength:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: VolumePerLength) -> typing.Tuple[VolumePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumePerLength
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: VolumePerLength) -> typing.Tuple[VolumePerLength, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: VolumePerLength
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> VolumePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> VolumePerLengthUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: VolumePerLengthUnit) -> typing.Tuple[VolumePerLengthUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: VolumePerLengthUnit) -> typing.Tuple[VolumePerLengthUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: VolumePerLengthUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: VolumePerLength) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumePerLength) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: VolumePerLength, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another VolumePerLength within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: VolumePerLength
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current VolumePerLength.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: VolumePerLengthUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: VolumePerLengthUnit) -> VolumePerLength:
        """ Converts this VolumePerLength to another VolumePerLength with the unit representation .

        :return: A VolumePerLength with the specified unit.
        :rtype: VolumePerLength
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> VolumePerLength:
        """
        """
        pass


# noinspection PyPep8Naming
class WarpingMomentOfInertia(ValueType, IQuantity[WarpingMomentOfInertiaUnit], IQuantity, IFormattable, IEquatable[WarpingMomentOfInertia], IComparable, IComparable[WarpingMomentOfInertia], IConvertible):
    """ A geometric property of an area that is used to determine the warping stress.
    """

    Info: typing.ClassVar[QuantityInfo[WarpingMomentOfInertiaUnit]]

    BaseDimensions: typing.ClassVar[BaseDimensions]

    BaseUnit: typing.ClassVar[WarpingMomentOfInertiaUnit]

    MaxValue: typing.ClassVar[WarpingMomentOfInertia]

    MinValue: typing.ClassVar[WarpingMomentOfInertia]

    QuantityType: typing.ClassVar[QuantityType]

    Units: typing.ClassVar[Array[WarpingMomentOfInertiaUnit]]

    Zero: typing.ClassVar[WarpingMomentOfInertia]

    @property
    def Value(self) -> float:
        """ The numeric value this quantity was constructed with.
        """
        pass

    @property
    def Unit(self) -> WarpingMomentOfInertiaUnit:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[WarpingMomentOfInertiaUnit]:
        """
        """
        pass

    @property
    def Type(self) -> QuantityType:
        """ The "Property QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" of this quantity.
        """
        pass

    @property
    def CentimetersToTheSixth(self) -> float:
        """ Get WarpingMomentOfInertia in CentimetersToTheSixth.
        """
        pass

    @property
    def DecimetersToTheSixth(self) -> float:
        """ Get WarpingMomentOfInertia in DecimetersToTheSixth.
        """
        pass

    @property
    def FeetToTheSixth(self) -> float:
        """ Get WarpingMomentOfInertia in FeetToTheSixth.
        """
        pass

    @property
    def InchesToTheSixth(self) -> float:
        """ Get WarpingMomentOfInertia in InchesToTheSixth.
        """
        pass

    @property
    def MetersToTheSixth(self) -> float:
        """ Get WarpingMomentOfInertia in MetersToTheSixth.
        """
        pass

    @property
    def MillimetersToTheSixth(self) -> float:
        """ Get WarpingMomentOfInertia in MillimetersToTheSixth.
        """
        pass

    def __init__(self, value: float, unit: WarpingMomentOfInertiaUnit) -> None:
        """ Creates the quantity with the given numeric value and unit.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unit: The unit representation to construct this quantity with.
        :type unit: WarpingMomentOfInertiaUnit

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    def __init__(self, value: float, unitSystem: UnitSystem) -> None:
        """Creates an instance of the quantity with the given numeric value in units compatible with the given "UnitSystem".
        If multiple compatible units were found, the first match is used.

        :param value: The numeric value to construct this quantity with.
        :type value: float
        :param unitSystem: The unit system to create the quantity with.
        :type unitSystem: UnitSystem

        :exception ArgumentNullException: The given "UnitSystem" is null.
        :exception ArgumentException: No unit was found for the given "UnitSystem".
        """
        pass

    @typing.overload
    def ToString(self) -> str:
        """ Gets the default string representation of value and unit.

        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the default string representation of value and unit using the given format provider.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implicitly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str) -> str:
        """Gets the string representation of this instance in the specified format string using "Property CurrentUICulture".

        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @typing.overload
    def ToString(self, format: str, provider: IFormatProvider) -> str:
        """Gets the string representation of this instance in the specified format string using the specified format provider, or "Property CurrentUICulture" if null.

        :param format: The format string.
        :type format: str
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: WarpingMomentOfInertiaUnit) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: WarpingMomentOfInertiaUnit
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def GetAbbreviation(unit: WarpingMomentOfInertiaUnit, provider: IFormatProvider) -> str:
        """ Get unit abbreviation string.

        :param unit: Unit to get abbreviation for.
        :type unit: WarpingMomentOfInertiaUnit
        :param provider: Format to use for localization. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: Unit abbreviation string.
        :rtype: str
        """
        pass

    @staticmethod
    def FromCentimetersToTheSixth(centimeterstothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Get WarpingMomentOfInertia from CentimetersToTheSixth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromDecimetersToTheSixth(decimeterstothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Get WarpingMomentOfInertia from DecimetersToTheSixth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromFeetToTheSixth(feettothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Get WarpingMomentOfInertia from FeetToTheSixth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromInchesToTheSixth(inchestothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Get WarpingMomentOfInertia from InchesToTheSixth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMetersToTheSixth(meterstothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Get WarpingMomentOfInertia from MetersToTheSixth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def FromMillimetersToTheSixth(millimeterstothesixth: QuantityValue) -> WarpingMomentOfInertia:
        """ Get WarpingMomentOfInertia from MillimetersToTheSixth.

        :exception ArgumentException: If value is NaN or Infinity.
        """
        pass

    @staticmethod
    def From(value: QuantityValue, fromUnit: WarpingMomentOfInertiaUnit) -> WarpingMomentOfInertia:
        """ Dynamically convert from value and unit enum "WarpingMomentOfInertiaUnit" to "WarpingMomentOfInertia".

        :param value: Value to convert from.
        :type value: QuantityValue
        :param fromUnit: Unit to convert from.
        :type fromUnit: WarpingMomentOfInertiaUnit
        :return: WarpingMomentOfInertia unit value.
        :rtype: WarpingMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str) -> WarpingMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def Parse(str: str, provider: IFormatProvider) -> WarpingMomentOfInertia:
        """ Parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception ArgumentException: Expected string to have one or two pairs of quantity and unit in the format
        "<quantity> <unit>". Eg. "5.5 m" or "1ft 2in"
        :exception AmbiguousUnitParseException: More than one unit is represented by the specified unit abbreviation.
        Example: Volume.Parse("1 cup") will throw, because it can refer to any of
        "Field MetricCup", "Field UsLegalCup" and "Field UsCustomaryCup".
        :exception UnitsNetException: If anything else goes wrong, typically due to a bug or unhandled case.
        We wrap exceptions in "UnitsNetException" to allow you to distinguish
        Units.NET exceptions from other exceptions.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, result: WarpingMomentOfInertia) -> typing.Tuple[WarpingMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: WarpingMomentOfInertia
        """
        pass

    @staticmethod
    @typing.overload
    def TryParse(str: str, provider: IFormatProvider, result: WarpingMomentOfInertia) -> typing.Tuple[WarpingMomentOfInertia, bool]:
        """ Try to parse a string with one or two quantities of the format "<quantity> <unit>".

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param result: Resulting unit quantity if successful.
        :type result: WarpingMomentOfInertia
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str) -> WarpingMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def ParseUnit(str: str, provider: IFormatProvider) -> WarpingMomentOfInertiaUnit:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider

        :exception ArgumentNullException: The value of 'str' cannot be null.
        :exception UnitsNetException: Error parsing string.
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, unit: WarpingMomentOfInertiaUnit) -> typing.Tuple[WarpingMomentOfInertiaUnit, bool]:
        """
        """
        pass

    @staticmethod
    @typing.overload
    def TryParseUnit(str: str, provider: IFormatProvider, unit: WarpingMomentOfInertiaUnit) -> typing.Tuple[WarpingMomentOfInertiaUnit, bool]:
        """ Parse a unit string.

        :param str: String to parse. Typically in the form: {number} {unit}
        :type str: str
        :param unit: The parsed unit if successful.
        :type unit: WarpingMomentOfInertiaUnit
        :param provider: Format to use when parsing number and unit. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: True if successful, otherwise false.
        :rtype: bool
        """
        pass

    @typing.overload
    def CompareTo(self, obj: typing.Any) -> int:
        """
        """
        pass

    @typing.overload
    def CompareTo(self, other: WarpingMomentOfInertia) -> int:
        """
        """
        pass

    @typing.overload
    def Equals(self, obj: typing.Any) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: WarpingMomentOfInertia) -> bool:
        """Consider using "Function ComparisonType)" for safely comparing floating point values.
        """
        pass

    @typing.overload
    def Equals(self, other: WarpingMomentOfInertia, tolerance: float, comparisonType: ComparisonType) -> bool:
        """ Compare equality to another WarpingMomentOfInertia within the given absolute or relative tolerance.

         Relative tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a percentage of this quantity's value. will be converted into this quantity's unit for comparison. A relative tolerance of 0.01 means the absolute difference must be within +/- 1% of this quantity's value to be considered equal. In this example, the two quantities will be equal if the value of b is within +/- 1% of a (0.02m or 2cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Relative);

         Absolute tolerance is defined as the maximum allowable absolute difference between this quantity's value and as a fixed number in this quantity's unit. will be converted into this quantity's unit for comparison. In this example, the two quantities will be equal if the value of b is within 0.01 of a (0.01m or 1cm). var a = Length.FromMeters(2.0); var b = Length.FromInches(50.0); a.Equals(b, 0.01, ComparisonType.Absolute);

         Note that it is advised against specifying zero difference, due to the nature of floating point operations and using System.Double internally.

        :param other: The other quantity to compare to.
        :type other: WarpingMomentOfInertia
        :param tolerance: The absolute or relative tolerance value. Must be greater than or equal to 0.
        :type tolerance: float
        :param comparisonType: The comparison type: either relative or absolute.
        :type comparisonType: ComparisonType
        :return: True if the absolute difference between the two values is not greater than the specified relative or absolute tolerance.
        :rtype: bool
        """
        pass

    def GetHashCode(self) -> int:
        """ Returns the hash code for this instance.

        :return: A hash code for the current WarpingMomentOfInertia.
        :rtype: int
        """
        pass

    @typing.overload
    def As(self, unit: WarpingMomentOfInertiaUnit) -> float:
        """ Convert to the unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """
        """
        pass

    @typing.overload
    def ToUnit(self, unit: WarpingMomentOfInertiaUnit) -> WarpingMomentOfInertia:
        """ Converts this WarpingMomentOfInertia to another WarpingMomentOfInertia with the unit representation .

        :return: A WarpingMomentOfInertia with the specified unit.
        :rtype: WarpingMomentOfInertia
        """
        pass

    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> WarpingMomentOfInertia:
        """
        """
        pass


# noinspection PyPep8Naming
class QuantityType(Enum, IComparable, IFormattable, IConvertible):
    """ Lists all generated quantities with the same name as the quantity struct type,
     such as Length, Mass, Force etc.
     This is useful for populating options in the UI, such as creating a generic conversion
     tool with inputValue, quantityName, fromUnit and toUnit selectors.
    """

    value__: int = ...

    Undefined: QuantityType = ...

    Acceleration: QuantityType = ...

    AmountOfSubstance: QuantityType = ...

    AmplitudeRatio: QuantityType = ...

    Angle: QuantityType = ...

    ApparentEnergy: QuantityType = ...

    ApparentPower: QuantityType = ...

    Area: QuantityType = ...

    AreaDensity: QuantityType = ...

    AreaMomentOfInertia: QuantityType = ...

    BitRate: QuantityType = ...

    BrakeSpecificFuelConsumption: QuantityType = ...

    Capacitance: QuantityType = ...

    CoefficientOfThermalExpansion: QuantityType = ...

    Density: QuantityType = ...

    Duration: QuantityType = ...

    DynamicViscosity: QuantityType = ...

    ElectricAdmittance: QuantityType = ...

    ElectricCharge: QuantityType = ...

    ElectricChargeDensity: QuantityType = ...

    ElectricConductance: QuantityType = ...

    ElectricConductivity: QuantityType = ...

    ElectricCurrent: QuantityType = ...

    ElectricCurrentDensity: QuantityType = ...

    ElectricCurrentGradient: QuantityType = ...

    ElectricField: QuantityType = ...

    ElectricInductance: QuantityType = ...

    ElectricPotential: QuantityType = ...

    ElectricPotentialAc: QuantityType = ...

    ElectricPotentialChangeRate: QuantityType = ...

    ElectricPotentialDc: QuantityType = ...

    ElectricResistance: QuantityType = ...

    ElectricResistivity: QuantityType = ...

    ElectricSurfaceChargeDensity: QuantityType = ...

    Energy: QuantityType = ...

    Entropy: QuantityType = ...

    Force: QuantityType = ...

    ForceChangeRate: QuantityType = ...

    ForcePerLength: QuantityType = ...

    Frequency: QuantityType = ...

    FuelEfficiency: QuantityType = ...

    HeatFlux: QuantityType = ...

    HeatTransferCoefficient: QuantityType = ...

    Illuminance: QuantityType = ...

    Information: QuantityType = ...

    Irradiance: QuantityType = ...

    Irradiation: QuantityType = ...

    KinematicViscosity: QuantityType = ...

    LapseRate: QuantityType = ...

    Length: QuantityType = ...

    Level: QuantityType = ...

    LinearDensity: QuantityType = ...

    LinearPowerDensity: QuantityType = ...

    Luminosity: QuantityType = ...

    LuminousFlux: QuantityType = ...

    LuminousIntensity: QuantityType = ...

    MagneticField: QuantityType = ...

    MagneticFlux: QuantityType = ...

    Magnetization: QuantityType = ...

    Mass: QuantityType = ...

    MassConcentration: QuantityType = ...

    MassFlow: QuantityType = ...

    MassFlux: QuantityType = ...

    MassFraction: QuantityType = ...

    MassMomentOfInertia: QuantityType = ...

    MolarEnergy: QuantityType = ...

    MolarEntropy: QuantityType = ...

    Molarity: QuantityType = ...

    MolarMass: QuantityType = ...

    Permeability: QuantityType = ...

    Permittivity: QuantityType = ...

    Power: QuantityType = ...

    PowerDensity: QuantityType = ...

    PowerRatio: QuantityType = ...

    Pressure: QuantityType = ...

    PressureChangeRate: QuantityType = ...

    Ratio: QuantityType = ...

    RatioChangeRate: QuantityType = ...

    ReactiveEnergy: QuantityType = ...

    ReactivePower: QuantityType = ...

    RelativeHumidity: QuantityType = ...

    RotationalAcceleration: QuantityType = ...

    RotationalSpeed: QuantityType = ...

    RotationalStiffness: QuantityType = ...

    RotationalStiffnessPerLength: QuantityType = ...

    Scalar: QuantityType = ...

    SolidAngle: QuantityType = ...

    SpecificEnergy: QuantityType = ...

    SpecificEntropy: QuantityType = ...

    SpecificVolume: QuantityType = ...

    SpecificWeight: QuantityType = ...

    Speed: QuantityType = ...

    StandardVolumeFlow: QuantityType = ...

    Temperature: QuantityType = ...

    TemperatureChangeRate: QuantityType = ...

    TemperatureDelta: QuantityType = ...

    ThermalConductivity: QuantityType = ...

    ThermalResistance: QuantityType = ...

    Torque: QuantityType = ...

    TorquePerLength: QuantityType = ...

    Turbidity: QuantityType = ...

    VitaminA: QuantityType = ...

    Volume: QuantityType = ...

    VolumeConcentration: QuantityType = ...

    VolumeFlow: QuantityType = ...

    VolumePerLength: QuantityType = ...

    WarpingMomentOfInertia: QuantityType = ...


# noinspection PyPep8Naming
class UnitConverter:
    """ Convert between units of a quantity, such as converting from meters to centimeters of a given length.
    """

    Default: typing.ClassVar[UnitConverter]

    def __init__(self) -> None: ...

    @staticmethod
    def RegisterDefaultConversions(unitConverter: UnitConverter) -> None:
        """Registers the default conversion functions in the given "UnitConverter" instance.

        :param unitConverter: The "UnitConverter" to register the default conversion functions in.
        :type unitConverter: UnitConverter
        """
        pass

    @typing.overload
    def SetConversionFunction(self, from: Enum, to: Enum, conversionFunction: ConversionFunction[TQuantity]) -> None:
        """Sets the conversion function from two units of the same quantity type.

        TQuantity: The type of quantity, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction[TQuantity]
        """
        pass

    @typing.overload
    def SetConversionFunction(self, from: Enum, to: Enum, conversionFunction: ConversionFunction) -> None:
        """Sets the conversion function from two units of different quantity types.

        TQuantityFrom: From quantity type, must implement "IQuantity".
        TQuantityTo: To quantity type, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction
        """
        pass

    @typing.overload
    def SetConversionFunction(self, fromType: Type, from: Enum, toType: Type, to: Enum, conversionFunction: ConversionFunction) -> None:
        """Sets the conversion function from two units of different quantity types.

        :param fromType: From quantity type, must implement "IQuantity".
        :type fromType: Type
        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param toType: To quantity type, must implement "IQuantity".
        :type toType: Type
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction
        """
        pass

    @typing.overload
    def GetConversionFunction(self, from: Enum, to: Enum) -> ConversionFunction:
        """Gets the conversion function from two units of the same quantity type.

        TQuantity: The quantity type, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :return:
        :rtype: ConversionFunction
        """
        pass

    @typing.overload
    def GetConversionFunction(self, from: Enum, to: Enum) -> ConversionFunction:
        """Gets the conversion function from two units of different quantity types.

        TQuantityFrom: From quantity type, must implement "IQuantity".
        TQuantityTo: To quantity type, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :return:
        :rtype: ConversionFunction
        """
        pass

    @typing.overload
    def GetConversionFunction(self, fromType: Type, from: Enum, toType: Type, to: Enum) -> ConversionFunction:
        """Gets the conversion function from two units of different quantity types.

        :param fromType: From quantity type, must implement "IQuantity".
        :type fromType: Type
        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param toType: To quantity type, must implement "IQuantity".
        :type toType: Type
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        """
        pass

    @typing.overload
    def TryGetConversionFunction(self, from: Enum, to: Enum, conversionFunction: ConversionFunction) -> typing.Tuple[ConversionFunction, bool]:
        """Gets the conversion function for two units of the same quantity type.

        TQuantity: The quantity type, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction
        :return: true if set; otherwise, false.
        :rtype: bool
        """
        pass

    @typing.overload
    def TryGetConversionFunction(self, from: Enum, to: Enum, conversionFunction: ConversionFunction) -> typing.Tuple[ConversionFunction, bool]:
        """Gets the conversion function for two units of different quantity types.

        TQuantityFrom: From quantity type, must implement "IQuantity".
        TQuantityTo: To quantity type, must implement "IQuantity".

        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction
        :return: true if set; otherwise, false.
        :rtype: bool
        """
        pass

    @typing.overload
    def TryGetConversionFunction(self, fromType: Type, from: Enum, toType: Type, to: Enum, conversionFunction: ConversionFunction) -> typing.Tuple[ConversionFunction, bool]:
        """Try to get the conversion function for two units of the same quantity type.

        :param fromType: From quantity type, must implement "IQuantity".
        :type fromType: Type
        :param from: From unit enum value, such as "Field Kilometer".
        :type from: Enum
        :param toType: To quantity type, must implement "IQuantity".
        :type toType: Type
        :param to: To unit enum value, such as "Field Centimeter".
        :type to: Enum
        :param conversionFunction: The quantity conversion function.
        :type conversionFunction: ConversionFunction
        :return: true if set; otherwise, false.
        :rtype: bool
        """
        pass

    @typing.overload
    def TryGetConversionFunction(self, lookupKey: ValueTuple[Type, Enum, Type, Enum], conversionFunction: ConversionFunction) -> typing.Tuple[ConversionFunction, bool]:
        """

        :param lookupKey:
        :type lookupKey: ValueTuple[Type, Enum, Type, Enum]
        :param conversionFunction:
        :type conversionFunction: ConversionFunction
        :return: true if set; otherwise, false.
        :rtype: bool
        """
        pass

    @staticmethod
    def Convert(fromValue: QuantityValue, fromUnitValue: Enum, toUnitValue: Enum) -> float:
        """ Convert between any two quantity units given a numeric value and two unit enum values.

        :param fromValue: Numeric value.
        :type fromValue: QuantityValue
        :param fromUnitValue: From unit enum value.
        :type fromUnitValue: Enum
        :param toUnitValue: To unit enum value, must be compatible with .
        :type toUnitValue: Enum
        :return: The converted value in the new unit representation.
        :rtype: float
        """
        pass

    @staticmethod
    def TryConvert(fromValue: QuantityValue, fromUnitValue: Enum, toUnitValue: Enum, convertedValue: float) -> typing.Tuple[float, bool]:
        """ Try to convert between any two quantity units given a numeric value and two unit enum values.

        :param fromValue: Numeric value.
        :type fromValue: QuantityValue
        :param fromUnitValue: From unit enum value.
        :type fromUnitValue: Enum
        :param toUnitValue: To unit enum value, must be compatible with .
        :type toUnitValue: Enum
        :param convertedValue: The converted value, if successful. Otherwise default.
        :type convertedValue: float
        :return: True if successful.
        :rtype: bool
        """
        pass

    @staticmethod
    def ConvertByName(fromValue: QuantityValue, quantityName: str, fromUnit: str, toUnit: str) -> float:
        """ Convert between any two quantity units by their names, such as converting a "Length" of N "Meter" to "Centimeter".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param fromValue: Input value, which together with represents the quantity to
        convert from.
        :type fromValue: QuantityValue
        :param quantityName: Name of quantity, such as "Length" and "Mass". "QuantityType" for all
        values.
        :type quantityName: str
        :param fromUnit: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnit: str
        :param toUnit: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnit: str
        :return: Output value as the result of converting to .
        :rtype: float

        :exception UnitNotFoundException: No units match the abbreviation.
        :exception AmbiguousUnitParseException: More than one unit matches the abbreviation.
        """
        pass

    @staticmethod
    def TryConvertByName(inputValue: QuantityValue, quantityName: str, fromUnit: str, toUnit: str, result: float) -> typing.Tuple[float, bool]:
        """ Convert between any two quantity units by their names, such as converting a "Length" of N "Meter" to "Centimeter".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param inputValue: Input value, which together with represents the quantity to
        convert from.
        :type inputValue: QuantityValue
        :param quantityName: Name of quantity, such as "Length" and "Mass". "QuantityType" for all
        values.
        :type quantityName: str
        :param fromUnit: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnit: str
        :param toUnit: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnit: str
        :param result: Result if conversion was successful, 0 if not.
        :type result: float
        :return: True if conversion was successful.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def ConvertByAbbreviation(fromValue: QuantityValue, quantityName: str, fromUnitAbbrev: str, toUnitAbbrev: str) -> float:
        """ Convert between any two quantity units by their abbreviations, such as converting a "Length" of N "m" to "cm".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param fromValue: Input value, which together with represents the quantity to
        convert from.
        :type fromValue: QuantityValue
        :param quantityName: Name of quantity, such as "Length" and "Mass". "QuantityInfo" for all
        values.
        :type quantityName: str
        :param fromUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnitAbbrev: str
        :param toUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnitAbbrev: str
        :return: Output value as the result of converting to .
        :rtype: float
        """
        pass

    @staticmethod
    @typing.overload
    def ConvertByAbbreviation(fromValue: QuantityValue, quantityName: str, fromUnitAbbrev: str, toUnitAbbrev: str, culture: str) -> float:
        """ Convert between any two quantity units by their abbreviations, such as converting a "Length" of N "m" to "cm".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param fromValue: Input value, which together with represents the quantity to
        convert from.
        :type fromValue: QuantityValue
        :param quantityName: Name of quantity, such as "Length" and "Mass". "QuantityType" for all
        values.
        :type quantityName: str
        :param fromUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnitAbbrev: str
        :param toUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnitAbbrev: str
        :param culture: Culture to parse abbreviations with.
        :type culture: str
        :return: Output value as the result of converting to .
        :rtype: float

        :exception UnitNotFoundException: No unit types match the prefix of or no units
        are mapped to the abbreviation.
        :exception AmbiguousUnitParseException: More than one unit matches the abbreviation.
        """
        pass

    @staticmethod
    @typing.overload
    def TryConvertByAbbreviation(fromValue: QuantityValue, quantityName: str, fromUnitAbbrev: str, toUnitAbbrev: str, result: float) -> typing.Tuple[float, bool]:
        """ Convert between any two quantity units by their abbreviations, such as converting a "Length" of N "m" to "cm".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param fromValue: Input value, which together with represents the quantity to
        convert from.
        :type fromValue: QuantityValue
        :param quantityName: Name of quantity, such as "Length" and "Mass". "QuantityType" for all
        values.
        :type quantityName: str
        :param fromUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnitAbbrev: str
        :param toUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnitAbbrev: str
        :param result: Result if conversion was successful, 0 if not.
        :type result: float
        :return: True if conversion was successful.
        :rtype: bool
        """
        pass

    @staticmethod
    @typing.overload
    def TryConvertByAbbreviation(fromValue: QuantityValue, quantityName: str, fromUnitAbbrev: str, toUnitAbbrev: str, result: float, culture: str) -> typing.Tuple[float, bool]:
        """ Convert between any two quantity units by their abbreviations, such as converting a "Length" of N "m" to "cm".
         This is particularly useful for creating things like a generated unit conversion UI,
         where you list some selectors:
         a) Quantity: Length, Mass, Force etc.
         b) From unit: Meter, Centimeter etc if Length is selected
         c) To unit: Meter, Centimeter etc if Length is selected

        :param fromValue: Input value, which together with represents the quantity to
        convert from.
        :type fromValue: QuantityValue
        :param quantityName: Name of quantity, such as "Length" and "Mass". "QuantityType" for all
        values.
        :type quantityName: str
        :param fromUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type fromUnitAbbrev: str
        :param toUnitAbbrev: Name of unit, such as "Meter" or "Centimeter" if "Length" was passed as
        .
        :type toUnitAbbrev: str
        :param culture: Culture to parse abbreviations with.
        :type culture: str
        :param result: Result if conversion was successful, 0 if not.
        :type result: float
        :return: True if conversion was successful.
        :rtype: bool
        """
        pass


# noinspection PyPep8Naming
class IDecimalQuantity(metaclass=ABCMeta):
    """ Represents a quantity with a decimal value.
    """

    @property
    def Value(self) -> Decimal:
        """ The decimal value this quantity was constructed with.
        """
        pass


# noinspection PyPep8Naming
class IQuantity(IFormattable, metaclass=ABCMeta):
    """ Represents a quantity.
    """

    @property
    def Type(self) -> QuantityType:
        """ The "QuantityType" of this quantity.
        """
        pass

    @property
    def Dimensions(self) -> BaseDimensions:
        """ The "BaseDimensions" of this quantity.
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo:
        """ Information about the quantity type, such as unit values and names.
        """
        pass

    @property
    def Unit(self) -> Enum:
        """ The unit this quantity was constructed with -or- BaseUnit if default ctor was used.
        """
        pass

    @property
    def Value(self) -> float:
        """ The value this quantity was constructed with. See also "Property Unit".
        """
        pass

    @abstractmethod
    @typing.overload
    def As(self, unit: Enum) -> float:
        """ Gets the value in the given unit.

        :param unit: The unit enum value. The unit must be compatible, so for "Length" you should provide a "LengthUnit" value.
        :type unit: Enum
        :return: Value converted to the specified unit.
        :rtype: float

        :exception InvalidCastException: Wrong unit enum type was given.
        """
        pass

    @abstractmethod
    @typing.overload
    def As(self, unitSystem: UnitSystem) -> float:
        """ Gets the value in the unit determined by the given "UnitSystem". If multiple units were found for the given "UnitSystem",
         the first match will be used.

        :param unitSystem: The "UnitSystem" to convert the quantity value to.
        :type unitSystem: UnitSystem
        :return: The converted value.
        :rtype: float
        """
        pass

    @abstractmethod
    @typing.overload
    def ToUnit(self, unit: Enum) -> IQuantity:
        """ Converts to a quantity with the given unit representation, which affects things like "Function IFormatProvider)".

        :param unit: The unit enum value. The unit must be compatible, so for "Length" you should provide a "LengthUnit" value.
        :type unit: Enum
        :return: A new quantity with the given unit.
        :rtype: IQuantity
        """
        pass

    @abstractmethod
    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> IQuantity:
        """ Converts to a quantity with a unit determined by the given "UnitSystem", which affects things like "Function IFormatProvider)".
         If multiple units were found for the given "UnitSystem", the first match will be used.

        :param unitSystem: The "UnitSystem" to convert the quantity to.
        :type unitSystem: UnitSystem
        :return: A new quantity with the determined unit.
        :rtype: IQuantity
        """
        pass

    @abstractmethod
    @typing.overload
    def ToString(self, provider: IFormatProvider) -> str:
        """ Gets the string representation of value and unit. Uses two significant digits after radix.

        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @abstractmethod
    @typing.overload
    def ToString(self, provider: IFormatProvider, significantDigitsAfterRadix: int) -> str:
        """ Get string representation of value and unit.

        :param significantDigitsAfterRadix: The number of significant digits after the radix point.
        :type significantDigitsAfterRadix: int
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass

    @abstractmethod
    @typing.overload
    def ToString(self, provider: IFormatProvider, format: str, args: Array[typing.Any]) -> str:
        """ Get string representation of value and unit.

        :param format: String format to use. Default: "{0:0.##} {1} for value and unit abbreviation respectively."
        :type format: str
        :param args: Arguments for string format. Value and unit are implictly included as arguments 0 and 1.
        :type args: Array[typing.Any]
        :param provider: Format to use for localization and number formatting. Defaults to "Property CurrentUICulture" if null.
        :type provider: IFormatProvider
        :return: String representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class IQuantity(IQuantity, IFormattable, typing.Generic[TUnitType], metaclass=ABCMeta):
    """ A stronger typed interface where the unit enum type is known, to avoid passing in the
     wrong unit enum type and not having to cast from "Enum".
    """

    @property
    def Unit(self) -> TUnitType:
        """
        """
        pass

    @property
    def QuantityInfo(self) -> QuantityInfo[TUnitType]:
        """
        """
        pass

    @abstractmethod
    def As(self, unit: TUnitType) -> float:
        """ Convert to a unit representation .

        :return: Value converted to the specified unit.
        :rtype: float
        """
        pass

    @abstractmethod
    @typing.overload
    def ToUnit(self, unit: TUnitType) -> IQuantity[TUnitType]:
        """ Converts to a quantity with the given unit representation, which affects things like "Function IFormatProvider)".

        :param unit: The unit enum value.
        :type unit: TUnitType
        :return: A new quantity with the given unit.
        :rtype: IQuantity[TUnitType]
        """
        pass

    @abstractmethod
    @typing.overload
    def ToUnit(self, unitSystem: UnitSystem) -> IQuantity[TUnitType]:
        """ Converts to a quantity with a unit determined by the given "UnitSystem", which affects things like "Function IFormatProvider)".
         If multiple units were found for the given "UnitSystem", the first match will be used.

        :param unitSystem: The "UnitSystem" to convert the quantity to.
        :type unitSystem: UnitSystem
        :return: A new quantity with the determined unit.
        :rtype: IQuantity[TUnitType]
        """
        pass


# noinspection PyPep8Naming
class QuantityFormatter:
    """The QuantityFormatter class is responsible for formatting a quantity using the given format string.
    """

    def __init__(self) -> None: ...

    @staticmethod
    @typing.overload
    def Format(quantity: IQuantity[TUnitType], format: str) -> str:
        """Formats a quantity using the given format string and format provider.
        The valid format strings are as follows:
        A standard numeric format string.Any of the standard numeric format for "Property Value" except for "G" or "g". "C" or "c", "E" or "e", "F" or "f", "N" or "n", "P" or "p", "R" or "r" are all accepted. "G" or "g".The value with 2 significant digits after the radix followed by the unit abbreviation, such as "1.23 m"."A" or "a".The default unit abbreviation for "Property Unit", such as "m"."A0", "A1", ..., "An" or "a0", "a1", ..., "an".The n-th unit abbreviation for "Property Unit". "a0" is the same as "a". A "FormatException" will be thrown if the requested abbreviation index does not exist."V" or "v".The string representation of "Property Value" using the default ToString method."U" or "u".The enum name of "Property Unit", such as "Meter"."Q" or "q".The quantity name, such as "Length"."S1", "S2", ..., "Sn" or "s1", "s2", ..., "sn".The value with n significant digits after the radix followed by the unit abbreviation. For example, "s4" would return "1.2345 m" if "Property Value" is 1.2345678. Trailing zeros are omitted.

        TUnitType: The quantity's unit type, for example "LengthUnit".

        :param quantity: The quantity to format.
        :type quantity: IQuantity[TUnitType]
        :param format: The format string.
        :type format: str
        :return: The string representation.
        :rtype: str
        """
        pass

    @staticmethod
    @typing.overload
    def Format(quantity: IQuantity[TUnitType], format: str, formatProvider: IFormatProvider) -> str:
        """Formats a quantity using the given format string and format provider.
        The valid format strings are as follows:
        A standard numeric format string.Any of the standard numeric format for "Property Value" except for "G" or "g". "C" or "c", "E" or "e", "F" or "f", "N" or "n", "P" or "p", "R" or "r" are all accepted. "G" or "g".The value with 2 significant digits after the radix followed by the unit abbreviation, such as "1.23 m"."A" or "a".The default unit abbreviation for "Property Unit", such as "m"."A0", "A1", ..., "An" or "a0", "a1", ..., "an".The n-th unit abbreviation for "Property Unit". "a0" is the same as "a". A "FormatException" will be thrown if the requested abbreviation index does not exist."V" or "v".The string representation of "Property Value" using the default ToString method."U" or "u".The enum name of "Property Unit", such as "Meter"."Q" or "q".The quantity name, such as "Length"."S1", "S2", ..., "Sn" or "s1", "s2", ..., "sn".The value with n significant digits after the radix followed by the unit abbreviation. For example, "s4" would return "1.2345 m" if "Property Value" is 1.2345678. Trailing zeros are omitted.

        TUnitType: The quantity's unit type, for example "LengthUnit".

        :param quantity: The quantity to format.
        :type quantity: IQuantity[TUnitType]
        :param format: The format string.
        :type format: str
        :param formatProvider: The format provider to use for localization and number formatting. Defaults to
        "Property CurrentUICulture" if null.
        :type formatProvider: IFormatProvider
        :return: The string representation.
        :rtype: str
        """
        pass


# noinspection PyPep8Naming
class QuantityInfo:
    """ Information about the quantity, such as names, unit values and zero quantity.
     This is useful to enumerate units and present names with quantities and units
     chose dynamically at runtime, such as unit conversion apps or allowing the user to change the
     unit representation.
     Typically you obtain this by looking it up via "Property QuantityInfo".
    """

    @property
    def Name(self) -> str:
        """ Quantity name, such as "Length" or "Mass".
        """
        pass

    @property
    def QuantityType(self) -> QuantityType:
        """ Quantity type, such as "Field Length" or "Field Mass".
        """
        pass

    @property
    def UnitInfos(self) -> Array[UnitInfo]:
        """ The units for this quantity.
        """
        pass

    @property
    def UnitNames(self) -> Array[str]:
        """ All unit names for the quantity, such as ["Centimeter", "Decimeter", "Meter", ...].
        """
        pass

    @property
    def Units(self) -> Array[Enum]:
        """ All unit enum values for the quantity, such as [ "Field Centimeter",
         "Field Decimeter", "Field Meter", ...].
        """
        pass

    @property
    def BaseUnitInfo(self) -> UnitInfo:
        """ The base unit of this quantity.
        """
        pass

    @property
    def BaseUnit(self) -> Enum:
        """ The base unit for the quantity, such as "Field Meter".
        """
        pass

    @property
    def Zero(self) -> IQuantity:
        """ Zero value of quantity, such as "Property Zero".
        """
        pass

    @property
    def UnitType(self) -> Type:
        """ Unit enum type, such as "LengthUnit" or "MassUnit".
        """
        pass

    @property
    def ValueType(self) -> Type:
        """ Quantity value type, such as "Length" or "Mass".
        """
        pass

    @property
    def BaseDimensions(self) -> BaseDimensions:
        """ The "Property BaseDimensions" for a quantity.
        """
        pass

    def __init__(self, quantityType: QuantityType, unitInfos: Array[UnitInfo], baseUnit: Enum, zero: IQuantity, baseDimensions: BaseDimensions) -> None:
        """ Constructs an instance.

        :param quantityType: The quantity enum value.
        :type quantityType: QuantityType
        :param unitInfos: The information about the units for this quantity.
        :type unitInfos: Array[UnitInfo]
        :param baseUnit: The base unit enum value.
        :type baseUnit: Enum
        :param zero: The zero quantity.
        :type zero: IQuantity
        :param baseDimensions: The base dimensions of the quantity.
        :type baseDimensions: BaseDimensions

        :exception ArgumentException: Quantity type can not be undefined.
        :exception ArgumentNullException: If units -or- baseUnit -or- zero -or- baseDimensions is null.
        """
        pass

    def __init__(self, name: str, unitType: Type, unitInfos: Array[UnitInfo], baseUnit: Enum, zero: IQuantity, baseDimensions: BaseDimensions, quantityType: QuantityType) -> None:
        """ Constructs an instance.

        :param name: Name of the quantity.
        :type name: str
        :param unitType: The unit enum type, such as "LengthUnit".
        :type unitType: Type
        :param unitInfos: The information about the units for this quantity.
        :type unitInfos: Array[UnitInfo]
        :param baseUnit: The base unit enum value.
        :type baseUnit: Enum
        :param zero: The zero quantity.
        :type zero: IQuantity
        :param baseDimensions: The base dimensions of the quantity.
        :type baseDimensions: BaseDimensions
        :param quantityType: The the quantity type. Defaults to Undefined.
        :type quantityType: QuantityType

        :exception ArgumentException: Quantity type can not be undefined.
        :exception ArgumentNullException: If units -or- baseUnit -or- zero -or- baseDimensions is null.
        """
        pass

    def GetUnitInfoFor(self, baseUnits: BaseUnits) -> UnitInfo:
        """Gets the "UnitInfo" whose "BaseUnits" is a subset of .

        :param baseUnits: The "BaseUnits" to check against.
        :type baseUnits: BaseUnits
        :return: The "UnitInfo" that has "BaseUnits" that is a subset of .
        :rtype: UnitInfo

        :exception ArgumentNullException: is null.
        :exception InvalidOperationException: No unit was found that is a subset of .
        :exception InvalidOperationException: More than one unit was found that is a subset of .
        """
        pass

    def GetUnitInfosFor(self, baseUnits: BaseUnits) -> IEnumerable[UnitInfo]:
        """Gets an "IEnumerable[T]" of "UnitInfo" that have "BaseUnits" that is a subset of .

        :param baseUnits: The "BaseUnits" to check against.
        :type baseUnits: BaseUnits
        :return: An "IEnumerable[T]" of "UnitInfo" that have "BaseUnits" that is a subset of .
        :rtype: IEnumerable[UnitInfo]

        :exception ArgumentNullException: is null.
        """
        pass


# noinspection PyPep8Naming
class QuantityInfo(QuantityInfo, typing.Generic[TUnit]):
    """ This is a specialization of "QuantityInfo", for when the unit type is known.
     Typically you obtain this by looking it up statically from "Property Info" or
     "Property QuantityInfo", or dynamically via "Property QuantityInfo".

    TUnit: The unit enum type, such as "LengthUnit".
    """

    @property
    def UnitInfos(self) -> Array[UnitInfo[TUnit]]:
        """
        """
        pass

    @property
    def Units(self) -> Array[TUnit]:
        """
        """
        pass

    @property
    def BaseUnitInfo(self) -> UnitInfo[TUnit]:
        """
        """
        pass

    @property
    def BaseUnit(self) -> TUnit:
        """
        """
        pass

    @property
    def Zero(self) -> IQuantity[TUnit]:
        """
        """
        pass

    @property
    def UnitType(self) -> TUnit:
        """
        """
        pass

    def __init__(self, quantityType: QuantityType, unitInfos: Array[UnitInfo[TUnit]], baseUnit: TUnit, zero: IQuantity[TUnit], baseDimensions: BaseDimensions) -> None:
        """
        """
        pass

    def __init__(self, name: str, unitInfos: Array[UnitInfo[TUnit]], baseUnit: TUnit, zero: IQuantity[TUnit], baseDimensions: BaseDimensions, quantityType: QuantityType) -> None:
        """
        """
        pass

    def GetUnitInfoFor(self, baseUnits: BaseUnits) -> UnitInfo[TUnit]:
        """
        """
        pass

    def GetUnitInfosFor(self, baseUnits: BaseUnits) -> IEnumerable[UnitInfo[TUnit]]:
        """
        """
        pass


# noinspection PyPep8Naming
class QuantityNotFoundException(UnitsNetException, ISerializable):
    """ Quantity type was not found. This is typically thrown for dynamic conversions,
     such as "Function String)".
    """

    def __init__(self) -> None:
        """
        """
        pass

    def __init__(self, message: str) -> None:
        """
        """
        pass

    def __init__(self, message: str, innerException: Exception) -> None:
        """
        """
        pass


# noinspection PyPep8Naming
class UnitAttributeBase(Attribute, metaclass=ABCMeta):
    """Is the base class for all attributes that are related to "QuantityTypeConverter[TQuantity]"
    """

    @property
    def UnitType(self) -> Enum:
        """The unit enum type, such as "LengthUnit"
        """
        pass

    @UnitType.setter
    def UnitType(self, value: Enum) -> None: ...

    def __init__(self, unitType: typing.Any) -> None:
        """Initializes a new instance of the "UnitAttributeBase" class.

        :param unitType:
        :type unitType: typing.Any
        """
        pass


# noinspection PyPep8Naming
class DefaultUnitAttribute(UnitAttributeBase):
    """This attribute defines the default Unit to use if the string to convert only consists of digits
    """

    def __init__(self, unitType: typing.Any) -> None:
        """Initializes a new instance of the "DefaultUnitAttribute" class.

        :param unitType: The unit the quantity gets when the string parsing dose only consist of digits
        :type unitType: typing.Any
        """
        pass


# noinspection PyPep8Naming
class ConvertToUnitAttribute(DefaultUnitAttribute):
    """This attribute defines the Unit the quantity is converted to after it has been parsed.
    """

    def __init__(self, unitType: typing.Any) -> None:
        """Initializes a new instance of the "ConvertToUnitAttribute" class.

        :param unitType: The unit the quantity is converted to when parsing from string
        :type unitType: typing.Any
        """
        pass


# noinspection PyPep8Naming
class DisplayAsUnitAttribute(DefaultUnitAttribute):
    """This attribute defines the unit the quantity has when converting to string
    """

    @property
    def Format(self) -> str:
        """The formating used when the quantity is converted to string. See "Function IFormatProvider)"
        """
        pass

    @Format.setter
    def Format(self, value: str) -> None: ...

    def __init__(self, unitType: typing.Any, format: str) -> None:
        """Initializes a new instance of the "DisplayAsUnitAttribute" class.

        :param unitType: The unit the quantity should be displayed in
        :type unitType: typing.Any
        :param format: Formating string "Function IFormatProvider)"
        :type format: str
        """
        pass


# noinspection PyPep8Naming
class QuantityTypeConverter(TypeConverter, typing.Generic[TQuantity]):
    """ Converts between IQuantity and string. Implements a TypeConverter for IQuantitys. This allows eg the PropertyGrid to read and write properties of type IQuantity.

    For basic understanding of TypeConverters consult the .NET documentation.
     When a string is converted a Quantity the unit given by the string is used. When no unit is given by the string the base unit is used. The base unit can be overwritten by use of the "DefaultUnitAttribute". The converted Quantity can be forced to be in a certain unit by use of the "ConvertToUnitAttribute".

     The displayed unit can be forced to a certain unit by use of the "DisplayAsUnitAttribute". The "DisplayAsUnitAttribute" provides the possibility to format the displayed Quantity.

    TQuantity: Quantity value type, such as "Length" or "Mass".
    """

    def __init__(self) -> None: ...

    def CanConvertFrom(self, context: ITypeDescriptorContext, sourceType: Type) -> bool:
        """ Returns true if sourceType if of type "str"

        :param context: An "ITypeDescriptorContext" that provides a format context.
        :type context: ITypeDescriptorContext
        :param sourceType: A "Type" that represents the type you want to convert from.
        :type sourceType: Type
        :return: true if this converter can perform the conversion; otherwise, false.
        :rtype: bool
        """
        pass

    def ConvertFrom(self, context: ITypeDescriptorContext, culture: CultureInfo, value: typing.Any) -> typing.Any:
        """ Converts the given object, when it is of type "str" to the type of this converter, using the specified context and culture information.

        :param context: An System.ComponentModel.ITypeDescriptorContext that provides a format context.
        :type context: ITypeDescriptorContext
        :param culture: The System.Globalization.CultureInfo to use as the current culture.
        :type culture: CultureInfo
        :param value: The System.Object to convert.
        :type value: typing.Any
        :return: An "IQuantity" object.
        :rtype: typing.Any

        :exception NotSupportedException: The conversion cannot be performed.
        :exception ArgumentException: Unit value is not a know unit enum type.
        """
        pass

    def CanConvertTo(self, context: ITypeDescriptorContext, destinationType: Type) -> bool:
        """Returns true whether this converter can convert the "IQuantity" to string, using the specified context.

        :param context: An "ITypeDescriptorContext" that provides a format context.
        :type context: ITypeDescriptorContext
        :param destinationType: A "Type" that represents the type you want to convert to.
        :type destinationType: Type
        :return: true if this converter can perform the conversion; otherwise, false.
        :rtype: bool
        """
        pass

    def ConvertTo(self, context: ITypeDescriptorContext, culture: CultureInfo, value: typing.Any, destinationType: Type) -> typing.Any:
        """Converts the given "IQuantity" object to "str", using the specified context and culture information.

        :param context: An "ITypeDescriptorContext" that provides a format context.
        :type context: ITypeDescriptorContext
        :param culture: A "CultureInfo". If null is passed, the current culture is assumed.
        :type culture: CultureInfo
        :param value: The "typing.Any" to convert.
        :type value: typing.Any
        :param destinationType: The "Type" to convert the parameter to.
        :type destinationType: Type
        :return: An "typing.Any" that represents the converted value.
        :rtype: typing.Any

        :exception ArgumentNullException: The parameter is null.
        :exception NotSupportedException: The conversion cannot be performed.
        """
        pass


# noinspection PyPep8Naming
class QuantityValue(ValueType):
    """ A type that supports implicit cast from all .NET numeric types, in order to avoid a large number of overloads
     and binary size for all From(value, unit) factory methods, for each of the 700+ units in the library.
     "QuantityValue" stores the value internally with the proper type to preserve the range or precision of the original value:
     "float" for [byte, short, int, long, float, double] "Decimal" for [decimal] to preserve the 128-bit precision
     At the time of this writing, this reduces the number of From(value, unit) overloads to 1/4th:
     From 8 (int, long, double, decimal + each nullable) down to 2 (QuantityValue and QuantityValue?).
     This also adds more numeric types with no extra overhead, such as float, short and byte.
    """

    def ToString(self) -> str:
        """Returns the string representation of the numeric value.
        """
        pass


# noinspection PyPep8Naming
class ConversionFunction(MulticastDelegate, ICloneable, ISerializable):

    def __init__(self, object: typing.Any, method: IntPtr) -> None: ...

    def Invoke(self, inputValue: IQuantity) -> IQuantity: ...

    def BeginInvoke(self, inputValue: IQuantity, callback: AsyncCallback, object: typing.Any) -> IAsyncResult: ...

    def EndInvoke(self, result: IAsyncResult) -> IQuantity: ...


# noinspection PyPep8Naming
class ConversionFunction(MulticastDelegate, ICloneable, ISerializable, typing.Generic[TQuantity]):
    """

    TQuantity:
    """

    def __init__(self, object: typing.Any, method: IntPtr) -> None: ...

    def Invoke(self, inputValue: TQuantity) -> TQuantity: ...

    def BeginInvoke(self, inputValue: TQuantity, callback: AsyncCallback, object: typing.Any) -> IAsyncResult: ...

    def EndInvoke(self, result: IAsyncResult) -> TQuantity: ...


# noinspection PyPep8Naming
class UnitInfo:
    """ Information about the unit, such as its name and value.
     This is useful to enumerate units and present names with quantities and units
     chosen dynamically at runtime, such as unit conversion apps or allowing the user to change the
     unit representation.
     Typically you obtain this by looking it up via "Property UnitInfos".
    """

    @property
    def Value(self) -> Enum:
        """The enum value of the unit, such as [ "Field Centimeter",
         "Field Decimeter", "Field Meter", ...].
        """
        pass

    @property
    def Name(self) -> str:
        """The name of the unit, such as ["Centimeter", "Decimeter", "Meter", ...].
        """
        pass

    @property
    def BaseUnits(self) -> BaseUnits:
        """Gets the "Property BaseUnits" for this unit.
        """
        pass

    def __init__(self, value: Enum, baseUnits: BaseUnits) -> None:
        """Creates an instance of the UnitInfo class.

        :param value: The enum value for this class, for example "Field Meter".
        :type value: Enum
        :param baseUnits: The "Property BaseUnits" for this unit.
        :type baseUnits: BaseUnits
        """
        pass


# noinspection PyPep8Naming
class UnitInfo(UnitInfo, typing.Generic[TUnit]):
    """ This is a specialization of "UnitInfo", for when the unit type is known.
     Typically you obtain this by looking it up statically from "Property UnitInfos" or
     or dynamically via "Property QuantityInfo".

    TUnit: The unit enum type, such as "LengthUnit".
    """

    @property
    def Value(self) -> TUnit:
        """
        """
        pass

    def __init__(self, value: TUnit, baseUnits: BaseUnits) -> None:
        """
        """
        pass


# noinspection PyPep8Naming
class UnitMath(metaclass=ABCMeta):
    """ A set of extension methods for some of the most common Math operations, such as Min, Max, Sum and Average
    """

    @staticmethod
    def Abs(value: TQuantity) -> TQuantity:
        """Returns the absolute value of a .

        :param value: A quantity with a value that is greater than or equal to "Field MinValue",
        but less than or equal to "Field MaxValue".
        :type value: TQuantity
        :return: A quantity with a value, such that 0 ≤ value ≤ "Field MaxValue".
        :rtype: TQuantity
        """
        pass

    @staticmethod
    @typing.overload
    def Sum(source: IEnumerable[TQuantity], unitType: Enum) -> TQuantity:
        """Computes the sum of a sequence of values.

        :param source: A sequence of values to calculate the sum of.
        :type source: IEnumerable[TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The sum of the values in the sequence, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source is null.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Sum(source: IEnumerable[TSource], selector: Func[TSource, TQuantity], unitType: Enum) -> TQuantity:
        """ Computes the sum of the sequence of values that are obtained by invoking a
         transform function on each element of the input sequence.

        TSource: The type of the elements of source.
        TQuantity: The type of quantity that is produced by this operation

        :param source: A sequence of values that are used to calculate a sum.
        :type source: IEnumerable[TSource]
        :param selector: A transform function to apply to each element.
        :type selector: Func[TSource, TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The sum of the projected values, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source or selector is null.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Min(val1: TQuantity, val2: TQuantity) -> TQuantity:
        """Returns the smaller of two values.

        TQuantity: The type of quantities to compare.

        :param val1: The first of two values to compare.
        :type val1: TQuantity
        :param val2: The second of two values to compare.
        :type val2: TQuantity
        :return: Parameter or , whichever is smaller.
        :rtype: TQuantity
        """
        pass

    @staticmethod
    @typing.overload
    def Min(source: IEnumerable[TQuantity], unitType: Enum) -> TQuantity:
        """Computes the min of a sequence of values.

        :param source: A sequence of values to calculate the min of.
        :type source: IEnumerable[TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The min of the values in the sequence, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Min(source: IEnumerable[TSource], selector: Func[TSource, TQuantity], unitType: Enum) -> TQuantity:
        """ Computes the min of the sequence of values that are obtained by invoking a
         transform function on each element of the input sequence.

        TSource: The type of the elements of source.
        TQuantity: The type of quantity that is produced by this operation

        :param source: A sequence of values that are used to calculate a min.
        :type source: IEnumerable[TSource]
        :param selector: A transform function to apply to each element.
        :type selector: Func[TSource, TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The min of the projected values, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source or selector is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Max(val1: TQuantity, val2: TQuantity) -> TQuantity:
        """Returns the larger of two values.

        TQuantity: The type of quantities to compare.

        :param val1: The first of two values to compare.
        :type val1: TQuantity
        :param val2: The second of two values to compare.
        :type val2: TQuantity
        :return: Parameter or , whichever is larger.
        :rtype: TQuantity
        """
        pass

    @staticmethod
    @typing.overload
    def Max(source: IEnumerable[TQuantity], unitType: Enum) -> TQuantity:
        """Computes the max of a sequence of values.

        :param source: A sequence of values to calculate the max of.
        :type source: IEnumerable[TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The max of the values in the sequence, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Max(source: IEnumerable[TSource], selector: Func[TSource, TQuantity], unitType: Enum) -> TQuantity:
        """ Computes the max of the sequence of values that are obtained by invoking a
         transform function on each element of the input sequence.

        TSource: The type of the elements of source.
        TQuantity: The type of quantity that is produced by this operation

        :param source: A sequence of values that are used to calculate a max.
        :type source: IEnumerable[TSource]
        :param selector: A transform function to apply to each element.
        :type selector: Func[TSource, TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The max of the projected values, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source or selector is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Average(source: IEnumerable[TQuantity], unitType: Enum) -> TQuantity:
        """Computes the average of a sequence of values.

        :param source: A sequence of values to calculate the average of.
        :type source: IEnumerable[TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The average of the values in the sequence, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass

    @staticmethod
    @typing.overload
    def Average(source: IEnumerable[TSource], selector: Func[TSource, TQuantity], unitType: Enum) -> TQuantity:
        """ Computes the average of the sequence of values that are obtained by invoking
         a transform function on each element of the input sequence.

        TSource: The type of the elements of source.
        TQuantity: The type of quantity that is produced by this operation

        :param source: A sequence of values that are used to calculate an average.
        :type source: IEnumerable[TSource]
        :param selector: A transform function to apply to each element.
        :type selector: Func[TSource, TQuantity]
        :param unitType: The desired unit type for the resulting quantity
        :type unitType: Enum
        :return: The average of the projected values, represented in the specified unit type.
        :rtype: TQuantity

        :exception ArgumentNullException: source or selector is null.
        :exception InvalidOperationException: source contains no elements.
        :exception ArgumentException: source contains quantity types different from .
        """
        pass


# noinspection PyPep8Naming
class UnitNotFoundException(UnitsNetException, ISerializable):
    """ Unit was not found. This is typically thrown for dynamic conversions,
     such as "Function String)".
    """

    def __init__(self) -> None:
        """
        """
        pass

    def __init__(self, message: str) -> None:
        """
        """
        pass

    def __init__(self, message: str, innerException: Exception) -> None:
        """
        """
        pass


# noinspection PyPep8Naming
class UnitsNetException(Exception, ISerializable):
    """ The base type for UnitsNet exceptions.
    """

    def __init__(self) -> None:
        """
        """
        pass

    def __init__(self, message: str) -> None:
        """
        """
        pass

    def __init__(self, message: str, innerException: Exception) -> None:
        """
        """
        pass


# noinspection PyPep8Naming
class UnitSystem(IEquatable[UnitSystem]):
    """ A unit system defined by a combination of base units.
     This is typically used to define the "working units" for consistently creating and presenting quantities in the selected base units,
     such as "Property SI" to use SI base units such as meters, kilograms and seconds.
    """

    @property
    def BaseUnits(self) -> BaseUnits:
        """ The base units of this unit system.
        """
        pass

    SI: typing.ClassVar[UnitSystem]

    def __init__(self, baseUnits: BaseUnits) -> None:
        """Creates an instance of a unit system with the specified base units.

        :param baseUnits: The base units for the unit system.
        :type baseUnits: BaseUnits
        """
        pass

    @typing.overload
    def Equals(self, other: typing.Any) -> bool:
        """
        """
        pass

    @typing.overload
    def Equals(self, other: UnitSystem) -> bool:
        """
        """
        pass

    def GetHashCode(self) -> int:
        """
        """
        pass
